SystemOrganization addCategory: #OLE!
SystemOrganization addCategory: #'OLE-Common-ByAayush'!
SystemOrganization addCategory: #'OLE-RomanNumberActivity'!
SystemOrganization addCategory: #'OLE-MoreVariablesActivity'!
SystemOrganization addCategory: #'OLE-VariablesActivity'!
SystemOrganization addCategory: #'OLE-AddSubtractVariableActivity'!
SystemOrganization addCategory: #'OLE-AlphabeticalOrderActivity'!
SystemOrganization addCategory: #'OLE-MemoryGameActivity'!
SystemOrganization addCategory: #'OLE-SetsTabularActivity'!
SystemOrganization addCategory: #'OLE-AddSubstractActivity'!
SystemOrganization addCategory: #'OLE-FractionAndEquivalentDecimalActivity'!
SystemOrganization addCategory: #'OLE-translation'!
SystemOrganization addCategory: #'OLE-LcmActivity'!
SystemOrganization addCategory: #'OLE-Vocab'!
SystemOrganization addCategory: #'OLE-FractionMultiplicationActivity'!
SystemOrganization addCategory: #'OLE-NoticeReadingActivity'!
SystemOrganization addCategory: #'OLE-TriangleClassificationActivity'!

!Project class methodsFor: '*ole' stamp: 'lg 12/7/2007 10:52'!
fromUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project fromUrl: (FileUrl absoluteFromText: filename) asString].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/21/2007 13:29'!
iconFor: projectName inDirectory: dirName
	| dir icon |
	dir := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dirName.
	icon := SketchMorph fromFile: (dir fullNameFor: projectName, '.gif').
	icon on: #click send: #openFromDirectory:andProjectName: to: ProjectLoading args: {dirName. projectName}.
	icon on: #mouseEnter send: #mouseOverHighlight to: icon.
	icon on: #mouseLeave send: #mouseOverUnhighlight to: icon.
	^icon
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/21/2007 13:28'!
linksForDirectory: dirName
	| projects morph |
	projects := Project projectsInDirectory: Smalltalk imagePath, FileDirectory slash, dirName.
	projects isEmpty ifTrue: [^nil].
	morph := AlignmentMorph new layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		wrapCentering: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		cellInset: 10;
		color: Color transparent.
	projects do: [ :p | morph addMorphBack: (Project iconFor: p inDirectory: dirName)].
	^morph
! !

!Project class methodsFor: '*ole' stamp: 'lg 11/25/2007 11:26'!
namedUnderImage: projectName
	| filename |
	filename :=ProjectLoading findProjectFileNamed: projectName recursivelyInDirectory: Smalltalk imagePath.
	^filename ifNotNil: [Project namedUrl: (FileUrl absoluteFromText: filename)].
! !

!Project class methodsFor: '*ole' stamp: 'lg 12/17/2007 16:01'!
projectsInDirectory: dirName
	| projects parse |
	projects := Set new.
	(FileDirectory on: dirName) fileNames do:
		[ :fn | parse := Project parseProjectFileName: fn.
			(parse at: 3) = 'pr' ifTrue: [projects add: (parse at: 1)]].
	^projects asArray sort.! !

!Project class methodsFor: '*ole' stamp: 'cjs 8/1/2008 17:13'!
registerSingleSound: aSoundName
| tmpTile exists |

exists := false.
ActiveWorld submorphs do:
		[:m |
              m class = SoundTile
				ifTrue:
					[m literal = aSoundName
						ifTrue: [exists := true]]].

exists ifFalse: [ tmpTile := SoundTile new.
						tmpTile currentWorld addMorph: tmpTile.
						tmpTile hide.
						tmpTile setLiteral: aSoundName]! !

!Project class methodsFor: '*ole' stamp: 'cjs 8/1/2008 16:05'!
registerSounds: soundStringArray

soundStringArray do: [ :str | self registerSingleSound: str]! !

!Project methodsFor: '*ole' stamp: 'lg 10/13/2007 09:05'!
exit
	"Leave the current project and return to the project in which this one was created."

	self isTopProject ifTrue: [^ self beep: 'click' ].
	parentProject enter: false revert: false saveForRevert: false.
! !

!Project methodsFor: '*ole-file in/out' stamp: 'lg 11/24/2007 18:55'!
objectForDataStream: refStrm
	| uu dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."

	"Use a copy with no parent, previous or next to reduce extra stuff copied"
	refStrm project == self ifTrue: [^ self copy setParent: nil].

	dp _ (uu _ self url) size > 0 ifTrue: [
		(uu asString beginsWith: Smalltalk imagePath asUrl asString) ifTrue: [
			"OLE extension for flexibility: if the project was loaded from a path under the image directory, just remember the project name and then reload it by searching recursively for a project of that name. -luke"
			DiskProxy global: #Project selector: #namedUnderImage: args: {self name}
		] ifFalse: [
			DiskProxy global: #Project selector: #namedUrl: args: {uu}.
		]
	] ifFalse: [
		DiskProxy global: #Project selector: #named: args: {self name}
	].
	refStrm replace: self with: dp.
	^ dp
! !

!Project methodsFor: '*ole-disk i/o' stamp: 'lg 12/7/2007 11:07'!
setupDiskProxyUnderImage
	^DiskProxy new setupForProjectUnderImage: self name! !

TextMorph subclass: #AnswerViewMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TextMorph subclass: #EpaathText
	instanceVariableNames: 'PangoID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-translation'!

!EpaathText class methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 12:04'!
authoringPrototype

	^self new! !

!EpaathText class methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 12:05'!
createFromWorldMenu
	self authoringPrototype openInWorld! !

!EpaathText class methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 10:53'!
registerEpaathTextDomain

	TextDomainManager registerDomain: 'epaath'.
	TextDomainManager registerClass: #EpaathText domain: 'epaath'.

	! !

!EpaathText class methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 11:17'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: {#EpaathText. #authoringPrototype. 'Text' translatedNoop. 'Epaath specific text.' translatedNoop}
						forFlapNamed: 'PlugIn Supplies'.

						cl registerQuad: {#EpaathText. #authoringPrototype. 'Text' translatedNoop. 'Epaath specific text.' translatedNoop}
						forFlapNamed: 'Supplies'.]! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/11/2008 14:48'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: ('rename pango id'  translatedTo: LocaleID current inDomain: 'epaath') action: #changePangoIDFromDialog! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/11/2008 14:40'!
changePangoIDFromDialog
	self setPangoIDFromDialog; redoContent.! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 10:51'!
initialize
	| baseFont style index |

	PangoID := FillInTheBlank request: 'type pango id (english version of text)' translated initialAnswer: 'text'.
	super initialize.
	self redoContent.
	self position: 600@400; width: 200.
	
	baseFont _ Preferences standardEToysFont.
	style _ baseFont textStyle.
	index _ style fontIndexOfPointSize: 24.
	style defaultFontIndex: index.
	self contents addAttribute: (TextFontChange fontNumber: index).
	self	contentsWrapped: text;
		setTextStyle: style;
		margins: 0@0
! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/11/2008 13:47'!
localeChanged
"Remember contents for previous locale and change contents to new locale if existing.

TODO:
- find out how to read .po/.mo files into a custom created InternalTranslator
- find out how to manipulate translation domains to make them work for us. So we can keep on using the generic 'textInstance translate.' mechanism
- find out how to use the language editor mechanism for epaath
- integrate the specialized epaath language features into the gui
-- put an EpaathText icon in the supply bin
-- put language translator in the OLE section of the main menu" 

self redoContent.
.! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/11/2008 14:32'!
pangoID
	^PangoID! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 11:08'!
pangoID: id
	PangoID := id.
	self localeChanged! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 11:07'!
redoContent

	self contents: (self  pangoID translatedTo: LocaleID current inDomain: 'epaath')! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 11:06'!
setPangoIDFromDialog

	self pangoID: (FillInTheBlank request: 'type pango id (english version of text)' translated initialAnswer: 'text')! !

!EpaathText methodsFor: 'as yet unclassified' stamp: 'cjs 8/11/2008 13:47'!
translated
	self redoContent! !

!EpaathText class methodsFor: 'as yet unclassified' stamp: 'cjs 8/12/2008 10:53'!
initialize
	
	self registerEpaathTextDomain.
	self registerInFlapsRegistry.! !

TextMorph subclass: #GameLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameLevel methodsFor: 'as yet unclassified' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^true! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

GameTextMorph subclass: #ScoreTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

ScoreTextMorph subclass: #MistakesTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameMistakes
	^true! !

!MistakesTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/3/2007 12:47'!
isGameScore
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:37'!
isGameInput
	^false! !

!ScoreTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 16:52'!
isGameScore
	^true! !

TextMorph subclass: #MyNepaliText
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyNepaliText class methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
newWithMaxLength: aNumber
	| model |
	model:= self basicNew.
	model maxLength: aNumber.
	model initialize.
	^model	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/25/2008 10:42'!
acceptText
	self fontName: #DevanagariNew size: 50! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:58'!
defaultText: aString  fontIndexOfPointSize: aNumber

	| style index |
	text:= Text fromString:aString.
	style:=TextStyle named:'DevanagariNew'.
	index:= style fontIndexOfPointSize: aNumber.
	text addAttribute:(TextFontChange fontNumber: index).
	^text! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:56'!
handleKeystroke: anEvent
	"System level event handling. Avoid Tab Handling, This was done to avoid variableDocks problem"

	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:[^self].
	self keyStroke: anEvent! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/25/2008 10:38'!
initialize
	super initialize.
	"Don't wrap the contents"
	text:= self defaultText: 'ram' fontIndexOfPointSize:30.
	
	self contentsWrapped:text;
		backgroundColor: Color white;
		borderWidth:1;
		autoFit: false;
		crAction: (MessageSend receiver: self selector: #acceptText).
	self setFontStyle.
	self maxLength ifNil:[self maxLength:5]! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 17:39'!
keyStroke: evt
	super keyStroke: evt.
	(super elementCount>= (self maxLength+1))ifTrue:[self contents:  ((self contents)asString truncateTo: (self maxLength)).
		evt hand newKeyboardFocus: self.
		self handleInteraction: [editor mouseDown: evt] fromEvent: evt.
	].
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
maxLength
	"Answer the value of maxLength"

	^ maxLength	
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 14:57'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength _ anObject! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/21/2008 12:14'!
setDefaultText
	| defaultText |
	defaultText:= self defaultText:'??' fontIndexOfPointSize:30.
	self setCharacters: defaultText
	! !

!MyNepaliText methodsFor: 'as yet unclassified' stamp: 'Ram 1/18/2008 15:04'!
setFontStyle
	| style |
	style:=TextStyle named:'DevanagariNew'.
	self setTextStyle:style.! !

TextMorph subclass: #MyText
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyText class methodsFor: 'as yet unclassified' stamp: 'Ram 1/3/2008 14:58'!
newWithMaxLength: aNumber
	| model |
	model:= self basicNew.
	model maxLength: aNumber.
	model initialize.
	^model! !

!MyText methodsFor: 'as yet unclassified' stamp: 'Ram 1/21/2008 13:17'!
acceptText
! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:55'!
defaultText: aString  fontIndexOfPointSize: aNumber

	| baseFont style index |
	text:= Text fromString:aString.
	baseFont:=Preferences standardEToysFont.
	style:=baseFont textStyle.
	index:= style fontIndexOfPointSize: aNumber.
	text addAttribute:(TextFontChange fontNumber: index).
	^text! !

!MyText methodsFor: 'event handling' stamp: 'Ram 3/18/2008 13:01'!
handleKeystroke: anEvent
	"System level event handling. Avoid Tab Handling, This was done to avoid variableDocks problem"

	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	"anEvent keyCharacter = Character tab ifTrue:[^self]."
	self keyStroke: anEvent! !

!MyText methodsFor: 'initialization' stamp: 'Ram 1/3/2008 15:14'!
initialize
	super initialize.
	"Don't wrap the contents"
	text:= self defaultText: 'Ram' fontIndexOfPointSize:24.
	
	self contentsWrapped:text;
		backgroundColor: Color white;
		borderWidth:1;
		autoFit: false;
		crAction: (MessageSend receiver: self selector: #acceptText).
	self setFontStyle.
	self maxLength ifNil:[self maxLength:5]! !

!MyText methodsFor: 'event handling' stamp: 'Ram 3/18/2008 13:03'!
keyStroke: evt

	super keyStroke: evt.
	(super elementCount>= (self maxLength+1))ifTrue:[self contents:  ((self contents)asString truncateTo: (self maxLength)).
		evt hand newKeyboardFocus: self.
		self handleInteraction: [editor mouseDown: evt] fromEvent: evt.
	].

! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:56'!
maxLength
	"Answer the value of maxLength"

	^ maxLength! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:56'!
maxLength: anObject
	"Set the value of maxLength"

	maxLength _ anObject
	! !

!MyText methodsFor: 'accessing' stamp: 'Ram 1/3/2008 14:55'!
setFontStyle
	| baseFont style |
	baseFont:=Preferences standardEToysFont.
	style:=baseFont textStyle.
	self setTextStyle:style.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:36'!
gameValue
	^self getCharacters asNumber.! !

!TextMorph methodsFor: '*ole-game' stamp: 'lg 10/29/2007 15:33'!
gameValue: value
	self contents: value asString.! !

RectangleMorph subclass: #DisplayBoardR
	instanceVariableNames: 'strMessage index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!DisplayBoardR methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 17:03'!
index
	^index! !

!DisplayBoardR methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 17:03'!
index: aNumber
	index := aNumber! !

!DisplayBoardR methodsFor: 'initialization' stamp: 'A 8/20/2008 15:17'!
initialize
	super initialize.
	self strMessage: StringMorph new.
	self addMorph: self strMessage.
! !

!DisplayBoardR methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:16'!
strMessage
	^strMessage! !

!DisplayBoardR methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:16'!
strMessage: aStringMorph
	strMessage := aStringMorph! !

RectangleMorph subclass: #DisplayBoardX
	instanceVariableNames: 'dispImage index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!DisplayBoardX methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 10:36'!
dispImage
	^dispImage! !

!DisplayBoardX methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 10:36'!
dispImage: anImageMorph
	dispImage:= anImageMorph! !

!DisplayBoardX methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 10:36'!
index
	^index! !

!DisplayBoardX methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 10:36'!
index: aNumber
	index := aNumber! !

!DisplayBoardX methodsFor: 'initialization' stamp: 'Aayush 10/22/2008 10:36'!
initialize
	super initialize.
	self dispImage: ImageMorph new.
	self addMorph: self dispImage.
	self dispImage center: self center.! !

RectangleMorph subclass: #FootBallGame
	instanceVariableNames: 'answerList soundList GameLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
answerList
	"Answer the value of answerList"

	^ answerList! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
answerList: anObject
	"Set the value of answerList"

	answerList _ anObject! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:26'!
GameLevel
	"Answer the value of GameLevel"

	^ GameLevel! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:26'!
GameLevel: anObject
	"Set the value of GameLevel"

	GameLevel _ anObject! !

!FootBallGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/27/2008 12:28'!
loadAnswer
	self gameLevel =1 
	ifTrue:[
		self answerList: #('its a red book' 'she  is a girl' 'There is an apple' 'Its ink' 'its only three oClock' 'He is a boy' 'We see two oranges' 
			'The book is blue' 'Its four oClock' ).	]
	ifFalse:[
		self answerList: #('He is sleeping' 'That is a red door' 'It has a tail' 'Its got wheels' 'Its an insect' 'Rain is falling' 'The window is open' 
			'He has got a cap' 'They are friends' ).
	]! !

!FootBallGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/27/2008 12:30'!
loadSound
	self gameLevel =1 
	ifTrue:[
		self soundList: #('itsRedbook' 'sheGirl' 'theresApple' 'itsInk' 'its3Oclock' 'heBoy' 'weOranges' 'bookBlue' 'its4Oclock')	]
	ifFalse:[
		self soundList: #('heIsSleeping' 'thatsRedDoor' 'itHasATail' 'itsGotsWheel' 'itsInsect' 'itsRaining' 'theWindowsIsOpen' 'heIsWearingACap' 'theyAreFriends' ).
	]! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
soundList
	"Answer the value of soundList"

	^ soundList! !

!FootBallGame methodsFor: 'accessing' stamp: 'Ram 3/27/2008 12:24'!
soundList: anObject
	"Set the value of soundList"

	soundList _ anObject! !

RectangleMorph subclass: #MemoryTile
	instanceVariableNames: 'textBox picture showText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MemoryTile methodsFor: 'as yet unclassified' stamp: ''!
getAlpha
	^ self renderedMorph color alpha * 100! !

!MemoryTile methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self width: 125.
	self height: 125.
	self
		color: (Color
				r: 0.613
				g: 0.903
				b: 1.0).
	self showText: true.
	self initTextBox.
	self initPicture! !

!MemoryTile methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 10:26'!
initPicture
	self picture: ImageMorph new.
	self picture center: self center.
	self addMorph: self picture.
	self picture hide! !

!MemoryTile methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 00:58'!
initTextBox
	| |
	self textBox: StringMorph new.
	self textBox fontName: 'BitstreamVeraSans' size: 36.
	self textBox contents: 'Test'.
	self textBox lock.
	self addMorph: self textBox.

"	
	x := 2 random.
	x = 1
		ifTrue: [self textBox heading: -45]
		ifFalse: [self textBox heading: 45]

	self textBox heading: -45.
"! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
picture
	^ picture! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
picture: anImage 
	picture := anImage! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: 'Aayush 4/9/2008 15:09'!
setAlpha: aFloat 
	| aMorph aValue aColor |
	aMorph := self renderedMorph.
	(aColor := aMorph color) isColor
		ifTrue: 
		[
			aValue := (aFloat / 100 max: 0) min: 1.
			aMorph
				color: (Color
						r: aColor red
						g: aColor green
						b: aColor blue
						alpha: aValue)
		]! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
showText
	^ showText! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
showText: aBoolean 
	showText := aBoolean! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: ''!
stepTime
	^ 10! !

!MemoryTile methodsFor: 'as yet unclassified' stamp: 'Aayush 4/14/2008 17:10'!
step
	self getAlpha > 0
	ifTrue: 
	[
		self setAlpha: self getAlpha - 10
	]
	ifFalse: 
	[
		self stopStepping.
		self setAlpha: 100.
		
		self showText = true ifTrue: 
		[
			self textBox visible = true ifTrue: 
			[
				self textBox hide.
				(self owner) noOfTilesOpen > 0 ifTrue:
				[
					(self owner) noOfTilesOpen: (self owner) noOfTilesOpen -1.
					(self owner) noOfTilesOpen = 0 ifTrue:
					[
						(self owner) processTileClickEvent: true.
						(self owner) currentOpen:0.
						(self owner) previousOpen:0.
					]
				]
			]
			ifFalse: 
			[
				self textBox show.
				(self owner) noOfTilesOpen = 1 ifTrue:
				[
					(self owner) processTileClickEvent: true.
				]
			]
		]
		ifFalse: 
		[
			(self picture) visible = true ifTrue: 
			[
				(self picture) hide.
				(self owner) noOfTilesOpen > 0 ifTrue:
				[
					(self owner) noOfTilesOpen: (self owner) noOfTilesOpen -1.
					(self owner) noOfTilesOpen = 0 ifTrue:
					[
						(self owner) processTileClickEvent: true.
						(self owner) currentOpen:0.
						(self owner) previousOpen:0.
					]
				]
			]
			ifFalse: 
			[
				(self picture) show.
				(self owner) noOfTilesOpen = 1 ifTrue:
				[
					(self owner) processTileClickEvent: true.
				]
			]
		].
		
		(self owner) noOfTilesOpen = 2 ifTrue:
		[
			World displayWorldSafely.
			(Delay forMilliseconds: 800) wait.
			(self owner) checkAnswer = true ifTrue:
			[				
				(self owner) processTileClickEvent: true.

				(self owner) pairMatched: (self owner) pairMatched + 1.
				(self owner) pairMatched = 15 ifTrue:
				[
					(self owner) gameRunning: false.
					(self owner) timer player timeUp.
				].

				((self owner) magicStarIndex = (self owner) currentOpen or: [ (self owner) magicStarIndex = (self owner) 				previousOpen]) ifTrue:
				[
					(self owner) showingAll: true.
					(self owner) showAll.
					(self owner) processTileClickEvent:false.
				].

				( (self owner) tiles at: ((self owner) currentOpen) ) hide.
				( (self owner) tiles at: ((self owner) previousOpen) ) hide.
				(self owner) currentOpen:0.
				(self owner) previousOpen:0.
				(self owner) noOfTilesOpen:0.
			]
			ifFalse:
			[
				( (self owner) tiles at: ((self owner) currentOpen) ) startStepping.
				( (self owner) tiles at: ((self owner) previousOpen) ) startStepping.
				(self owner) currentOpen:0.
				(self owner) previousOpen:0.
			]
		]
	]! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
textBox
	^ textBox! !

!MemoryTile methodsFor: 'accessing - properties' stamp: ''!
textBox: aUserText 
	textBox := aUserText! !

RectangleMorph subclass: #MyPicWordExt
	instanceVariableNames: 'questionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:50'!
addMajorQuesion: questionWithSound minor: aQuestion
	| p1 |
	p1:= Dictionary new.
	p1 at:'major' put: questionWithSound.
	p1 at:'minor' put: aQuestion.
	questionList add: p1.
^ self! !

!MyPicWordExt methodsFor: 'initialization' stamp: 'Ram 1/31/2008 17:09'!
initialize
	super initialize.
	questionList:= OrderedCollection new.! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:09'!
majorQuestionAt: aIndex
	
	| question majorQuestion |
	question:= questionList at: aIndex.
	majorQuestion:= question at: 'major'.
	^majorQuestion! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:10'!
minorQuestionAt: aIndex
	
	| question minorQuestion |
	question:= questionList at: aIndex.
	minorQuestion:= question at: 'minor'.
	^minorQuestion! !

!MyPicWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 17:09'!
prepareQuesion
	questionList:= OrderedCollection new.
	! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:08'!
questionList
	"Answer the value of questionList"

	^ questionList! !

!MyPicWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 17:08'!
questionList: anObject
	"Set the value of questionList"

	questionList _ anObject! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum minSum haveMadeMistake score total level difficulty lastAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

NumberGame subclass: #MultiplyGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame class methodsFor: 'game' stamp: 'lg 10/12/2007 12:50'!
beginGame
	World allMorphsDo: [ :m | (m isKindOf: NumberGame) ifTrue: [m beginGame] ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:42'!
answer: n
	lastAnswer := n.
	n = self getGameValue ifTrue: [self win: n] ifFalse: [self lose].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/24/2007 09:58'!
beginGame
	ActiveWorld cleanUpReferences.
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m resetObjectSequence]].
	self setLevel: 1.
	self setScore: 0.
	World selectMorphs: #isGameChoice do: #show.
	self setTotal: -1. "XXX cheesy"
	self newGame.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:10'!
chooseObject
	World allMorphsDo: [ :m | (m isKindOf: ObjectSetMorph) ifTrue: [m installNewTallyMorph ]].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:38'!
difficulty: d
	difficulty := d.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:34'!
displayAnswer: n
	[ World selectKind: AnswerViewMorph do: [ :m | m contents: n asString. m show. (Delay forSeconds: 2) wait ]] fork.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 12/5/2007 12:08'!
displayMood: mood
	"["GameFeedbackMorph showState: mood.
	 (mood = #happy) ifTrue: [World selectKind: AnswerViewMorph do: [:m | m contents: lastAnswer asString; show]].
	World doOneCycleNow.
	 (Delay forSeconds: 2) wait.
	 GameFeedbackMorph showState: #neutral.
	 World selectKind: AnswerViewMorph do: #hide
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:19'!
endGame
	self beep: 'byebye'.
	World selectMorphs: #isGameChoice do: #hide.
	World selectMorphs: #isGameInput do: [ :m | m setGameValue: 0 ].! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:33'!
gameChoices
	^World allMorphs select: #isGameChoice.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/8/2007 17:06'!
increaseInputs
	| used seed |
	used := minValue * self gameInputs size.
	seed := ((minSum to: maxSum) - used) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/9/2007 09:07'!
initialize
	super initialize.
	self beginGame.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 14:45'!
lose
	self beep: 'wrong3'. self displayMood: #sad; mistake.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 14:03'!
mistake
	haveMadeMistake := true.
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 14:02'!
newGame
	haveMadeMistake := false.
	self setTotal: total + 1; resetInputs; increaseInputs; updateChoices.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
score
	self setScore: score + 1.
	(score \\ 10) = 0 ifTrue: [self setLevel: 1 + (score / 10)].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 13:33'!
setLevel: n
	level := n.
	World selectMorphs: #isGameLevel do: [:morph | morph contents: level asString].
	self chooseObject.
	difficulty = #easy
		ifTrue:
		[n = 1 ifTrue: [minValue := 1. minSum :=2. maxSum := 4].
		 n = 2 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 3 ifTrue: [minValue := 1. minSum := 2. maxSum := 8].
		 n = 4 ifTrue: [minValue := 0. minSum := 2. maxSum := 9].
		 n > 4 ifTrue: [self endGame] ]
		ifFalse:
		[n = 1 ifTrue: [minValue := 1. minSum := 2. maxSum := 6].
		 n = 2 ifTrue: [minValue := 0. minSum := 0. maxSum := 9].
		 n = 3 ifTrue: [minValue := 0. minSum := 9. maxSum := 15].
		 n = 4 ifTrue: [minValue := 0. minSum := 12. maxSum := 20].
		 n > 4 ifTrue: [self endGame] ].

! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 12:55'!
setScore: n
	score := n.
	World selectMorphs: #isGameScore do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/13/2007 13:52'!
setTotal: n
	total := n.
	World selectMorphs: #isGameTotal do: [ :morph | morph setGameValue: score].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/2/2007 15:33'!
updateChoices
	| choices correct answers results stream |
	choices := self gameChoices.
	correct := self getGameValue.
	answers := (minValue to: maxSum) asArray shuffled reject: [ :x | x == correct]. 
	stream := answers readStream.
	results := OrderedCollection new.
	(choices size - 1) timesRepeat: [ results add: stream next ].
	results add: correct.
	results := results shuffled.
	stream := results readStream.
	choices do: [ :choice | choice setGameValue: stream next ].! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 18:57'!
win: n
	((n < 22) or: [n = 77]) ifTrue: [self beep: n asString] ifFalse: [self beep: 'right1'].
	self displayAnswer: n.
	haveMadeMistake ifFalse: [self score].
	self displayMood: #happy.
	self newGame.
! !

NumberGame subclass: #QuestionNumberGame
	instanceVariableNames: 'questions question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionNumberGame class methodsFor: 'game' stamp: 'lg 10/14/2007 16:01'!
readQuestion
	World selectKind: self do: #readQuestion.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:00'!
answer
	^question valueOfProperty: #answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:19'!
beginGame
	questions := (World allMorphs detect: [ :m | m isKindOf: QuestionSetMorph ]) questions.
	super beginGame.
! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 14:04'!
getGameValue
	^self answer.! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 17:59'!
newGame
	total := total + 1.
	question ifNotNil: [question delete].
	questions atEnd ifTrue: [ ^self endGame ].
	question := questions next.
	World addMorph: question.
	question position: 75@125.
	question lock.
	haveMadeMistake := false.
	self setupChoicesForQuestion.! !

!QuestionNumberGame methodsFor: 'game' stamp: 'lg 10/14/2007 16:04'!
readQuestion
	self beep: (question valueOfProperty: #questionSound).! !

!QuestionNumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 10:32'!
setupChoicesForQuestion
	| choices answers rightAnswer |
	choices := self gameChoices shuffled readStream.
	choices atEnd ifTrue: [^self].
	rightAnswer := question valueOfProperty: #answer.
	answers := ((rightAnswer // 2 to: rightAnswer * 2) asOrderedCollection remove: rightAnswer; yourself) shuffled readStream.
	choices next setGameValue: rightAnswer.
	[choices atEnd] whileFalse: [ choices next setGameValue: answers next ].! !

RectangleMorph subclass: #ObjectiveQuestionGame
	instanceVariableNames: 'objectiveQuestionList gameTitle question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:30'!
addQuestion: aQuestion

	objectiveQuestionList add: aQuestion.! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 16:54'!
answerAt: aIndex
	^question correctAns! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:30'!
clearQuestionList
	objectiveQuestionList := OrderedCollection new.! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:31'!
gameTitle
	"Answer the value of gameTitle"

	^ gameTitle! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:31'!
gameTitle: anObject
	"Set the value of gameTitle"

	gameTitle _ anObject! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:28'!
objectiveQuestionList
	"Answer the value of objectiveQuestionList"

	^ objectiveQuestionList! !

!ObjectiveQuestionGame methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:28'!
objectiveQuestionList: anObject
	"Set the value of objectiveQuestionList"

	objectiveQuestionList _ anObject! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 15:25'!
questionAt: aIndex
	 question:=(objectiveQuestionList at: aIndex asInteger).
	^question! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/31/2008 12:44'!
questionOptionSize
	 ^question isNil ifFalse:[ question optionList size].
! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:38'!
questionOption
	 ^question isNil ifFalse:[ question optionList].
! !

!ObjectiveQuestionGame methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 15:03'!
totalQuestion
	^objectiveQuestionList size.! !

RectangleMorph subclass: #OleActionVerb
	instanceVariableNames: 'verbList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:16'!
addVerb: verb
	verbList add: verb.! !

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:44'!
clearVerbList
	verbList:= OrderedCollection new! !

!OleActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 3/19/2008 11:16'!
verbAt: aIndex
	^verbList at: aIndex! !

!OleActionVerb methodsFor: 'accessing' stamp: 'Ram 3/19/2008 11:14'!
verbList
	"Answer the value of verbList"

	^ verbList! !

!OleActionVerb methodsFor: 'accessing' stamp: 'Ram 3/19/2008 11:14'!
verbList: anObject
	"Set the value of verbList"

	verbList _ anObject! !

RectangleMorph subclass: #RectangleText
	instanceVariableNames: 'tMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RectangleText methodsFor: 'accessing' stamp: 'Ram 4/7/2008 16:44'!
getCharacter
	tMorph getCharacters.! !

!RectangleText methodsFor: 'as yet unclassified' stamp: 'Ram 4/7/2008 17:48'!
handlesMouseDown: evt
	^true! !

!RectangleText methodsFor: 'as yet unclassified' stamp: 'Ram 4/8/2008 09:57'!
handlesMouseOver: evt 
	^true.! !

!RectangleText methodsFor: 'as yet unclassified' stamp: 'Ram 4/7/2008 16:45'!
initialize
	super initialize.
	tMorph:= InputFieldMorph new.
	self addMorph: tMorph.
	tMorph borderWidth:0;
		beAllFont: (StrikeFont familyName: 'BitStreamVeraSans' size: 40);
		center: self center;
		setCharacters:'A';
		centered.! !

!RectangleText methodsFor: 'as yet unclassified' stamp: 'Ram 4/7/2008 17:48'!
mouseDown: evt
	Transcript show: 'down';cr.! !

!RectangleText methodsFor: 'as yet unclassified' stamp: 'Ram 4/7/2008 17:50'!
mouseOver: evt
	self color: Color white.
	Transcript show:'sdfsdf'! !

!RectangleText methodsFor: 'accessing' stamp: 'Ram 4/7/2008 16:34'!
setCharacter: aChar
	tMorph setCharacters: aChar.! !

!RectangleText methodsFor: 'accessing' stamp: 'Ram 4/7/2008 16:27'!
tMorph
	"Answer the value of tMorph"

	^ tMorph! !

!RectangleText methodsFor: 'accessing' stamp: 'Ram 4/7/2008 16:27'!
tMorph: anObject
	"Set the value of tMorph"

	tMorph _ anObject! !

RectangleMorph subclass: #SetsGame
	instanceVariableNames: 'currentStage colDisplayGrid inputSensor answer answerStage1 imgQusNo1 imgQusNo2 displayGrid displayGridP gridHeadingR gridHeadingC gridValueC gridValueR cellValue currentQuestion ansDisplay qusDisplay qusNoDisplay btnNext imgQusNoId ansSelected moveImgQusNo2 questionSet qusRemainInSet imgRowInfo imgColInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-SetsTabularActivity'!

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/27/2008 12:33'!
addAns
	[self qusRemainInSet size > 0] whileTrue:
	[
		(self qusRemainInSet) removeAt:1	
	].

"--------------------1--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------2--------------------"
	(self answer) add: 'LMFS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'DMFS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'SBMNS'.
"--------------------3--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------4--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
"--------------------5--------------------"
	(self answer) add: 'DMFS'.
	(self answer) add: 'LMFS'.
	(self answer) add: 'SBMFS'.
	(self answer) add: 'DMIS'.
	(self answer) add: 'LMIS'.
	(self answer) add: 'SBMIS'.
	(self answer) add: 'DMNS'.
	(self answer) add: 'LMNS'.
	(self answer) add: 'SBMNS'.
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
ansDisplay
	^ansDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
ansDisplay: anImageMorph
	ansDisplay:= anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 13:12'!
ansSelected
	^ansSelected! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 13:13'!
ansSelected: aMatrix
	ansSelected:= aMatrix! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:05'!
answer
	^answer! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:05'!
answer: anArray
	answer := anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:44'!
btnNext
	^btnNext! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:44'!
btnNext: anImageMorph
	btnNext:= anImageMorph.! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:18'!
cellValue
	^cellValue! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:18'!
cellValue: aString
	cellValue := aString! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 6/3/2008 15:37'!
changeColRowInfoImage
	| tCenter |
	tCenter:= self imgColInfo center.
	(self imgColInfo) center: (self imgRowInfo) center.
	(self imgRowInfo) center: tCenter.
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 6/3/2008 15:38'!
changeHeadingImage
	| t1 x count |

	self swapGridValue.
	self randGridValuePosition.
	t1 := 'Heading-'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString beginsWith: t1])
				ifTrue: [
		x := (t2 externalName asString) subStrings:'-'.
		x := x at:2.

		count := 2.
		[
			(self gridValueR at:count) = x ifTrue:
			[
				(self gridHeadingR at:(count-1)) wearCostume: t2.
				(self gridHeadingR at:(count-1)) center: (self displayGrid at:count at:1) center.
			]
			ifFalse:
			[
				(self gridValueC at:count) = x ifTrue:
				[
					(self gridHeadingC at:(count-1)) wearCostume: t2.
					(self gridHeadingC at:(count-1)) center: (self displayGrid at:1 at:count) center.
				]
			].
			count := count +1.
			count <=4.				
		]whileTrue.
]].

self changeColRowInfoImage.! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/26/2008 10:56'!
changeQuestionImage: qusNo
	| t1 t3 |
	self currentStage = 2 ifTrue:
	[
		t1 := 'question-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								(self qusDisplay dispImage) wearCostume: t2.
								(self qusDisplay dispImage) center: (self qusDisplay center).
							]
			]
	]
	ifFalse:
	[
		t1 := 'discription-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								(self qusDisplay dispImage) wearCostume: t2.
								(self qusDisplay dispImage) center: (self qusDisplay center).
							]
			]
	]! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/29/2008 09:57'!
changeQusNoImage: qusNo
	| t1 t3 |
	self currentStage = 2 ifTrue:
	[
		t1 := 'circle-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								((self qusNoDisplay) dispImage) wearCostume: t2.
								((self qusNoDisplay) dispImage) center: ((self qusNoDisplay) center).
								self imgQusNo2 wearCostume: t2.
								self imgQusNo2 center:((self qusNoDisplay) dispImage) center.
							]
		]
	]
	ifFalse:
	[
		t1 := 'discCellPos-'.
		t3 := t1,(qusNo asString).
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t3])
					ifTrue: [
								((self qusNoDisplay) dispImage) wearCostume: t2.
								((self qusNoDisplay) dispImage) center: ((self qusNoDisplay) center).
								self imgQusNo2 wearCostume: t2.
								self imgQusNo2 center:((self qusNoDisplay) dispImage) center.
							]
		]
	]! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/19/2008 10:05'!
checkAnswer
	| arr x y z1 z2 ans |
	arr := self cellValue subStrings: ':'.
	x := arr at:1.
	y := arr at:2.
	z1 := x,y.
	z2 := y,x.
	ans := self answer at: self currentQuestion.

	( ans  = z1  or: [ ans = z2] ) ifTrue:
	[
		^true.
	]
	ifFalse:
	[
		^false.
	].	
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/18/2008 09:19'!
colDisplayGrid
	^colDisplayGrid! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/18/2008 09:43'!
colDisplayGrid: aColor
	colDisplayGrid:=aColor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 15:04'!
currentQuestion
	^currentQuestion! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 15:04'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/26/2008 10:41'!
currentStage
	^currentStage! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/26/2008 10:42'!
currentStage: aNumber
	currentStage:= aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/22/2008 11:36'!
displayGridP
	^displayGridP! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/22/2008 11:37'!
displayGridP: aMatrix
	displayGridP:= aMatrix! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/15/2008 16:52'!
displayGrid
	^displayGrid! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/15/2008 16:53'!
displayGrid: aMatrix
	displayGrid := aMatrix! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/19/2008 09:38'!
getCellValueRow:r Col:c
	self cellValue: (self gridValueR at:r),':', (self gridValueC at:c).

! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:25'!
gridHeadingC
	^gridHeadingC! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:27'!
gridHeadingC: anArray
	gridHeadingC :=  anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridHeadingR
	^gridHeadingR! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridHeadingR: anArray
	gridHeadingR :=  anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:28'!
gridValueC
	^gridValueC! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:29'!
gridValueC: anArray
	gridValueC:= anArray! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:29'!
gridValueR
	^gridValueR! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:30'!
gridValueR: anArray
	gridValueR:= anArray! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/23/2008 11:19'!
hideAnsSelected
	self ansDisplay hide.
! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/22/2008 15:40'!
hideAnswer
	| row col |
	row:=1.
	[
		col:=1.
		[
			(self displayGridP at:row at: col) hide.
			col := col +1.
			col <=3.
		]whileTrue.	

		row := row + 1.
		row <=3
	]whileTrue.

! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/29/2008 12:07'!
highLightDisplayGridRow:r Col:c
	| col row |
	col := 1.
	[
		(self displayGrid at:r at:col) color: (Color r:0.6 g:0.7 b:0.8). 
		col := col + 1.
		col <= 4
	]whileTrue.

	row := 1.
	[
		(self displayGrid at:row at:c) color: (Color r:0.6 g:0.7 b:0.8). 
		row := row + 1.
		row <= 4
	]whileTrue.

	(self displayGrid at:r at:c) color: (Color r:0.5 g:0.6 b:0.7). 
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgColInfo
	^imgColInfo! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgColInfo: aImageMorph
	imgColInfo:= aImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:55'!
imgQusNo1
	^imgQusNo1! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:56'!
imgQusNo1: anImageMorph
	imgQusNo1:=anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:55'!
imgQusNo2
	^imgQusNo2! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/19/2008 03:56'!
imgQusNo2: anImageMorph
	imgQusNo2:=anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:59'!
imgQusNoId
	^imgQusNoId! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 12:59'!
imgQusNoId: aNumber
	imgQusNoId:=aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:15'!
imgRowInfo
	^imgRowInfo! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 6/3/2008 14:16'!
imgRowInfo: aImageMorph
	imgRowInfo:= aImageMorph! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 12:51'!
initAnswer
	self answer: OrderedCollection new.
	self addAns.
	self ansSelected: (Matrix rows:4 columns:4).

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:39'!
initCostume
	| t1 |
	t1 := 'box'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self qusDisplay wearCostume: t2.
			self ansDisplay wearCostume: t2.
		]
	].

	t1 := 'box-small'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self qusNoDisplay) wearCostume: t2.
		]
	].

	t1 := 'type'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self imgRowInfo) wearCostume: t2.
		]
	].

	t1 := 'method'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			(self imgColInfo) wearCostume: t2.
		]
	].

	t1 := 'btn_next'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnNext wearCostume: t2.
		]
	].

	self changeQuestionImage:1.
	self changeQusNoImage:1.
	self changeHeadingImage.

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/23/2008 11:30'!
initDisplayGridP
	| col row |
	self displayGridP: (Matrix rows:3 columns:3).
	row := 1.
	[
		col := 1.
		[
			(self displayGridP) at:row at:col put: (ImageMorph new).	
			((self displayGridP) at:row at:col) on:#mouseEnter send:#showAnsSelected:V2:V3: to:self withValue:((row+1) asString, '-', (col+1) asString).
			((self displayGridP) at:row at:col) on:#mouseLeave send:#hideAnsSelected to:self.
			((self displayGridP) at:row at:col) openInWorld.
			((self displayGridP) at:row at:col) hide.
			self addMorph: ((self displayGridP) at:row at:col).	
			((self displayGridP) at:row at:col) center: (self displayGrid at:(row+1) at:(col+1)) center.

			col := col + 1.
			col <= 3.
		]whileTrue.		

		row := row + 1.	
		row <= 3
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/26/2008 15:35'!
initDisplayGrid
	| row col x y |
	x := 0.
	y := 0.
	self displayGrid: (Matrix rows:4 columns:4).

	row := 1.
	[
		col := 1.
		[
			(row =1 and: [ col = 1]) ifFalse:
			[			
				(self displayGrid) at:row at:col put: (RectangleMorph new).	
				((self displayGrid) at:row at:col) width: 200.
				((self displayGrid) at:row at:col) height: 100.
				((self displayGrid) at:row at:col) left:x.
				((self displayGrid) at:row at:col) top:y.
				self addMorph: ((self displayGrid) at:row at:col).	
			].
			x  := x + 200.
			col := col + 1.
			col <= 4.
		]whileTrue.		

		x := 0.
		y := y + 100.
		row := row + 1.	
		row <= 4
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/19/2008 03:31'!
initGridHeading
	| count |
	self gridHeadingR: (Array new:3).	
	self gridHeadingC: (Array new:3).	
	count := 1.
	[
		(self gridHeadingR) at:count put:(ImageMorph new).
		self addMorph: ((self gridHeadingR) at:count).
		((self gridHeadingR) at:count) center: (self displayGrid at:(count + 1) at:1) center.

		(self gridHeadingC) at:count put:(ImageMorph new).
		self addMorph: ((self gridHeadingC) at:count).
		((self gridHeadingC) at:count ) center: (self displayGrid at:1 at:(count + 1)) center.

		count := count + 1.
		count <= 3.
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/19/2008 12:11'!
initGridValue
	self gridValueR: (Array withAll: #('empty' 'DM' 'LM' 'SBM')).
	self gridValueC: (Array withAll: #('empty' 'FS' 'IS' 'NS')).

	! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:20'!
initImgColRowInfo
	self imgColInfo: ImageMorph new.
	self imgRowInfo: ImageMorph new.
	self addMorph:(self imgRowInfo).
	self addMorph:(self imgColInfo).
! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 6/3/2008 14:36'!
initialize
	super initialize.
	self inputSensor: InputSensor new.
	self width:800.
	self height:400.
	self color: (Color r:0.5 g:0.5 b:0.5).
	self initDisplayGrid.
	self initDisplayGridP.
	self initGridHeading.
	self initImgColRowInfo.
	self qusRemainInSet: (OrderedCollection new).

	self colDisplayGrid: (self displayGrid at:2 at:2) color.
	
	self initGridValue.
	self initAnswer.

	self initQusImage.
	self reset.

! !

!SetsGame methodsFor: 'Initialization' stamp: 'Aayush 5/29/2008 09:41'!
initQusImage
	self qusDisplay: DisplayBoard new.
	self qusDisplay openInWorld.
	self qusDisplay left:300.
	self qusDisplay top:500.

	self qusNoDisplay: DisplayBoard new.
	self qusNoDisplay openInWorld.
	self qusNoDisplay left:0.
	self qusNoDisplay top:500.
	
	self ansDisplay: DisplayBoard new.
	self ansDisplay openInWorld.
	self ansDisplay left:800.
	self ansDisplay top:300.
	self ansDisplay hide.

	self btnNext: ImageMorph new.
	self btnNext on:#mouseDown send:#nextClick to:self.
	self btnNext openInWorld.
	self btnNext left:800.
	self btnNext top:700.
	self btnNext hide.

	self imgQusNo2: ImageMorph new.
	self imgQusNo2 openInWorld.
	self imgQusNo2 comeToFront.
	self imgQusNo2 left:0.
	self imgQusNo2 top:500.
	self imgQusNo2 on:#mouseUp send:#toggleMoveImgQusNo2 to:self.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 10:49'!
initQusRemainInSet: setNumber

	| count x siz |

	x := (setNumber*9)-8.
	siz :=(self qusRemainInSet) size.
	siz > 0 ifTrue:
	[
		[
			self qusRemainInSet removeAt:1.
			siz :=(self qusRemainInSet) size.

			siz > 0
		]whileTrue.
	].

	count:= 1.
	[
		self qusRemainInSet add:x.
		x := x + 1.

		count := count + 1.
		count <= 9
	]whileTrue.

	! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 17:19'!
inputSensor
	^inputSensor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'a 5/16/2008 17:19'!
inputSensor: aninputSensor
	inputSensor := aninputSensor! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 15:25'!
moveImgQusNo2
	^moveImgQusNo2! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 15:26'!
moveImgQusNo2: aBoolean
	moveImgQusNo2:=aBoolean! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/29/2008 11:15'!
nextClick
	| y q |
	self btnNext hide.
	self changeHeadingImage.
	self hideAnswer.
	self imgQusNo2 show.
	self qusDisplay show.
	self qusNoDisplay show.


	self currentStage = 1 ifTrue:
	[
		self currentStage: self currentStage + 1.
		self imgQusNoId:1.
		self questionSet: 1.
	]
	ifFalse:
	[
		self questionSet: self questionSet + 1.
		self questionSet > 5 ifTrue:
		[
			self imgQusNoId:1.
			self questionSet: 1.
		]
	].
	self initQusRemainInSet: self questionSet.


	y := ((self qusRemainInSet) size) random.
	q := (self qusRemainInSet) at:y.
	self currentQuestion:q.

	self changeQuestionImage:q.
	(self qusRemainInSet) removeAt:y.

	self changeQusNoImage:self imgQusNoId.
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:44'!
questionSet
	^questionSet! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:45'!
questionSet: aNumber
	questionSet:= aNumber! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
qusDisplay
	^qusDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/23/2008 10:30'!
qusDisplay: anImageMorph
	qusDisplay:= anImageMorph! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/29/2008 09:38'!
qusNoDisplay
	^qusNoDisplay! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'Aayush 5/29/2008 09:38'!
qusNoDisplay: aDispalyBoard
	qusNoDisplay := aDispalyBoard.! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:49'!
qusRemainInSet
	^qusRemainInSet
! !

!SetsGame methodsFor: 'Accessing - Properties' stamp: 'A 5/26/2008 16:50'!
qusRemainInSet: aList
	qusRemainInSet:= aList.
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/22/2008 13:53'!
randGridValuePosition
	| count tmpArr1 tmpArr2 list1 list2 x1 y1 x2 y2 |

	tmpArr1 := Array new:3.
	tmpArr2 := Array new:3.

	list1 := OrderedCollection new.
	list1 addAll: #(1 2 3).

	list2 := OrderedCollection new.
	list2 addAll: #(1 2 3).

	count:=2.
	[
		x1 := (list1 size) random.
		y1 := list1 at:x1.
		tmpArr1 at:y1 put: (self gridValueR at:count). 
		list1 removeAt:x1.

		x2 := (list2 size) random.
		y2 := list2 at:x2.
		tmpArr2 at:y2 put: (self gridValueC at:count). 
		list2 removeAt:x2.

		count := count + 1.
		count <=4
	]whileTrue.

	count:=2.
	[
		self gridValueR at:count put: (tmpArr1 at:(count-1)).
		self gridValueC at:count put: (tmpArr2 at:(count-1)).

		count := count +1.
		count <=4
	]whileTrue.
! !

!SetsGame methodsFor: 'Display-Grid' stamp: 'Aayush 5/18/2008 09:40'!
resetDisplayGridColor
	| row col |
	row := 1.
	[	
		col := 1.
		[
			(row = 1 and: [ col= 1]) ifFalse:
			[
				(self displayGrid at:row at:col) color: (self colDisplayGrid).
			].

			col := col + 1.
			col <= 4
		]whileTrue.

		row := row + 1.
		row <= 4
	]whileTrue.
! !

!SetsGame methodsFor: 'Initialization' stamp: 'A 5/27/2008 10:58'!
reset
	| |
	self currentQuestion: 1.
	self imgQusNoId:1.
	self currentStage:1.
	self moveImgQusNo2:0.
	self questionSet:1.
	self initQusRemainInSet:1.
	self qusRemainInSet removeAt:1.
	self btnNext hide.

	self cellValue: ''.
	self hideAnswer.	
	self initCostume.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/26/2008 14:15'!
showAnsSelected:x V2:y V3:z
	| arr row col t1 |
	self currentStage = 2 ifTrue:
	[
		arr:= x subStrings: '-'.
		row:=(arr at:1) asInteger.
		col:=(arr at:2) asInteger.

		t1 := 'question-', (self ansSelected at:row at:col) asString.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				((self ansDisplay) dispImage) wearCostume: t2.
			]
		].

		(self ansDisplay) center: (self displayGrid at:row at:col) center.
		((self ansDisplay) dispImage) center: (self ansDisplay) center.

		self ansDisplay top: self ansDisplay top + 150.
		self ansDisplay show.
		self ansDisplay comeToFront.
	]
	ifFalse:
	[
		arr:= x subStrings: '-'.
		row:=(arr at:1) asInteger.
		col:=(arr at:2) asInteger.

		t1 := 'discription-', (self ansSelected at:row at:col) asString.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				((self ansDisplay) dispImage) wearCostume: t2.
			]
		].

		(self ansDisplay) center: (self displayGrid at:row at:col) center.
		((self ansDisplay) dispImage) center: (self ansDisplay) center.

		self ansDisplay top: self ansDisplay top + 115.
		self ansDisplay show.
		self ansDisplay comeToFront.
	]
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/22/2008 16:18'!
stepTime
	^250.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 5/29/2008 12:16'!
step
	| row col none y q |

	none := true.
	row := 2.
	[	
		col := 2.
		[
			((self inputSensor cursorPoint) > (((self displayGrid at:row at:col) topLeft) + (30@11)) 
			and: [ (self inputSensor cursorPoint) < (((self displayGrid at:row at:col) bottomRight) + (30@11)) ]) ifTrue:
			[
				self resetDisplayGridColor.
				self highLightDisplayGridRow:row Col:col.
				self getCellValueRow:row Col:col.
				none := false.
			
				self moveImgQusNo2 = 2 ifTrue:
				[
					self moveImgQusNo2:0. 

					self checkAnswer ifTrue:
					[
						SoundService default playSoundNamedOrBeep: 'right1'.

						self imgQusNo2 center: ((self qusNoDisplay) dispImage) center.
						(self displayGridP at:(row-1) at:(col-1)) wearCostume: self imgQusNo2.
						(self displayGridP at:(row-1) at:(col-1)) center: (self displayGrid at:row at:col) center.		
						(self displayGridP at:(row-1) at:(col-1)) show.

						self ansSelected at:row at:col put:(self currentQuestion).
	
						self imgQusNoId: self imgQusNoId + 1.
						self imgQusNoId > 9 ifTrue:
						[
							self imgQusNoId:1.
							self btnNext show.
							self imgQusNo2 hide.
							self qusDisplay hide.
							self qusNoDisplay hide.
						]
						ifFalse:
						[	
							y := ((self qusRemainInSet) size) random.
							q := (self qusRemainInSet) at:y.
							self currentQuestion:q.

							self changeQuestionImage:q.
							(self qusRemainInSet) removeAt:y.

							self currentStage = 2 ifTrue:
							[
								self changeQusNoImage:self imgQusNoId.
							]
							ifFalse:
							[
								self changeQusNoImage:q.
							]
						]
					]
					ifFalse:
					[
						SoundService default playSoundNamedOrBeep: 'wrong3'.
					]
				].
			].


			col := col + 1.
			col <= 4
		]whileTrue.

		row := row + 1.
		row <= 4
	]whileTrue.	

	none = true ifTrue:
	[
		self resetDisplayGridColor.
		self cellValue: ''.
	].

	self moveImgQusNo2 = 1 ifTrue:
	[
		self imgQusNo2 center: ((self inputSensor cursorPoint) - (30@30)). 
	]
	ifFalse:
	[
			self imgQusNo2 center: ((self qusNoDisplay) dispImage) center. 
			self moveImgQusNo2:0.
	].
! !

!SetsGame methodsFor: 'Question-Generation' stamp: 'Aayush 5/22/2008 14:20'!
swapGridValue
	| count tmpArr |

	tmpArr := Array new:4.

	count:=1.
	[
		tmpArr at:count put: (self gridValueR at:count).

		count := count + 1.
		count <=4
	]whileTrue.
	
	count:=1.
	[
		self gridValueR at:count put: (self gridValueC at:count).

		count := count + 1.
		count <=4
	]whileTrue.

	count:=1.
	[
		self gridValueC at:count put: (tmpArr at:count).

		count := count + 1.
		count <=4
	]whileTrue.
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/3/2008 15:33'!
test
	self imgColInfo left: (self left +200 - (self imgColInfo width)).
	self imgColInfo top: (self top + 40).
	self imgRowInfo left: (self left + 75).
	self imgRowInfo top: (self top + 100 - (self imgColInfo height)).
! !

!SetsGame methodsFor: 'miscellaneous' stamp: 'A 5/26/2008 15:48'!
toggleMoveImgQusNo2
	self moveImgQusNo2 = 0 ifTrue:
	[
		self moveImgQusNo2: 1.
	]
	ifFalse:
	[
		self moveImgQusNo2 = 1 ifTrue:
		[
			self moveImgQusNo2: 2.
		]
	]! !

RectangleMorph subclass: #VariableDisplay
	instanceVariableNames: 'textMultiplier stringArraySize textReasult stringReasult stringArray1 stringArray2 lineArray plusSignArray1 plusSignArray2 equalSign1 equalSign2 equalSign3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-MoreVariablesActivity'!

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 12:05'!
equalSign1
	^equalSign1! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 12:06'!
equalSign1: aStringMorph
	equalSign1 := aStringMorph! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 12:05'!
equalSign2
	^equalSign2! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 12:06'!
equalSign2: aStringMorph 
	equalSign2 := aStringMorph! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:47'!
equalSign3
	^equalSign3! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:47'!
equalSign3: aStringMorph
	equalSign3 := aStringMorph! !

!VariableDisplay methodsFor: 'initialization' stamp: 'Aayush 7/24/2008 14:46'!
initialize
	super initialize.

	self stringArraySize: StringMorph new.
	self addMorph: self stringArraySize.
	self stringArraySize contents: '3'.

	self equalSign1: StringMorph new.
	self addMorph: self equalSign1.
	self equalSign1 contents: '='.
	(self equalSign1) fontName:'BitstreamVeraSans' size:'36'.

	self equalSign2: StringMorph new.
	self addMorph: self equalSign2.
	self equalSign2 contents: '='.
	(self equalSign2) fontName:'BitstreamVeraSans' size:'36'.

	self equalSign3: StringMorph new.
	self addMorph: self equalSign3.
	self equalSign3 contents: '='.
	(self equalSign3) fontName:'BitstreamVeraSans' size:'36'.

	self textMultiplier: MyTextMorph new.
	self addMorph: self textMultiplier.

	self textReasult: MyTextMorph new.
	self addMorph: self textReasult.

	self stringReasult: StringMorph new.
	self addMorph: self stringReasult.
	self stringReasult contents: '3x'.
 
	self stringArray1: OrderedCollection new.
	self stringArray2: OrderedCollection new.
	self lineArray: OrderedCollection new.
	self plusSignArray1: OrderedCollection new.
	self plusSignArray2: OrderedCollection new.

	self initPositionWithSize:3 variable:'y'.
	self showHideQuantity: false.
! !

!VariableDisplay methodsFor: 'initialization' stamp: 'Aayush 7/24/2008 15:33'!
initPositionWithSize:s variable:v
	
	| count left top top1 top2 |
	self removeAllMorphFromArray.

	left:= self left +10.

	count := 1.
	[ count <= s ] whileTrue:
	[
		top := self top + 10.

		self stringArray1 add: (StringMorph new).
		self addMorph: (self stringArray1 at:count).
		(self stringArray1 at:count) contents: v.
		(self stringArray1 at:count) left: left.
		(self stringArray1 at:count) top: top.
		(self stringArray1 at:count) fontName:'LucidaCalligraphy' size:'36'.

		top1 := (top + (self stringArray1 at:count) height + 10).		

		self stringArray2 add: (StringMorph new).
		self addMorph: (self stringArray2 at:count).
		(self stringArray2 at:count) contents: '12'.
		(self stringArray2 at:count) left: left.
		(self stringArray2 at:count) top: top1.
		(self stringArray2 at:count) fontName:'LucidaCalligraphy' size:'36'.

		top2 := (top1 + (self stringArray2 at:count) height + 2).		

		self lineArray add: (LineMorph new).
		self addMorph: (self lineArray at:count).
		(self lineArray at:count) verticesAt:1 put:(0@0).
		(self lineArray at:count) verticesAt:2 put:(25@0).
		(self lineArray at:count) left: left.
		(self lineArray at:count) top: top2.

		self plusSignArray1 add: (StringMorph new).
		self plusSignArray2 add: (StringMorph new).

		count ~= s ifTrue:
		[
			left:= left + (self stringArray2 at:count) width + 10.

			self addMorph: (self plusSignArray1 at:count).
			(self plusSignArray1 at:count) contents: '+'.
			(self plusSignArray1 at:count) left: left.
			(self plusSignArray1 at:count) top: top.
			(self plusSignArray1 at:count) fontName:'BitstreamVeraSans' size:'36'.

			self addMorph: (self plusSignArray2 at:count).
			(self plusSignArray2 at:count) contents: '+'.
			(self plusSignArray2 at:count) left: left.
			(self plusSignArray2 at:count) top: top1.
			(self plusSignArray2 at:count) fontName:'BitstreamVeraSans' size:'36'.

			left:= left + (self plusSignArray1 at:count) width + 10.
		]
		ifFalse:
		[
			left := left + (self stringArray2 at:count) width + 10.		
		].

		count:= count + 1.
	].		
	
	self equalSign1 left: left.
	self equalSign1 top: top.
	(self equalSign1) fontName:'BitstreamVeraSans' size:'36'.

	self equalSign2 left: left.
	self equalSign2 top: top1.
	(self equalSign2) fontName:'BitstreamVeraSans' size:'36'.

	top2 := top2 + self textReasult height.

	self equalSign3 left: left.
	self equalSign3 top: top2.
	(self equalSign2) fontName:'BitstreamVeraSans' size:'36'.

	left := left + (self equalSign1) width + 10.

	self stringReasult contents: (s asString, ' X ').
	self stringReasult left: left.
	self stringReasult top: top.
	(self stringReasult) fontName:'BitstreamVeraSans' size:'36'.

	s > 1 ifTrue:
	[
		self stringArraySize contents: (s asString, ' X').
		self stringArraySize left: left.
		self stringArraySize top: top1.
		(self stringArraySize) fontName:'BitstreamVeraSans' size:'36'.
		left := left + self stringArraySize width + 10.
	].


	self stringArray1 add: (StringMorph new).
	self addMorph: (self stringArray1 at:count).
	(self stringArray1 at:count) contents: v.
	(self stringArray1 at:count) left: left.
	(self stringArray1 at:count) top: top.
	(self stringArray1 at:count) fontName:'LucidaCalligraphy' size:'36'.

	self textMultiplier setCharacters: ''.
	self textMultiplier left: left.
	self textMultiplier top: top1.

	self textReasult setCharacters: ''.
	self textReasult left: left.
	self textReasult top: top2.

	self width: (left + self textMultiplier width +20) - self left.
	self height: (top2 +  (self textReasult height) + 10 + 10 ) - self top.

	self showHideReasult:false.
	self showHideQuantity:false.


! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/19/2008 17:00'!
lineArray
	^lineArray! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/19/2008 17:00'!
lineArray: anOrderedCollection
	lineArray := anOrderedCollection! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:47'!
plusSignArray1  
	^plusSignArray1! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:47'!
plusSignArray1: anOrderedCollection
	plusSignArray1 := anOrderedCollection! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:48'!
plusSignArray2  
	^plusSignArray2! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:48'!
plusSignArray2: anOrderedCollection
	plusSignArray2 := anOrderedCollection! !

!VariableDisplay methodsFor: 'miscellaneous' stamp: 'Aayush 6/20/2008 16:01'!
removeAllMorphFromArray

	[ self lineArray size > 0 ] whileTrue:
	[
		self removeMorph: (self lineArray at:1).
		self lineArray removeFirst.

		self removeMorph: (self stringArray1 at:1).
		self stringArray1 removeFirst.

		self removeMorph: (self stringArray2 at:1).
		self stringArray2 removeFirst.

		self removeMorph: (self plusSignArray1 at:1).
		self plusSignArray1 removeFirst.

		self removeMorph: (self plusSignArray2 at:1).
		self plusSignArray2 removeFirst.
	].! !

!VariableDisplay methodsFor: 'miscellaneous' stamp: 'Aayush 7/1/2008 12:14'!
showHideQuantity: aBoolean

	| size count |
	size := self stringArray2 size.	
	count := 1.

	aBoolean ifTrue:
	[
		[ count <= size ] whileTrue:
		[
			(self stringArray2 at: count) show.
			count := count + 1.
		]
	]
	ifFalse:
	[
		[ count <= size] whileTrue:
		[
			(self stringArray2 at: count) hide.
			count := count + 1.
		]
	]! !

!VariableDisplay methodsFor: 'miscellaneous' stamp: 'Aayush 7/3/2008 14:23'!
showHideReasult:aBoolean

	aBoolean ifTrue:
	[
		(self equalSign3) show.
		self textReasult show.
	]
	ifFalse:
	[
		(self equalSign3) hide.
		self textReasult hide.
	]! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:04'!
stringArray1
	^stringArray1! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:04'!
stringArray1: anOrderedCollection
	stringArray1 := anOrderedCollection! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:05'!
stringArray2
	^stringArray2! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:05'!
stringArray2: anOrderedCollection
	stringArray2 := anOrderedCollection! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 09:08'!
stringArraySize
	^stringArraySize! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 09:08'!
stringArraySize: aStringMorph
	stringArraySize := aStringMorph! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:00'!
stringReasult
	^stringReasult! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 15:01'!
stringReasult: aStringMorph
	stringReasult := aStringMorph! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/19/2008 16:51'!
textMultiplier
	^textMultiplier! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 09:07'!
textMultiplier: myTextMorph
	textMultiplier := myTextMorph! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:59'!
textReasult
	^textReasult! !

!VariableDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 6/20/2008 14:59'!
textReasult: myTextMorph
	textReasult := myTextMorph! !

RectangleMorph subclass: #VariableDisplay2
	instanceVariableNames: 'stringArray1 stringArray2 plusSignArray1 plusSignArray2 lineArray equalSignArray signArray valueArray sizeArray textMultiplier textReasult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubtractVariableActivity'!

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:07'!
equalSignArray
	^equalSignArray! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:07'!
equalSignArray: anOrderedCollection
	equalSignArray := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'initialization' stamp: 'Aayush 7/24/2008 16:07'!
initialize
	super initialize.

	self stringArray1: OrderedCollection new.
	self stringArray2: OrderedCollection new.
	self lineArray: OrderedCollection new.
	self plusSignArray1: OrderedCollection new.
	self plusSignArray2: OrderedCollection new.

	self sizeArray: OrderedCollection new.

	self valueArray: OrderedCollection new.
	self valueArray add: (StringMorph new).
	self valueArray add: (StringMorph new).
	self valueArray add: (StringMorph new).
	self valueArray add: (StringMorph new).
	(self valueArray at:1) fontName: 'BitStreamVeraSans' size:36.
	(self valueArray at:2) fontName: 'BitStreamVeraSans' size:36.
	(self valueArray at:3) fontName: 'BitStreamVeraSans' size:36.
	(self valueArray at:4) fontName: 'BitStreamVeraSans' size:36.

	self signArray: OrderedCollection new.
	self signArray add: (StringMorph new).
	self signArray add: (StringMorph new).
	self signArray add: (StringMorph new).
	self signArray add: (StringMorph new).
	(self signArray at:1) fontName: 'BitStreamVeraSans' size:36.
	(self signArray at:2) fontName: 'BitStreamVeraSans' size:36.
	(self signArray at:3) fontName: 'BitStreamVeraSans' size:36.
	(self signArray at:4) fontName: 'BitStreamVeraSans' size:36.

	self equalSignArray: OrderedCollection new.
	self equalSignArray add: (StringMorph new).
	self equalSignArray add: (StringMorph new).
	self equalSignArray add: (StringMorph new).
	(self equalSignArray at:1) fontName: 'BitStreamVeraSans' size:36.
	(self equalSignArray at:2) fontName: 'BitStreamVeraSans' size:36.
	(self equalSignArray at:3) fontName: 'BitStreamVeraSans' size:36.

	self textMultiplier: MyTextMorph new.
	self textReasult: MyTextMorph new.

	self initPositionwithSize:1 Value:'13' Sign:'-' Variable:'m'.
! !

!VariableDisplay2 methodsFor: 'initialization' stamp: 'Aayush 7/28/2008 10:44'!
initPositionwithSize:size Value:value Sign:sign Variable:variable
	| count top left top1 top2 top3 |

	self removeAllMorphFromArray.

	left:= self left +10.
	count := 1.
	[ count <= size ] whileTrue:
	[
		top := self top + 10.

		self stringArray1 add: (StringMorph new).
		self addMorph: (self stringArray1 at:count).
		(self stringArray1 at:count) contents: variable.
		(self stringArray1 at:count) left: left.
		(self stringArray1 at:count) top: top.
		(self stringArray1 at:count) fontName:'LucidaCalligraphy' size:'36'.

		top1 := (top + (self stringArray1 at:count) height + 10).		

		self stringArray2 add: (StringMorph new).
		self addMorph: (self stringArray2 at:count).
		(self stringArray2 at:count) contents: '12'.
		(self stringArray2 at:count) left: left.
		(self stringArray2 at:count) top: top1.
		(self stringArray2 at:count) fontName:'LucidaCalligraphy' size:'36'.

		top2 := (top1 + (self stringArray2 at:count) height + 2).		

		self lineArray add: (LineMorph new).
		self addMorph: (self lineArray at:count).
		(self lineArray at:count) verticesAt:1 put:(0@0).
		(self lineArray at:count) verticesAt:2 put:(25@0).
		(self lineArray at:count) left: left.
		(self lineArray at:count) top: top2.

		self plusSignArray1 add: (StringMorph new).
		self plusSignArray2 add: (StringMorph new).
		(self plusSignArray1 at:count) fontName:'BitStreamVeraSans' size:'36'.
		(self plusSignArray2 at:count) fontName:'BitStreamVeraSans' size:'36'.

		count ~= size ifTrue:
		[
			left:= left + (self stringArray2 at:count) width + 10.

			self addMorph: (self plusSignArray1 at:count).
			(self plusSignArray1 at:count) contents: '+'.
			(self plusSignArray1 at:count) left: left.
			(self plusSignArray1 at:count) top: top.

			self addMorph: (self plusSignArray2 at:count).
			(self plusSignArray2 at:count) contents: '+'.
			(self plusSignArray2 at:count) left: left.
			(self plusSignArray2 at:count) top: top1.

			left:= left + (self plusSignArray1 at:count) width + 10.
		]
		ifFalse:
		[
			left := left + (self stringArray2 at:count) width + 10.		
		].

		count:= count + 1.
	].		

	(self signArray at:1) top:top.
	(self signArray at:1) left:left.
	(self signArray at:1) contents:sign.
	self addMorph: (self signArray at:1).

	(self signArray at:2) top:top1.
	(self signArray at:2) left:left.
	(self signArray at:2) contents:sign.
	self addMorph: (self signArray at:2).

	left := left + ((self signArray at:1) width) + 10.

	(self valueArray at:1) top:top.
	(self valueArray at:1) left:left.
	(self valueArray at:1) contents:value.
	self addMorph: (self valueArray at:1).

	(self valueArray at:2) top:top1.
	(self valueArray at:2) left:left.
	(self valueArray at:2) contents:value.
	self addMorph: (self valueArray at:2).

	left := left + ((self valueArray at:1) width) + 10.

	(self equalSignArray at:1) top:top.
	(self equalSignArray at:1) left:left.
	(self equalSignArray at:1) contents:'='.
	self addMorph: (self equalSignArray at:1).

	(self equalSignArray at:2) top:top1.
	(self equalSignArray at:2) left:left.
	(self equalSignArray at:2) contents:'='.
	self addMorph: (self equalSignArray at:2).

	top3 := top2 + 10.

	(self equalSignArray at:3) top:top3.
	(self equalSignArray at:3) left:left.
	(self equalSignArray at:3) contents:'='.
	self addMorph: (self equalSignArray at:3).
	(self equalSignArray at:3) hide.

	left := left + ((self equalSignArray at:1) width) + 10.

	self textReasult top:top3.
	self textReasult left:left.
	self textReasult setCharacters: ''.
	self addMorph: self textReasult.
	self textReasult hide.

	size > 1 ifTrue:
	[
		self sizeArray add: (StringMorph new).
		self addMorph: (self sizeArray at:1).
		(self sizeArray at:1) fontName: 'BitStreamVeraSans' size:36.

		self sizeArray add: (StringMorph new).
		self addMorph: (self sizeArray at:2).
		(self sizeArray at:2) fontName: 'BitStreamVeraSans' size:36.

		(self sizeArray at:1) top:top.
		(self sizeArray at:1) left:left.
		(self sizeArray at:1) contents:( size asString),' X'.  
		self addMorph: (self sizeArray at:1).

		(self sizeArray at:2) top:top1.
		(self sizeArray at:2) left:left.
		(self sizeArray at:2) contents:(size asString),' X'.
		self addMorph: (self sizeArray at:2).

		left := left + ((self sizeArray at:2) width) + 10.
	].

	self stringArray1 add: (StringMorph new).
	self addMorph: (self stringArray1 at:count).
	(self stringArray1 at:count) contents: variable.
	(self stringArray1 at:count) left: left.
	(self stringArray1 at:count) top: top.
	(self stringArray1 at:count) fontName:'LucidaCalligraphy' size:'36'.

	self textMultiplier left:left.
	self textMultiplier top:top1.
	self textMultiplier setCharacters: ''.
	self addMorph: self textMultiplier.

	left := left + (self textMultiplier width) + 20.

	(self signArray at:3) top:top.
	(self signArray at:3) left:left.
	(self signArray at:3) contents:sign.
	self addMorph: (self signArray at:3).

	(self signArray at:4) top:top1.
	(self signArray at:4) left:left.
	(self signArray at:4) contents:sign.
	self addMorph: (self signArray at:4).

	left := left + ((self signArray at:1) width) + 10.

	(self valueArray at:3) top:top.
	(self valueArray at:3) left:left.
	(self valueArray at:3) contents:value.
	self addMorph: (self valueArray at:3).

	(self valueArray at:4) top:top1.
	(self valueArray at:4) left:left.
	(self valueArray at:4) contents:value.
	self addMorph: (self valueArray at:4).

	left := left + ((self valueArray at:1) width) + 10.

	self width:(left - self left).
	self height:(top3 + (self textReasult height) +10 - self top).

	self showHideReasult:false.
	self showHideQuantity:false.! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:53'!
lineArray
	^lineArray! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:52'!
lineArray: anOrderedCollection
	lineArray := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:55'!
plusSignArray1
	^plusSignArray1! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:52'!
plusSignArray1: anOrderedCollection
	plusSignArray1 := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:55'!
plusSignArray2
	^plusSignArray2! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:55'!
plusSignArray2: anOrderedCollection
	plusSignArray2 := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'miscellaneous' stamp: 'Aayush 7/24/2008 16:03'!
removeAllMorphFromArray
	[ self lineArray size > 0 ] whileTrue:
	[
		self removeMorph: (self lineArray at:1).
		self lineArray removeFirst.

		self removeMorph: (self stringArray1 at:1).
		self stringArray1 removeFirst.

		self removeMorph: (self stringArray2 at:1).
		self stringArray2 removeFirst.

		self removeMorph: (self plusSignArray1 at:1).
		self plusSignArray1 removeFirst.

		self removeMorph: (self plusSignArray2 at:1).
		self plusSignArray2 removeFirst.
	].
	
	[ self sizeArray size > 0 ] whileTrue:
	[
		self removeMorph: (self sizeArray at:1).
		self sizeArray removeFirst.
	].! !

!VariableDisplay2 methodsFor: 'miscellaneous' stamp: 'Aayush 7/2/2008 11:48'!
showHideQuantity: aBoolean

	| size count |
	size := self stringArray2 size.	
	count := 1.

	aBoolean ifTrue:
	[
		[ count <= size ] whileTrue:
		[
			(self stringArray2 at: count) show.
			count := count + 1.
		]
	]
	ifFalse:
	[
		[ count <= size] whileTrue:
		[
			(self stringArray2 at: count) hide.
			count := count + 1.
		]
	]! !

!VariableDisplay2 methodsFor: 'miscellaneous' stamp: 'Aayush 7/2/2008 15:40'!
showHideReasult:aBoolean

	aBoolean ifTrue:
	[
		(self equalSignArray at:3) show.
		self textReasult show.
	]
	ifFalse:
	[
		(self equalSignArray at:3) hide.
		self textReasult hide.
	]! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:56'!
signArray
	^signArray! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:56'!
signArray: anOrderedCollection
	signArray := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:57'!
sizeArray
	^sizeArray! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:57'!
sizeArray: anOrderedCollection
	sizeArray := anOrderedCollection! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:50'!
stringArray1
	^stringArray1
! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:51'!
stringArray1: anOrderedCollection
	stringArray1 := anOrderedCollection
! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:51'!
stringArray2
	^stringArray2
! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:51'!
stringArray2: anOrderedCollection
	stringArray2 := anOrderedCollection
! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:00'!
textMultiplier 
	^textMultiplier! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:01'!
textMultiplier: myTextMorph 
	textMultiplier := myTextMorph ! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:00'!
textReasult 
	^textReasult! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 10:00'!
textReasult: myTextMorph 
	textReasult := myTextMorph ! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:57'!
valueArray
	^valueArray! !

!VariableDisplay2 methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 09:58'!
valueArray: anOrderedCollection
	valueArray := anOrderedCollection! !

Object subclass: #ActionVerb
	instanceVariableNames: 'verbList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ActionVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:31'!
newWithVerbs: anOrderedCollection
	| model |
	model:= self basicNew.
	model verbList: anOrderedCollection.
	model initialize.
	^model.
! !

!ActionVerb methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 13:01'!
initialize
	super initialize.
! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList
	"Answer the value of verbList"

	^ verbList! !

!ActionVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:15'!
verbList: anObject
	"Set the value of verbList"

	verbList _ anObject! !

Object subclass: #AcVerb
	instanceVariableNames: 'verb question image answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/20/2007 11:50'!
newVerbWith: aVerb question: aQuestion image: anImage answer: anAnswer
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage;
		answer: anAnswer.
	model initialize.
	^model.

		

	! !

!AcVerb class methodsFor: 'as yet unclassified' stamp: 'Ram 12/18/2007 12:44'!
newVerbWith: aVerb question: aQuestion image: anImage
	| model |
	model:= self basicNew.
	model 
		verb: aVerb;
		question: aQuestion;
		image: anImage.
	model initialize.
	^model.

		

	! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer
	"Answer the value of answer"

	^ answer! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/20/2007 11:46'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image
	"Answer the value of image"

	^ image! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question
	"Answer the value of question"

	^ question! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
question: anObject
	"Set the value of question"

	question _ anObject! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb
	"Answer the value of verb"

	^ verb! !

!AcVerb methodsFor: 'accessing' stamp: 'Ram 12/18/2007 12:34'!
verb: anObject
	"Set the value of verb"

	verb _ anObject! !

Object subclass: #AnimalKingdom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Object subclass: #ColorPattern
	instanceVariableNames: 'blueCount yellowCount orangeCount greenCount colorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount
	"Answer the value of blueCount"

	^ blueCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
blueCount: anObject
	"Set the value of blueCount"

	blueCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/21/2007 10:21'!
clearPattern: object

	
| myPlayer |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.

		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList
	"Answer the value of colorList"

	^ colorList! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
colorList: anObject
	"Set the value of colorList"

	colorList _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount
	"Answer the value of greenCount"

	^ greenCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
greenCount: anObject
	"Set the value of greenCount"

	greenCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:11'!
initialize
	super initialize.
	self orangeCount:0.
	self blueCount:0.
	self yellowCount:0.
	self greenCount: 0.
	self colorList: OrderedCollection new.
! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:03'!
iteratePattern: object
	
| myPlayer myColor |
	object allMorphsDo:[:sub | 
		(sub isKindOf: ImageMorph)ifTrue:[
		myPlayer := sub player.
		myColor := myPlayer getColor1.
		(myColor = (Color r: 1.0 g: 1.0 b: 0.194)) ifTrue:[
			colorList add: 'Yellow'.
			yellowCount:= yellowCount +1.
			].
		(myColor = (Color r: 0.387 g: 0.613 b: 0.0)) ifTrue:[
			colorList add: 'Green'.
			greenCount:=greenCount +1.
			].
		(myColor = (Color r: 1.0 g: 0.484 b: 0.0)) ifTrue:[
			colorList add: 'Orange'.
			orangeCount:= orangeCount + 1.
			].
		(myColor = (Color r: 0.0 g: 0.194 b: 1.0)) ifTrue:[
			colorList add: 'Blue'.
			blueCount:= blueCount + 1.
			].
		]
	]! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount
	"Answer the value of orangeCount"

	^ orangeCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
orangeCount: anObject
	"Set the value of orangeCount"

	orangeCount _ anObject! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount
	"Answer the value of yellowCount"

	^ yellowCount! !

!ColorPattern methodsFor: 'accessing' stamp: 'Ram 12/13/2007 11:00'!
yellowCount: anObject
	"Set the value of yellowCount"

	yellowCount _ anObject! !

Object subclass: #MyQuestion
	instanceVariableNames: 'question option cIndex xIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
cIndex
	^cIndex! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
cIndex: aNumber
	cIndex := aNumber! !

!MyQuestion methodsFor: 'initialization' stamp: 'Aayush 9/26/2008 12:01'!
initialize
	super initialize.
	self option: OrderedCollection new.
! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
option
	^option! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
option: anOrderedCollection
	option := anOrderedCollection! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
question
	^question! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
question: aString
	question := aString! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
xIndex
	^xIndex! !

!MyQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/26/2008 12:01'!
xIndex: aNumber
	xIndex := aNumber! !

Object subclass: #NoticeReadingQuestion
	instanceVariableNames: 'question option cIndex xIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-NoticeReadingActivity'!

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:22'!
cIndex
	^cIndex! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:22'!
cIndex: aNumber
	cIndex := aNumber! !

!NoticeReadingQuestion methodsFor: 'initialization' stamp: 'Aayush 9/19/2008 11:53'!
initialize
	super initialize.
	self option: OrderedCollection new.
! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:21'!
option
	^option! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:21'!
option: anOrderedCollection
	option := anOrderedCollection! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:20'!
question
	^question! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:21'!
question: aString
	question := aString! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:22'!
xIndex
	^xIndex! !

!NoticeReadingQuestion methodsFor: 'accessing-property' stamp: 'Aayush 9/18/2008 15:22'!
xIndex: aNumber
	xIndex := aNumber! !

Object subclass: #ObjectiveAnswer
	instanceVariableNames: 'answer picture sound correctAnsDescription wrongAnsDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
answer
	"Answer the value of answer"

	^ answer! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
correctAnsDescription
	"Answer the value of correctAnsDescription"

	^ correctAnsDescription! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
correctAnsDescription: anObject
	"Set the value of correctAnsDescription"

	correctAnsDescription _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
picture
	"Answer the value of picture"

	^ picture! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
picture: anObject
	"Set the value of picture"

	picture _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
sound
	"Answer the value of sound"

	^ sound! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 16:16'!
sound: anObject
	"Set the value of sound"

	sound _ anObject! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
wrongAnsDescription
	"Answer the value of wrongAnsDescription"

	^ wrongAnsDescription! !

!ObjectiveAnswer methodsFor: 'accessing' stamp: 'Ram 3/30/2008 17:05'!
wrongAnsDescription: anObject
	"Set the value of wrongAnsDescription"

	wrongAnsDescription _ anObject! !

Object subclass: #ObjectiveQuestion
	instanceVariableNames: 'optionList questionSound correctAns question picture ans optionLanguage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:18'!
addOption: aString
	optionList add: aString
! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 5/22/2008 11:23'!
ans
	"Answer the value of ans"

	^ ans! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 5/22/2008 11:23'!
ans: anObject
	"Set the value of ans"

	ans _ anObject! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
correctAns
	"Answer the value of correctAns"

	^ correctAns! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
correctAns: anObject
	"Set the value of correctAns"

	correctAns _ anObject! !

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:19'!
noOfOption
	^optionList size.
! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: '<no author> 8/14/2008 12:11'!
optionLanguage
	"Answer the value of optionLanguage"

	^ optionLanguage! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: '<no author> 8/14/2008 12:11'!
optionLanguage: anObject
	"Set the value of optionLanguage"

	optionLanguage _ anObject! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
optionList
	"Answer the value of optionList"

	^ optionList! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
optionList: anObject
	"Set the value of optionList"

	optionList _ anObject! !

!ObjectiveQuestion methodsFor: 'option' stamp: 'Ram 3/30/2008 12:26'!
optionSize
	^optionList size.! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
picture
	"Answer the value of picture"

	^ picture! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
picture: anObject
	"Set the value of picture"

	picture _ anObject! !

!ObjectiveQuestion methodsFor: 'as yet unclassified' stamp: 'Ram 3/30/2008 12:18'!
prepareQuestion: aString
	optionList:= OrderedCollection new.
	question:= aString! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
questionSound
	"Answer the value of questionSound"

	^ questionSound! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
questionSound: anObject
	"Set the value of questionSound"

	questionSound _ anObject! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
question
	"Answer the value of question"

	^ question! !

!ObjectiveQuestion methodsFor: 'accessing' stamp: 'Ram 3/30/2008 12:16'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

OLE class
	instanceVariableNames: 'halosEnabled authorMode'!

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:15'!
authorMode
	Preferences
		disable: #eToyFriendly;
		enable: #warnIfNoSourcesFile;
		enable: #warnIfNoChangesFile;
		disable: #oleDeploymentMode;
		disable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/18/2007 12:29'!
deploy
	self userMode.
	Preferences
		disable: #warnIfNoSourcesFile;
		disable: #warnIfNoChangesFile;
		enable: #oleDeploymentMode.! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:45'!
ensureImagesAreLoaded
	| dir |
	Images isEmpty ifFalse: [^self].
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	#(1 2 5 10 25 50 100 500 1000) do: [ :n |
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_front.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , n asString , '_back.jpg').
		Images addMorphBack: (SketchMorph fromFile: dir , 'animal_', n asString , '.jpg')].
! !

!OLE class methodsFor: '*ole-project' stamp: 'lg 12/19/2007 14:19'!
initializeAnimalsOnMoney
	| dir numbers choices answer |
	dir := Smalltalk imagePath, FileDirectory slash, 'assets', FileDirectory slash, 'currency_notes', FileDirectory slash.
	choices := #(1 2 5 10 25 50 100 500 1000 ) shuffled first: 3.
	answer := choices atRandom.
	Hint setGraphic: (self animalGraphic: answer).
	{Choice1. Choice2. Choice3} with: choices do:
		[:choice :note |
			choice
				setFront: (self frontGraphic: note);
				setBack: (self backGraphic: note);
				setCorrect: note == answer.
			choice showFront]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/18/2007 12:19'!
isAuthorMode
	^Preferences eToyFriendly not.
! !

!OLE class methodsFor: 'image' stamp: 'lg 10/14/2007 09:49'!
saveSoon
	[(Delay forSeconds: 10) wait. SmalltalkImage current saveSession] fork.! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
updateSugarToolbar
	World allMorphsDo: [ :m | (m isKindOf: SugarNavigatorBar) ifTrue: [m removeAllMorphs; addButtons]]! !

!OLE class methodsFor: 'childproofing' stamp: 'lg 12/20/2007 23:16'!
userMode
	Preferences
		enable: #eToyFriendly;
		enable: #noHalos.
	self updateSugarToolbar.! !

!OLE class methodsFor: 'class initialization' stamp: 'lg 12/18/2007 12:26'!
initialize
	Preferences addBooleanPreference: #oleDeploymentMode categories: #('OLE' 'OLPC') default: false balloonHelp: 'Enable behaviour that is appropriate in images running the OLE Nepal E-Paati activities but not in development images, for example automatic removal of projects after use.'
! !

Object subclass: #PictureWordExt
	instanceVariableNames: 'questionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 15:35'!
addMajorQuesion: questionWithSound minor: aQuestion
	| p1 |
	p1:= Dictionary new.
	p1 at:'major' put: questionWithSound.
	p1 at:'minor' put: aQuestion.
	questionList add: p1.
	
	
! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:45'!
initialize
	super initialize.
	questionList:= OrderedCollection new.! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:48'!
majorQuestionAt: aIndex
	
	| question majorQuestion |
	question:= questionList at: aIndex.
	majorQuestion:= question at: 'major'.
	^majorQuestion! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 16:48'!
minorQuestionAt: aIndex
	
	| question minorQuestion |
	question:= questionList at: aIndex.
	minorQuestion:= question at: 'minor'.
	^minorQuestion! !

!PictureWordExt methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 15:13'!
prepareQuesion
	questionList:= OrderedCollection new.
	
! !

!PictureWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 15:03'!
questionList
	"Answer the value of questionList"

	^ questionList! !

!PictureWordExt methodsFor: 'accessing' stamp: 'Ram 1/31/2008 15:03'!
questionList: anObject
	"Set the value of questionList"

	questionList _ anObject! !

!SequenceableCollection methodsFor: '*ole-removing' stamp: 'lg 11/1/2007 08:38'!
without: element
	^self select: [ :o | o ~= element ].! !

Thumbnail subclass: #PicturePuzzleThumbnailMorph
	instanceVariableNames: 'puzzlePictureForm gridSize labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PicturePuzzleThumbnailMorph subclass: #PicturePuzzleFileThumbnailMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 09:24'!
initialize
	super initialize.
	self maxWidth: 200 minHeight: 150.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:09'!
labels: type
	labels := type.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:38'!
makeThumbnailFromForm: form
	puzzlePictureForm := form.
	^super makeThumbnailFromForm: form.! !

!PicturePuzzleThumbnailMorph methodsFor: 'event handling' stamp: 'lg 10/10/2007 14:55'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 18:34'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new showSketch: (SketchMorph withForm: puzzlePictureForm).
	morph center: World center.
	morph top: 90.
	morph rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph rescramble.
	morph openInWorld.! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 10:53'!
enter: returningFlag revert: revertFlag saveForRevert: saveForRevert
	"Look for our project on the server, then try to enter it!!  DiskProxy is acting as a stub for the real thing.  Called from a ProjectViewMorph in the current project.  If have url, use it.  Else look in current Project's server and folder."

	constructorSelector == #namedExample: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromExampleEtoys:
					withArguments: constructorArgs) ].
	constructorSelector == #namedUrl: ifTrue: ["Project namedUrl: xxx"
		^ ((Smalltalk at: globalObjectName) perform: #fromUrl:
					withArguments: constructorArgs) ].
	constructorSelector == #named: ifTrue: [
		CurrentProjectRefactoring currentFromMyServerLoad: constructorArgs first].	"name"
	constructorSelector == #namedUnderImage: ifTrue: [
		^ ((Smalltalk at: globalObjectName) perform: #fromUnderImage: withArguments: constructorArgs)].
! !

!DiskProxy methodsFor: '*ole' stamp: 'lg 12/7/2007 11:01'!
setupForProjectUnderImage: projectName
	globalObjectName := #Project.
	constructorSelector := #namedUnderImage:.
	constructorArgs := { projectName }.
! !

Morph subclass: #AddSubstractVariableActivity
	instanceVariableNames: 'objectDisplay variableDisplay questionPool gameOverDisplay score noOfAttempt btnConfirm btnPlayAgain question discription1 discription2 currentQuestion start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubtractVariableActivity'!

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: ''!
btnConfirmClick
	self noOfAttempt: self noOfAttempt + 1.
	self checkAnswer
		ifTrue: [SoundService default playSoundNamedOrBeep: 'right1'.
			self start: true.
			self startStepping]
		ifFalse: [SoundService default playSoundNamedOrBeep: 'wrong3'.
			self variableDisplay showHideReasult: false.
			self variableDisplay showHideQuantity: false].
	ActiveHand keyboardFocus: self variableDisplay textMultiplier.
	self variableDisplay textMultiplier editor selectAll! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:17'!
btnConfirm
	^btnConfirm! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:18'!
btnConfirm: anImageMorph
	btnConfirm := anImageMorph! !

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/3/2008 11:04'!
btnPlayAgainClick
	self reset.! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:19'!
btnPlayAgain
	^btnPlayAgain! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:18'!
btnPlayAgain: anImageMorph
	btnPlayAgain := anImageMorph! !

!AddSubstractVariableActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/3/2008 11:14'!
checkAnswer
	| txtR ans |

	txtR := (self variableDisplay textReasult getCharacters).
	ans := (self question at:self currentQuestion) at:8.	

	( txtR = ans ) ifTrue:
 	[
		^true.
	].

	^false.
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:30'!
currentQuestion
	^currentQuestion! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:30'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:13'!
discription1
	^discription1! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:13'!
discription1: aDisplayMorph
	discription1 := aDisplayMorph! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:14'!
discription2
	^discription2! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:14'!
discription2: anImageMorph
	discription2 := anImageMorph! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:10'!
gameOverDisplay
	^gameOverDisplay! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:11'!
gameOverDisplay: aRectangleMorph
	gameOverDisplay := aRectangleMorph! !

!AddSubstractVariableActivity methodsFor: 'initialization' stamp: 'Aayush 7/2/2008 14:21'!
initCostume
	| t1 |
	t1 := 'objectDisplay'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objectDisplay wearCostume: t2.
		]
	].

	t1 := 'discription'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self discription1 wearCostume: t2.
		]
	].

	t1 := 'confirm_nepali'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnConfirm wearCostume: t2.
		]
	].

	t1 := 'play_again'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnPlayAgain wearCostume: t2.
		]
	].! !

!AddSubstractVariableActivity methodsFor: 'initialization' stamp: 'Aayush 7/2/2008 16:15'!
initialize
	| msgSend1 msgSend2 |
	super initialize.
	self objectDisplay: DisplayBoard new openInWorld. 
	self discription1: DisplayBoard new openInWorld. 
	self discription2: ImageMorph new openInWorld. 
	self btnConfirm: ImageMorph new openInWorld. 
	self btnPlayAgain: ImageMorph new openInWorld. 
	self score: StringMorph new openInWorld.
	self gameOverDisplay: RectangleMorph new openInWorld.
	self questionPool: OrderedCollection new.
	self variableDisplay: VariableDisplay2 new openInWorld.

	msgSend1 := MessageSend new.
	msgSend1 selector: #textMultiplierCrAction.
	msgSend1 receiver: self.
	self variableDisplay textMultiplier crAction: msgSend1.

	msgSend2 := MessageSend new.
	msgSend2 selector: #textReasultCrAction.
	msgSend2 receiver: self.
	self variableDisplay textReasult crAction: msgSend2.

	self btnConfirm on:#mouseUp send:#btnConfirmClick to:self.
	self btnPlayAgain on:#mouseUp send:#btnPlayAgainClick to:self.

	self initCostume.
	self initQuestion.
	self reset.! !

!AddSubstractVariableActivity methodsFor: 'initialization' stamp: 'Aayush 7/28/2008 10:41'!
initQuestion

	| count |
	self question: OrderedCollection new.

	count := 1.
	[ count <= 6 ] whileTrue:
	[
		self question add:(Array new:8).

		count := count + 1.
	].

	(self question at:1) at:1 put:'1'.	
	(self question at:1) at:2 put:'2'.	
	(self question at:1) at:3 put:'3'.	
	(self question at:1) at:4 put:3.	   
	(self question at:1) at:5 put:'+'.	
	(self question at:1) at:6 put:'7'.	
	(self question at:1) at:7 put:'x'.
	(self question at:1) at:8 put:'97'.

	(self question at:2) at:1 put:'4'.	
	(self question at:2) at:2 put:'5'.	
	(self question at:2) at:3 put:'6'.	
	(self question at:2) at:4 put:1.	   
	(self question at:2) at:5 put:'-'.	
	(self question at:2) at:6 put:'22'.	
	(self question at:2) at:7 put:'r'.
	(self question at:2) at:8 put:'48'.

	(self question at:3) at:1 put:'7'.	
	(self question at:3) at:2 put:'8'.	
	(self question at:3) at:3 put:'9'.	
	(self question at:3) at:4 put:2.	   
	(self question at:3) at:5 put:'-'.	
	(self question at:3) at:6 put:'16'.	
	(self question at:3) at:7 put:'y'.
	(self question at:3) at:8 put:'34'.

	(self question at:4) at:1 put:'10'.	
	(self question at:4) at:2 put:'11'.	
	(self question at:4) at:3 put:'12'.	
	(self question at:4) at:4 put:1.	   
	(self question at:4) at:5 put:'-'.	
	(self question at:4) at:6 put:'30'.	
	(self question at:4) at:7 put:'p'.
	(self question at:4) at:8 put:'50'.

	(self question at:5) at:1 put:'13'.	
	(self question at:5) at:2 put:'14'.	
	(self question at:5) at:3 put:'15'.	
	(self question at:5) at:4 put:2.	   
	(self question at:5) at:5 put:'+'.	
	(self question at:5) at:6 put:'7'.	
	(self question at:5) at:7 put:'x'.
	(self question at:5) at:8 put:'37'.

	(self question at:6) at:1 put:'16'.	
	(self question at:6) at:2 put:'17'.	
	(self question at:6) at:3 put:'18'.	
	(self question at:6) at:4 put:4.	   
	(self question at:6) at:5 put:'-'.	
	(self question at:6) at:6 put:'8'.	
	(self question at:6) at:7 put:'x'.
	(self question at:6) at:8 put:'56'.
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:21'!
noOfAttempt
	^noOfAttempt! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:21'!
noOfAttempt: aNumber
	noOfAttempt := aNumber! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:12'!
objectDisplay
	^objectDisplay! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:12'!
objectDisplay: aDisplayMorph
	objectDisplay:= aDisplayMorph! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:14'!
questionPool
	^questionPool
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:17'!
questionPool: anOrderedCollection
	questionPool := anOrderedCollection
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:19'!
question
	^question! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:20'!
question: anOrderedCollection
	question := anOrderedCollection! !

!AddSubstractVariableActivity methodsFor: 'initialization' stamp: 'Aayush 7/28/2008 16:18'!
reset
	self score contents: '0'.
	self noOfAttempt: 0.
	self currentQuestion: 1.
	self start:false.
	self secondPassed:0.

	[ self questionPool size > 0 ] whileTrue:
	[
		self questionPool removeFirst.
	]. 
	self questionPool addAll: #(1 2 3 4 5 6).

	self btnPlayAgain hide.
	self btnConfirm show.
	self gameOverDisplay hide.

	self showNewQuestion.
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:20'!
score
	^score! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 12:20'!
score: aStringMorph
	score := aStringMorph! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/28/2008 13:46'!
secondPassed
	^secondPassed! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/28/2008 13:47'!
secondPassed: aNumber
	secondPassed := aNumber! !

!AddSubstractVariableActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/10/2008 15:54'!
showNewQuestion
	| x size oDisplay oDiscription1 oDiscription2 sign value variable |

	x := (self questionPool size) random.
	self currentQuestion: (self questionPool at:x).
	self questionPool removeAt: x.

	oDisplay := 'Image_', ((self question at:(self currentQuestion)) at:1).
	oDiscription1 := 'Image_', ((self question at:(self currentQuestion)) at:2).
	oDiscription2 := 'Image_', ((self question at:(self currentQuestion)) at:3).

	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDisplay])				
		ifTrue:
	 	[
			self objectDisplay dispImage wearCostume: t2.
			self objectDisplay dispImage center: self objectDisplay center.
		]
	].
	
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDiscription1])				
		ifTrue:
	 	[
			self discription1 dispImage wearCostume: t2.
			self discription1 dispImage center: self discription1 center.
			self discription1 dispImage top: self discription1 top + 90.
		]
	].
"
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDiscription2])				
		ifTrue:
	 	[
			self discription2 wearCostume: t2.
		]
	].
"
	size := (self question at:(self currentQuestion)) at:4.
	sign := (self question at:(self currentQuestion)) at:5.
	value := (self question at:(self currentQuestion)) at:6.
	variable := (self question at:(self currentQuestion)) at:7.

	self variableDisplay initPositionwithSize:size Value:value Sign:sign Variable:variable.
	self variableDisplay center: self discription1 center.
	self variableDisplay top: self variableDisplay top + 130.

	ActiveHand keyboardFocus: ((self variableDisplay) textMultiplier).
! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/28/2008 13:44'!
start
	^start! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/28/2008 13:44'!
start: aBoolean
	start := aBoolean! !

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:47'!
stepTime
	^1000.
! !

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:51'!
step
	self start ifTrue:
	[
		self secondPassed:self secondPassed + 1.
		self secondPassed = 4 ifTrue:
		[
			self noOfAttempt = 1 ifTrue:
			[
				self score contents: ((((self score) contents) asInteger) + 1) asString.
			].
	
			self questionPool size = 0 ifTrue:
			[
				self btnPlayAgain show.
				self btnConfirm hide.
				self gameOverDisplay show.
			]
			ifFalse:
			[
				self showNewQuestion.
				self noOfAttempt:0.
			].

			self secondPassed:0.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/3/2008 14:32'!
textMultiplierCrAction
	| size count |
	ActiveHand keyboardFocus: ((self variableDisplay) textReasult).
	((self variableDisplay) textReasult) editor selectAll.

	size := ((self variableDisplay) stringArray2) size.
	count := 1.

	[ count <= size ] whileTrue:
	[
		(((self variableDisplay) stringArray2) at:count) contents: ((self variableDisplay) textMultiplier) getCharacters.
		(((self variableDisplay) stringArray2) at:count) show.

		count := count + 1.
	].

	self variableDisplay showHideReasult:true.
! !

!AddSubstractVariableActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/2/2008 15:43'!
textReasultCrAction
	self btnConfirmClick.! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:12'!
variableDisplay
	^variableDisplay! !

!AddSubstractVariableActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/2/2008 15:12'!
variableDisplay: aVariableDisplay2Morph
	variableDisplay := aVariableDisplay2Morph! !

Morph subclass: #AlphabeticalOrderGame
	instanceVariableNames: 'randomString randomStringBG orderedString orderedStringBG question inputSensor currentQuestion selectedRandomString randomStringState btnCheckAnswer btnNext noOfAttempt score qusNo picturePosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AlphabeticalOrderActivity'!

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/12/2008 10:20'!
addRemoveOrderedStringAllEventHandler: aBoolean
| count size |

	count := 1.
	size := self orderedString size.
	[count <= size] whileTrue:
	[
		aBoolean ifTrue:
		[
			(self orderedStringBG at:count) on:#mouseDown send:#orderedStringClick:v1:v2: to:self withValue:count.
			(self orderedStringBG at:count) on:#mouseEnter send:#orderedStringMouseEnter:v1:v2: to:self withValue:count.
			(self orderedStringBG at:count) on:#mouseLeave send:#resetOrderedStringBGColor to:self.

			(self orderedString at:count) on:#mouseDown send:#orderedStringClick:v1:v2: to:self withValue:count.
			(self orderedString at:count) on:#mouseEnter send:#orderedStringMouseEnter:v1:v2: to:self withValue:count.
			(self orderedString at:count) on:#mouseLeave send:#resetOrderedStringBGColor to:self.
		]
		ifFalse:
		[
			(self orderedStringBG at:count) on:#mouseDown send:#doNothing to:self.
			(self orderedStringBG at:count) on:#mouseEnter send:#doNothing to:self.
			(self orderedStringBG at:count) on:#mouseLeave send:#doNothing to:self.

			(self orderedString at:count) on:#mouseDown send:#doNothing to:self.
			(self orderedString at:count) on:#mouseEnter send:#doNothing to:self.
			(self orderedString at:count) on:#mouseLeave send:#doNothing to:self.
		].
		count := count + 1.
	].! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/12/2008 10:23'!
addRemoveRandomStringAllEventHandler: aBoolean
| count size |

	count := 1.
	size := self randomString size.
	[count <= size] whileTrue:
	[
		aBoolean ifTrue:
		[
			(self randomStringBG at:count) on:#mouseDown send:#randomStringClick:v1:v2: to:self withValue:count.
			(self randomStringBG at:count) on:#mouseEnter send:#randomStringMouseEnter:v1:v2: to:self withValue:count.
			(self randomStringBG at:count) on:#mouseLeave send:#resetRandomStringBGColor to:self.

			(self randomString at:count) on:#mouseDown send:#randomStringClick:v1:v2: to:self withValue:count.
			(self randomString at:count) on:#mouseEnter send:#randomStringMouseEnter:v1:v2: to:self withValue:count.
			(self randomString at:count) on:#mouseLeave send:#resetRandomStringBGColor to:self.
		]
		ifFalse:
		[
			(self randomStringBG at:count) on:#mouseDown send:#doNothing to:self.
			(self randomStringBG at:count) on:#mouseEnter send:#doNothing to:self.
			(self randomStringBG at:count) on:#mouseLeave send:#doNothing to:self.

			(self randomString at:count) on:#mouseDown send:#doNothing to:self.
			(self randomString at:count) on:#mouseEnter send:#doNothing to:self.
			(self randomString at:count) on:#mouseLeave send:#doNothing to:self.
		].
		count := count + 1.
	].! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 17:02'!
btnCheckAnswerClick
	| x y z |
	self noOfAttempt: self noOfAttempt + 1.
	
	self checkAnswer ifTrue:
	[
		SoundService default playSoundNamedOrBeep: 'correct2'.

		self noOfAttempt = 1 ifTrue:
		[
			self score contents: (self score contents asInteger + 1) asString.
		].	
		self noOfAttempt:0.	
		
		x := (self picturePosition size) random.
		y := self picturePosition at:x.
		z := ((self currentQuestion -1)//6)+1.
		self showPicture:z position:y.
		self picturePosition removeAt:x.

		self btnCheckAnswer hide.

		(self currentQuestion \\ 6 = 0 ) ifTrue:
		[
"			self qusNo contents: '6'.
"
			self currentQuestion: self currentQuestion + 1. 
			self btnNext show.	
			self addRemoveOrderedStringAllEventHandler:false.
			self addRemoveRandomStringAllEventHandler:false.
			SoundService default playSoundNamedOrBeep: 'Badhai cha'.
		]
		ifFalse:
		[
"			self qusNo contents: (self currentQuestion \\ 6) asString.
"
			self currentQuestion: self currentQuestion + 1. 
			self generateNewQuestion.
			self hideAllOrderedString.
			self addRemoveRandomStringAllEventHandler:true.
		].
	]
	ifFalse:
	[
		SoundService default playSoundNamedOrBeep: 'incorrect'.
	].
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 15:46'!
btnCheckAnswer
	^btnCheckAnswer! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 15:47'!
btnCheckAnswer: anImageMorph
	btnCheckAnswer := anImageMorph! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/18/2008 16:23'!
btnNextClick
	(self currentQuestion > self question size) ifTrue:
	[
		self reset.
	]
	ifFalse:
	[
		self score contents: '0'.
		self qusNo contents: '6'.
		self generateNewQuestion.
		self hideAllOrderedString.

		self btnNext hide.
		self btnCheckAnswer hide.
		self addRemoveOrderedStringAllEventHandler:true.
		self addRemoveRandomStringAllEventHandler:true.
		self hideAllPictures.
		self picturePosition addAll: #(1 2 3 4 5 6).
	]
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/9/2008 12:20'!
btnNext
	^btnNext! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/9/2008 12:21'!
btnNext: anImageMoroh
	btnNext := anImageMoroh! !

!AlphabeticalOrderGame methodsFor: 'question-answer' stamp: 'Aayush 6/6/2008 15:09'!
checkAnswer
	
	| count size check |
	count:=1.
	size := self orderedString size.
	check := 0.
	[ count < size ] whileTrue:
	[
		(self orderedString at:count) contents < (self orderedString at:(count+1)) contents ifTrue:
		[
			check := check + 1.				
		].
		count := count + 1.
	].

	(check = (size-1)) ifTrue:
	[
		^true	
	].

	^false.
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 10:40'!
currentQuestion
	^currentQuestion! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 10:41'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/19/2008 12:02'!
currentSet
	| |
	^ ((self currentQuestion -1)//6)+1.
	
! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/9/2008 14:33'!
doNothing
	^self
! !

!AlphabeticalOrderGame methodsFor: 'question-answer' stamp: 'Aayush 6/6/2008 14:21'!
generateNewQuestion
	| list count x y size |
	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6).
	
	count := 1.
	size := self randomString size.
	[ count <= size. ] whileTrue:
	[
		x := (list size) random.
		y := list at:x.
		(self randomString at:y) contents: ((self question at: (self currentQuestion)) at:count).
		(self randomString at:y) center: (self randomStringBG at:y) center.
		(self randomString at:y) show.
		list removeAt:x.		
		count := count + 1.
	].
! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/6/2008 14:43'!
getHiddenRandomStringIndex

	| count size |
	count:=1.
	size:= self randomString size.
	[ count <= size ] whileTrue:
	[
		(self randomString at:count) visible = false ifTrue:
		[
			^count.
		].
		count := count + 1.
	].
	^0.! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/6/2008 16:25'!
hideAllOrderedString
	| count size |
	count:=1.
	size:= self orderedString size.
	[count <= size] whileTrue:
	[
		(self orderedString at:count) hide.

		count := count + 1.
	].! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 16:56'!
hideAllPictures
		| t1 |
	t1 := 'elephant_'.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString beginsWith: t1])
					ifTrue: [t2 hide.]].

		t1 := 'house_'.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString beginsWith: t1])
					ifTrue: [t2 hide.]].

		t1 := 'ship_'.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString beginsWith: t1])
					ifTrue: [t2 hide.]].


! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 16:42'!
highLightOrderedStringBG: anIndex
	| count size |

	size := 	(self orderedStringBG) size.
	count := 1.
	[ count <= size] whileTrue:
	[
		count = anIndex ifTrue:
		[
			(self orderedStringBG at: anIndex) color: (Color r:0.5 g:0.6 b:0.7 alpha:0.5).
			(self orderedStringBG at: anIndex) borderWidth:2.
		]
		ifFalse:
		[
			(self orderedStringBG at: count) color: (Color r:0.613 g:0.903 b:1.0 alpha:0).
			(self orderedStringBG at: count) borderWidth:0.
		].
		count := count + 1.
	].
! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/12/2008 09:57'!
highLightRandomStringBG: anIndex
	| count size |

	size := 	(self randomStringBG) size.
	count := 1.
	[ count <= size] whileTrue:
	[
		count = anIndex ifTrue:
		[
			(self randomStringBG at: anIndex) color: (Color r:0.5 g:0.6 b:0.7 alpha:0.3).
			(self randomStringBG at: anIndex) borderWidth:2.
"			(self randomString at: anIndex) fontName:'BitStreamVeraSans' size:48.
"		]
		ifFalse:
		[
			(self randomStringBG at: count) color: (Color r:0.613 g:0.903 b:1.0 alpha:0).
			(self randomStringBG at: count) borderWidth:0.
"			(self randomString at: anIndex) fontName:'BitStreamVeraSans' size:36.
"		].
		count := count + 1.
	].
! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/9/2008 12:39'!
initBtn
	self btnCheckAnswer: ImageMorph new.
	self btnCheckAnswer on:#mouseDown send:#btnCheckAnswerClick to:self.
	self btnCheckAnswer openInWorld.

	self btnNext: ImageMorph new.
	self btnNext on:#mouseDown send:#btnNextClick to:self.
	self btnNext openInWorld.
	self btnNext hide.! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/9/2008 12:37'!
initCostume
	| t1 |
	t1 := 'btn_next'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnNext wearCostume: t2.
		]
	].

	t1 := 'check_answer'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnCheckAnswer wearCostume: t2.
		]
	].
! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/11/2008 14:23'!
initialize
	super initialize.
	self width:182.
	self height:50.

	self inputSensor: InputSensor new.
	self score: StringMorph new.
	self score openInWorld.
	self qusNo: StringMorph new.
	self qusNo openInWorld.
	self picturePosition: OrderedCollection new.
	self question: (OrderedCollection new).
	self initQuestions.

	self initStringMorph.
	self initBtn.
	self initCostume.
	self reset.

	
	! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/25/2008 13:16'!
initQuestions
	self question add: ( OrderedCollection new ).
	(self question at:1) addAll: #('apple' 'lamp' 'horse' 'cat' 'door' 'finger').

	self question add: ( OrderedCollection new ).
	(self question at:2) addAll: #('axe' 'volley-ball' 'plate' 'stick' 'river' 'mountain').

	self question add: ( OrderedCollection new ).
	(self question at:3) addAll: #('window' 'tree' 'bottle' 'fish' 'pan' 'house').

	self question add: ( OrderedCollection new ).
	(self question at:4) addAll: #('leaf' 'net' 'tiger' 'ladder' 'goat' 'egg').

	self question add: ( OrderedCollection new ). 
	(self question at:5) addAll: #('glass' 'bus' 'nose' 'pencil' 'flag' 'table').

	self question add: ( OrderedCollection new ).
	(self question at:6) addAll:  #('watch' 'radio' 'star' 'glass' 'picture' 'nail').

"
	self question add: ( OrderedCollection new ).
	(self question at:7) addAll: #('basket' 'watch' 'umbrella' 'ear' 'hand' 'dog').

	self question add: ( OrderedCollection new).
	(self question at:8) addAll: #('hen' 'yak' 'zip' 'bird' 'mat' 'duck').

	self question add: ( OrderedCollection new ).
	(self question at:9) addAll: #('mango' 'snake' 'pot' 'orange' 'jacket' 'eye').

	self question add: ( OrderedCollection new ).
	(self question at:10) addAll: #('flag' 'banana' 'key' 'table' 'pumkin' 'carrot').
"

	self question add: ( OrderedCollection new).
	(self question at:7) addAll: #('bottle' 'bus' 'bird' 'basket' 'bed' 'bread').

	self question add: ( OrderedCollection new).
	(self question at:8) addAll: #('elephant' 'egg' 'ear' 'eye' 'example' 'eight').

	self question add: ( OrderedCollection new).
	(self question at:9) addAll: #('ant' 'areoplane' 'apple' 'axe' 'audio' 'arrow').

	self question add: ( OrderedCollection new).
	(self question at:10) addAll: #('pig' 'pot' 'pan' 'pencil' 'pumkin' 'practice').

	self question add: ( OrderedCollection new).
	(self question at:11) addAll: #('stick' 'school' 'snake' 'slate' 'smile' 'short').

	self question add: ( OrderedCollection new).
	(self question at:12) addAll: #('dog' 'duck' 'dam' 'den' 'dig' 'drink').

"
	self question add: ( OrderedCollection new).
	(self question at:17) addAll: #('food' 'flag' 'figure' 'fat' 'frog' 'few').

	self question add: ( OrderedCollection new).
	(self question at:18) addAll: #('glass' 'gold' 'gim' 'game' 'gem' 'gun').

	self question add: ( OrderedCollection new).
	(self question at:19) addAll: #('nose' 'lamp' 'horse' 'cat' 'door' 'finger').

	self question add: ( OrderedCollection new).
	(self question at:20) addAll: #('tree' 'tiger' 'table' 'truck' 'thanks' 'top').
"

	self question add: ( OrderedCollection new). 
	(self question at:13) addAll: #('bottle' 'box' 'basket' 'banana' 'candle' 'carrot').

	self question add: ( OrderedCollection new).
	(self question at:14) addAll: #('dog' 'elephant' 'fish' 'door' 'egg' 'finger').

	self question add: ( OrderedCollection new).
	(self question at:15) addAll: #('horse' 'lamp' 'house' 'ladder' 'mat' 'mango').

	self question add: ( OrderedCollection new).
	(self question at:16) addAll: #('mat' 'mountain' 'lamp' 'house' 'horse' 'ladder').

	self question add: ( OrderedCollection new).
	(self question at:17) addAll: #('pencil' 'jacket' 'mountain' 'mouse' 'jam' 'pen').

	self question add: ( OrderedCollection new).
	(self question at:18) addAll: #('rat' 'star' 'kite' 'stick' 'radio' 'kind').

"
	self question add: ( OrderedCollection new).	
	(self question at:27) addAll: #('tree' 'trolley' 'tempo' 'tram' 'watch' 'wall').

	self question add: ( OrderedCollection new).
	(self question at:28) addAll: #('nose' 'hand' 'ear' 'aeroplane' 'hat' 'note').

	self question add: ( OrderedCollection new).
	(self question at:29) addAll: #('lamb' 'lamp' 'leave' 'leaf' 'ship' 'sheep').

	self question add: ( OrderedCollection new).
	(self question at:30) addAll: #('picture' 'pot' 'pin' 'timber' 'tiger' 'polish').
"! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/11/2008 12:05'!
initStringMorph
	| count top left |

	self orderedString: (OrderedCollection new).
	self orderedStringBG: (OrderedCollection new).

	self randomString: (OrderedCollection new).
	self randomStringBG: (OrderedCollection new).

	top := 400.
	left := 0.
	count:= 1.
	[count <= 6] whileTrue:
	[
		(self orderedStringBG) add: (RectangleMorph new).
		(self orderedStringBG at:count) width:182.
		(self orderedStringBG at:count) height:50.
		(self orderedStringBG at:count) openInWorld. 
		(self orderedStringBG at:count) top: top.
		(self orderedStringBG at:count) left:0.
		(self orderedStringBG at:count) on:#mouseDown send:#orderedStringClick:v1:v2: to:self withValue:count.
		(self orderedStringBG at:count) on:#mouseEnter send:#orderedStringMouseEnter:v1:v2: to:self withValue:count.
		(self orderedStringBG at:count) on:#mouseLeave send:#resetOrderedStringBGColor to:self.

		top := top + (self orderedStringBG at:count) height.

		(self randomStringBG) add: (RectangleMorph new).
		(self randomStringBG at:count) width:182.
		(self randomStringBG at:count) height:50.
		(self randomStringBG at:count) openInWorld.
		(self randomStringBG at:count) toggleStickiness.
		(self randomStringBG at:count) top:200.
		(self randomStringBG at:count) left:left.
		(self randomStringBG at:count) on:#mouseDown send:#randomStringClick:v1:v2: to:self withValue:count.
		(self randomStringBG at:count) on:#mouseEnter send:#randomStringMouseEnter:v1:v2: to:self withValue:count.
		(self randomStringBG at:count) on:#mouseLeave send:#resetRandomStringBGColor to:self.
		left := left + 185.

		(self orderedString) add: (StringMorph new).
		(self orderedString at:count) fontName:'BitstreamVeraSans' size:36.
		(self orderedString at:count) openInWorld.
"		(self orderedString at:count) hide.
"		(self orderedString at:count) center: (self orderedStringBG at:count) center.
		(self orderedString at:count) on:#mouseDown send:#orderedStringClick:v1:v2: to:self withValue:count.
		(self orderedString at:count) on:#mouseEnter send:#orderedStringMouseEnter:v1:v2: to:self withValue:count.
		(self orderedString at:count) on:#mouseLeave send:#resetOrderedStringBGColor to:self.

		(self randomString) add: (StringMorph new).
		(self randomString at:count) fontName:'BitstreamVeraSans' size:36.
		(self randomString at:count) openInWorld.
		(self randomString at:count) center: (self randomStringBG at:count) center.
		(self randomString at:count) on:#mouseDown send:#randomStringClick:v1:v2: to:self withValue:count.
		(self randomString at:count) on:#mouseEnter send:#randomStringMouseEnter:v1:v2: to:self withValue:count.
		(self randomString at:count) on:#mouseLeave send:#resetRandomStringBGColor to:self.

		count := count + 1.
	].
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 10:31'!
inputSensor
	^inputSensor! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 10:36'!
inputSensor: ipSensor
	inputSensor:= ipSensor.! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 16:03'!
noOfAttempt
	^noOfAttempt
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 16:03'!
noOfAttempt: aNumber
	noOfAttempt:= aNumber
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 12:12'!
orderedStringBG
	^orderedStringBG! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:14'!
orderedStringBG: anArray
	orderedStringBG:= anArray! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/12/2008 10:24'!
orderedStringClick:index v1:y v2:z

	| x tmpContents count check size |
	(self orderedString at:index) visible = true ifTrue:
	[
		self selectedRandomString = 0 ifTrue:
		[
			x := self getHiddenRandomStringIndex.
			(self randomString at:x) contents:(self orderedString at:index) contents.
			(self orderedString at:index) hide.
			(self randomString at:x) show.
			self selectedRandomString:x.
			self randomStringState:1.
		]
		ifFalse:
		[
			tmpContents := (self randomString at: self selectedRandomString) contents.
			(self randomString at: self selectedRandomString) contents: (self orderedString at:index) contents.
			(self orderedString at:index) contents: tmpContents.
			(self orderedString at:index) center:(self orderedStringBG at:index) center.
		]
	]
	ifFalse:
	[
		self selectedRandomString > 0 ifTrue:
		[
			(self orderedString at:index) contents:(self randomString at:(self selectedRandomString)) contents.
			(self orderedString at:index) center: (self orderedStringBG at:index) center.
			(self orderedString at:index) show.
			(self randomString at:(self selectedRandomString)) hide.
			self selectedRandomString:0.
			self randomStringState:0.
		]
	].

	count:=1.
	check := 0.
	size := self orderedString size.
	[ count <= size ] whileTrue:
	[
		(self orderedString at:count) visible = true ifTrue:
		[
			check := check + 1.
		].
		count := count + 1.
	].

	check = size ifTrue:
	[
		self btnCheckAnswer show.
		self addRemoveRandomStringAllEventHandler:false.
	]
	ifFalse:
	[
		self btnCheckAnswer hide.
	]! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 11:43'!
orderedStringMouseEnter:index v1:x v2:y
	self highLightOrderedStringBG:index! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:13'!
orderedString
	^orderedString! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:14'!
orderedString: anArray
	orderedString:= anArray! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/11/2008 14:21'!
picturePosition
	^picturePosition
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/11/2008 14:22'!
picturePosition: anOrderedCollection
	picturePosition := anOrderedCollection
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 16:07'!
question
	^question! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 16:08'!
question: anArray
	question:= anArray! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/9/2008 15:05'!
qusNo
	^qusNo
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/9/2008 15:06'!
qusNo: aStringMorph
	qusNo := aStringMorph
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 14:21'!
randomStringBG
	^randomStringBG! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:13'!
randomStringBG: anArray
	randomStringBG:= anArray! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 12:27'!
randomStringClick:index v1:y v2:z
	self randomStringState = 0 ifTrue:
	[
		self randomStringState:1.
	]
	ifFalse:
	[
		self randomStringState = 1 ifTrue:
		[
			(self randomString at: (self selectedRandomString)) center: (self randomStringBG at:(self selectedRandomString)) center.
		]
	].	

	self selectedRandomString: index.! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 11:52'!
randomStringMouseEnter:index v1:x v2:y
	self highLightRandomStringBG:index! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 13:54'!
randomStringState
	^randomStringState! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 13:54'!
randomStringState: aNumber
	randomStringState := aNumber! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:12'!
randomString
	^randomString! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/2/2008 10:13'!
randomString: anArray
	randomString:= anArray.! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 16:43'!
resetOrderedStringBGColor
	| count size |
	count:=1.
	size := self orderedStringBG size.
	[count <=  size] whileTrue:
	[
		(self orderedStringBG at:count) color: (Color r:0.613 g:0.903 b:1.0 alpha:0).
		(self orderedStringBG at:count) borderWidth:0.
		count := count + 1.
	].! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/12/2008 09:56'!
resetRandomStringBGColor
	| count size |
	count:=1.
	size := self randomStringBG size.
	[count <=  size] whileTrue:
	[
"		(self randomStringBG at:count) color: (Color r:0.613 g:0.903 b:1.0).
"		(self randomStringBG at:count) color: (Color r:0.613 g:0.903 b:1.0 alpha:0).
		(self randomStringBG at:count) borderWidth:0.

"		(self randomString at: count) fontName:'BitStreamVeraSans' size:36.
"		count := count + 1.
	].! !

!AlphabeticalOrderGame methodsFor: 'initialization' stamp: 'Aayush 6/12/2008 11:21'!
reset
	| |
	self currentQuestion:1.
	self selectedRandomString:0.
	self randomStringState:0.
	self noOfAttempt:0.
	self score contents:'0'.
	self qusNo contents:'6'.

	self generateNewQuestion.
	self hideAllOrderedString.
	self btnNext hide.
	self btnCheckAnswer hide.
	self hideAllPictures.

	self addRemoveOrderedStringAllEventHandler:true.
	self addRemoveRandomStringAllEventHandler:true.

	[ self picturePosition size > 0 ] whileTrue:
	[
		self picturePosition removeFirst.
	].
	self picturePosition addAll: #(1 2 3 4 5 6).
! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 16:09'!
score
	^score! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/6/2008 16:10'!
score: aNumber
	score:= aNumber! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 13:49'!
selectedRandomString
	^selectedRandomString! !

!AlphabeticalOrderGame methodsFor: 'accessing - properties' stamp: 'Aayush 6/4/2008 13:49'!
selectedRandomString: aNumber
	selectedRandomString := aNumber! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 14:02'!
showPictureName:aString index:aNumber
! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 14:10'!
showPicture:aType position:anIndex

	"elephant"
	| t1 |
	aType = 1 ifTrue:
	[
		t1 := 'elephant_'.
		t1 := t1 , anIndex asString.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
						and: [t2 externalName asString sameAs: t1])
					ifTrue: [t2 show.]]
	]
	ifFalse:
	[
		"house"
		aType = 2 ifTrue:
		[
			t1 := 'house_'.
			t1 := t1 , anIndex asString.
			World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
							and: [t2 externalName asString sameAs: t1])
						ifTrue: [t2 show.]]
		]
		ifFalse:
		[
			"ship"
			aType = 3 ifTrue:
			[
				t1 := 'ship_'.
				t1 := t1 , anIndex asString.
				World
					allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
								and: [t2 externalName asString sameAs: t1])
							ifTrue: [t2 show.]]
			]
		]
	]

	
! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 12:14'!
stepTime
	^1000.! !

!AlphabeticalOrderGame methodsFor: 'miscellaneous' stamp: 'Aayush 6/11/2008 12:13'!
step
	self randomStringState = 1 ifTrue:
	[
		self selectedRandomString >= 1 ifTrue:
		[
			(self randomString at: selectedRandomString) center: ((self inputSensor) cursorPoint + (0@25)).
		]
	]
	ifFalse:
	[
		self selectedRandomString >= 1 ifTrue:
		[
			(self randomString at: selectedRandomString) center: (self randomStringBG at: selectedRandomString) center.
		]
	].	! !

Morph subclass: #FractionAndEquivalentDecimalDivideHowTo1
	instanceVariableNames: 'str1 str2 str3 str4 str5 str6 str7 str8 str9 str10 str11 str12 str13 str14 str15 str16 str17 line1 line2 line3 line4 start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 13:15'!
fontName:f size:s
	self str1 fontName:f size:s.
	self str2 fontName:f size:s.
	self str3 fontName:f size:s.
	self str4 fontName:f size:s.
	self str5 fontName:f size:s.
	self str6 fontName:f size:s.
	self str7 fontName:f size:s.
	self str8 fontName:f size:s.
	self str9 fontName:f size:s.
	self str10 fontName:f size:s.
	self str11 fontName:f size:s.
	self str12 fontName:f size:s.
	self str13 fontName:f size:s.
	self str14 fontName:f size:s.
	self str15 fontName:f size:s.
	self str16 fontName:f size:s.
	self str17 fontName:f size:s.
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 16:19'!
initialize
	super initialize.
	self start:false.

	self str1: StringMorph new.
	self addMorph: self str1.
	self str1 contents:'20 ) 45'.
	
	self str2: StringMorph new.
	self addMorph: self str2.
	self str2 contents:'2'.
	
	self str3: StringMorph new.
	self addMorph: self str3.
	self str3 contents:'40'.
	
	self str4: StringMorph new.
	self addMorph: self str4.
	self str4 contents:'-'.
	
	self str5: StringMorph new.
	self addMorph: self str5.
	self str5 contents:'5'.
	
	self str6: StringMorph new.
	self addMorph: self str6.
	self str6 contents:'.'.
	
	self str7: StringMorph new.
	self addMorph: self str7.
	self str7 contents:'0'.
	
	self str8: StringMorph new.
	self addMorph: self str8.
	self str8 contents:'2'.
	
	self str9: StringMorph new.
	self addMorph: self str9.
	self str9 contents:'40'.
	
	self str10: StringMorph new.
	self addMorph: self str10.
	self str10 contents:'-'.
	
	self str11: StringMorph new.
	self addMorph: self str11.
	self str11 contents:'0'.
	
	self str12: StringMorph new.
	self addMorph: self str12.
	self str12 contents:'1'.
	
	self str13: StringMorph new.
	self addMorph: self str13.
	self str13 contents:'0'.
	
	self str14: StringMorph new.
	self addMorph: self str14.
	self str14 contents:'5'.
	
	self str15: StringMorph new.
	self addMorph: self str15.
	self str15 contents:'100'.
	
	self str16: StringMorph new.
	self addMorph: self str16.
	self str16 contents:'-'.
	
	self str17: StringMorph new.
	self addMorph: self str17.
	self str17 contents:'X'.

	self line1: LineMorph new.
	self addMorph: self line1.
	self line1 verticesAt:1 put:(0@0).
	self line1 verticesAt:2 put:(40@0).

	self line2: LineMorph new.
	self addMorph: self line2.
	self line2 verticesAt:1 put:(0@0).
	self line2 verticesAt:2 put:(40@0).

	self line3: LineMorph new.
	self addMorph: self line3.
	self line3 verticesAt:1 put:(0@0).
	self line3 verticesAt:2 put:(40@0).

	self line4: LineMorph new.
	self addMorph: self line4.
	self line4 verticesAt:1 put:(0@0).
	self line4 verticesAt:2 put:(40@0).
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:34'!
line1
	^line1! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:34'!
line1: aLineMorph
	line1 := aLineMorph! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:34'!
line2
	^line2! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:35'!
line2: aLineMorph
	line2 := aLineMorph! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:34'!
line3
	^line3! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:35'!
line3: aLineMorph
	line3 := aLineMorph! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:34'!
line4
	^line4! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:35'!
line4: aLineMorph
	line4 := aLineMorph! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 13:35'!
reset
	self start:false.
	self secondPassed:0.

	self str2 hide.
	self str3 hide.
	self str4 hide.
	self str5 hide.
	self str6 hide.
	self str7 hide.
	self str8 hide.
	self str9 hide.
	self str10 hide.
	self str11 hide.
	self str12 hide.
	self str13 hide.
	self str14 hide.
	self str15 hide.
	self str16 hide.
	self str17 hide.
	
	self line2 hide.
	self line3 hide.
	self line4 hide.
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:37'!
secondPassed
	^secondPassed! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:37'!
secondPassed: aNumber
	secondPassed := aNumber! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:36'!
start
	^start! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:40'!
start: aBoolean
	start := aBoolean! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 12:41'!
stepTime
	^1000.! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 16:11'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
	
		self secondPassed = 1 ifTrue:
		[
			self str2 show.
		].

		self secondPassed = 2 ifTrue:
		[
			self str3 show.
		].

		self secondPassed = 3 ifTrue:
		[
			self str4 show.
			self line2 show.
		].

		self secondPassed = 4 ifTrue:
		[
			self str5 show.
		].

		self secondPassed = 5 ifTrue:
		[
			self str6 show.
		].

		self secondPassed = 6 ifTrue:
		[
			self str7 show.
		].

		self secondPassed = 7 ifTrue:
		[
			self str8 show.
		].

		self secondPassed = 8 ifTrue:
		[
			self str9 show.
		].

		self secondPassed = 9 ifTrue:
		[
			self str10 show.
			self line3 show.
		].

		self secondPassed = 10 ifTrue:
		[
			self str11 show.
		].

		self secondPassed = 11 ifTrue:
		[
			self str12 show.
		].

		self secondPassed = 12 ifTrue:
		[
			self str6 player setScaleFactor:2.
		].

		self secondPassed = 13 ifTrue:
		[
			self str6 player setScaleFactor:1.
			self str13 show.
		].

		self secondPassed = 14 ifTrue:
		[
			self str14 show.
		].

		self secondPassed = 15 ifTrue:
		[
			self str15 show.
		].

		self secondPassed = 16 ifTrue:
		[
			self str16 show.
			self line4 show.
		].

		self secondPassed = 17 ifTrue:
		[
			self str17 show.
			self start:false.
		].
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str10
	^str10
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str10: aStringMorph
	str10 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str11
	^str11
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str11: aStringMorph
	str11 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str12
	^str12
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str12: aStringMorph
	str12 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str13
	^str13
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str13: aStringMorph
	str13 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str14
	^str14
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str14: aStringMorph
	str14 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:16'!
str15
	^str15
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str15: aStringMorph
	str15 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:16'!
str16
	^str16
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str16: aStringMorph
	str16 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:16'!
str17
	^str17
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:19'!
str17: aStringMorph
	str17 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:14'!
str1
	^str1
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str1: aStringMorph
	str1 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:14'!
str2
	^str2
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str2: aStringMorph
	str2 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:14'!
str3
	^str3
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str3: aStringMorph
	str3 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:14'!
str4
	^str4
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str4: aStringMorph
	str4 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:14'!
str5
	^str5
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str5: aStringMorph
	str5 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str6
	^str6
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str6: aStringMorph
	str6 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str7
	^str7
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str7: aStringMorph
	str7 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str8
	^str8
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str8: aStringMorph
	str8 := aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:15'!
str9
	^str9
! !

!FractionAndEquivalentDecimalDivideHowTo1 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 12:18'!
str9: aStringMorph
	str9 := aStringMorph
! !

FractionAndEquivalentDecimalDivideHowTo1 subclass: #FractionAndEquivalentDecimalDivideHowTo2
	instanceVariableNames: 'str18 str19 str20 str21 str22'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 13:53'!
fontName:f size:s
	super fontName:f size:s.

	self str18 fontName:f size:s.
	self str19 fontName:f size:s.
	self str20 fontName:f size:s.
	self str21 fontName:f size:s.
	self str22 fontName:f size:s.
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 16:19'!
initialize
	super initialize.

	self str1 contents:'45 ) 20'.
	
	self str2 contents:'0'.
	
	self str3 contents:'.'.
	
	self str4 contents:'0'.
	
	self str5 contents:'4'.
	
	self str6 contents:'180'.
	
	self str7 contents:'-'.
	
	self str8 contents:'0'.
	
	self str9 contents:'2'.
	
	self str10 contents:'0'.
	
	self str11 contents:'4'.
	
	self str12 contents:'180'.
	
	self str13 contents:'-'.
	
	self str14 contents:'0'.
	
	self str15 contents:'2'.
	
	self str16 contents:'0'.
	
	self str17 contents:'4'.

	self str18:StringMorph new.
	self addMorph:self str18.
	self str18 contents:'180'.

	self str19:StringMorph new.
	self addMorph:self str19.
	self str19 contents:'-'.

	self str20:StringMorph new.
	self addMorph:self str20.
	self str20 contents:'0'.

	self str21:StringMorph new.
	self addMorph:self str21.
	self str21 contents:'2'.

	self str22:StringMorph new.
	self addMorph:self str22.
	self str22 contents:'0'.

! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 13:36'!
reset
	super reset.

	self str18 hide.
	self str19 hide.
	self str20 hide.
	self str21 hide.
	self str22 hide.
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 09:41'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
	
		self secondPassed = 1 ifTrue:
		[
			self str2 show.
			self str3 show.
		].

		self secondPassed = 2 ifTrue:
		[
			self str4 show.
		].

		self secondPassed = 3 ifTrue:
		[
			self str5 show.
		].

		self secondPassed = 4 ifTrue:
		[
			self str6 show.
		].

		self secondPassed = 5 ifTrue:
		[
			self str7 show.
			self line2 show.
		].

		self secondPassed = 6 ifTrue:
		[
			self str8 show.
		].

		self secondPassed = 7 ifTrue:
		[
			self str9 show.
		].

		self secondPassed = 8 ifTrue:
		[
			self str3 player setScaleFactor:2.
		].

		self secondPassed = 9 ifTrue:
		[
			self str3 player setScaleFactor:1.
			self str10 show.
		].

		self secondPassed = 10 ifTrue:
		[
			self str11 show.
		].

		self secondPassed = 11 ifTrue:
		[
			self str12 show.
		].

		self secondPassed = 12 ifTrue:
		[
			self str13 show.
			self line3 show. 
		].

		self secondPassed = 13 ifTrue:
		[
			self str14 show.
		].

		self secondPassed = 14 ifTrue:
		[
			self str15 show.
		].

		self secondPassed = 15 ifTrue:
		[
			self str3 player setScaleFactor:2.
		].

		self secondPassed = 16 ifTrue:
		[
			self str3 player setScaleFactor:1.
			self str16 show.
		].

		self secondPassed = 17 ifTrue:
		[
			self str17 show.
		].

		self secondPassed = 18 ifTrue:
		[
			self str18 show.
		].

		self secondPassed = 19 ifTrue:
		[
			self str19 show.
			self line4 show.		
		].

		self secondPassed = 20 ifTrue:
		[
			self str20 show.
		].

		self secondPassed = 21 ifTrue:
		[
			self str21 show.
		].

		self secondPassed = 22 ifTrue:
		[
			self str3 player setScaleFactor:2.
		].

		self secondPassed = 23 ifTrue:
		[
			self str3 player setScaleFactor:1.
			self str22 show.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:31'!
str18
	^str18
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:32'!
str18: aStringMorph
	str18 :=aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:31'!
str19
	^str19
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:32'!
str19: aStringMorph
	str19 :=aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:31'!
str20
	^str20
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:32'!
str20: aStringMorph
	str20 :=aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:31'!
str21
	^str21
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:32'!
str21: aStringMorph
	str21 :=aStringMorph
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:31'!
str22
	^str22
! !

!FractionAndEquivalentDecimalDivideHowTo2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 13:32'!
str22: aStringMorph
	str22 :=aStringMorph
! !

FractionAndEquivalentDecimalDivideHowTo1 subclass: #FractionAndEquivalentDecimalDivideHowTo3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalDivideHowTo3 methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 14:00'!
initialize
	super initialize.
	
	self str1 contents:'10 ) 11'.
	
	self str2 contents:'1'.
	
	self str3 contents:'10'.
	
	self str4 contents:'-'.
	
	self str5 contents:'1'.
	
	self str6 contents:'.'.
	
	self str7 contents:'0'.
	
	self str8 contents:'1'.
	
	self str9 contents:'10'.
	
	self str10 contents:'-'.
	
	self str11 contents:'X'.

! !

!FractionAndEquivalentDecimalDivideHowTo3 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 16:12'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
	
		self secondPassed = 1 ifTrue:
		[
			self str2 show.
		].

		self secondPassed = 2 ifTrue:
		[
			self str3 show.
		].

		self secondPassed = 3 ifTrue:
		[
			self str4 show.
			self line2 show.
		].

		self secondPassed = 4 ifTrue:
		[
			self str5 show.
		].

		self secondPassed = 5 ifTrue:
		[
			self str6 show.
		].

		self secondPassed = 6 ifTrue:
		[
			self str7 show.
		].

		self secondPassed = 7 ifTrue:
		[
			self str8 show.
		].

		self secondPassed = 8 ifTrue:
		[
			self str9 show.
		].

		self secondPassed = 9 ifTrue:
		[
			self str10 show.
			self line3 show.
		].

		self secondPassed = 10 ifTrue:
		[
			self str11 show.
			self start:false.
		].

	]
	ifFalse:
	[
		self stopStepping.
	]
	! !

Morph subclass: #FractionDisplay
	instanceVariableNames: 'wholeNumber numerator denomenator line qusNo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:30'!
denomenator
	^denomenator! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:30'!
denomenator: aStringMorph
	denomenator := aStringMorph! !

!FractionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/19/2008 11:37'!
fontName:f size:s
	self wholeNumber fontName:f size:s.
	self numerator fontName:f size:s.
	self denomenator fontName:f size:s.
! !

!FractionDisplay methodsFor: 'initialization' stamp: 'A 8/19/2008 11:21'!
initialize
	super initialize.
	
	self wholeNumber:StringMorph new.
	self numerator:StringMorph new.
	self denomenator:StringMorph new.

	self line: LineMorph new.
	self line verticesAt:1 put:(0@0).
	self line verticesAt:2 put:(30@0).

	self addMorph: self wholeNumber.
	self addMorph: self numerator.
	self addMorph: self denomenator.
	self addMorph: self line.


! !

!FractionDisplay methodsFor: 'initialization' stamp: 'A 8/19/2008 11:23'!
initWholeNumber:wn Numerator:n Denomenator:d

	wn = nil ifTrue:
	[
		self wholeNumber hide.
	]
	ifFalse:
	[
		self wholeNumber contents:wn.
		self wholeNumber show.
	].

	n = nil ifTrue:
	[
		self numerator hide.
	]
	ifFalse:
	[
		self numerator contents:n.
		self numerator show.
	].

	d = nil ifTrue:
	[
		self denomenator hide.
		self line hide.
	]
	ifFalse:
	[
		self denomenator contents:d.
		self denomenator show.
		self line show.

		(self denomenator width >= self numerator width) ifTrue:
		[
			self line width: (self denomenator width +10).
		]
		ifFalse:
		[
			self line width: (self numerator width +10).
		] 
	].
! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:32'!
line
	^line! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:32'!
line: aLineMorph
	line := aLineMorph! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:29'!
numerator
	^numerator! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:29'!
numerator: aStringMorph
	numerator := aStringMorph! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 13:57'!
qusNo
	^qusNo! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 13:57'!
qusNo:aNumber
	qusNo := aNumber! !

!FractionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/19/2008 11:36'!
showWholeNumber:wn Numerator:n Denomenator:d

	| x y |
	self height:50.

	self initWholeNumber:wn Numerator:n Denomenator:d.
	
	x := self left.
	y := self top + (self height/2).

	self wholeNumber visible ifTrue:
	[
		self wholeNumber center:((x + (self wholeNumber width/2))@y).
		x := x + self wholeNumber width + 5.
	].

	self line center: ((x + (self line width/2))@y).

	self denomenator visible ifTrue:
	[
		self denomenator center: (self line center + (0@5) + (0@(self denomenator height/2))).
		self numerator center: (self line center - (0@5) - (0@(self numerator height/2))).
	]
	ifFalse:
	[
		self numerator center: (self line center).
	].

	x := x + self line width.

	self width:(x - self left).

! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:28'!
wholeNumber
	^wholeNumber! !

!FractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:29'!
wholeNumber: aStringMorph
	wholeNumber := aStringMorph! !

Morph subclass: #FractionMultiplicationMorph
	instanceVariableNames: 'numerator1 numerator2 numerator3 numerator4 denomenator1 denomenator2 denomenator3 denomenator4 lineN1 lineN2 lineD1 lineD2 line1 line2 line3 resN resD res eq1 eq2 mul start secPassed eventReceiver eventSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:22'!
denomenator1
	^denomenator1! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:24'!
denomenator1: aStringMorph
	denomenator1 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:22'!
denomenator2
	^denomenator2! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:24'!
denomenator2: aStringMorph
	denomenator2 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:22'!
denomenator3
	^denomenator3! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:24'!
denomenator3: aStringMorph
	denomenator3 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:22'!
denomenator4
	^denomenator4! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:24'!
denomenator4: aStringMorph
	denomenator4 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:33'!
eq1
	^eq1
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:33'!
eq1: aStringMorph
	eq1 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:33'!
eq2
	^eq2
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:33'!
eq2: aStringMorph
	eq2 := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 09:32'!
eventReceiver
	^eventReceiver! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 09:33'!
eventSelector
	^eventSelector! !

!FractionMultiplicationMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 11:28'!
fontName:f size:s

	self numerator1 fontName:f size:s.
	self numerator2 fontName:f size:s.
	self numerator3 fontName:f size:s.
	self numerator4 fontName:f size:s.

	self denomenator1 fontName:f size:s.
	self denomenator2 fontName:f size:s.
	self denomenator3 fontName:f size:s.
	self denomenator4 fontName:f size:s.

	self resN fontName:f size:s.
	self resD fontName:f size:s.

	self eq1 fontName:f size:s.
	self eq2 fontName:f size:s.
	self mul fontName:f size:s.

	self res fontName:f size:s.

! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 09:34'!
initEventReceiver:r Selector:s
	eventReceiver:=r.
	eventSelector:=s.
! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 11:17'!
initialize
	super initialize.
	self start: false.
	self secPassed:0.

	self numerator1: StringMorph new.
	self addMorph:self numerator1.

	self numerator2: StringMorph new.
	self addMorph:self numerator2.

	self numerator3: StringMorph new.
	self addMorph:self numerator3.

	self numerator4: StringMorph new.
	self addMorph:self numerator4.

	self denomenator1: StringMorph new.
	self addMorph:self denomenator1.

	self denomenator2: StringMorph new.
	self addMorph:self denomenator2.

	self denomenator3: StringMorph new.
	self addMorph:self denomenator3.

	self denomenator4: StringMorph new.
	self addMorph:self denomenator4.

	self resN: StringMorph new.
	self addMorph:self resN.

	self resD: StringMorph new.
	self addMorph:self resD.

	self res: StringMorph new.
	self addMorph:self res.
	
	self eq1: StringMorph new.
	self eq1 contents: '='.
	self addMorph:self eq1.

	self eq2: StringMorph new.
	self eq2 contents: '='.
	self addMorph:self eq2.

	self mul: StringMorph new.
	self addMorph:self mul.
	self mul contents: 'X'.

	self line1: LineMorph new.
	self line1 verticesAt:1 put:(0@0).
	self line1 verticesAt:2 put:(20@0).
	self addMorph:self line1.

	self line2: LineMorph new.
	self line2 verticesAt:1 put:(0@0).
	self line2 verticesAt:2 put:(20@0).
	self addMorph:self line2.

	self line3: LineMorph new.
	self line3 verticesAt:1 put:(0@0).
	self line3 verticesAt:2 put:(20@0).
	self addMorph:self line3.

	self lineN1: LineMorph new.
	self lineN1 verticesAt:1 put:(0@0).
	self lineN1 verticesAt:2 put:(20@20).
	self addMorph:self lineN1.

	self lineN2: LineMorph new.
	self lineN2 verticesAt:1 put:(0@0).
	self lineN2 verticesAt:2 put:(20@20).
	self addMorph:self lineN2.

	self lineD1: LineMorph new.
	self lineD1 verticesAt:1 put:(0@0).
	self lineD1 verticesAt:2 put:(20@20).
	self addMorph:self lineD1.

	self lineD2: LineMorph new.
	self lineD2 verticesAt:1 put:(0@0).
	self lineD2 verticesAt:2 put:(20@20).
	self addMorph:self lineD2.
! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 10:47'!
initN1:n1 D1:d1 N2:n2 D2:d2

	self numerator1 contents:n1.
	self denomenator1 contents:d1.

	self numerator2 contents:n2.
	self denomenator2 contents:d2.
! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 10:48'!
initN3:n3 D3:d3 N4:n4 D4:d4
	
	self numerator3 contents:n3.
	self denomenator3 contents:d3.

	self numerator4 contents:n4.
	self denomenator4 contents:d4.

! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 10:48'!
initResN:n ResD:d Res:r
	self resN contents:n.
	self resD contents:d.
	self res contents:r.

	! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 10:47'!
initResN:n ResD:d
	self resN contents:n.
	self resD contents:d.

	! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:13'!
line1
	^line1
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:11'!
line1: aLineMorph
	line1 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:13'!
line2
	^line2
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:12'!
line2: aLineMorph
	line2 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:17'!
line3
	^line3
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:17'!
line3: aLineMorph
	line3 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:09'!
lineD1
	^lineD1
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:10'!
lineD1: aLineMorph
	lineD1 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:09'!
lineD2
	^lineD2
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:10'!
lineD2: aLineMorph
	lineD2 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:08'!
lineN1
	^lineN1
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:10'!
lineN1: aLineMorph
	lineN1 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:09'!
lineN2
	^lineN2
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:10'!
lineN2: aLineMorph
	lineN2 := aLineMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:33'!
mul
	^mul
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:34'!
mul: aStringMorph
	mul := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:03'!
numerator1
	^numerator1! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:04'!
numerator1: aStringMorph
	numerator1 := aStringMorph! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:03'!
numerator2
	^numerator2! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:04'!
numerator2: aStringMorph
	numerator2 := aStringMorph! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:03'!
numerator3
	^numerator3! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:04'!
numerator3: aStringMorph
	numerator3 := aStringMorph! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:03'!
numerator4
	^numerator4! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:04'!
numerator4: aStringMorph
	numerator4 := aStringMorph! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:06'!
resD
	^resD
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:06'!
resD: aStringMorph
	resD := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 11:33'!
reset
	self secPassed:0.
	self start:false.

	self numerator3 hide.
	self numerator4 hide.

	self denomenator3 hide.
	self denomenator4 hide.

	self lineN1 hide.
	self lineN2 hide.
	self lineD1 hide.
	self lineD2 hide.
	self line3 hide.

	self eq2 hide.
	self resN hide.
	self resD hide.
	self res hide.
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:04'!
resN
	^resN! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:05'!
resN: aStringMorph
	resN := aStringMorph! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:06'!
res
	^res
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:07'!
res: aStringMorph
	res := aStringMorph
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:41'!
secPassed
	^secPassed! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:41'!
secPassed: aNumber
	secPassed := aNumber
! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:39'!
start
	^start! !

!FractionMultiplicationMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 10:39'!
start: aBoolean
	start := aBoolean! !

!FractionMultiplicationMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 10:38'!
stepTime
	^500
	! !

!FractionMultiplicationMorph methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 09:45'!
step
	self start ifTrue:
	[
		self secPassed = 1 ifTrue:
		[
			self lineD1 show.
			self denomenator3 show.
		].

		self secPassed = 2 ifTrue:
		[
			self lineN2 show.
			self numerator4 show.
		].

		self secPassed = 3 ifTrue:
		[
			self lineD2 show.
			self denomenator4 show.
		].

		self secPassed = 4 ifTrue:
		[
			self lineN1 show.
			self numerator3 show.
		].

		self secPassed = 5 ifTrue:
		[
			self resN show.
			self resD show.
			self line3 show.
		].

		self secPassed = 6 ifTrue:
		[
			self eq2 show.
			self res show.
		].

		self secPassed = 7 ifTrue:
		[
"			self reset.
"			self start:false.
			(self eventReceiver) perform:(self eventSelector).
		].

		self secPassed: self secPassed + (0.5).		
	]
	ifFalse:
	[
		self stopStepping.	
	].
! !

!FractionMultiplicationMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 14:26'!
test
	self initN1:'21' D1:'4' N2:'8' D2:'3'.
	self initN3:'7' D3:'1' N4:'2' D4:'1'.
	self initResN:'7 X 2' ResD:'1' Res:'14'.
	
	self fontName:'BitstreamVeraSans' size:36.
! !

Morph subclass: #FractionMultiplicationQuestionDisplay
	instanceVariableNames: 'wholeNumber1 wholeNumber2 numerator1 numerator2 denomenator1 denomenator2 sign line1 line2 qusNo equals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:21'!
denomenator1
	^denomenator1! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:21'!
denomenator1: aStringMorph
	denomenator1 := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:21'!
denomenator2
	^denomenator2! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:21'!
denomenator2: aStringMorph
	denomenator2 := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/15/2008 15:27'!
equals
	^equals! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/15/2008 15:27'!
equals: aStringMorph
	equals := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 15:34'!
fontName:f size:s
	self wholeNumber1 fontName:f size:s.
	self wholeNumber2 fontName:f size:s.
	self numerator1 fontName:f size:s.
	self numerator2 fontName:f size:s.
	self denomenator1 fontName:f size:s.
	self denomenator2 fontName:f size:s.
	self equals fontName:f size:s.
! !

!FractionMultiplicationQuestionDisplay methodsFor: 'initialization' stamp: 'A 8/15/2008 15:27'!
initialize
	super initialize.
	
	self line1: LineMorph new.
	self line1 verticesAt:1 put:(0@0).
	self line1 verticesAt:2 put:(30@0).
	self addMorph:self line1.

	self line2: LineMorph new.
	self line2 verticesAt:1 put:(0@0).
	self line2 verticesAt:2 put:(30@0).
	self addMorph:self line2.

	self wholeNumber1:StringMorph new.
	self addMorph:self wholeNumber1.
	
	self wholeNumber2:StringMorph new.
	self addMorph:self wholeNumber2.

	self denomenator1:StringMorph new.
	self addMorph:self denomenator1.

	self denomenator2:StringMorph new.
	self addMorph:self denomenator2.

	self numerator1:StringMorph new.
	self addMorph:self numerator1.

	self numerator2:StringMorph new.
	self addMorph:self numerator2.

	self sign:StringMorph new.
	self addMorph:self sign.

	self equals:StringMorph new.
	self addMorph:self equals.

! !

!FractionMultiplicationQuestionDisplay methodsFor: 'initialization' stamp: 'A 8/14/2008 10:31'!
initValues:qus
	(qus at:1) = nil ifTrue:
	[
		self wholeNumber1 hide.
	]
	ifFalse:
	[
		self wholeNumber1 contents:(qus at:1).
	].

	(qus at:3) = nil ifTrue:
	[
		self denomenator1 hide.
		self line1 hide.
	]
	ifFalse:
	[
		self denomenator1 contents:(qus at:3).
	].

	(qus at:4) = nil ifTrue:
	[
		self wholeNumber2 hide.
	]
	ifFalse:
	[
		self wholeNumber2 contents:(qus at:4).
	].

	(qus at:6) = nil ifTrue:
	[
		self denomenator2 hide.
		self line2 hide.
	]
	ifFalse:
	[
		self denomenator2 contents:(qus at:6).
	].

	self numerator1 contents:(qus at:2).
	self numerator2 contents:(qus at:5).
! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:22'!
line1
	^line1! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:25'!
line1: aLineMorph
	line1 := aLineMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:22'!
line2
	^line2! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:25'!
line2: aLineMorph
	line2 := aLineMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/14/2008 10:29'!
maxWidthObj1:o1 Obj2:o2
	o1 width > o2 width ifTrue:
	[
		^o1 width.
	].

	^o2 width.! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:20'!
numerator1
	^numerator1! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:20'!
numerator1: aStringMorph
	numerator1 := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:20'!
numerator2
	^numerator2! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:20'!
numerator2: aStringMorph
	numerator2 := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:09'!
qusNo
	^qusNo! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:09'!
qusNo: aNumber
	qusNo := aNumber! !

!FractionMultiplicationQuestionDisplay methodsFor: 'initialization' stamp: 'A 8/14/2008 15:29'!
reset

	self wholeNumber1 contents:'1'.
	self wholeNumber2 contents:'1'.
	self denomenator1 contents:'1'.
	self denomenator2 contents:'1'.
	self numerator1 contents:'1'.
	self numerator2 contents:'1'.
	self sign contents:'X'.
! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/14/2008 09:35'!
showAll
	self line1 show.
	self line2 show.
	self wholeNumber1 show.
	self wholeNumber2 show.
	self denomenator1 show.
	self denomenator2 show.
	self numerator1 show.
	self numerator2 show.
	self sign show.
! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 16:46'!
showQuestion:qus Sign:s
	| x y |
	self reset.
	self showAll.
	self initValues:qus.

	self equals contents:'='.

	self sign contents:s.

	self line1 width: (self maxWidthObj1:(self numerator1) Obj2:(self denomenator1)).
	self line2 width: (self maxWidthObj1:(self numerator2) Obj2:(self denomenator2)).

	x := self left + 5.
	y :=self top + (self height/2).

	self wholeNumber1 visible ifTrue:
	[
		self wholeNumber1 center:((x + (self wholeNumber1 width/2))@y).
		x := x + self wholeNumber1 width + 10.
	].

	self line1 center:((x + (self line1 width/2))@y).

	self denomenator1 visible ifTrue:
	[
		self denomenator1 center:( (line1 center) + (0@(self denomenator1 height/2)) + (0@10) ).
		self numerator1 center:( (line1 center) - (0@(self numerator1 height/2)) - (0@10) ).
	]
	ifFalse:
	[
		self numerator1 center:line1 center.
	].

	x := x + self line1 width + 10.

	self sign center:((x + (self sign width/2))@y).

	x := x + self sign width + 10.

	self wholeNumber2 visible ifTrue:
	[
		self wholeNumber2 center:((x + (self wholeNumber2 width/2))@y).
		x := x + self wholeNumber2 width + 10.
	].

	self line2 center:((x + (self line2 width/2))@y).

	self denomenator2 visible ifTrue:
	[
		self denomenator2 center:( (line2 center) + (0@(self denomenator2 height/2)) + (0@10) ).
		self numerator2 center:( (line2 center) - (0@(self numerator2 height/2)) - (0@10) ).
	]
	ifFalse:
	[
		self numerator2 center:line2 center.
	].

	x := x + self line2 width + 10.
	
	self equals center: ((x@y) + (self equals width/2@0)).

	x := x + self equals width + 5.

	self width:(x - self left).
	self height:50.! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 10:26'!
sign
	^sign! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:26'!
sign: aStringMorph
	sign := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 15:34'!
test2
	self equals: StringMorph new.
	self addMorph: self equals.! !

!FractionMultiplicationQuestionDisplay methodsFor: 'miscellaneous' stamp: 'A 8/14/2008 10:28'!
test
	| qus |
	qus := Array withAll:#('1' '22' '333' '4444' '55555' '666666').
	self showQuestion:qus Sign:'X'.! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:18'!
wholeNumber1
	^wholeNumber1! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:19'!
wholeNumber1: aStringMorph
	wholeNumber1 := aStringMorph! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:18'!
wholeNumber2
	^wholeNumber2! !

!FractionMultiplicationQuestionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 09:19'!
wholeNumber2: aStringMorph
	wholeNumber2 := aStringMorph! !

Morph subclass: #GameFeedbackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameFeedbackMorph class methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 18:00'!
showState: state
	| class |
	class := state caseOf: { [#happy]   -> [GameHappyMorph].
						 [#neutral] -> [GameNeutralMorph].
						 [#sad]       -> [GameSadMorph] }.
	World selectKind: self do: [ :m | (m isKindOf: class) ifTrue: [m show] ifFalse: [m hide] ].
! !

GameFeedbackMorph subclass: #GameHappyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameNeutralMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

GameFeedbackMorph subclass: #GameSadMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlighterMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Morph subclass: #HighlightMorph
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:19'!
handlesMouseDown: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:23'!
handlesMouseOver: event
	^true! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 11:04'!
mouseDown: event
	self color: Color transparent.
	self beep: 'click'.
	project enter! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseEnter: event
	self color: (Color yellow alpha: 0.3).! !

!HighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 14:25'!
mouseLeave: event
	self color: Color transparent.! !

Morph subclass: #LcmHowTo
	instanceVariableNames: 'str1 str2 str3 str4 str5 str6 str7 line1 line2 line3 line4 start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:39'!
fontName:f size:s
	self str1 fontName:f size:s.
	self str2 fontName:f size:s.
	self str3 fontName:f size:s.
	self str4 fontName:f size:s.
	self str5 fontName:f size:s.
	self str6 fontName:f size:s.
	self str7 fontName:f size:s.
! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 13:23'!
initialize
	super initialize.
	self start:false.
	self secondPassed:0.

	self str1: StringMorph new.
	self str1 contents:'4,8'.
	self addMorph:self str1.

	self str2: StringMorph new.
	self str2 contents:'2'.
	self addMorph:self str2.

	self str3: StringMorph new.
	self str3 contents:'2,'.
	self addMorph:self str3.

	self str4: StringMorph new.
	self str4 contents:'4'.
	self addMorph:self str4.

	self str5: StringMorph new.
	self str5 contents:'2'.
	self addMorph:self str5.

	self str6: StringMorph new.
	self str6 contents:'1,'.
	self addMorph:self str6.

	self str7: StringMorph new.
	self str7 contents:'2'.
	self addMorph:self str7.

	self line1:LineMorph new.
	self line1 verticesAt:1 put:(0@0).
	self line1 verticesAt:2 put:(30@0).
	self addMorph:self line1.

	self line2:LineMorph new.
	self line2 verticesAt:1 put:(0@0).
	self line2 verticesAt:2 put:(30@0).
	self addMorph:self line2.

	self line3:LineMorph new.
	self line3 verticesAt:1 put:(0@0).
	self line3 verticesAt:2 put:(30@0).
	self addMorph:self line3.

	self line4:LineMorph new.
	self line4 verticesAt:1 put:(0@0).
	self line4 verticesAt:2 put:(30@0).
	self addMorph:self line4.

	self fontName:'BitstreamVeraSans' size:36.
! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:13'!
line1 
	^line1! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
line1: aLineMorph 
	line1 := aLineMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:13'!
line2 
	^line2! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
line2: aLineMorph 
	line2 := aLineMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:13'!
line3 
	^line3! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
line3: aLineMorph 
	line3 := aLineMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:13'!
line4 
	^line4! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
line4: aLineMorph 
	line4 := aLineMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/9/2008 13:29'!
reset
	self line3 hide.
	self line4 hide.

	self start:false.
	self secondPassed:0.


	self str2 hide.
	self str3 hide.
	self str4 hide.
	self str5 hide.
	self str6 hide.
	self str7 hide.

! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:16'!
secondPassed
	^secondPassed! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:15'!
secondPassed:	aNumber
	secondPassed:=aNumber! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
start
	^start! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:14'!
start: aBoolean
	start := aBoolean! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:16'!
stepTime
	^1000! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'a 10/20/2008 15:27'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.

		self secondPassed = 1 ifTrue:
		[
			self str2 show.		
		].

		self secondPassed = 2 ifTrue:
		[
			self str3 show.		
		].

		self secondPassed = 3 ifTrue:
		[
			self str4 show.		
		].

		self secondPassed = 4 ifTrue:
		[
			self str5 show.		
			self line3 show.
			self line4 show.
		].

		self secondPassed = 5 ifTrue:
		[
			self str6 show.		
		].

		self secondPassed = 6 ifTrue:
		[
			self str7 show.
			self start:false.
			self owner lcmHowTo1Complete. 		
		].

	]
	ifFalse:
	[
		self stopStepping.
	]! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str1
	^str1! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str1: aStringMorph
	str1 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str2
	^str2! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str2: aStringMorph
	str2 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str3
	^str3! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str3: aStringMorph
	str3 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str4
	^str4! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str4: aStringMorph
	str4 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str5
	^str5! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str5: aStringMorph
	str5 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str6
	^str6! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str6: aStringMorph
	str6 := aStringMorph! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:11'!
str7
	^str7! !

!LcmHowTo methodsFor: 'as yet unclassified' stamp: 'Aayush 9/5/2008 10:12'!
str7: aStringMorph
	str7 := aStringMorph! !

Morph subclass: #LcmPageTimer1
	instanceVariableNames: 'start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 15:11'!
initialize
	super initialize.
	self start:false.
	self secondPassed:0.
! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/9/2008 14:09'!
reset
	self start:false.
	self secondPassed:0.
! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 14:59'!
secondPassed
	^secondPassed! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 14:59'!
secondPassed: aNumber
	^secondPassed := aNumber! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 14:58'!
start
	^start! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 14:58'!
start: aBoolean
	start := aBoolean! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 15:00'!
stepTime
	^1000! !

!LcmPageTimer1 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 15:09'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed > 3 ifTrue:
		[
			self owner object1 hide.
			self owner moveableObject1 show.
			self owner motionGuide1 startMotion.

			self start:false.
			self secondPassed:0.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

LcmPageTimer1 subclass: #LcmPageTimer2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPageTimer2 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 15:12'!
initialize
	super initialize! !

!LcmPageTimer2 methodsFor: 'as yet unclassified' stamp: 'Aayush 9/4/2008 15:13'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed > 3 ifTrue:
		[
			self owner object2 hide.
			self owner moveableObject2 show.
			self owner motionGuide2 startMotion.

			self start:false.
			self secondPassed:0.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

Morph subclass: #MemoryGame
	instanceVariableNames: 'wordPairList imagePairList pictureHolder tiles ansPair gameMode currentOpen previousOpen noOfTilesOpen processTileClickEvent timer magicStar magicStarIndex gameTimePassed magicStarTimePassed gameRunning showingAll showingAllTimePassed pairMatched playTableOf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-MemoryGameActivity'!

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:11'!
ansPair
	^ansPair
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:11'!
ansPair: anArray
	ansPair := anArray
! !

!MemoryGame methodsFor: 'Change-Preferences' stamp: 'Aayush 4/14/2008 12:02'!
changeTextDirection:random
	| index x |
	index:=1.
	[
		random = true ifTrue:
		[
			x := 2 random.
			x = 1 ifTrue:
			[
				((self tiles at:index) textBox) heading: -45.
			]
			ifFalse:
			[
				((self tiles at:index) textBox) heading: 45.
			]
		]
		ifFalse:
		[
			((self tiles at:index) textBox) heading: -45.
		].
		index:= index + 1.
		index <=30.
	]whileTrue.! !

!MemoryGame methodsFor: 'Change-Preferences' stamp: 'Aayush 4/14/2008 12:03'!
changeTextSize:size
	| index |
	index:=1.
	[
		((self tiles at:index) textBox) fontName: 'BitstreamVeraSans' size: size.
		index:= index + 1.
		index <=30.
	]whileTrue.! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/10/2008 21:52'!
checkAnswer
	(self ansPair at: (self currentOpen)) = self previousOpen ifTrue:
	[
		^ true.
	]
	ifFalse:
	[
		^ false.
	].! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
currentOpen
	^currentOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
currentOpen: aNumber
	currentOpen:= aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:54'!
gameMode
	^gameMode
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:55'!
gameMode: aNumber
	gameMode := aNumber.
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:15'!
gameRunning
	^gameRunning! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:16'!
gameRunning: aBoolean
	gameRunning := aBoolean.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
gameTimePassed
	^gameTimePassed! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
gameTimePassed: aNumber
	gameTimePassed := aNumber! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 17:19'!
generateImagePairQuestions
	| list qusCount x tileSelected1 tileSelected2 picFromHolder |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		(self pictureHolder) cursor: qusCount.
		picFromHolder := (self pictureHolder) valueAtCursor.

		(self tiles at:tileSelected1) showText:false.
		((self tiles at:tileSelected1) textBox) hide.
		((self tiles at:tileSelected1) picture) wearCostume: picFromHolder form.

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		(self tiles at:tileSelected2) showText:false.
		((self tiles at:tileSelected2) textBox) hide.
		((self tiles at:tileSelected2) picture) wearCostume: picFromHolder form.

		list removeAt:x.
		(self pictureHolder) cursor: (self pictureHolder) cursor + 1.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 11:04'!
generateImageWordPairQuestions

	| list qusCount x tileSelected1 tileSelected2 picFromHolder |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).


	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		picFromHolder := (self pictureHolder) valueAtCursor.

		(self tiles at:tileSelected1) showText:false.
		((self tiles at:tileSelected1) textBox) hide.
		((self tiles at:tileSelected1) picture) wearCostume: picFromHolder form.

		(self pictureHolder) cursor: (self pictureHolder) cursor + 1.

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		(self tiles at:tileSelected2) showText:true.
		((self tiles at:tileSelected1) picture) hide.
		((self tiles at: tileSelected2) textBox) contents: picFromHolder externalName.

		list removeAt:x.
		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 15:52'!
generateMathQuestions
	| list qusCount x z y tileSelected1 tileSelected2 |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).
"
	z := self playTableOf.
"
	z := 8 random + 1.

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		y := qusCount + 1.
				
		((self tiles at: tileSelected1) textBox) contents: z printString,'*', y printString.

		list removeAt:	x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		((self tiles at: tileSelected2) textBox) contents: (z*y) printString.

		list removeAt:	x.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 00:43'!
generateWordPairQuestions

	| list qusCount x tileSelected1 tileSelected2 |

	list := OrderedCollection new.
	list addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30).

	qusCount := 1.
	[
		x :=(list size) random.
		tileSelected1 := list at:x.
	
		((self tiles at: tileSelected1) textBox) contents: ((self wordPairList at:qusCount) at:1).

		list removeAt:x.
		
		Transcript show: '[', tileSelected1 printString, ','.

		x :=(list size) random.
		tileSelected2 := list at:x.

		Transcript show: tileSelected2 printString, '] '.

		((self tiles at: tileSelected2) textBox) contents: ((self wordPairList at:qusCount) at:2).

		list removeAt:x.

		self ansPair at: tileSelected1 put:tileSelected2.
		self ansPair at: tileSelected2 put:tileSelected1.

		qusCount := qusCount + 1.
		qusCount <=15
	]whileTrue.	! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 11:59'!
getStarIndex
	
	| list tileIndex x |

	list := OrderedCollection new.

	tileIndex := 1.
	[
		(self tiles at: tileIndex) visible = true ifTrue:
		[
			list add: tileIndex.
		].

		tileIndex := tileIndex + 1.
		tileIndex <= 30
	]whileTrue.

	x := (list size)	random.
	
	^ (list at:x).
	
! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 13:06'!
hideAll
	| index |
	index := 1.
	[
		(self tiles at:index) textBox hide.
		(self tiles at:index) picture hide.

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:20'!
imagePairList
	^imagePairList! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:20'!
imagePairList: anArray
	imagePairList := anArray.! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 17:11'!
initImagePairList
	self imagePairList: (Array new:30).

	self imagePairList at:1 put: 1.
	self imagePairList at:2 put: 2.
	self imagePairList at:3 put: 3.
	self imagePairList at:4 put: 4.
	self imagePairList at:5 put: 5.
	self imagePairList at:6 put: 6.
	self imagePairList at:7 put: 7.
	self imagePairList at:8 put: 8.
	self imagePairList at:9 put: 9.
	self imagePairList at:10 put: 10.
	self imagePairList at:11 put: 11.
	self imagePairList at:12 put: 12.
	self imagePairList at:13 put: 13.
	self imagePairList at:14 put: 14.
	self imagePairList at:15 put: 15.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 15:37'!
initialize
	super initialize.

	self toggleStickiness.

	self gameMode:1.
	self currentOpen:0.
	self previousOpen:0.
	self noOfTilesOpen:0.
	self magicStarIndex:0.
	self gameTimePassed:0.
	self gameRunning: false.
	self magicStarTimePassed:0.
	self processTileClickEvent: true.
	self showingAll: false.
	self showingAllTimePassed:0.
	self pairMatched:0.
	self playTableOf: 2.

	self timer: MyTimer new.
	self timer setTimerHour:1 Minute:0 Second:0.
	self timer countUp: true.
	self timer openInWorld.
	
	self ansPair: (Array new:30).

	self initTilesPosition.

	self magicStar: StarMorph new.
	self magicStar color: (Color r:1 g:0 b:0).
	self magicStar toggleStickiness.

	self addMorph: self magicStar.
	(self magicStar) hide.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 11:31'!
initPictureHolder
	self pictureHolder: PasteUpMorph new.
	self pictureHolder toggleAutoLineLayout.
	self pictureHolder openInWorld.
! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 11:34'!
initTilesPosition

	| tileIndex tileWidth tileHeight left top row |
	self tiles: (Array new:30).
	tileIndex := 1.
	[
		self tiles at:tileIndex put: MemoryTile new.
		(self tiles at: tileIndex) on: #mouseDown send: #tileClick:v2:v3: to:self withValue:tileIndex.

	tileIndex := tileIndex +1.
	tileIndex<=30] whileTrue.

	tileWidth := (self tiles at:1) width.
	tileHeight := (self tiles at:1) height.

	self bounds: (0@0 extent: (  ((tileWidth*6) + (5*5))  @  ((tileHeight*5) + (4*5))  )  ).

	left := 0.
	top := 0.
	tileIndex := 1.

	row := 1.
	[
		6 timesRepeat:
		[
			self addMorph: (self tiles at: tileIndex).
		

			(self tiles at: tileIndex) left: left.
			(self tiles at: tileIndex) top: top.
			left := left + (self tiles at: tileIndex) width + 5.
			tileIndex := tileIndex + 1.

		].
		top := top + (self tiles at: 1) height + 5.
		left := 0.

		row := row + 1.
		row <=5
	] whileTrue.
	! !

!MemoryGame methodsFor: 'initialization' stamp: 'Aayush 4/11/2008 00:46'!
initWordPairList
	| index |
	self
		wordPairList: (Array new: 15).
	index := 1.
	[(self wordPairList) at:index put: (Array new:2).
	index := index + 1.
	index <= 15] whileTrue.
	(self wordPairList at: 1)
		at: 1
		put: 'Sheep'.
	(self wordPairList at: 1)
		at: 2
		put: 'Wool'.
	(self wordPairList at: 2)
		at: 1
		put: 'Cow'.
	(self wordPairList at: 2)
		at: 2
		put: 'Milk'.
	(self wordPairList at: 3)
		at: 1
		put: 'Wheat'.
	(self wordPairList at: 3)
		at: 2
		put: 'Flour'.
	(self wordPairList at: 4)
		at: 1
		put: 'Hen'.
	(self wordPairList at: 4)
		at: 2
		put: 'Egg'.
	(self wordPairList at: 5)
		at: 1
		put: 'Bee'.
	(self wordPairList at: 5)
		at: 2
		put: 'Honey'.
	(self wordPairList at: 6)
		at: 1
		put: 'Lamp'.
	(self wordPairList at: 6)
		at: 2
		put: 'Light'.
	(self wordPairList at: 7)
		at: 1
		put: 'Cloud'.
	(self wordPairList at: 7)
		at: 2
		put: 'Rain'.
	(self wordPairList at: 8)
		at: 1
		put: 'Tap'.
	(self wordPairList at: 8)
		at: 2
		put: 'Watar'.
	(self wordPairList at: 9)
		at: 1
		put: 'Tree'.
	(self wordPairList at: 9)
		at: 2
		put: 'Fruit'.
	(self wordPairList at: 10)
		at: 1
		put: 'Wood'.
	(self wordPairList at: 10)
		at: 2
		put: 'Chair'.
	(self wordPairList at: 11)
		at: 1
		put: 'Cloth'.
	(self wordPairList at: 11)
		at: 2
		put: 'Shirt'.
	(self wordPairList at: 12)
		at: 1
		put: 'Brick'.
	(self wordPairList at: 12)
		at: 2
		put: 'House'.
	(self wordPairList at: 13)
		at: 1
		put: 'Sugar'.
	(self wordPairList at: 13)
		at: 2
		put: 'Sweet'.
	(self wordPairList at: 14)
		at: 1
		put: 'Glass'.
	(self wordPairList at: 14)
		at: 2
		put: 'Bottle'.
	(self wordPairList at: 15)
		at: 1
		put: 'Leather'.
	(self wordPairList at: 15)
		at: 2
		put: 'Shoes'! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:08'!
magicStarIndex
	^magicStarIndex.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:09'!
magicStarIndex: aNumber
	magicStarIndex := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:10'!
magicStarTimePassed
	^magicStarTimePassed! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:10'!
magicStarTimePassed: aNumber
	magicStarTimePassed := aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:52'!
magicStar
	^magicStar! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:52'!
magicStar: aStarMorph
	magicStar := aStarMorph! !

!MemoryGame methodsFor: 'Questions-Answers' stamp: 'Aayush 4/11/2008 11:06'!
makeNewQuestions
	
	| x |
	self gameMode = 1 ifTrue:
	[
		self generateMathQuestions.
	]
	ifFalse:
	[
		self gameMode = 2 ifTrue:
		[
			self generateImageWordPairQuestions.
		]
		ifFalse:
		[
			self gameMode = 3 ifTrue:
			[
				self generateImagePairQuestions.
			]
			ifFalse:
			[
				self gameMode = 4 ifTrue:
				[
					self generateWordPairQuestions.
				]
				ifFalse:
				[
	
				]
			]
		]
	].

	x :=1.
	[
		((self tiles at:x) textBox) center: ((self tiles at:x) center).
		((self tiles at:x) picture) center: ((self tiles at:x) center).
		x := x + 1.
		x <= 30
	]whileTrue.
	! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 20:12'!
noOfTilesOpen
	^noOfTilesOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 20:12'!
noOfTilesOpen: aNumber
	noOfTilesOpen := aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 13:10'!
pairMatched
	^pairMatched! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 13:10'!
pairMatched: aNumber
	pairMatched := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: ''!
pictureHolder
	^ pictureHolder! !

!MemoryGame methodsFor: 'accessing - properties' stamp: ''!
pictureHolder: aPasteUpMorph 
	pictureHolder := aPasteUpMorph! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 11:58'!
placeStarAt: tileIndex
	
	| left top row col qus rem |

	row := 1.
	col := tileIndex.

	tileIndex > 6 ifTrue:
	[
		qus := tileIndex // 6.
		rem := tileIndex \\ 6.

		col := rem.
		row := qus.

		col ~= 0 ifTrue:
		[
			row := qus + 1.						
		]
		ifFalse:
		[
			col := 6.
		]
	].

	left :=  ( (col-1) * ((self tiles at:1) width) + ((col-1)*5) ) + self left.
	top :=  ( (row-1) * ((self tiles at:1) height) + ((row-1)*5) ) + self top.

	(self magicStar) left: left.
	(self magicStar) top: top.

	(self magicStar) comeToFront.
	(self magicStar) show.
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 15:30'!
playTableOf
	^playTableOf! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 15:31'!
playTableOf: aNumber
	playTableOf := aNumber.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:10'!
previousOpen
	^previousOpen! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:09'!
previousOpen: aNumber
	previousOpen:= aNumber! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 22:50'!
processTileClickEvent
	^processTileClickEvent! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/10/2008 22:50'!
processTileClickEvent: aBoolean
	processTileClickEvent := aBoolean! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 16:14'!
reset
	| index |
	
	self pairMatched:0.
	self currentOpen:0.
	self previousOpen:0.
	self noOfTilesOpen:0.
	self showingAll: false.
	self magicStarIndex:0.
	self magicStar hide.
	self gameTimePassed:0.
	self gameRunning: false.
	self magicStarTimePassed:0.
	self showingAllTimePassed:0.
	self processTileClickEvent: true.
	self timer reset.

	index := 1.
	[
		(self tiles at:index) show.
		(self tiles at:index) textBox hide.
		(self tiles at:index) picture hide.

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 13:07'!
showAll
	| index |
	index := 1.
	[
		(self tiles at:index) visible = true ifTrue:
		[
			(self tiles at:index) showText = true ifTrue:
			[
				(self tiles at:index) textBox show.
			]
			ifFalse:
			[
				(self tiles at:index) picture show.
			]
		].

		index := index + 1.
		index <= 30
	]whileTrue.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:57'!
showingAllTimePassed
	^showingAllTimePassed
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:57'!
showingAllTimePassed: aNumber
	showingAllTimePassed := aNumber
! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:56'!
showingAll
	^showingAll! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 12:56'!
showingAll: aBoolean
	showingAll := aBoolean.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 14:45'!
startNewGame
	self reset.
	self makeNewQuestions.
	self gameRunning: true.
	self timer start.
	self startStepping.! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/11/2008 12:11'!
stepTime
	^1000! !

!MemoryGame methodsFor: 'as yet unclassified' stamp: 'Aayush 4/14/2008 17:05'!
step
	self gameRunning = false ifTrue:
	[
		self stopStepping.
	]
	ifFalse:
	[
		self gameTimePassed: self gameTimePassed + 1.

		self showingAll = true ifTrue:
		[
			self showingAllTimePassed:  self showingAllTimePassed + 1.

			self showingAllTimePassed = 7 ifTrue:
			[
				self showingAllTimePassed:  0.
				self showingAll: false.
				self processTileClickEvent:true.
				self hideAll.
			]
		].

		(self magicStar)  visible = true ifTrue:
		[
			self magicStarTimePassed: self magicStarTimePassed +1.		

			self magicStarTimePassed = 5 ifTrue:
			[
				(self magicStar) hide.
				self magicStarTimePassed:0.
				self magicStarIndex:0.
			]
		].

		self gameTimePassed = 10 ifTrue:
		[
			self gameTimePassed:0.
			self magicStarIndex:   (self getStarIndex).
			self placeStarAt: (self magicStarIndex).
		]
	]
! !

!MemoryGame methodsFor: 'events-processing' stamp: 'Aayush 4/11/2008 12:28'!
tileClick:tileIndex v2:x v3:y
	self gameRunning = true ifTrue:
	[
		self processTileClickEvent = true ifTrue:
		[
			self processTileClickEvent: false.
			self currentOpen = tileIndex ifTrue:
			[
				self noOfTilesOpen: 0.
				self previousOpen: 0.
				self currentOpen: 0.
				self processTileClickEvent: true.
			]
			ifFalse:
			[
				self noOfTilesOpen: self noOfTilesOpen + 1.
				self previousOpen: self currentOpen.
				self currentOpen: tileIndex.
			].
			(self tiles at:tileIndex) startStepping.
		]
	]

! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 15:12'!
tiles
	^tiles.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 15:12'!
tiles: anArray
	tiles:= anArray! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:42'!
timer
	^timer! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/11/2008 11:43'!
timer: timerMorph
	timer :=  timerMorph.! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:17'!
wordPairList
	^ wordPairList! !

!MemoryGame methodsFor: 'accessing - properties' stamp: 'Aayush 4/9/2008 16:17'!
wordPairList: anArray 
	wordPairList := anArray! !

Morph subclass: #MoreVariablesActivity
	instanceVariableNames: 'objectDisplay1 objectDisplay2 objectDiscription1 objectDiscription2 objectDiscription3 variableDisplay btnConfirm score noOfAttempt btnPlayAgain question currentQuestion questionPool gameOverDisplay start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-MoreVariablesActivity'!

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:42'!
btnConfirmClick
	self noOfAttempt: self noOfAttempt + 1.	
	self checkAnswer ifTrue:
	[
		SoundService default playSoundNamedOrBeep: 'right1'.

		self start:true.
		self startStepping.
	]
	ifFalse:
	[
		SoundService default playSoundNamedOrBeep: 'wrong3'.
		self variableDisplay showHideReasult:false.
		self variableDisplay showHideQuantity:false.
	].
	
	ActiveHand keyboardFocus: ((self variableDisplay) textMultiplier).
	((self variableDisplay) textMultiplier) editor selectAll.! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:08'!
btnConfirm
	^btnConfirm! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:09'!
btnConfirm: anImageMorph
	btnConfirm:= anImageMorph! !

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/1/2008 16:04'!
btnPlayAgainClick
	self reset.	! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:17'!
btnPlayAgain
	^btnPlayAgain! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:18'!
btnPlayAgain: anImageMorph
	btnPlayAgain := anImageMorph! !

!MoreVariablesActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/1/2008 13:27'!
checkAnswer
	| valueOfOne quantity txtM strValueOfOne txtR strProduct |

	valueOfOne := (self question at: (self currentQuestion)) at:6.
	quantity := (self question at: (self currentQuestion)) at:5.

	txtM := (self variableDisplay textMultiplier getCharacters).
	strValueOfOne := valueOfOne asString.

	strProduct := (valueOfOne * quantity) asString.
	txtR := (self variableDisplay textReasult getCharacters).

	( txtM = strValueOfOne and: [ strProduct = txtR] ) ifTrue:
 	[
		^true.
	].

	^false.! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/25/2008 15:52'!
currentQuestion
	^currentQuestion! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/25/2008 15:53'!
currentQuestion: aNumber
	currentQuestion:=aNumber! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 16:34'!
gameOverDisplay
	^gameOverDisplay! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 16:34'!
gameOverDisplay: aRectangleMorph
	gameOverDisplay:= aRectangleMorph! !

!MoreVariablesActivity methodsFor: 'initialization' stamp: 'Aayush 6/30/2008 09:45'!
initCostume
		| t1 |
	t1 := 'objDisplay1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objectDisplay1 wearCostume: t2.
		]
	].

	t1 := 'objDisplay2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objectDisplay2 wearCostume: t2.
		]
	].

	t1 := 'objDiscription1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objectDiscription1 wearCostume: t2.
		]
	].
	
	t1 := 'objDiscription2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objectDiscription2 wearCostume: t2.
		]
	].

	t1 := 'confirm_nepali'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnConfirm wearCostume: t2.
		]
	].

	t1 := 'play_again'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnPlayAgain wearCostume: t2.
		]
	].! !

!MoreVariablesActivity methodsFor: 'initialization' stamp: 'Aayush 6/30/2008 11:04'!
initialize
	| msgSend1 msgSend2 |
	super initialize.
		
	self objectDisplay1: (DisplayBoard new) openInWorld.
	self objectDisplay2: (DisplayBoard new) openInWorld.
	self objectDiscription1: (DisplayBoard new) openInWorld.
	self objectDiscription2: (DisplayBoard new) openInWorld.
	self objectDiscription3: (ImageMorph new) openInWorld.
	self variableDisplay: (VariableDisplay new) openInWorld.

	msgSend1 := MessageSend new.
	msgSend1 selector: #textMultiplierCrAction.
	msgSend1 receiver: self.
	self variableDisplay textMultiplier crAction: msgSend1.

	msgSend2 := MessageSend new.
	msgSend2 selector: #textReasultCrAction.
	msgSend2 receiver: self.
	self variableDisplay textReasult crAction: msgSend2.

	self score: (StringMorph new) openInWorld.
	self score contents: 'Score'.

	self btnConfirm: (ImageMorph  new) openInWorld.
	self btnConfirm on:#mouseUp send:#btnConfirmClick to:self.

	self btnPlayAgain: (ImageMorph  new) openInWorld.
	self btnPlayAgain on:#mouseUp send:#btnPlayAgainClick to:self.

	self initQuestion.
	self initCostume.

	self questionPool: OrderedCollection new.
	self gameOverDisplay: RectangleMorph new openInWorld.
	self reset.
! !

!MoreVariablesActivity methodsFor: 'initialization' stamp: 'Aayush 7/24/2008 16:19'!
initQuestion
	| count |
	self question: OrderedCollection new.

	count := 1.
	[ count <= 8 ] whileTrue:
	[
		self question add:(Array new:8).

		count := count + 1.
	].

	(self question at:1) at:1 put:'1'.	
	(self question at:1) at:2 put:'2'.	
	(self question at:1) at:3 put:'3'.	
	(self question at:1) at:4 put:'4'.	
	(self question at:1) at:5 put:3.	
	(self question at:1) at:6 put:15.	
	(self question at:1) at:7 put:'x'.
	(self question at:1) at:8 put:'5'.

	(self question at:2) at:1 put:'6'.	
	(self question at:2) at:2 put:'7'.	
	(self question at:2) at:3 put:'8'.	
	(self question at:2) at:4 put:'9'.	
	(self question at:2) at:5 put:4.	
	(self question at:2) at:6 put:10.	
	(self question at:2) at:7 put:'p'.	
	(self question at:2) at:8 put:'10'.

	(self question at:3) at:1 put:'11'.	
	(self question at:3) at:2 put:'12'.	
	(self question at:3) at:3 put:'13'.	
	(self question at:3) at:4 put:'14'.	
	(self question at:3) at:5 put:2.	
	(self question at:3) at:6 put:7.	
	(self question at:3) at:7 put:'m'.	
	(self question at:3) at:8 put:'15'.

	(self question at:4) at:1 put:'16'.	
	(self question at:4) at:2 put:'17'.	
	(self question at:4) at:3 put:'18'.	
	(self question at:4) at:4 put:'19'.	
	(self question at:4) at:5 put:3.	
	(self question at:4) at:6 put:25.	
	(self question at:4) at:7 put:'n'.	
	(self question at:4) at:8 put:'20'.

	(self question at:5) at:1 put:'21'.	
	(self question at:5) at:2 put:'22'.	
	(self question at:5) at:3 put:'23'.	
	(self question at:5) at:4 put:'24'.	
	(self question at:5) at:5 put:4.	
	(self question at:5) at:6 put:50.	
	(self question at:5) at:7 put:'r'.	
	(self question at:5) at:8 put:'25'.

	(self question at:6) at:1 put:'26'.	
	(self question at:6) at:2 put:'27'.	
	(self question at:6) at:3 put:'28'.	
	(self question at:6) at:4 put:'29'.	
	(self question at:6) at:5 put:3.	
	(self question at:6) at:6 put:30.	
	(self question at:6) at:7 put:'x'.	
	(self question at:6) at:8 put:'30'.

	(self question at:7) at:1 put:'31'.	
	(self question at:7) at:2 put:'32'.	
	(self question at:7) at:3 put:'33'.	
	(self question at:7) at:4 put:'34'.	
	(self question at:7) at:5 put:5.	
	(self question at:7) at:6 put:20.	
	(self question at:7) at:7 put:'y'.	
	(self question at:7) at:8 put:'35'.

	(self question at:8) at:1 put:'36'.	
	(self question at:8) at:2 put:'37'.	
	(self question at:8) at:3 put:'38'.	
	(self question at:8) at:4 put:'39'.	
	(self question at:8) at:5 put:4.	
	(self question at:8) at:6 put:2.	
	(self question at:8) at:7 put:'z'.	
	(self question at:8) at:8 put:'40'.
! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:12'!
noOfAttempt
	^noOfAttempt! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:12'!
noOfAttempt: aNumber
	noOfAttempt := aNumber! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:41'!
objectDiscription1
	^objectDiscription1! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:46'!
objectDiscription1: aDisplayBoard
	objectDiscription1 := aDisplayBoard! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:41'!
objectDiscription2
	^objectDiscription2! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:46'!
objectDiscription2: aDisplayBoard
	objectDiscription2 := aDisplayBoard! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/30/2008 11:03'!
objectDiscription3
	^objectDiscription3! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/30/2008 11:03'!
objectDiscription3: anImageMorph
	objectDiscription3 := anImageMorph! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:40'!
objectDisplay1
	^objectDisplay1! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:46'!
objectDisplay1: aDisplayBoard
	objectDisplay1 := aDisplayBoard! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:41'!
objectDisplay2
	^objectDisplay2! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:46'!
objectDisplay2: aDisplayBoard
	objectDisplay2 := aDisplayBoard! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 15:45'!
questionPool
	^questionPool! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 15:46'!
questionPool: anOrderedCollection
	questionPool := anOrderedCollection! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/25/2008 14:59'!
question
	^question! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/25/2008 15:36'!
question: anOrderedCollection
	question := anOrderedCollection! !

!MoreVariablesActivity methodsFor: 'initialization' stamp: 'Aayush 7/28/2008 13:38'!
reset
	self score contents: '0'.
	self noOfAttempt: 0.
	self currentQuestion:1.
	self secondPassed:0.
	self start:false.

	[ self questionPool size > 0 ] whileTrue:
	[
		self questionPool removeFirst.
	]. 
	self questionPool addAll: #(1 2 3 4 5 6 7 8).

	self gameOverDisplay hide.
	self btnPlayAgain hide.
	self btnConfirm show.

	self showNewQuestion.
! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:11'!
score
	^score
! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 11:11'!
score: aStringMorph
	score:= aStringMorph
! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:58'!
secondPassed
	^secondPassed! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:58'!
secondPassed:aNumber
	secondPassed := aNumber! !

!MoreVariablesActivity methodsFor: 'Question-Answer' stamp: 'Aayush 8/26/2008 15:55'!
showNewQuestion
	| x size vrible oDisplay1 oDisplay2 oDiscription1 oDiscription2 oDiscription3 |

	x := (self questionPool size) random.
	self currentQuestion: (self questionPool at:x).
	self questionPool removeAt: x.

	oDisplay1 := 'Image_', ((self question at:(self currentQuestion)) at:1).
	oDisplay2 := 'Image_',((self question at:(self currentQuestion)) at:2).
	oDiscription1 := 'Image_', ((self question at:(self currentQuestion)) at:3).
	oDiscription2 := 'Image_', ((self question at:(self currentQuestion)) at:4).
	oDiscription3 := 'Image_', ((self question at:(self currentQuestion)) at:8).

	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDisplay1])				
		ifTrue:
	 	[
			self objectDisplay1 dispImage wearCostume: t2.
			self objectDisplay1 dispImage center: self objectDisplay1 center.
		]
	].
	
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDisplay2])				
		ifTrue:
	 	[
			self objectDisplay2 dispImage wearCostume: t2.
			self objectDisplay2 dispImage center: self objectDisplay2 center.
		]
	].
	
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDiscription1])				
		ifTrue:
	 	[
			self objectDiscription1 dispImage wearCostume: t2.
			self objectDiscription1 dispImage center: self objectDiscription1 center.
		]
	].

	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDiscription2])				
		ifTrue:
	 	[
			self objectDiscription2 dispImage wearCostume: t2.
			self objectDiscription2 dispImage center: self objectDiscription2 center.
			self objectDiscription2 dispImage top: ((self objectDiscription2 top) + 20).
		]
	].

	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: oDiscription3])				
		ifTrue:
	 	[
			self objectDiscription3 wearCostume: t2.
		]
	].

	size := (self question at:(self currentQuestion)) at:5.
	vrible := (self question at:(self currentQuestion)) at:7.

	self variableDisplay initPositionWithSize:size variable: vrible.
	self variableDisplay center:((self objectDiscription2 center x)@(self variableDisplay center y)).

	ActiveHand keyboardFocus: ((self variableDisplay) textMultiplier).
	((self variableDisplay) textMultiplier) editor selectAll.! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:56'!
start
	^start! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:57'!
start: aBoolean
	start := aBoolean! !

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:39'!
stepTime
	^1000.! !

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:43'!
step
	self start ifTrue:
	[
		self secondPassed:self secondPassed + 1.
		self secondPassed = 4 ifTrue:
		[
			self noOfAttempt = 1 ifTrue:
			[
				self score contents: ((((self score) contents) asInteger) + 1) asString.
			].
		
			self questionPool size = 0 ifTrue:
			[
				self btnPlayAgain show.
				self btnConfirm hide.
				self gameOverDisplay show.
			]
			ifFalse:
			[
				self showNewQuestion.
				self noOfAttempt:0.
			].

			self secondPassed:0.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/3/2008 14:36'!
textMultiplierCrAction
	| size count |
	ActiveHand keyboardFocus: ((self variableDisplay) textReasult).
	((self variableDisplay) textReasult) editor selectAll.
	
	size := ((self variableDisplay) stringArray2) size.
	count := 1.

	[ count <= size ] whileTrue:
	[
		(((self variableDisplay) stringArray2) at:count) contents: ((self variableDisplay) textMultiplier) getCharacters.
		(((self variableDisplay) stringArray2) at:count) show.

		count := count + 1.
	].

	self variableDisplay showHideReasult:true.
! !

!MoreVariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 6/27/2008 14:21'!
textReasultCrAction
	self btnConfirmClick! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:59'!
variableDisplay
	^variableDisplay! !

!MoreVariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/23/2008 10:59'!
variableDisplay: aVariableDisplayMorph
	variableDisplay := aVariableDisplayMorph! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/30/2007 17:27'!
additionsToViewerCategoryAsObject
	"Answer viewer additions for the 'as object' category.  Just priming the pump at this point."

	^#(
		#'as object' 
		(
			(slot size 'My physical size' Number readOnly Player getObjectSize unused unused)
			(slot name  	'The name by which I am known' String readWrite Player 	getName Player setName:)
			(slot hash 'My hash value' Number readOnly Player getHash unused unused)
			(command explore 'Open up an Explorer on this object')
			(command halt: 'Put up a pre-debug notifier' String)
			(slot printString 'A string rendition of myself' String readOnly  Player getPrintString unused unused)
			(command inform: 'Put up message box for the user' String)
			(command printInTranscript 'Prints a description of the object to the Transcript')
			(command printDirectlyToDisplay 'Prints a description of the object directly to the screen')
			(command waitForSeconds: 'Wait for a period of seconds (Squeak will not execute other scripts during this time)' Number)
			(slot className 'The name of the class of the object' String readOnly player getClassName unused unused)

		))
! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 11/1/2007 10:36'!
additionsToViewerCategoryGameInstrument
	(World allMorphs select: [ :m | m isKindOf: AddingGameMorph]) ifEmpty: [^ #() ].
	^#( #'game instrument'
			( (slot gameInstrumentType 'The type of game instrument.' GameInstrumentType readWrite Player getGameInstrumentType Player setGameInstrumentType:)
"			  (slot gameValue 'The numeric value' Number readWrite Player getGameValue Player setGameValue:)" )
		)! !

!Morph class methodsFor: '*ole-scripting' stamp: 'lg 10/29/2007 14:46'!
supportsGameValue
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/30/2007 12:44'!
addGameItemsTo: aMenu hand: aHandMorph
"	aMenu add: 'OLE game...' translated subMenu:  (self buildGameMenu: aHandMorph)"! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameChoiceString
	^ (self gameInstrumentType = #choice) yesNoString , 'be game choice'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
beGameInputString
	^ (self gameInstrumentType = #input) yesNoString , 'be game input'.! !

!Morph methodsFor: '*ole-menu' stamp: 'lg 10/29/2007 17:49'!
buildGameMenu: aHand
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self hasGameValue ifTrue:
		[aMenu addUpdating: #beGameInputString target: self selector: #toggleGameInstrumentType: argumentList: { #gameInput }.
		 aMenu addUpdating: #beGameChoiceString target: self selector: #toggleGameInstrumentType: argumentList: { #gameChoice } ].
	^ aMenu! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole-bugfix' stamp: 'lg 10/2/2007 15:44'!
fixYourLayout
	| realExtent |
	realExtent := self extent.
	self extent: 10@10.
	self extent: realExtent.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameChoices
	^self gameInstrumentsOfType: #choice.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
gameInputs
	^self gameInstrumentsOfType: #input.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 11/26/2007 11:58'!
gameInstrumentsOfType: type
	| morphs |
	morphs := self allMorphs select: [ :m | (m valueOfProperty: #gameInstrumentType) = type ].
	^morphs asArray sort: [ :a :b | (a x + a y) < (b x + b y) ].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType
	^(self valueOfProperty: #gameInstrumentType) ifNil: [#none].! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
gameInstrumentType: type
	self setProperty: #gameInstrumentType toValue: type.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/10/2007 10:33'!
grab
	self center: World activeHand center.
	World activeHand grabMorph: self.! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 11:36'!
hasGameValue
	^false.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 10:06'!
highlightOnMouseOver
	| morph |
	morph := SimpleHighlightMorph new beSticky; extent: self extent; position: self position.
	self addMorph:morph.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:40'!
invocation: spec event: ignored1 morph: ignored2
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 15:10'!
isGameChoice
	^false! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:38'!
isGameInput
	^self gameInstrumentType = #gameInput.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/8/2007 17:10'!
isGameLevel
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/3/2007 12:46'!
isGameMistakes
	^false! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 16:51'!
isGameScore
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 10/13/2007 14:03'!
isGameTotal
	^false! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:37'!
morph: ignored1 event: ignored2 invocation: spec.
	(spec at: 1) perform: (spec at: 2) withArguments: (spec at: 3).! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:27'!
mouseOverHighlight
	| highlight |
	highlight := Morph new color: (Color yellow alpha: 0.25).
	highlight lock; extent: self extent; position: self position.
	self addMorph: highlight.
! !

!Morph methodsFor: '*ole-highlight' stamp: 'lg 12/20/2007 22:29'!
mouseOverUnhighlight
	self removeAllMorphs.! !

!Morph methodsFor: '*ole-event handling' stamp: 'lg 12/17/2007 18:43'!
on: event send: selector to: object args: args
	self on: event send: #invocation:event:morph: to: self withValue: {object. selector. args}
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 10/12/2007 17:46'!
selectKind: class do: aBlock 
	self allMorphsDo: [ :morph | (morph isKindOf: class) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*ole' stamp: 'lg 10/3/2007 12:45'!
selectMorphs: test do: aBlock 
	self allMorphsDo: [ :morph | (test value: morph) ifTrue: [aBlock value: morph]].! !

!Morph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:41'!
showAnimal
           World addMorph: self.
           self position: 200@200! !

!Morph methodsFor: '*ole' stamp: 'lg 10/11/2007 13:06'!
spreadMorphs
	| morph stream blockWidth blockHeight spareWidth spareHeight objectWidth objectHeight columns rows |
	self submorphs isEmpty ifTrue: [^self].
	columns := self submorphs size sqrt roundedUp.
	rows := (self submorphs size / columns) roundedUp.
	blockWidth := self width / columns.
	blockHeight := self height / rows.
	objectWidth := self submorphs first width.
	objectHeight := self submorphs first height.
	spareWidth := blockWidth - objectWidth max: 0.
	spareHeight := blockHeight - objectHeight max: 0.
	stream := self submorphs readStream.
	(0 to: rows-1) do: [:row | (0 to: columns-1) do: [:col |
		morph := stream next.
		morph ifNotNil: [morph position: self position + ((col * blockWidth + (0 to: spareWidth) atRandom) @ (row * blockHeight + (0 to: spareHeight) atRandom))]
	]]! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 14:52'!
supportsGameValue
	^self class supportsGameValue.! !

!Morph methodsFor: '*ole' stamp: 'lg 11/26/2007 16:36'!
takeMorphs: morphs mirroringSubmorphsOf: x
	| sourcePositions relativePositions destinationPositions morph source dest |
	sourcePositions := morphs collect: #position.
	relativePositions := x submorphs collect: [ :m | m position - m owner position ].
	destinationPositions := relativePositions collect: [ :point | point + self position ].
	morphs do: [ :m | World addMorph: m ].
"	self break."
	(0 to: 1 by: 0.01) do: [ :amount | (1 to: morphs size) do: [ :ix |
		morph := morphs at: ix.
		source := sourcePositions at: ix.
		dest := destinationPositions at: ix.
		morph position: (source interpolateTo: dest at: amount).
		World displayWorldSafely.
	]].
	morphs do: [ :m | self addMorph: m ].
! !

!Morph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 17:37'!
toggleGameInstrumentType: type
	| newType |
	newType := self gameInstrumentType = type ifTrue: [nil] ifFalse: [type].
	self gameInstrumentType: newType.! !

!Morph methodsFor: '*ole' stamp: 'ss 12/14/2007 14:27'!
waitForSeconds: n 
	World displayWorldSafely.
	(Delay forSeconds: n) wait.! !

!Morph methodsFor: '*ole-override' stamp: 'lg 12/18/2007 12:42'!
wantsHaloFromClick

	^ self valueOfProperty: #wantsHaloFromClick ifAbsent: [^Preferences noHalos not].! !

Morph subclass: #MotionGuide
	instanceVariableNames: 'pathVertices targetObject stepInterval forwardStep start loop tpIndex headingDirection finishEventReceiver finishEventSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MotionGuide methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 14:23'!
clearVertices
	[self pathVertices size >= 1] whileTrue:
	[
		self pathVertices removeFirst.
	].! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 7/28/2008 14:03'!
distanceBetweenPoint:p Point1: p1
	^(((p x - p1 x) squared) + ((p y - p1 y) squared)) safeSquareRoot! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/30/2008 10:14'!
finishEventReceiver
	^finishEventReceiver! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/30/2008 10:14'!
finishEventSelector
	^finishEventSelector! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 13:13'!
forwardStep
	^forwardStep! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/29/2008 13:11'!
forwardStep: aNumber
	forwardStep := aNumber! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/29/2008 10:59'!
headingDirection
	^headingDirection! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/29/2008 10:59'!
headingDirection: aNumber
	headingDirection := aNumber! !

!MotionGuide methodsFor: 'initialization' stamp: 'Aayush 7/29/2008 13:05'!
initialize
	super initialize.
	self pathVertices: OrderedCollection new.
	self stepInterval:500.
	self forwardStep:5.0.
	self loop:false.
	self tpIndex:2.
	self start:false.! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 8/8/2008 16:00'!
initVertices: vArray TargetObject:tObject
	| count size |

	self clearVertices.

	count := 1.
	size := vArray size.
	[ count <= size ] whileTrue:
	[
		self pathVertices add: (vArray at:count).
		count := count + 1.
	].

	self targetObject: tObject.

	self targetObject player setLocationRounded: (self pathVertices at:1).
	self tpIndex:2.
	self setHeadingTowards: (self pathVertices at:2).

! !

!MotionGuide methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 11:37'!
intiFinishEventReceiver:anObject FinishEventSelector:aSelector
	finishEventReceiver := anObject.
	finishEventSelector := aSelector.
! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:15'!
loop
	^loop! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:16'!
loop: aBoolean
	loop := aBoolean! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 13:04'!
pathVertices
	^pathVertices
! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 13:05'!
pathVertices: anOrderedCollection
	pathVertices:= anOrderedCollection
! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 7/29/2008 12:09'!
reached: index
	| ox oy tx ty |

	ox := self targetObject player getX.
	oy := self targetObject player getY.
	tx := (self pathVertices at:index) x.
	ty := (self pathVertices at:index) y.

	(self headingDirection=1 or:[self headingDirection=2 or:[self headingDirection=8]] ) ifTrue:
	[
		ox < tx ifTrue:
		[
			^false.
		]
		ifFalse:
		[
			^true.
		]		
	]
	ifFalse:
	[
		(self headingDirection=4 or:[self headingDirection=5 or:[self headingDirection=6]] ) ifTrue:
		[
			ox > tx ifTrue:
			[
				^false.
			]
			ifFalse:
			[
				^true.
			]		
		]
		ifFalse:
		[
			(self headingDirection=3) ifTrue:
			[
				oy < ty ifTrue:
				[
					^false.
				]
				ifFalse:
				[
					^true.
				]		
			]
			ifFalse:
			[
				(self headingDirection=7) ifTrue:
				[
					oy > ty ifTrue:
					[
						^false.
					]
					ifFalse:
					[
						^true.
					]		
				]
				ifFalse:
				[
					^false.
				]
			]
		]
	]! !

!MotionGuide methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 12:45'!
reset
	self targetObject player setLocationRounded: (self pathVertices at:1).
	self setHeadingTowards: (self pathVertices at:2).
	self tpIndex:2.
	self start:false.! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 7/29/2008 11:50'!
setHeadingDirection
	| ox oy tx ty |

	ox := self targetObject player getX.
	oy := self targetObject player getY.
	tx := (self pathVertices at:(self tpIndex)) x.
	ty := (self pathVertices at:(self tpIndex)) y.

	(ox < tx and: [oy = ty]) ifTrue:	
	[
		self headingDirection:1.
	]
	ifFalse:
	[
		(ox < tx and: [oy < ty]) ifTrue:	
		[
			self headingDirection:2.
		]
		ifFalse:
		[
			(ox = tx and: [oy < ty]) ifTrue:	
			[
				self headingDirection:3.
			]
			ifFalse:
			[
				(ox > tx and: [oy < ty]) ifTrue:	
				[
					self headingDirection:4.
				]
				ifFalse:
				[
					(ox > tx and: [oy = ty]) ifTrue:	
					[
						self headingDirection:5.
					]
					ifFalse:
					[
						(ox > tx and: [oy > ty]) ifTrue:	
						[
							self headingDirection:6.
						]
						ifFalse:
						[
							(ox = tx and: [oy > ty]) ifTrue:	
							[
								self headingDirection:7.
							]
							ifFalse:
							[
								(ox < tx and: [oy > ty]) ifTrue:	
								[
									self headingDirection:8.
								]
							].
						].
					].
				].
			].
		].
	].
! !

!MotionGuide methodsFor: 'motion' stamp: 'A 8/15/2008 12:40'!
setHeadingTowards:aPoint
	| p b thetaR thetaD |

	p :=  ((aPoint y) - (self targetObject player getY)).
	b := (aPoint x) - (self targetObject player getX).
	
"	(aPoint = (859@148)) ifTrue:
	[
		self break.
	].
"
	b = 0 ifTrue:
	[
		p < 0 ifTrue:
		[
			thetaD := -90.
		]
		ifFalse:
		[
			thetaD := 90.
		]
	]
	ifFalse:
	[
		thetaR := (p/b) arcTan.
		thetaD := thetaR * (180/3.142).
	].

	(p<=0 and:[b<0]) ifTrue:
	[
		thetaD := thetaD + 180.
	]
	ifFalse:
	[
		(p>=0 and:[b<0]) ifTrue:
		[
			thetaD := thetaD + 180.
		]
	].

	self setHeadingDirection.
	self targetObject player setHeadingTheta:thetaD.	
! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 7/28/2008 14:15'!
startMotion
	self start:true.
	self startStepping.! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:11'!
start
	^start! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:11'!
start: aBoolean
	start := aBoolean! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 13:12'!
stepInterval
	^stepInterval! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 13:12'!
stepInterval: aNumber
	stepInterval := aNumber! !

!MotionGuide methodsFor: 'miscellaneous' stamp: 'Aayush 7/28/2008 13:15'!
stepTime
	^self stepInterval! !

!MotionGuide methodsFor: 'miscellaneous' stamp: 'Aayush 7/31/2008 15:36'!
step
	self start ifTrue:
	[
		(self reached: self tpIndex) ifTrue:
		[
			(self tpIndex + 1) > self pathVertices size ifTrue:
			[
				self loop ifTrue:
				[
					self finishEventReceiver ~= nil ifTrue:
					[
						(self finishEventReceiver) perform:(self finishEventSelector).
					].

					self tpIndex:2.		
					self targetObject player setLocationRounded: (self pathVertices at:1).
					self setHeadingTowards: (self pathVertices at:2).
				]
				ifFalse:
				[
					self start:false.
					self finishEventReceiver ~= nil ifTrue:
					[
						(self finishEventReceiver) perform:(self finishEventSelector).
					]
				]
			]
			ifFalse:
			[
"				self targetObject player setLocationRounded: (self pathVertices at:(self tpIndex)).
"				self tpIndex: self tpIndex + 1.
				self setHeadingTowards: (self pathVertices at:(self tpIndex)).
				self targetObject player forward:(self forwardStep).
			].
		]
		ifFalse:
		[
			self targetObject player forward:(self forwardStep).
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
	! !

!MotionGuide methodsFor: 'motion' stamp: 'Aayush 7/28/2008 14:15'!
stopMotion
	self start:false.! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:06'!
targetObject
	^targetObject! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:06'!
targetObject: anObject
	targetObject := anObject! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:44'!
tpIndex
	^tpIndex! !

!MotionGuide methodsFor: 'accessing-property' stamp: 'Aayush 7/28/2008 14:44'!
tpIndex: aNumber
	tpIndex := aNumber! !

Morph subclass: #MotionGuideExtended
	instanceVariableNames: 'pathVertices targetObject stepInterval forwardStep start loop targetPointIndex changeOrientation headingDirection eventReceiver vertexReachedEventSelector pathCompleteEventSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 10:13'!
changeOrientation
	^changeOrientation! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 10:13'!
changeOrientation: aBoolean
	changeOrientation := aBoolean! !

!MotionGuideExtended methodsFor: 'miscellaneous' stamp: 'A 8/21/2008 17:31'!
clearVertices
	[self pathVertices size >= 1] whileTrue:
	[
		self pathVertices removeFirst.
	].! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:27'!
eventReceiver
	^eventReceiver
! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:26'!
forwardStep
	^forwardStep! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:27'!
forwardStep: aNumber
	forwardStep := aNumber! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 11:26'!
headingDirection
	^headingDirection! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 11:27'!
headingDirection:aNumber
	headingDirection:=aNumber! !

!MotionGuideExtended methodsFor: 'initialization' stamp: 'A 8/22/2008 10:13'!
initialize
	super initialize.
	self pathVertices: OrderedCollection new.
	self stepInterval:500.
	self forwardStep:5.0.
	self loop:false.
	self targetPointIndex:2.
	self start:false.
	self changeOrientation:false.
! !

!MotionGuideExtended methodsFor: 'initialization' stamp: 'A 8/22/2008 11:25'!
initVertices: vArray TargetObject:tObject
	| count size |

	self clearVertices.

	count := 1.
	size := vArray size.
	[ count <= size ] whileTrue:
	[
		self pathVertices add: (vArray at:count).
		count := count + 1.
	].

	self targetObject: tObject.

	self targetObject player setLocationRounded: (self pathVertices at:1).
	self targetPointIndex:2.
	self setDirectionTowards: (self pathVertices at:2).

! !

!MotionGuideExtended methodsFor: 'initialization' stamp: 'A 8/22/2008 10:37'!
intiEventReceiver:anObject VertexReachedSelector:vrSelector PathCompleteSelector:pcSelector
	vertexReachedEventSelector := vrSelector.
	pathCompleteEventSelector := pcSelector.
	eventReceiver := anObject.

! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:21'!
loop
	^loop! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:21'!
loop: aBoolean
	loop := aBoolean! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 10:09'!
pathCompleteSelector
	^pathCompleteEventSelector! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:22'!
pathVertices
	^pathVertices! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:23'!
pathVertices: anOrderedCollection
	pathVertices := anOrderedCollection! !

!MotionGuideExtended methodsFor: 'motion' stamp: 'A 8/22/2008 10:16'!
reached: index
	| ox oy tx ty |

	ox := self targetObject player getX.
	oy := self targetObject player getY.
	tx := (self pathVertices at:index) x.
	ty := (self pathVertices at:index) y.

	(self headingDirection=1 or:[self headingDirection=2 or:[self headingDirection=8]] ) ifTrue:
	[
		ox < tx ifTrue:
		[
			^false.
		]
		ifFalse:
		[
			^true.
		]		
	]
	ifFalse:
	[
		(self headingDirection=4 or:[self headingDirection=5 or:[self headingDirection=6]] ) ifTrue:
		[
			ox > tx ifTrue:
			[
				^false.
			]
			ifFalse:
			[
				^true.
			]		
		]
		ifFalse:
		[
			(self headingDirection=3) ifTrue:
			[
				oy < ty ifTrue:
				[
					^false.
				]
				ifFalse:
				[
					^true.
				]		
			]
			ifFalse:
			[
				(self headingDirection=7) ifTrue:
				[
					oy > ty ifTrue:
					[
						^false.
					]
					ifFalse:
					[
						^true.
					]		
				]
				ifFalse:
				[
					^false.
				]
			]
		]
	]! !

!MotionGuideExtended methodsFor: 'initialization' stamp: 'A 8/21/2008 17:30'!
reset
	self targetObject player setLocationRounded: (self pathVertices at:1).
	self setHeadingTowards: (self pathVertices at:2).
	self targetPointIndex:2.
	self start:false.! !

!MotionGuideExtended methodsFor: 'motion' stamp: 'A 8/22/2008 12:08'!
setDirectionTowards:aPoint
	| p b thetaR thetaD |

	p :=  ((aPoint y) - (self targetObject player getY)).
	b := (aPoint x) - (self targetObject player getX).
	
	b = 0 ifTrue:
	[
		p < 0 ifTrue:
		[
			thetaD := -90.
		]
		ifFalse:
		[
			thetaD := 90.
		]
	]
	ifFalse:
	[
		thetaR := (p/b) arcTan.
		thetaD := thetaR * (180/3.142).
	].

	(p<=0 and:[b<0]) ifTrue:
	[
		thetaD := thetaD + 180.
	]
	ifFalse:
	[
		(p>=0 and:[b<0]) ifTrue:
		[
			thetaD := thetaD + 180.
		]
	].

	self setHeadingDirection.

	self changeOrientation ifTrue:
	[
		self targetObject player setHeadingTheta:thetaD.	
	]
	ifFalse:
	[
		self targetObject player setForwardDirection:(90-thetaD).	
	].

! !

!MotionGuideExtended methodsFor: 'motion' stamp: 'A 8/22/2008 11:26'!
setHeadingDirection
	| ox oy tx ty |

	ox := self targetObject player getX.
	oy := self targetObject player getY.
	tx := (self pathVertices at:(self targetPointIndex)) x.
	ty := (self pathVertices at:(self targetPointIndex)) y.

	(ox < tx and: [oy = ty]) ifTrue:	
	[
		self headingDirection:1.
	]
	ifFalse:
	[
		(ox < tx and: [oy < ty]) ifTrue:	
		[
			self headingDirection:2.
		]
		ifFalse:
		[
			(ox = tx and: [oy < ty]) ifTrue:	
			[
				self headingDirection:3.
			]
			ifFalse:
			[
				(ox > tx and: [oy < ty]) ifTrue:	
				[
					self headingDirection:4.
				]
				ifFalse:
				[
					(ox > tx and: [oy = ty]) ifTrue:	
					[
						self headingDirection:5.
					]
					ifFalse:
					[
						(ox > tx and: [oy > ty]) ifTrue:	
						[
							self headingDirection:6.
						]
						ifFalse:
						[
							(ox = tx and: [oy > ty]) ifTrue:	
							[
								self headingDirection:7.
							]
							ifFalse:
							[
								(ox < tx and: [oy > ty]) ifTrue:	
								[
									self headingDirection:8.
								]
							].
						].
					].
				].
			].
		].
	].
! !

!MotionGuideExtended methodsFor: 'motion' stamp: 'A 8/22/2008 11:30'!
startMotion
	self start:true.
	self startStepping.! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:21'!
start
	^start! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:22'!
start: aBoolean
	start := aBoolean! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:23'!
stepInterval
	^stepInterval! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:23'!
stepInterval: aNumber
	stepInterval := aNumber! !

!MotionGuideExtended methodsFor: 'miscellaneous' stamp: 'A 8/21/2008 17:28'!
stepTime
	^self stepInterval.! !

!MotionGuideExtended methodsFor: 'miscellaneous' stamp: 'A 8/22/2008 12:39'!
step
	| tmp |
	self start ifTrue:
	[
		(self reached: self targetPointIndex) ifTrue:
		[
			(self targetPointIndex + 1) > self pathVertices size ifTrue:
			[
				self loop ifTrue:
				[
					self pathCompleteSelector ~= nil ifTrue:
					[
						(self eventReceiver) perform:(self pathCompleteSelector).
					].

					self targetPointIndex:2.		
					self targetObject player setLocationRounded: (self pathVertices at:1).

					self setDirectionTowards: (self pathVertices at:2).
				]
				ifFalse:
				[
					self start:false.
					self pathCompleteSelector ~= nil ifTrue:
					[
						(self eventReceiver) perform:(self pathCompleteSelector).
					]
				]
			]
			ifFalse:
			[
				self vertexReachedSelector ~= nil ifTrue:
				[
					tmp := Array new:1.
					tmp at:1 put:(self targetPointIndex).
					(self eventReceiver) perform:(self vertexReachedSelector) withArguments:tmp .
				].

				self targetPointIndex: self targetPointIndex + 1.
				self setDirectionTowards: (self pathVertices at:(self targetPointIndex)).
				self targetObject player forward:(self forwardStep).
			].
		]
		ifFalse:
		[
			self targetObject player forward:(self forwardStep).
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
	! !

!MotionGuideExtended methodsFor: 'motion' stamp: 'A 8/22/2008 11:30'!
stopMotion
	self start:false.! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:24'!
targetObject
	^targetObject! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:24'!
targetObject: anObject
	targetObject := anObject! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:17'!
targetPointIndex
	^targetPointIndex! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 17:16'!
targetPointIndex: aNumber
	targetPointIndex := aNumber! !

!MotionGuideExtended methodsFor: 'accessing - properties' stamp: 'A 8/22/2008 10:09'!
vertexReachedSelector
	^vertexReachedEventSelector
	
! !

Morph subclass: #MyTimer
	instanceVariableNames: 'ledHour ledMinute ledSecond counting countUp aHour aMinute aSecond'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aHour
	^ aHour! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aHour: aNumber 
	(aNumber >= 0
			and: [aNumber < 100])
		ifTrue: [aHour := aNumber]
		ifFalse: [aHour := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aMinute
	^ aMinute! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aMinute: aNumber 
	(aNumber >= 0
			and: [aNumber < 60])
		ifTrue: [aMinute := aNumber]
		ifFalse: [aMinute := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aSecond
	^ aSecond! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
aSecond: aNumber 
	(aNumber >= 0
			and: [aNumber < 60])
		ifTrue: [aSecond := aNumber]
		ifFalse: [aSecond := 0]! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
counting
	^ counting! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
counting: aBoolean 
	counting := aBoolean! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
countUp
	^ countUp! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
countUp: aBoolean 
	countUp := aBoolean.
	aBoolean = true
		ifTrue: [self
				displayTimeHour: 0
				Minute: 0
				Second: 0]
		ifFalse: [self
				displayTimeHour: self aHour
				Minute: self aMinute
				Second: self aSecond]! !

!MyTimer methodsFor: 'timer' stamp: ''!
displayTimeHour: h Minute: m Second: s 
	self ledHour value: h.
	self ledMinute value: m.
	self ledSecond value: s! !

!MyTimer methodsFor: 'initialization' stamp: 'aayush 3/19/2008 14:17'!
initializeSelf
	self width: 154.
	self
		color: (Color
				r: 0
				g: 1
				b: 0).
	self ledHour: LedMorph new.
	self addMorph: self ledHour.
	self ledHour left: 0.
	self ledMinute: LedMorph new.
	self addMorph: self ledMinute.
	self ledMinute left: 52.
	self ledSecond: LedMorph new.
	self addMorph: self ledSecond.
	self ledSecond left: 104.
	self
		setTimerHour: 0
		Minute: 1
		Second: 5.
	self countUp: false.
	self reset.

	"self assuredPlayer."
	self player class compileSilently: 'timeUp' classified: 'scripts'.
	"self player class assuredMethodInterfaceFor: #timeUp"
! !

!MyTimer methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self initializeSelf! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledHour
	^ ledHour! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledHour: aLedMorph 
	ledHour := aLedMorph! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledMinute
	^ ledMinute! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledMinute: aLedMorph 
	ledMinute := aLedMorph! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledSecond
	^ ledSecond! !

!MyTimer methodsFor: 'accessingSelf' stamp: ''!
ledSecond: aLedMorph 
	ledSecond := aLedMorph! !

!MyTimer methodsFor: 'timer' stamp: ''!
pause
	self counting: false! !

!MyTimer methodsFor: 'timer' stamp: ''!
reset
	self countUp: self countUp.
	self counting: false! !

!MyTimer methodsFor: 'timer' stamp: ''!
setTimerHour: h Minute: m Second: s 
	self aHour: h.
	self aMinute: m.
	self aSecond: s.
	self reset! !

!MyTimer methodsFor: 'timer' stamp: ''!
start
	self counting: true! !

!MyTimer methodsFor: 'timer' stamp: ''!
stepTime
	^ 1000! !

!MyTimer methodsFor: 'as yet unclassified' stamp: ''!
step
	self counting = true
		ifTrue: [self updateTime]! !

!MyTimer methodsFor: 'timer' stamp: ''!
updateTime
	| sec min hr |
	sec := self ledSecond value.
	min := self ledMinute value.
	hr := self ledHour value.
	self countUp = true
		ifTrue: [sec := self ledSecond value.
			sec + 1 >= 59
				ifTrue: [self ledSecond value: 0.
					sec := 0.
					min := self ledMinute value.
					min + 1 >= 59
						ifTrue: [self ledMinute value: 0.
							min := 0.
							hr := self ledHour value.
							hr + 1 > 99
								ifTrue: [self pause.
									self player timeUp]
								ifFalse: [hr := hr + 1.
									self ledHour value: hr]]
						ifFalse: [min := min + 1.
							self ledMinute value: min]]
				ifFalse: [sec := sec + 1.
					self ledSecond value: sec].
			(hr = self aHour
					and: [min = self aMinute]
					and: [sec = self aSecond])
				ifTrue: [self pause.
					self player timeUp]]
		ifFalse: [sec := self ledSecond value.
			sec - 1 <= 0
				ifTrue: [min := self ledMinute value.
					min - 1 < 0
						ifTrue: [hr := self ledHour value.
							hr - 1 < 0
								ifTrue: [self ledSecond value: 0.
									self pause.
									self player timeUp]
								ifFalse: [self ledMinute value: 59.
									self ledSecond value: 59.
									hr := hr - 1.
									self ledHour value: hr]]
						ifFalse: [min := min - 1.
							self ledSecond value: 59.
							self ledMinute value: min]]
				ifFalse: [sec := sec - 1.
					self ledSecond value: sec]].
	self changed! !

Morph subclass: #PicturePuzzleMorph
	instanceVariableNames: 'labels rows columns realImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:30'!
checkCompletion
	(submorphs allSatisfy: #hasRightPiece) ifTrue: [self completed].! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:16'!
columns: c
	columns := c.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:27'!
completed
	self showSketch.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/13/2007 13:02'!
initialize
	super initialize.
	rows := 6.
	columns := 6.
	labels := #().
	self beSticky.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/13/2007 13:02'!
labels: collection
	labels := collection.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 10:21'!
placeInEmptyBox: morph
	| empty |
	empty := submorphs detect: [ :m | (m isKindOf: PicturePuzzleBlockMorph) and: [m submorphs isEmpty] ].
	empty addMorph: morph.
! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:17'!
rescramble
	self scrambleForm: realImageForm.! !

!PicturePuzzleMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 17:38'!
rows: r
	rows := r.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 19:02'!
scrambleForm: form
	| letters tileWidth tileHeight morph sketch interior |
	self removeAllMorphs.
	letters := labels readStream.
	realImageForm := form.
	self extent: form extent.
	tileWidth := form width / columns.
	tileHeight := form height / rows.
 	(0 to: rows-1) do: [ :row | (0 to: columns-1) do: [ :col |
		morph := PicturePuzzleBlockMorph new.
		interior := (((row ~= 0) and: [row ~= (rows-1)]) and: [(col ~= 0) and: [col ~= (columns-1)]]).
		morph isInteriorBlock:interior.
		morph position: self position + ((col * tileWidth) @ (row * tileHeight)).
		morph extent: tileWidth @ tileHeight.
		morph layoutPolicy: TableLayout new.
		morph enableDrop: true.
		morph enableDrag: true.
		morph setProperty: #puzzlePosition toValue: row@col.
		self addMorph: morph.
		sketch := PicturePuzzlePieceMorph withForm: (form copy: (((col*tileWidth) @ (row*tileHeight)) extent: tileWidth@tileHeight)).
		sketch position: morph position.
		sketch setProperty: #puzzlePosition toValue: row@col.
		morph addMorph: sketch.
"		interior ifFalse: [sketch beSticky]."
		"Maybe label the morph"
		letters atEnd ifFalse: [sketch label: letters next].
	]].
	self shufflePieces.! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:28'!
showSketch
	self showSketch: (SketchMorph withForm: realImageForm).
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:32'!
showSketch: sketch
	realImageForm := sketch form.
	sketch position: self position.
	self extent: sketch extent.
	self removeAllMorphs; addMorph: sketch.
! !

!PicturePuzzleMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:25'!
shufflePieces
	| blocks pieces stream |
	blocks := self submorphs select: #isInteriorBlock.
	pieces := blocks collect: [ :block | block submorphs first ].
	stream := pieces shuffled readStream.
	blocks do: [ :block | block removeAllMorphs; addMorph: stream next ].
! !

Morph subclass: #QnA
	instanceVariableNames: 'question questionSound answer answerSound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
answerSound
	"Answer the value of answerSound"

	^ answerSound! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
answerSound: anObject
	"Set the value of answerSound"

	answerSound _ anObject! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
answer
	"Answer the value of answer"

	^ answer! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
questionSound
	"Answer the value of questionSound"

	^ questionSound! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
questionSound: anObject
	"Set the value of questionSound"

	questionSound _ anObject! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
question
	"Answer the value of question"

	^ question! !

!QnA methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:05'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Morph subclass: #Question
	instanceVariableNames: 'question answer image optionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

Question subclass: #QuestionWithSound
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionWithSound class methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 12:51'!
newQuestionWith: aQuestion sound: aSound
	|model|
	model:= self basicNew.

		


	

		! !

!QuestionWithSound methodsFor: 'as yet unclassified' stamp: 'Ram 1/31/2008 13:00'!
initialize
	super initialize.
	self sound:''! !

!QuestionWithSound methodsFor: 'accessing' stamp: 'Ram 1/31/2008 12:35'!
sound
	"Answer the value of sound"

	^ sound! !

!QuestionWithSound methodsFor: 'accessing' stamp: 'Ram 1/31/2008 12:35'!
sound: anObject
	"Set the value of sound"

	sound _ anObject! !

!Question methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 12:46'!
addOption: opt
	optionList add: opt.! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer
	"Answer the value of answer"

	^ answer! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
answer: anObject
	"Set the value of answer"

	answer _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image
	"Answer the value of image"

	^ image! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!Question methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 12:46'!
initialize
	super initialize.
	optionList:= OrderedCollection new.! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList
	"Answer the value of optionList"

	^ optionList! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
optionList: anObject
	"Set the value of optionList"

	optionList _ anObject! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question
	"Answer the value of question"

	^ question! !

!Question methodsFor: 'accessing' stamp: 'Ram 12/17/2007 13:24'!
question: anObject
	"Set the value of question"

	question _ anObject! !

Morph subclass: #QuestionDisplay
	instanceVariableNames: 'dispQuestion dispAnswer1 dispAnswer2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-RomanNumberActivity'!

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:22'!
dispAnswer1
	^dispAnswer1! !

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:32'!
dispAnswer1: aDisplayAnswer
	dispAnswer1 := aDisplayAnswer! !

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:24'!
dispAnswer2
	^dispAnswer2! !

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:27'!
dispAnswer2: aDisplayAnswer
	dispAnswer2 := aDisplayAnswer! !

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:22'!
dispQuestion
	^dispQuestion! !

!QuestionDisplay methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:27'!
dispQuestion: aDisplayBoardExtended
	dispQuestion:= aDisplayBoardExtended! !

!QuestionDisplay methodsFor: 'initialization' stamp: 'Aayush 7/7/2008 10:35'!
initCostume
	^self! !

!QuestionDisplay methodsFor: 'initialization' stamp: 'Aayush 7/7/2008 12:03'!
initialize
	super initialize.

	self dispQuestion: DisplayBoardExtended new.
	self dispAnswer1: DisplayAnswer new.
	self dispAnswer2: DisplayAnswer new.

	self addMorph: self dispQuestion.
	self addMorph: self dispAnswer1.
	self addMorph: self dispAnswer2.

	self dispAnswer1 top: self dispAnswer1 top + self dispQuestion height.
	self dispAnswer2 top: self dispAnswer2 top + self dispQuestion height + self dispAnswer1 height.

	self width:self dispAnswer2 width.
	self height: self dispQuestion height + (2 * (self dispAnswer1 height)).

	self initCostume.
! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

Morph subclass: #RomanNumberActivity
	instanceVariableNames: 'page1 page2 currentPage timer btnNext btnPrevious btnConfirm btnPlayAgain btnTryAgain questionDisplay question currentSet marbelBox strRomanValue start secondPassed gameOverDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-RomanNumberActivity'!

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 13:25'!
btnConfirmClick
	
	| count qusNo t1 |
	count := 1.
	[ count <= 10 ] whileTrue:
	[
		
		qusNo := (10*(self currentSet - 1)) + count.
		( ((self question at:qusNo) at:2) = ((self questionDisplay at:count) dispAnswer1 txtBox getCharacters) 															translateToUppercase withBlanksTrimmed) ifFalse:
		[
			(self questionDisplay at:count) dispAnswer2 show.
			t1 := 'Cross_sm'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
				ifTrue:
	 			[
					(self questionDisplay at:count) dispAnswer1 imgCheck wearCostume: t2.
					(self questionDisplay at:count) dispAnswer1 imgCheck show.
				]
			].
		]
		ifTrue:
		[
			t1 := 'Check_sm'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
				ifTrue:
	 			[
					(self questionDisplay at:count) dispAnswer1 imgCheck wearCostume: t2.
					(self questionDisplay at:count) dispAnswer1 imgCheck show.
				]
			].
		].
		count := count + 1.
	].
	
	self timer pause.
	self btnConfirm hide.
	self btnTryAgain show.
	self btnNext show.
	

	
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:55'!
btnConfirm
	^btnConfirm! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:55'!
btnConfirm: aImageMorph
	btnConfirm := aImageMorph! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 13:51'!
btnNextClick
	self currentPage = 1 ifTrue:
	[
		self start:false.
		self page1 hide.
		self page2 show.
		self timer reset.
		self timer start.
		self btnNext hide.
		self btnPrevious show.
		self currentPage:2.
		self showNewQuestion.
		self btnConfirm show.
		self btnTryAgain hide.
	]
	ifFalse:
	[
		self currentPage = 2 ifTrue:
		[
			self timer reset.
			self timer start.
			self btnNext hide.
			self btnPrevious show.
			self currentSet:2.
			self showNewQuestion.
			self btnConfirm show.
			self currentPage:3.
			self btnTryAgain hide.
		]
		ifFalse:
		[
			self currentPage = 3 ifTrue:
			[
				self timer reset.
				self btnNext hide.
				self btnPrevious hide.
				self btnConfirm hide.
				self btnTryAgain hide.
				self gameOverDisplay show.
			]
		]
	]
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:55'!
btnNext
	^btnNext! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:55'!
btnNext: aImageMorph
	btnNext := aImageMorph! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 13:44'!
btnPlayAgainClick
	self reset.
	self startAnimation.! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 10:12'!
btnPlayAgain
	^btnPlayAgain! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 10:13'!
btnPlayAgain: anImageMorph
	btnPlayAgain := anImageMorph! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 13:37'!
btnPreviousClick
	self currentPage = 2 ifTrue:
	[
		self reset.
		self startAnimation.
	]
	ifFalse:
	[
		self currentPage = 3 ifTrue:
		[
			self timer reset.
			self timer start.
			self btnNext hide.
			self btnPrevious show.
			self btnConfirm show.
			self currentSet:1.
			self showNewQuestion.
			self currentPage:2.
		]
	]
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 11:34'!
btnPrevious
	^btnPrevious! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 11:35'!
btnPrevious: anImageMorph
	^btnPrevious := anImageMorph! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 13:53'!
btnTryAgainClick
	| count |
	count := 1.
	[ count <= 10 ] whileTrue:
	[
		(self questionDisplay at:count) dispAnswer1 imgCheck hide.
		(self questionDisplay at:count) dispAnswer1 txtBox setCharacters: ' '.
		(self questionDisplay at:count) dispAnswer2 hide.		

		count := count + 1.	
	].

	self btnNext hide.
	self btnConfirm show.
	self btnTryAgain hide.
	self timer reset.
	self timer start.
	self timer changed.
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 10:23'!
btnTryAgain
	^btnTryAgain! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 10:24'!
btnTryAgain: anImageMorph
	btnTryAgain := anImageMorph! !

!RomanNumberActivity methodsFor: 'Question-Answer' stamp: 'aayush 7/8/2008 10:09'!
checkAnswer
	^self! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 12:03'!
currentPage
	^currentPage! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 12:04'!
currentPage: aNumber
	currentPage := aNumber! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 10:04'!
currentSet
	^currentSet! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 10:04'!
currentSet: aNumber
	currentSet:= aNumber! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/10/2008 12:19'!
gameOverDisplay
	^gameOverDisplay! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/11/2008 10:52'!
gameOverDisplay: aRectangleMorph
	gameOverDisplay := aRectangleMorph! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 14:17'!
initCostume
	| t1 size count t3 |
	
	size:= self questionDisplay size.
	
	count := 1.
	[ count <= size ] whileTrue:
	[
		t1 := 'bg1'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				(self questionDisplay at:count) dispQuestion wearCostume: t2.
			]
		].

		t1 := 'bg2'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				(self questionDisplay at:count) dispAnswer1 wearCostume: t2.
				(self questionDisplay at:count) dispAnswer1 top: (self questionDisplay at:count) dispQuestion top + 
					(self	questionDisplay at:count) dispQuestion height.
	(self questionDisplay at:count) dispAnswer1 txtBox center:((self questionDisplay at:count) dispAnswer1 center - (26@0)).
"				(self questionDisplay at:count) dispAnswer1 txtBox left:(self questionDisplay at:count) dispAnswer1 left.
"
				(self questionDisplay at:count) dispAnswer2 wearCostume: t2.
				(self questionDisplay at:count) dispAnswer2 top: (self questionDisplay at:count) dispAnswer1 top + 
					(self questionDisplay at:count) dispAnswer1 height.
			].
			(self questionDisplay at:count) width: (self questionDisplay at:count) dispAnswer2 width.
			(self questionDisplay at:count) height: (2*(self questionDisplay at:count) dispAnswer2 height) + 
				(self questionDisplay at:count) dispQuestion height.
		].

		t1 := 'Check_sm'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				(self questionDisplay at:count) dispAnswer1 imgCheck wearCostume: t2.
				(self questionDisplay at:count) dispAnswer2 imgCheck wearCostume: t2.
			]
		].
		
		(self questionDisplay at:count) width: (self questionDisplay at:count) dispAnswer1 width.
		
		count := count + 1.
	].

	t1 := 'confirm_nepali'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self btnConfirm wearCostume: t2.
		]
	].

	t1 := 'next'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self btnNext wearCostume: t2.
		]
	].

	count := 4.
	[ count <= 7 ] whileTrue:
	[
		t1 := 'box_', (count asString).
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
 			[
						(self marbelBox at:count) wearCostume: t2.
			]
		].

		count := count + 1.
	].

	count:=1.
	t1 := 'roman'.
	t3 := ''.
	[ count <=  7] whileTrue:
	[
		t3 := t1, '_',count asString.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t3])				
			ifTrue:
 			[
				(self strRomanValue at:count) wearCostume: t2.
			]
		].
		count := count + 1.
	].

	t1 := 'play_again'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self btnPlayAgain wearCostume: t2.
		]
	].

	t1 := 'previous'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self btnPrevious wearCostume: t2.
		]
	].

	t1 := 'try_again'.

	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[

			self btnTryAgain wearCostume: t2.
		]
	].
! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 11:58'!
initialize
	super initialize.

	self initPage1.
	self initPage2.

	self btnPlayAgain: ImageMorph new openInWorld.
	self btnPlayAgain on:#mouseUp send:#btnPlayAgainClick to:self.

	self gameOverDisplay: RectangleMorph new openInWorld.
	self gameOverDisplay addMorph: self btnPlayAgain.

	self btnNext: ImageMorph new openInWorld.
	self btnNext on:#mouseUp send:#btnNextClick to:self.

	self btnPrevious: ImageMorph new openInWorld.
	self btnPrevious on:#mouseUp send:#btnPreviousClick to:self.

	self initCostume.
	self initQuestion.
	self reset.
! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 11:31'!
initPage1
	| count |

	self page1: PasteUpMorph new openInWorld.
	self page1 width:400.
	self page1 height:400.

	self marbelBox: OrderedCollection new.
	self strRomanValue: OrderedCollection new.

	count:=1.
	[ count <=  7] whileTrue:
	[
		self strRomanValue add: (ImageMorph new).
		self page1 addMorph: (self strRomanValue at:count).

		count := count + 1.
	].

self marbelBox add: (AnimatedMarbleBox new).
self marbelBox add: (AnimatedMarbleBox new).
self marbelBox add: (AnimatedMarbleBox new).

self marbelBox add: (DisplayBoardExtended new).
(self marbelBox at:4) strMessage hide.
(self marbelBox at:4) dispImage hide.

self marbelBox add: (DisplayBoardExtended new).
(self marbelBox at:5) strMessage hide.
(self marbelBox at:5) dispImage hide.

self marbelBox add: (DisplayBoardExtended new).
(self marbelBox at:6) strMessage hide.
(self marbelBox at:6) dispImage hide.

self marbelBox add: (DisplayBoardExtended new).
(self marbelBox at:7) strMessage hide.
(self marbelBox at:7) dispImage hide.

(self marbelBox at:1) initMarbelsWithCount:1.
(self marbelBox at:2) initMarbelsWithCount:5.
(self marbelBox at:3) initMarbelsWithCount:10.

	count:=1.
	[ count <=7 ] whileTrue:
	[
		self page1 addMorph: (self marbelBox at:count).

		count := count + 1.
	].
! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 11:59'!
initPage2
	| msgSend argument count |

	self page2: PasteUpMorph new openInWorld.
	self page2 width:400.
	self page2 height:400.

	self timer: MyTimer new.
	self page2 addMorph: self timer.

	self btnConfirm: ImageMorph new.
	self page2 addMorph: self btnConfirm.
	self btnConfirm on:#mouseUp send:#btnConfirmClick to:self.

	self btnTryAgain: ImageMorph new openInWorld.
	self page2 addMorph: self btnTryAgain.
	self btnTryAgain on:#mouseUp send:#btnTryAgainClick to:self.

	self questionDisplay: OrderedCollection new.

	msgSend := OrderedCollection new.
	argument := OrderedCollection new.
	count := 1.

	[ count <= 10 ] whileTrue:
	[
		self questionDisplay add: (QuestionDisplay new).
		(self questionDisplay at:count) dispQuestion dispImage hide.
		(self questionDisplay at:count) dispQuestion strMessage fontName: 'BitstreamVersSans' size:200.
		(self questionDisplay at:count) dispAnswer1 strValue hide.
		(self questionDisplay at:count) dispAnswer2 show.
		(self questionDisplay at:count) dispAnswer2 strValue fontName: 'BitstreamVersSans' size:36.
		(self questionDisplay at:count) dispAnswer2 txtBox hide.
	
		msgSend add: MessageSend new.
		argument add:(Array new:1). 		
		(msgSend at:count) selector: #txtBoxCrActionWithId: .
		(msgSend at:count) receiver: self.
		(argument at:count) at:1 put:count.
		(msgSend at:count) arguments: (argument at:count).
		(self questionDisplay at:count) dispAnswer1 txtBox crAction: (msgSend at:count).

		self page2 addMorph: (self questionDisplay at:count).
 
		count := count + 1.
	].
	
	self timer countUp:true.
	self timer setTimerHour:9 Minute:59 Second:59.

! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 7/11/2008 09:29'!
initQuestionDisplayPosition

	| count left top |
	count:= 1.
	left := self page1 left + 30.
	top := self page1 top + 40.

	[ count <= self questionDisplay size] whileTrue:
	[
		(self questionDisplay at:count) left:left.
		(self questionDisplay at:count) top:top.

		(count \\ 4) = 0 ifTrue:
		[
				top := 	top + (self questionDisplay at:count) height + 10.
				left := self page1 left + 30.
		]
		ifFalse:
		[
			left := left + 	(self questionDisplay at:count) width + 20.
		].

		count := count + 1.
	].! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 7/24/2008 15:01'!
initQuestion
	| count |
	self question: OrderedCollection new.

	count := 1.
	[ count <= 20 ] whileTrue:
	[
		self question add: (Array new:2). 
		count := count + 1.
	].

	(self question at:1) at:1 put:'10'. 
	(self question at:1) at:2 put:'X'. 

	(self question at:2) at:1 put:'2'. 
	(self question at:2) at:2 put:'II'. 

	(self question at:3) at:1 put:'150'. 
	(self question at:3) at:2 put:'CL'. 

	(self question at:4) at:1 put:'50'. 
	(self question at:4) at:2 put:'L'. 

	(self question at:5) at:1 put:'500'. 
	(self question at:5) at:2 put:'D'. 

	(self question at:6) at:1 put:'1500'. 
	(self question at:6) at:2 put:'MD'. 

	(self question at:7) at:1 put:'12'. 
	(self question at:7) at:2 put:'XII'. 

	(self question at:8) at:1 put:'120'. 
	(self question at:8) at:2 put:'CXX'. 

	(self question at:9) at:1 put:'250'. 
	(self question at:9) at:2 put:'CCL'. 

	(self question at:10) at:1 put:'40'. 
	(self question at:10) at:2 put:'XL'. 

	(self question at:11) at:1 put:'3'. 
	(self question at:11) at:2 put:'III'. 

	(self question at:12) at:1 put:'16'. 
	(self question at:12) at:2 put:'XVI'. 

	(self question at:13) at:1 put:'62'. 
	(self question at:13) at:2 put:'LXII'. 

	(self question at:14) at:1 put:'59'. 
	(self question at:14) at:2 put:'LIX'. 

	(self question at:15) at:1 put:'127'. 
	(self question at:15) at:2 put:'CXXVII'. 

	(self question at:16) at:1 put:'355'. 
	(self question at:16) at:2 put:'CCCLV'. 

	(self question at:17) at:1 put:'400'. 
	(self question at:17) at:2 put:'CD'. 

	(self question at:18) at:1 put:'757'. 
	(self question at:18) at:2 put:'DCCLVII'. 

	(self question at:19) at:1 put:'935'. 
	(self question at:19) at:2 put:'CMXXXV'. 

	(self question at:20) at:1 put:'1205'. 
	(self question at:20) at:2 put:'MCCV'. 
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 10:59'!
marbelBox
	^marbelBox! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 11:02'!
marbelBox: anOrderedCollection
	marbelBox := anOrderedCollection! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:52'!
page1
	^page1! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:53'!
page1: aPasteUpPorph
	page1 := aPasteUpPorph! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:52'!
page2
	^page2! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:53'!
page2: aPasteUpPorph
	page2 := aPasteUpPorph! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:56'!
questionDisplay
	^questionDisplay! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:56'!
questionDisplay: anOrderedCollection
	questionDisplay := anOrderedCollection! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 09:45'!
question
	^question! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 09:46'!
question: anOrderedCollection
	question := anOrderedCollection! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 12:04'!
reset
	| count |
	self currentSet:1.
	self start:false.
	self stopStepping.
	self secondPassed:0.
	self currentPage:1.

	count := 1.
	[ count <= 3 ]  whileTrue:
	[
		(self marbelBox at:count) reset.
		count := count + 1.
	].

	self page1 show.
	self page2 hide.
	self gameOverDisplay hide.

	self btnConfirm show.
	self btnTryAgain hide.
	self btnNext show.
	self btnPrevious hide.
	self timer reset.
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/10/2008 11:02'!
secondPassed
	^secondPassed! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/10/2008 11:02'!
secondPassed: aNumber
	secondPassed := aNumber! !

!RomanNumberActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/11/2008 09:35'!
showNewQuestion
	
	| count qusNo |
	count := 1.
	[ count <= 10 ] whileTrue:
	[
		qusNo  := (10*(self currentSet - 1)) + count.
		(self questionDisplay at:count) dispQuestion strMessage contents: ((self question at:qusNo) at:1). 
		(self questionDisplay at:count) dispQuestion strMessage center:(self questionDisplay at:count) dispQuestion center.		
		(self questionDisplay at:count) dispAnswer1 imgCheck hide.
		(self questionDisplay at:count) dispAnswer1 txtBox setCharacters: ' '.
		(self questionDisplay at:count) dispAnswer2 hide.		
		(self questionDisplay at:count) dispAnswer2 strValue contents: ((self question at:qusNo) at:2).
		(self questionDisplay at:count) dispAnswer2 strValue center: ((self questionDisplay at:count) dispAnswer2 center - (25@0)).
		count := count + 1.	
	].
! !

!RomanNumberActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 11:05'!
startAnimation
	| count |
	count := 1.
	[ count <= 3 ]  whileTrue:
	[
		(self marbelBox at:count) start:true.
		(self marbelBox at:count) startStepping.
		count := count + 1.
	].

	self start:true.
	self startStepping.
! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/10/2008 10:58'!
start
	^start! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/10/2008 10:58'!
start: aBoolean
	start:= aBoolean! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/10/2008 10:57'!
stepTime
	^1000.
! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 12:42'!
step
	| count |
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 30 ifTrue:
		[
			self btnNextClick.
		].
	]
	ifFalse:
	[
		self stopStepping.
	].! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 11:03'!
strRomanValue
	^strRomanValue! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 11:03'!
strRomanValue: anOrderedCollection
	strRomanValue := anOrderedCollection! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/11/2008 15:49'!
test
	| count |
	count := 1.
	[count <= 10] whileTrue:
	[
		(self questionDisplay at:count) dispAnswer1 txtBox maxLength:6.
		count := count + 1.
	].! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:53'!
timer
	^timer! !

!RomanNumberActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/7/2008 09:54'!
timer: aMyTimer
	timer := aMyTimer! !

!RomanNumberActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/14/2008 16:21'!
txtBoxCrActionWithId:argument
	| y |
	y := argument. 
	(y + 1 > self questionDisplay size) ifTrue:
	[
		self btnNext visible ifFalse:
		[
			self btnConfirmClick.
		]
	]
	ifFalse:
	[
		ActiveHand keyboardFocus: (self questionDisplay at:(y+1)) dispAnswer1 txtBox.
		(self questionDisplay at:(y+1)) dispAnswer1 txtBox borderWidth:1.
	].
! !

Morph subclass: #SimpleHighlightMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:40'!
handlesMouseOver: event
	^true! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:07'!
initialize
	super initialize.
	self color: Color transparent.! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 10:08'!
mouseEnter: event
	^self color: (Color yellow alpha: 0.25).! !

!SimpleHighlightMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/13/2007 09:41'!
mouseLeave: event
	^self color: Color transparent.! !

Morph subclass: #SubstractActivity
	instanceVariableNames: 'page1 page2 page0 questionDisplay gun start question gameMode targetIndex answerDisplay score life gameOverDisplay btnPlayAgain currentPage btnNext btnStartGame radGameMode aSubstraction1 aAddition1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubstractActivity'!

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 13:06'!
aAddition1
	^aAddition1
	! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 13:06'!
aAddition1: aAnimatedAdditionMorph
	aAddition1 := aAnimatedAdditionMorph.
	! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 11:43'!
answerDisplay
	^answerDisplay! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 11:43'!
answerDisplay: aStringMorph
	answerDisplay := aStringMorph! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 10:03'!
answer
	^answer! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 10:03'!
answer: aStringMorph
	answer := aStringMorph! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 14:48'!
aSubstraction1
	^aSubstraction1! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 14:49'!
aSubstraction1: aAnimatedSubstractMorph
	aSubstraction1 := aAnimatedSubstractMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 10:53'!
btnNextClick

	self currentPage = 0 ifTrue:
	[
		self aAddition1 reset.
		self page0 hide.
		self page2 hide.
		self page1 show.
		self aSubstraction1 startAnimation.
		self currentPage:1.
	]
	ifFalse:
	[
		self currentPage = 1 ifTrue:
		[
			self aSubstraction1 reset.
			self page0 hide.
			self page1 hide.
			self page2 show.
			self btnNext hide.
			self currentPage:2.
		]
	]

! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 15:31'!
btnNext
	^btnNext! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 15:31'!
btnNext: anImageMorph
	btnNext := anImageMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 09:52'!
btnPlayAgainClick
	self reset.
	self aAddition1 startAnimation.! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:30'!
btnPlayAgain
	^btnPlayAgain! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:30'!
btnPlayAgain: anImageMorph
	btnPlayAgain := anImageMorph! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 14:45'!
btnStartGame
	^btnStartGame! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 14:46'!
btnStartGame: anImageMorph
	btnStartGame := anImageMorph! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/22/2008 11:51'!
changeAnswer
	self answerDisplay strMessage contents: ((self question at:(5 random)) at:4) asString.
	self answerDisplay strMessage center: self answerDisplay center.
	! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/24/2008 09:58'!
changeAnswer:id
	| tmp count size |
	tmp := OrderedCollection new.
	count := 1.
	size := self question size.
	[count <= size] whileTrue:
	[
		id ~= count ifTrue:
		[
			tmp add:count.
		].
		count := count + 1.
	].

	self answerDisplay strMessage contents: ((self question at:(tmp at:((tmp size) random))) at:4) asString.
	self answerDisplay strMessage center: self answerDisplay center.
! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/22/2008 11:49'!
checkAnswer
	| x z |
	x := self answerDisplay strMessage contents.
	z := ((self question at:(self targetIndex) ) at:4).

	x = z ifTrue:
	[
		^true
	].
	^false.

	! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/18/2008 15:28'!
convertDigitArrayToNumber: orderedColection
	| size count result |
	size :=  orderedColection size.
	count := 1.
	result := 0.
	[ count <= size ] whileTrue:
	[
		result := result + ( (orderedColection at:count) * (10 raisedTo:(size-count)) ).
		count := count + 1.
	].
	^result.	! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/18/2008 17:08'!
convertNumberToDigitArray:baseDigits Number:number
	| baseDigitCount divider count baseNumber |

	baseNumber := number.
	baseDigitCount := self digitCount:baseNumber.
	
	count :=1.
	[ count < baseDigitCount ] whileTrue:
	[
		divider := 10 raisedTo: (baseDigitCount - count).
		baseDigits add: (baseNumber // divider).
		baseNumber := baseNumber \\ divider.
		count := count + 1.
	].
	baseDigits add: baseNumber.	! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 09:54'!
currentPage
	^currentPage! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 09:54'!
currentPage: aNumber
	currentPage := aNumber! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/21/2008 14:41'!
decreaseLife
	self life contents: ((self life contents) asInteger- 1) asString.
	self life contents = '0' ifTrue:
	[
		self reset.
		self gameOverDisplay show.
	]

	! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/22/2008 10:00'!
decreaseScore
	| intScore |
	intScore := (self score contents asInteger) - 1.
	intScore < 0 ifFalse:
	[
		self score contents: intScore asString.
	]
! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/18/2008 15:28'!
digitCount: number
	| divider digit res doLoop |
	divider := 10.
	digit := 1.
	doLoop := true.
	[ doLoop ] whileTrue:
	[
		res := number // divider.
		(res <=0) ifTrue:
		[
			doLoop := false.
		]
		ifFalse:
		[
			digit := digit + 1.
			divider := divider raisedTo:digit.
		]
	].
	^digit.! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/24/2008 10:37'!
findNewNumber: newNumberArray
	| baseDigits baseNumber targetDigitCount baseDigitCount targetDigits startPosition num targetNumber doAdd scr xx |

	self gameMode = 1 ifTrue:
	[
		doAdd := true.
	]
	ifFalse:
	[
		self gameMode = 2 ifTrue:
		[
			doAdd := false.
		]
		ifFalse:
		[
			self gameMode = 3 ifTrue:
			[
				doAdd := 2 random.
				doAdd = 1 ifTrue:
				[
					doAdd := true.
				]
				ifFalse:
				[
					doAdd := false.
				]
			]
		]
	].
	scr := self getScore.
	scr < 25 ifTrue:
	[
		baseNumber := 10 random.
	]
	ifFalse:
	[
		scr < 50 ifTrue:
		[
			baseNumber := 99 random.
		]
		ifFalse:
		[
			xx := 2 random.
			xx = 1 ifTrue:
			[
				baseNumber := 99 random.
			]
			ifFalse:
			[
				baseNumber := 999 random.
			]
		].
	].

	baseDigits := OrderedCollection new.
	self convertNumberToDigitArray:baseDigits Number:baseNumber.
	baseDigitCount := baseDigits size.

	targetDigitCount := self digitCount: (baseNumber random).
	targetDigits := OrderedCollection new.

	startPosition := baseDigitCount - targetDigitCount + 1.

	targetDigitCount timesRepeat:
	[
		doAdd ifTrue:
		[
			num := 9 - baseDigits at:startPosition.
			num := (num+1) random - 1.
			targetDigits add:num.
		]
		ifFalse:
		[
			num := baseDigits at:startPosition.
			num := (num+1) random - 1.
			targetDigits add:num.
		].
		
		startPosition := startPosition + 1.
	].

	targetNumber := self convertDigitArrayToNumber:targetDigits.

	newNumberArray at:1 put: baseNumber asString.
	doAdd ifTrue:
	[
		newNumberArray at:2 put: '+'.
		newNumberArray at:4 put: (baseNumber + targetNumber) asString.
	]
	ifFalse:
	[
		newNumberArray at:2 put: '-'.
		newNumberArray at:4 put: (baseNumber - targetNumber) asString.
	].
	newNumberArray at:3 put: targetNumber asString.
! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 10:07'!
gameModeSelect:mode
	self gameMode:mode.
! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 10:08'!
gameMode
	^gameMode! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 10:08'!
gameMode: aNumber
	gameMode := aNumber! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:27'!
gameOverDisplay
	^gameOverDisplay! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:28'!
gameOverDisplay: aRectangleMorph
	gameOverDisplay := aRectangleMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/22/2008 10:46'!
getScore
	^self score contents asInteger.! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 13:33'!
gun
	^gun! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 13:34'!
gun: anImageMorph
	gun := anImageMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/29/2008 15:19'!
increaseScore
	| intScore stepInterval count size |
	intScore := (self score contents) asInteger.
	intScore := intScore + 1.
	self score contents: intScore asString.

	(intScore \\ 25) = 0 ifTrue:
	[
		stepInterval := ((self questionDisplay at:1) stepInterval) - 200. 

		count := 1.
		size := self questionDisplay size.

		[ count <= size ] whileTrue:
		[
			(self questionDisplay at:count) stepInterval: stepInterval.
			count := count + 1.
		].

		self life contents: ((self life contents) asInteger + 10) asString.
	].! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 15:39'!
initCostume
	| extName count size |

	extName := 'play_again'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self btnPlayAgain wearCostume: t2.
		]
	].

	extName := 'start_new_game'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self btnStartGame wearCostume: t2.
		]
	].

	extName := 'answerDisplayBg'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self answerDisplay wearCostume: t2.
		]
	].

	count := 1.
	size := self questionDisplay size.
	[count <= size ] whileTrue:
	[
		(self questionDisplay at:1) initCostume.		
		count := count + 1.
	].

	self gun initCostume.

	extName := 'next'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self btnNext wearCostume: t2.
		]
	].
! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 09:55'!
initialize
	super initialize.
	self start: false.

	self initPage1.
	self initPage2.
	self gameMode:3.
	self currentPage:0.

	self gameOverDisplay:(RectangleMorph new) openInWorld.
	self btnPlayAgain: (ImageMorph new) openInWorld.
	self btnPlayAgain on:#mouseUp send:#btnPlayAgainClick to:self.
	self btnNext: ImageMorph new openInWorld.
	self btnNext on:#mouseUp send:#btnNextClick to:self.

	self initCostume

! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 8/1/2008 14:23'!
initPage0
	self aAddition1: AnimatedAdditionMorph new openInWorld.
	self page0: self aAddition1.

	! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 15:34'!
initPage1
"	self page1: (PasteUpMorph new) openInWorld.
	self page1 width:100.
	self page1 height: 100.

	self aSubstraction1: AnimatedSubstractionMorph new.
	self page1 addMorph: self aSubstraction1.
"
	self btnNext: ImageMorph new openInWorld.
	self btnNext on:#mouseUp send:#btnNextClick to:self.

! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 10:06'!
initPage2
	self page2: (PasteUpMorph new) openInWorld.
	self page2 width:100.
	self page2 height: 100.
	self targetIndex:0.

	self question: OrderedCollection new.
	self question add: (Array withAll:#('1' '+' '2' '3')).
	self question add: (Array withAll:#('2' '+' '3' '5')).
	self question add: (Array withAll:#('3' '+' '4' '7')).
	self question add: (Array withAll:#('4' '+' '5' '9')).
	self question add: (Array withAll:#('2' '+' '4' '6')).

	self questionDisplay: (OrderedCollection new).
	self questionDisplay add: (AnimatedCloud new).
	(self questionDisplay at:1) id:1.
	(self questionDisplay at:1) parent:self.
	(self questionDisplay at:1) on:#mouseUp send:#questionDisplayClick:V2:V3: to:self withValue:1.

	self questionDisplay add: (AnimatedCloud new).
	(self questionDisplay at:2) id:2.
	(self questionDisplay at:2) parent:self.
	(self questionDisplay at:2) on:#mouseUp send:#questionDisplayClick:V2:V3: to:self withValue:2.

	self questionDisplay add: (AnimatedCloud new).
	(self questionDisplay at:3) id:3.
	(self questionDisplay at:3) parent:self.
	(self questionDisplay at:3) on:#mouseUp send:#questionDisplayClick:V2:V3: to:self withValue:3.

	self questionDisplay add: (AnimatedCloud new).
	(self questionDisplay at:4) id:4.
	(self questionDisplay at:4) parent:self.
	(self questionDisplay at:4) on:#mouseUp send:#questionDisplayClick:V2:V3: to:self withValue:4.

	self questionDisplay add: (AnimatedCloud new).
	(self questionDisplay at:5) id:5.
	(self questionDisplay at:5) parent:self.
	(self questionDisplay at:5) on:#mouseUp send:#questionDisplayClick:V2:V3: to:self withValue:5.

	self page2 addMorph: ( self questionDisplay at:1 ).
	self page2 addMorph: ( self questionDisplay at:2 ).
	self page2 addMorph: ( self questionDisplay at:3 ).
	self page2 addMorph: ( self questionDisplay at:4 ).
	self page2 addMorph: ( self questionDisplay at:5 ).

	self gun: Gun new.
	self page2 addMorph: self gun.
	self gun parent:self.

	self answerDisplay: DisplayBoardText new.
	(self answerDisplay strMessage) fontName: 'BitstreamVeraSans' size:36.
	self page2 addMorph: self answerDisplay.

	self life: StringMorph new.
	self life fontName: 'BitstreamVeraSans' size:36.
	self life contents: '25'.
	self page2 addMorph: self life.

	self score: (StringMorph new).
	self score fontName: 'BitstreamVeraSans' size:36.
	self score contents: '0'.
	self page2 addMorph: self score.

	self btnStartGame: (ImageMorph new).
	self btnStartGame on:#mouseUp send:#startGame to:self.
	self page2 addMorph: self btnStartGame.

	self radGameMode: RadioButton new.
	self radGameMode initName:'Select Game Mode' Receiver:self Selector:#gameModeSelect:
								sImageName:'radioSelect' usImageName:'radioUnSelect'.
	self page2 addMorph:(self radGameMode).
	! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 7/21/2008 15:04'!
initQuestionDisplayPosition
	| count size |
	count :=1.
	size := questionDisplay size.
	[ count <= size ] whileTrue:
	[
		(self questionDisplay at:count) initPosition:850.
		count := count + 1.
	]
! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:15'!
life
	^life! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:53'!
life: aNumber
	life := aNumber! !

!SubstractActivity methodsFor: 'Question-Answer' stamp: 'Aayush 7/21/2008 13:36'!
makeQuestionFor:index
	
	| loop size count check |
	loop := true.
	size := self question size. 
	[ loop ] whileTrue:
	[
		self findNewNumber: (self question at:index).

		check := 0.
		count := 1.
		[count <= size ] whileTrue:
		[
			count = index	ifFalse:
			[
				(((self question at:index) at:4) = ((self question at:count) at:4)) ifFalse:
				[
					check := check + 1.
				]
			].
			count := count + 1.		
		].

		check = 4 ifTrue:
		[
			loop := false.
		].
	].
	
	(self questionDisplay at:index) insertMessage:((self question at:index) at:1) Message2:((self question at:index) 																		at:3) Operator:((self question at:index) at:2).
	(self questionDisplay at:index) strMessage show.
	(self questionDisplay at:index) strMessage2 show.


	! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 12:54'!
page0
	^page0! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 12:54'!
page0: aPasteUpMorph
	page0 := aPasteUpMorph! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:35'!
page1
	^page1! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:35'!
page1: aPasteUpMorph
	page1 := aPasteUpMorph! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:35'!
page2
	^page2! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:36'!
page2: aPasteUpMorph
	page2 := aPasteUpMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/21/2008 16:47'!
questionDisplayClick:index V2:v2 V3:v3
	self targetIndex:index.
	self selectTarget: index.
	self gun fire.

! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:38'!
questionDisplay
	^questionDisplay! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 09:38'!
questionDisplay: anOrderedCollection
	questionDisplay := anOrderedCollection! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 12:34'!
question
	^question! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/15/2008 12:34'!
question: anOrderedCollection
	question := anOrderedCollection! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/23/2008 09:43'!
radGameMode
	^radGameMode! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/23/2008 09:44'!
radGameMode: aRadioButton
	radGameMode := aRadioButton! !

!SubstractActivity methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 09:55'!
reset
	| count size |
	self start: false.
	self life contents: '10'.
	self score contents: '0'.
	self currentPage:0.

	count := 1.
	size := self questionDisplay size.
	[ count <= size ] whileTrue:
	[
		(self questionDisplay at:count) reset.

		count := count + 1.
	].

	self gun reset.
	self gameOverDisplay hide.

	self page0 show.
	self page1 hide.
	self page2 hide.
	self btnNext show.
	self gameOverDisplay hide.
	self aSubstraction1 reset.
	self aAddition1 reset.! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:13'!
score
	^score! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:14'!
score: aStringMorph
	score :=  aStringMorph! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/24/2008 10:45'!
selectTarget: index
	| count size |
	
	count := 1.
	size := self questionDisplay size.
	[ count <= size ] whileTrue:
	[
		count = index ifTrue:
		[
			(self questionDisplay at:count) aimedAt:true.	
			(self questionDisplay at:count) selectionImage show..
		]
		ifFalse:
		[
			(self questionDisplay at:count) aimedAt:false.
			(self questionDisplay at:count) selectionImage hide.
		].
		count := count + 1.
	].
	self gun lockAt: (self questionDisplay at:index).
! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 17:00'!
setQuestionDisplayStepInterval:interval
	| count size |
	count := 1.
	size := self questionDisplay size.
	[ count <= size ] whileTrue:
	[
		(self questionDisplay at:count) stepInterval:interval.
		count := count + 1.
	].! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 13:14'!
startGame
	| count size |

	self life contents: '10'.
	self score contents: '0'.

	count := 1.
	size := self questionDisplay size.
	[ count <= size ] whileTrue:
	[
		(self questionDisplay at:count) reset.

		count := count + 1.
	].

	self gun reset.
"***************************************************"

	count := 1.
	size := self questionDisplay size.
	[ count <= size ] whileTrue:
	[
		(self questionDisplay at:count) start:true.
		(self questionDisplay at:count) startStepping.

		self makeQuestionFor:count.

		count := count + 1.
	].

	self start:true.
	self startStepping.

	self changeAnswer:1.! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:45'!
start
	^start! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:45'!
start: aBoolean
	start := aBoolean! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/18/2008 13:35'!
stepTime
	^500.! !

!SubstractActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/21/2008 17:05'!
step
	| keyStroke |

	self start ifTrue:
	[
		keyStroke := World lastKeystroke.
		keyStroke = '<up>' ifTrue:
		[
			self targetIndex ~= 0 ifTrue:
			[
				self gun fire.
			].
			World lastKeystroke: 'a'.
		]
		ifFalse:
		[
			keyStroke = '1' ifTrue:
			[
				self targetIndex:1.
				self selectTarget:self targetIndex.
				World lastKeystroke: 'a'.
			]
			ifFalse:
			[
				keyStroke = '2' ifTrue:
				[
					self targetIndex:2.
					self selectTarget:self targetIndex.
					World lastKeystroke: 'a'.
				]
				ifFalse:
				[
					keyStroke = '3' ifTrue:
					[
						self targetIndex:3.
						self selectTarget:self targetIndex.
						World lastKeystroke: 'a'.
					]
					ifFalse:
					[
						keyStroke = '4' ifTrue:
						[
							self targetIndex:4.
							self selectTarget:self targetIndex.
							World lastKeystroke: 'a'.
						]
						ifFalse:
						[
							keyStroke = '5' ifTrue:
							[
								self targetIndex:5.
								self selectTarget:self targetIndex.
								World lastKeystroke: 'a'.
							]
						]
					]
				]
			]
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:41'!
targetIndex
	^targetIndex! !

!SubstractActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:41'!
targetIndex: aNumber
	targetIndex := aNumber! !

Morph subclass: #TextLabel
	instanceVariableNames: 'textValue txt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Vocab'!

!TextLabel methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 11:58'!
getContainer: strContainerName
	| cont |
	cont:=World allMorphs select:[: each| ((each isKindOf:PasteUpMorph)and:[each externalName 	match:strContainerName])].
	cont size>0 
		ifTrue:[
		^(cont at:1).
		]! !

!TextLabel methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 11:42'!
initialize
	| rm |
	super initialize.
	self height: 40.
	self width: 120.

	rm:=RectangleMorph new.
	self txt: TextMorph new.
	rm addMorph: txt.

	self addMorph: txt.
	txt center: self center.
	txt lock:true.

	self color: Color white.
	self borderWidth:1.
	self borderColor:Color blue.

self on:#mouseLeave send:#onMouseLeaveCall to: self.
! !

!TextLabel methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 12:31'!
onMouseLeaveCall

	self selfPosition.
	self removeMultiple! !

!TextLabel methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 12:30'!
removeMultiple
 	| own cont |

	own:= self owner.
	('AnswerBox' match: own externalName )
	ifTrue:[
		own submorphs size>1 
			ifTrue:[
					cont:=self getContainer:'TextLabelContainer'.
					cont addMorph: self.
					].
			].

! !

!TextLabel methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 12:09'!
selfPosition
| own ownerList cont properPosition |
	own:= self owner externalName.
	ownerList:=#( 'AnswerBox' 'TextLabelContainer' ).
	cont:=self getContainer:'TextLabelContainer'.
	properPosition:=false.
	1 to: ownerList size do:[:each| (own match: (ownerList at:each))
		ifTrue:[
			properPosition:=true.
				]
		].
	(properPosition) ifFalse:[
		cont addMorph: self.
			^self.]! !

!TextLabel methodsFor: 'accessing' stamp: 'ram 10/1/2008 11:38'!
textValue
	"Answer the value of textValue"

	^ textValue! !

!TextLabel methodsFor: 'accessing' stamp: 'ram 10/1/2008 11:45'!
textValue: anObject
	"Set the value of textValue"

	textValue _ anObject.
	self txt setCharacters: anObject.! !

!TextLabel methodsFor: 'accessing' stamp: 'ram 10/1/2008 11:41'!
txt
	"Answer the value of txt"

	^ txt! !

!TextLabel methodsFor: 'accessing' stamp: 'ram 10/1/2008 11:41'!
txt: anObject
	"Set the value of txt"

	txt _ anObject! !

Morph subclass: #VariablesActivity
	instanceVariableNames: 'objToShow objDiscription msgWhatToDo msgHowTo reasult btnConfirm btnNext textBox question currentQuestion score noOfAttempt questionPool gameOverDisplay start secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-VariablesActivity'!

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/25/2008 10:24'!
btnConfirmClick
	self noOfAttempt:  self noOfAttempt + 1.

	self checkAnswer ifTrue:
	[
		SoundService default playSoundNamedOrBeep: 'right1'.
		self start:true.
		self startStepping.
	]
	ifFalse:
	[
		SoundService default playSoundNamedOrBeep: 'wrong3'.
	].

	ActiveHand keyboardFocus: self textBox.
! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:27'!
btnConfirm
	^btnConfirm! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:39'!
btnConfirm: anImageMorph
	btnConfirm := anImageMorph! !

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 6/18/2008 14:46'!
btnNextClick
	self reset.

! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 10:37'!
btnNext
	^btnNext! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 10:38'!
btnNext: anImageMorph
	btnNext := anImageMorph! !

!VariablesActivity methodsFor: 'question-answer' stamp: 'Aayush 6/19/2008 10:01'!
checkAnswer
	
	((self textBox) getCharacters) withBlanksTrimmed = ((self question at:(self currentQuestion)) at:8) ifTrue:
	[
		^true.
	].
	
	^false.! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/16/2008 12:26'!
currentQuestion
	^currentQuestion! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/16/2008 12:26'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 6/18/2008 12:22'!
doNothing
	^self! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 12:16'!
gameOverDisplay
	^gameOverDisplay! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/27/2008 12:16'!
gameOverDisplay: aRectanagleMorph
	gameOverDisplay := aRectanagleMorph! !

!VariablesActivity methodsFor: 'question-answer' stamp: 'Aayush 7/2/2008 17:01'!
generateNewQuestion
	| t1 x |

	x := self questionPool size random.
	self currentQuestion: (self questionPool at:x).
	self questionPool removeAt:x.

	t1 := 'Image_', ((self question at:(self currentQuestion)) at:1).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objToShow dispImage wearCostume: t2.
			self objToShow dispImage center: self objToShow center.
		]
	].

	t1 := 'Image_', ((self question at:(self currentQuestion)) at:3).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objDiscription dispImage wearCostume: t2.
			self objDiscription dispImage center: self objDiscription center.
		]
	].

	t1 := 'Image_', ((self question at:(self currentQuestion)) at:4).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self msgWhatToDo dispImage wearCostume: t2.
			self msgWhatToDo dispImage center: self msgWhatToDo center.
		]
	].

	t1 := 'Image_', ((self question at:(self currentQuestion)) at:5).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self msgHowTo dispImage wearCostume: t2.
			self msgHowTo dispImage center: self msgHowTo center.
		]
	].

	t1 := 'Image_',((self question at:(self currentQuestion)) at:7).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self reasult dispImage wearCostume: t2.
			self reasult dispImage center: self reasult center.
		]
	].

	self reasult hide.
	self btnConfirm hide.! !

!VariablesActivity methodsFor: 'question-answer' stamp: 'Aayush 6/16/2008 14:10'!
getNextQuestionNo
	self currentQuestion: self currentQuestion + 1.

	self currentQuestion > self question size ifTrue:
	[
		self currentQuestion:1.
	]
	ifFalse:
	[
		self currentQuestion.
	].

	^ self currentQuestion.
! !

!VariablesActivity methodsFor: 'initialization' stamp: 'Aayush 6/27/2008 12:11'!
initCostume
	| t1 |
	t1 := 'DisplayBoard_1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objToShow wearCostume: t2.
		]
	].

	t1 := 'DisplayBoard_3'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objDiscription wearCostume: t2.
		]
	].

	t1 := 'DisplayBoard_3'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self msgWhatToDo wearCostume: t2.
		]
	].

	t1 := 'DisplayBoard_2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self msgHowTo wearCostume: t2.
		]
	].

	t1 := 'DisplayBoard_4'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self reasult wearCostume: t2.
		]
	].

	t1 := 'confirm_nepali'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnConfirm wearCostume: t2.
		]
	].

	t1 := 'play_again'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self btnNext wearCostume: t2.
		]
	].
! !

!VariablesActivity methodsFor: 'initialization' stamp: 'Aayush 7/2/2008 16:58'!
initialize
	| msgSend1 |
	super initialize.
	self initQuestion.
	self questionPool: OrderedCollection new.
	self questionPool addAll: #(1 2 3 4 5 6 7 8).

	self objToShow: DisplayBoard new.
	self objToShow dispImage on:#mouseUp send:#objClick to:self.
	self objToShow openInWorld.

	self objDiscription: DisplayBoard new.
	self objDiscription openInWorld.

	self gameOverDisplay: (RectangleMorph new) openInWorld.
  
	self msgWhatToDo: DisplayBoard new.
	self msgWhatToDo openInWorld.

	self msgHowTo: DisplayBoard new.
	self msgHowTo openInWorld.

	self reasult: DisplayBoard new.
	self reasult openInWorld.

	self btnConfirm: ImageMorph new.
	self btnConfirm openInWorld.
	self btnConfirm on:#mouseUp send:#btnConfirmClick to:self.

	self btnNext: ImageMorph new.
	self btnNext openInWorld.
	self btnNext on:#mouseUp send:#btnNextClick to:self.

	self textBox: UserText new.
	self textBox openInWorld.

	msgSend1 := MessageSend new.
	msgSend1 selector: #btnConfirmClick.
	msgSend1 receiver: self.
	self textBox crAction: msgSend1.

	self score: StringMorph new.
	self score openInWorld.

	self initCostume.
	self reset.! !

!VariablesActivity methodsFor: 'initialization' stamp: 'Aayush 6/19/2008 09:37'!
initQuestion
	| count |

	self question: OrderedCollection new.

	count := 1.
	[ count <= 8 ] whileTrue:
	[
		self question add:(Array new:8).

		count := count + 1.
	].

	(self question at:1) at:1 put:'5'.	
	(self question at:1) at:2 put:'9'.	
	(self question at:1) at:3 put:'17'.	
	(self question at:1) at:4 put:'18'.	
	(self question at:1) at:5 put:'19'.	
	(self question at:1) at:6 put:'20'.	
	(self question at:1) at:7 put:'21'.	
	(self question at:1) at:8 put:'15'.	


	(self question at:2) at:1 put:'7'.	
	(self question at:2) at:2 put:'8'.	
	(self question at:2) at:3 put:'17'.	
	(self question at:2) at:4 put:'18'.	
	(self question at:2) at:5 put:'19'.	
	(self question at:2) at:6 put:'22'.	
	(self question at:2) at:7 put:'21'.	
	(self question at:2) at:8 put:'10'.	

	(self question at:3) at:1 put:'5'.	
	(self question at:3) at:2 put:'6'.	
	(self question at:3) at:3 put:'17'.	
	(self question at:3) at:4 put:'18'.	
	(self question at:3) at:5 put:'19'.	
	(self question at:3) at:6 put:'23'.	
	(self question at:3) at:7 put:'21'.	
	(self question at:3) at:8 put:'20'.	

	(self question at:4) at:1 put:'1'.	
	(self question at:4) at:2 put:'2'.	
	(self question at:4) at:3 put:'24'.	
	(self question at:4) at:4 put:'25'.	
	(self question at:4) at:5 put:'26'.	
	(self question at:4) at:6 put:'27'.	
	(self question at:4) at:7 put:'21'.	
	(self question at:4) at:8 put:'12'.	

	(self question at:5) at:1 put:'3'.	
	(self question at:5) at:2 put:'4'.	
	(self question at:5) at:3 put:'28'.	
	(self question at:5) at:4 put:'29'.	
	(self question at:5) at:5 put:'26'.	
	(self question at:5) at:6 put:'30'.	
	(self question at:5) at:7 put:'31'.	
	(self question at:5) at:8 put:'9'.	


	(self question at:6) at:1 put:'10'.	
	(self question at:6) at:2 put:'11'.	
	(self question at:6) at:3 put:'32'.	
	(self question at:6) at:4 put:'29'.	
	(self question at:6) at:5 put:'33'.	
	(self question at:6) at:6 put:'34'.	
	(self question at:6) at:7 put:'31'.	
	(self question at:6) at:8 put:'10'.	


	(self question at:7) at:1 put:'15'.	
	(self question at:7) at:2 put:'16'.	
	(self question at:7) at:3 put:'35'.	
	(self question at:7) at:4 put:'36'.	
	(self question at:7) at:5 put:'19'.	
	(self question at:7) at:6 put:'37'.	
	(self question at:7) at:7 put:'38'.	
	(self question at:7) at:8 put:'10'.	


	(self question at:8) at:1 put:'12'.	
	(self question at:8) at:2 put:'13'.	
	(self question at:8) at:3 put:'42'.	
	(self question at:8) at:4 put:'39'.	
	(self question at:8) at:5 put:'40'.	
	(self question at:8) at:6 put:'41'.	
	(self question at:8) at:7 put:'38'.	
	(self question at:8) at:8 put:'4'.	
! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:27'!
msgHowTo
	^msgHowTo! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:38'!
msgHowTo: aDisplayBoard
	msgHowTo := aDisplayBoard! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:26'!
msgWhatToDo
	^msgWhatToDo! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:38'!
msgWhatToDo: aDisplayBoard
	msgWhatToDo := aDisplayBoard! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 09:51'!
noOfAttempt
	^noOfAttempt! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 09:51'!
noOfAttempt: aNumber
	noOfAttempt := aNumber! !

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/2/2008 16:50'!
objClick
	| t1 |
	t1 := 'Image_', ((self question at:(self currentQuestion)) at:2).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self objToShow dispImage wearCostume: t2.
			self objToShow dispImage center: self objToShow center.
		]
	].

	t1 := 'Image_', ((self question at:(self currentQuestion)) at:6).
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
	 	[
			self msgHowTo dispImage wearCostume: t2.
			self msgHowTo dispImage center: self msgHowTo center.
		]
	].

	self objToShow dispImage on:#mouseUp send:#doNothing to:self.
	self reasult show.
	self btnConfirm show.


! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:26'!
objDiscription
	^objDiscription! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:38'!
objDiscription: aDisplayBoard
	objDiscription := aDisplayBoard! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:24'!
objToShow
	^objToShow! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:25'!
objToShow:	aDisplayBoard
	objToShow := aDisplayBoard
! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 10:19'!
questionPool
	^questionPool! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/17/2008 10:19'!
questionPool: anOrderedCollection
	questionPool := anOrderedCollection! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/13/2008 16:32'!
question
	^question! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/13/2008 16:32'!
question: anOrderedCollection
	question := anOrderedCollection! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/13/2008 14:10'!
reasult
	^reasult! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/13/2008 14:10'!
reasult: aDisplayMorph
	reasult := aDisplayMorph! !

!VariablesActivity methodsFor: 'initialization' stamp: 'Aayush 7/25/2008 10:23'!
reset
	self currentQuestion: 1.
	self score contents:'0'.
	self noOfAttempt:0.
	self secondPassed:0.
	self start:false.
	self btnConfirm hide.
	self btnNext hide.
	self textBox setCharacters: ' '.

	[ self questionPool size > 0 ] whileTrue:
	[
		self questionPool removeFirst.
	].
	self questionPool addAll: #(1 2 3 4 5 6 7 8).

	self generateNewQuestion.
	self objToShow dispImage on:#mouseUp send:#objClick to:self.
	self gameOverDisplay hide.
	self reasult hide.

	ActiveHand keyboardFocus: self textBox.
! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/16/2008 14:00'!
score
	^score! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/16/2008 14:00'!
score: aNumber
	score := aNumber! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:20'!
secondPassed
	^secondPassed! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:20'!
secondPassed:aNumber
	secondPassed := aNumber! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:16'!
start
	^start! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 7/25/2008 10:17'!
start: aBoolean
	start := aBoolean! !

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/25/2008 10:16'!
stepTime
	^1000.! !

!VariablesActivity methodsFor: 'miscellaneous' stamp: 'Aayush 7/25/2008 10:37'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.

		self secondPassed = 4 ifTrue:
		[
			self noOfAttempt = 1 ifTrue:
			[
				self score contents: ((((self score) contents) asInteger) + 1) asString.
			].
		
			self questionPool size = 0 ifTrue:
			[
				self btnNext show.
				self btnConfirm hide.
				self gameOverDisplay show.
			]
			ifFalse:
			[
				self generateNewQuestion.
				self noOfAttempt:0.
			].

			self objToShow dispImage on:#mouseUp send:#objClick to:self.
			self textBox setCharacters: ' '.
		
			self start:false.
			self secondPassed:0.
		]
	]
	ifFalse:
	[
		self stopStepping.
	].
! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:36'!
textBox
	^textBox! !

!VariablesActivity methodsFor: 'accessing - properties' stamp: 'Aayush 6/12/2008 15:37'!
textBox: anUserText
	textBox:=anUserText! !

!SampledSound class methodsFor: '*ole' stamp: 'lg 10/13/2007 21:02'!
addLibrarySoundsFromWaveDirectory: directory
	| files snd |
	files := (FileDirectory on: directory) fileNamesMatching: '*.wav'.
	files do: [ :file |
		snd := SampledSound fromWaveFileNamed: directory, '/', file.
		SampledSound addLibrarySoundNamed: (file copyUpTo: $.) samples: snd samples samplingRate: snd originalSamplingRate ].! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
getDifficultyLevel
	^costume difficultyLevel! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
getGameInstrumentType
	^costume gameInstrumentType.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
getGameValue
	^costume gameValue! !

!Player methodsFor: '*ole' stamp: 'lg 11/26/2007 12:37'!
getRightAnswer
	^costume getRightAnswer.! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:24'!
getTallyObject
	^costume tallyObject! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:46'!
sayNumber: n 
	self beep: n asString! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:25'!
setDifficultyLevel: n
	^costume difficultyLevel: n! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 17:44'!
setGameInstrumentType: type
	costume gameInstrumentType: type.! !

!Player methodsFor: '*ole' stamp: 'lg 10/29/2007 15:32'!
setGameValue: value
	costume gameValue: value! !

!Player methodsFor: '*ole' stamp: 'lg 11/11/2007 08:23'!
setTallyObject: morph
	^costume tallyObject: morph.! !

!Player methodsFor: '*ole' stamp: 'lg 11/1/2007 10:33'!
setupNewQuestion
	costume setupNewProblem! !

!Player methodsFor: '*ole' stamp: 'lg 10/30/2007 17:28'!
waitForSeconds: n 
	costume waitForSeconds: n.! !

StringMorph subclass: #AddingGameMorph
	instanceVariableNames: 'difficultyLevel tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/26/2007 12:20'!
additionsToViewerCategoryAddingGame
	^#( #'adding game' (
			(slot tallyObject 'The object to appear in tally boxes' Player readWrite Player getTallyObject Player setTallyObject:)
			(slot difficultyLevel 'How hard to make the adding problems (higher is harder)' Number readWrite Player getDifficultyLevel Player setDifficultyLevel:)
			(slot rightAnswer 'The correct answer to the number problem' Number readOnly Player getRightAnswer unused unused)
			(command setupNewQuestion 'Put a new problem on the screen')
		))! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:29'!
authoringPrototype
	^super authoringPrototype contents: '+'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!AddingGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 11:50'!
descriptionForPartsBin
	^ self partName: 'AddingGame' categories: {'OLE'} documentation: 'Adding game quiz generator'! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 11:52'!
answerForInputs: inputs
	| numbers |
	numbers := inputs collect: #gameValue.
	^self rules caseOf: { [#+] -> [numbers sum].  [#-] -> [numbers first - numbers second] }.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel
	^difficultyLevel! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:21'!
difficultyLevel: level
	difficultyLevel := level! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:27'!
getRightAnswer
	^self answerForInputs: World gameInputs.! !

!AddingGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/1/2007 09:47'!
initializeToStandAlone
	super initializeToStandAlone.
	self contents: '+'; fontName: 'BitstreamVeraSans' size: 100.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:50'!
rules
	self contents = '+' ifTrue: [^#+].
	self contents = '-' ifTrue: [^#-].
	^nil.! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:16'!
setupInputs: inputs
	| answer left right |
	self rules caseOf:
	{ [#+] -> [
		answer := (2 to: 9) atRandom.
		left := (1 to: answer - 1) atRandom.
		right := answer - left. ].
	   [#-] -> [
		answer := (1 to: 8) atRandom.
		left := (answer + 1 to: 9) atRandom.
		right := left - answer. ]
	}.
	inputs first setGameValue: left tallyObject: tallyObject.
	inputs second setGameValue: right tallyObject: tallyObject.
! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/26/2007 12:51'!
setupNewProblem
	| choices inputs answer choiceValues |
	self rules ifNil: [^self inform: 'Operator is not valid: ' , self contents].
	inputs := World gameInputs.
	choices := World gameChoices.
	inputs ifEmpty: [^self inform: 'You have to specify some inputs first'].
	choices ifEmpty: [^self inform: 'You have to specify some choices first'].
	self setupInputs: inputs.
"	inputs do: [ :choice | choice setGameValue: (1 to: 4) atRandom tallyObject: tallyObject]."
	answer := self answerForInputs: inputs.
"	answer := (inputs collect: #gameValue) sum."
	choiceValues := ( {answer} , ((2 to: 8) asArray shuffled without: answer) ) readStream.
	choices shuffled do: [ :input | input setGameValue: choiceValues next tallyObject: tallyObject].! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject
	^tallyObject! !

!AddingGameMorph methodsFor: 'game' stamp: 'lg 11/11/2007 08:10'!
tallyObject: morph
	tallyObject := morph.! !

AddingGameMorph subclass: #MinusGameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:42'!
authoringPrototype
	^super authoringPrototype contents: '-'; fontName: 'BitstreamVeraSansMono' size: 100.! !

!MinusGameMorph class methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:37'!
descriptionForPartsBin
	^ self partName: 'SubtractingGame' categories: {'OLE'} documentation: 'Subtracting game quiz generator'! !

!MinusGameMorph methodsFor: 'as yet unclassified' stamp: 'lg 11/24/2007 13:38'!
initializeToStandAlone
	super initializeToStandAlone contents: '-'.! !

StringMorph subclass: #RadioButton
	instanceVariableNames: 'textArray imageArray selectedIndex eventReceiver receiverSelector unSelectedImageName selectedImageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 14:14'!
addItem: label
	self textArray add: (StringMorph new) openInWorld.
	(self textArray at:(self textArray size)) contents:label.
	self imageArray add: (ImageMorph new) openInWorld.

"	self owner addMorph:(self textArray at:(self textArray size)).
	self owner addMorph:(self imageArray at:(self imageArray size)).
"

	(self imageArray at:(self textArray size)) on:#mouseUp send:#radioClick:V2:V3: to:self withValue:(self textArray size).
	(self textArray at:(self textArray size)) on:#mouseUp send:#radioClick:V2:V3: to:self withValue:(self textArray size).

	self initCostume.! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 12:10'!
doNothing
	^self.
! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 12:10'!
enable:aBoolean
	
	| count |
	aBoolean ifTrue:
	[
		count := 1.
		[count <= self textArray size] whileTrue:
		[
			(self imageArray at:count) on:#mouseUp send:#radioClick:V2:V3: to:self withValue:count.
			(self textArray at:count) on:#mouseUp send:#radioClick:V2:V3: to:self withValue:count.

			count := count + 1.
		]		
	]
	ifFalse:
	[
		count := 1.
		[count <= self textArray size] whileTrue:
		[
			(self imageArray at:count) on:#mouseUp send:#doNothing to:self.
			(self textArray at:count) on:#mouseUp send:#doNothing to:self.

			count := count + 1.
		]		
	]
! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:46'!
eventReceiver
	^eventReceiver! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 09:57'!
fontName:n size:s
	| count size |
	self fontName:n size:s.
	count := 1.
	size := self textArray size.
	[ count <= size ] whileTrue:
	[
		(self textArray at:count) fontName:n size:s.
	].
! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:20'!
imageArray
	^imageArray! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:20'!
imageArray: anOrderedCollection
	imageArray := anOrderedCollection! !

!RadioButton methodsFor: 'initialization' stamp: 'A 8/18/2008 15:40'!
initCostume
	| size count |
	size := self textArray size.
	count := 1.
	[ count <= size ] whileTrue:
	[
		count = self selectedIndex ifTrue:
		[
			(self imageArray at:count) wearCostume: self selectedImageName.
		]
		ifFalse:
		[
			(self imageArray at:count) wearCostume: self unSelectedImageName.
		].
		count := count + 1.
	].
! !

!RadioButton methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 09:30'!
initialize
	super initialize.
	self imageArray: OrderedCollection new.
	self textArray: OrderedCollection new.
	self contents: 'Radio Button'.

! !

!RadioButton methodsFor: 'initialization' stamp: 'Aayush 8/5/2008 14:29'!
initName:name Receiver:er Selector:s sImageName:sin usImageName:usin
	| extName |
	receiverSelector := s.
	self contents:name.
	eventReceiver := er.

	extName := sin.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self selectedImageName: t2.
		]
	].

	extName := usin.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self unSelectedImageName: t2.
		]
	].
! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 10:09'!
radioClick:index V2:v2 V3:v3
	| size count tmp |
	size := self textArray size.
	count := 1.
	[ count <= size ] whileTrue:
	[
		index = count ifTrue:
		[
			(self imageArray at:count) wearCostume: self selectedImageName.
		]
		ifFalse:
		[
			(self imageArray at:count) wearCostume: self unSelectedImageName.
		].
		count := count + 1.
	].

	self selectedIndex: index.

	(self eventReceiver) ~= nil ifTrue:
	[
		tmp := Array new:1.
		tmp at:1 put:index.

		(self eventReceiver) perform:(self receiverSelector) withArguments:tmp .
	].
! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 16:00'!
receiverSelector
	^receiverSelector! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 09:22'!
removeItemAt:index
! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:55'!
selectedImageName
	^selectedImageName! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 14:07'!
selectedImageName: anObject
	selectedImageName := anObject! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:23'!
selectedIndex
	^selectedIndex! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 14:16'!
selectedIndex: aNumber
	selectedIndex := aNumber! !

!RadioButton methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 10:09'!
select:index
	| count size |
	(index > 0 and: [ index <= self textArray size ] ) ifTrue:
	[
		self radioClick:index V2:1 V3:2
	]
	ifFalse:
	[
		index = 0 ifTrue:
		[
			self selectedIndex:nil.

			size := self textArray size.
			count := 1.
			[ count <= size ] whileTrue:
			[
				(self imageArray at:count) wearCostume: self unSelectedImageName.

				count := count + 1.
			].
		].
	].
! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:18'!
textArray
	^textArray! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:20'!
textArray: anOrderedCollection
	textArray := anOrderedCollection! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 12:55'!
unSelectedImageName
	^unSelectedImageName! !

!RadioButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 14:07'!
unSelectedImageName: anObject
	unSelectedImageName := anObject! !

SymbolListType subclass: #GameInstrumentType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameInstrumentType methodsFor: 'initialization' stamp: 'lg 10/31/2007 16:00'!
initialize
	super initialize.
	self vocabularyName: #GameInstrumentType.
	symbols := #(none choice input).! !

!GameInstrumentType methodsFor: 'queries' stamp: 'lg 10/29/2007 14:06'!
representsAType
	^true.! !

!FileDirectory methodsFor: '*ole' stamp: 'lg 10/13/2007 20:18'!
importWaveSounds
	self shouldBeImplemented! !

SugarNavTab subclass: #OLESugarNavTab
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!SugarNavTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:38'!
setVisibilityByMode
	self visible: true! !

ScriptableButton subclass: #AnimalButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!AnimalButton methodsFor: 'as yet unclassified' stamp: 'ss 10/5/2007 16:34'!
doButtonAction
	AnimalGame answer:self label! !

ScriptableButton subclass: #GameButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:37'!
doButtonAction
	NumberGame answer: (self submorphs first contents asInteger)! !

!GameButton methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:34'!
isGameChoice
	^true! !

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:45'!
setGameValue: n 
	self submorphs first contents: n asString.
	self fixYourLayout.! !

ScriptableButton subclass: #TextButton
	instanceVariableNames: 'isClicked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/8/2008 09:48'!
handlesMouseOver: evt
^true! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 12:11'!
initialize
	super initialize.
	self color:(Color r: 0.878 g: 0.94 b: 0.976).
	self isClicked: false.! !

!TextButton methodsFor: 'accessing' stamp: 'Ram 4/8/2008 11:32'!
isClicked
	"Answer the value of isClicked"

	^ isClicked! !

!TextButton methodsFor: 'accessing' stamp: 'Ram 4/8/2008 11:32'!
isClicked: anObject
	"Set the value of isClicked"

	isClicked _ anObject! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 10:30'!
mouseDown: evt
	| myText mp |
	(self isClicked=true) ifFalse:[
		myText:=World allMorphs select:[:each| (each isKindOf:UserText )
					and: ['myChar' match: each externalName]].
		myText:= myText at:1.
		mp:= myText player.
		mp receiveMessage: self label.
		self isClicked: true.
	]
	! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/8/2008 11:36'!
mouseEnter: evt
	(self isClicked=true) ifFalse:[
		self color: Color white.
	]! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 11:26'!
mouseLeave: evt
	(self isClicked=true) ifFalse:[
		self color:(Color r: 0.878 g: 0.94 b: 0.976).
	]! !

!TextButton methodsFor: 'as yet unclassified' stamp: 'Ram 4/9/2008 12:12'!
resetButton
	self isClicked:false.
	self color:(Color r: 0.878 g: 0.94 b: 0.976)..
	! !

PasteUpMorph subclass: #AnimatedAdditionMorph
	instanceVariableNames: 'collectionObject1 collectionObject2 sumObject motionGuide1 motionGuide2 moveableObject1 moveableObject2 totalNumber collectionNumber1 collectionNumber2 moveCount1 moveCount2 banner1 banner2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubstractActivity'!

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 10:46'!
banner1
	^banner1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 10:47'!
banner1: aBannerMorph
	banner1 := aBannerMorph! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 10:46'!
banner2
	^banner2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 8/1/2008 10:47'!
banner2: aBannerMorph
	banner2 := aBannerMorph! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 15:22'!
bannerComplete1:parameter
	self moveableObject1 show.
	self motionGuide1 startMotion.
	self banner1 reset.! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 15:52'!
bannerComplete2:parameter
	self moveableObject2 show.
	self motionGuide2 startMotion.
	self banner2 reset.! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:30'!
collectionNumber1
	^collectionNumber1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:31'!
collectionNumber1: aStringMorph
	collectionNumber1 := aStringMorph! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:30'!
collectionNumber2
	^collectionNumber2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:31'!
collectionNumber2: aStringMorph
	collectionNumber2 := aStringMorph! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:08'!
collectionObject1
	^collectionObject1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:08'!
collectionObject1: aAnimatedMarbel
	collectionObject1 :=aAnimatedMarbel! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:08'!
collectionObject2
	^collectionObject2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:08'!
collectionObject2: aAnimatedMarbel
	collectionObject2 :=aAnimatedMarbel! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 8/1/2008 15:06'!
initBanner
	self banner1: Banner new.
	self banner2: Banner new.
	self banner1 loop:false.
	self banner2 loop:false.
	self banner1 stepInterval:500.
	self banner2 stepInterval:500.
	
	self banner1 initReceiver:self changedSelector:nil roundCompleteSelector:#bannerComplete1:.
	self banner2 initReceiver:self changedSelector:nil roundCompleteSelector:#bannerComplete2:.

	self addMorph: self banner1.
	self addMorph: self banner2.
! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 14:43'!
initCostume
| extName |

	self collectionObject1 initCostume.
	self collectionObject2 initCostume.
	self sumObject initCostume.

	extName := 'marbel'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self moveableObject1 wearCostume: t2.
			self moveableObject2 wearCostume: t2.
		]
	].
! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 8/1/2008 11:11'!
initialize
	super initialize.

	self width:200.
	self height:100.

	self collectionObject1: AnimatedMarbleBox new.
	self collectionObject2: AnimatedMarbleBox new.
	self sumObject: AnimatedMarbleBox new.

	self moveableObject1: ImageMorph new.
	self moveableObject2: ImageMorph new.

	self motionGuide1: MotionGuide new.
	self motionGuide1 loop:false.
	self motionGuide1 stepInterval:100.
	self motionGuide1 forwardStep:20.

	self motionGuide2: MotionGuide new.
	self motionGuide2 loop:false.
	self motionGuide2 stepInterval:100.
	self motionGuide2 forwardStep:20.

	self collectionNumber1: StringMorph new.
	self collectionNumber2: StringMorph new.
	self totalNumber: StringMorph new.

	self collectionNumber1 contents: '0'.
	self collectionNumber2 contents: '0'.
	self totalNumber contents: '0'.

	self moveCount1:0.
	self moveCount2:0.

	self initObjectCount.

	self banner1: Banner new.
	self banner2: Banner new.
	self banner1 loop:false.
	self banner2 loop:false.
	self banner1 stepInterval:500.
	self banner2 stepInterval:500.
	
	self banner1 initReceiver:self changedSelector:nil roundCompleteSelector:#bannerComplete1.
	self banner2 initReceiver:self changedSelector:nil roundCompleteSelector:#bannerComplete2.

	self addMorph: self motionGuide1.
	self addMorph: self motionGuide2.
	self addMorph: self collectionObject1.
	self addMorph: self collectionObject2.
	self addMorph: self sumObject.
	self addMorph: self moveableObject1.
	self addMorph: self moveableObject2.
	self addMorph: self collectionNumber1.
	self addMorph: self collectionNumber2.
	self addMorph: self totalNumber.
	self addMorph: self banner1.
	self addMorph: self banner2.
! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 10:15'!
initMotionGuide
	| tmpA |
	tmpA := Array new:5.

	tmpA at:1 put:292@519.
	tmpA at:2 put:355@450.
	tmpA at:3 put:403@383.
	tmpA at:4 put:423@305.
	tmpA at:5 put:418@223.

	self motionGuide1 initVertices:tmpA TargetObject:self moveableObject1.
	self motionGuide1 intiFinishEventReceiver:(self)  FinishEventSelector:#moveFinished1.

	tmpA at:1 put:924@504.
	tmpA at:2 put:842@436.
	tmpA at:3 put:777@387.
	tmpA at:4 put:727@311.
	tmpA at:5 put:695@225.

	self motionGuide2 initVertices:tmpA TargetObject:self moveableObject2.
	self motionGuide2 intiFinishEventReceiver:(self)  FinishEventSelector:#moveFinished2.! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 16:08'!
initObjectCount
	self collectionObject1 initMarbelsWithCount:10.
	self collectionObject2 initMarbelsWithCount:10.
	self sumObject initMarbelsWithCount:20.
! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 14:28'!
initObjectCount:count
	self collectionObject1 initMarbelsWithCount:count.
	self collectionObject2 initMarbelsWithCount:count.
	self sumObject initMarbelsWithCount:count.
! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:10'!
motionGuide1
	^motionGuide1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:10'!
motionGuide1: aMotionGuide
	motionGuide1 := aMotionGuide! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:09'!
motionGuide2
	^motionGuide2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:09'!
motionGuide2: aMotionGuide
	motionGuide2 := aMotionGuide! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:20'!
moveableObject1
	^moveableObject1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:21'!
moveableObject1: anImageMorph
	moveableObject1 := anImageMorph! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:20'!
moveableObject2
	^moveableObject2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:21'!
moveableObject2: anImageMorph
	moveableObject2 := anImageMorph! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 15:16'!
moveCount1
	^moveCount1! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 15:16'!
moveCount1: aNumber
	moveCount1 := aNumber! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 15:16'!
moveCount2
	^moveCount2! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 15:16'!
moveCount2: aNumber
	moveCount2 := aNumber! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 16:45'!
moveFinished1
	((self moveCount1 + 1) <= 10) ifTrue:
	[
		self moveCount1:self moveCount1 + 1.
		(self collectionObject1 marbels at:(self moveCount1)) show.

		self collectionNumber1 contents: self moveCount1 asString.
		self totalNumber contents: (self moveCount1 + self moveCount2) asString.
		self sumObject hideAllMarbels.
		self showTotalObject: (self moveCount1 + self moveCount2).

		self motionGuide1 reset.
		self moveableObject1 hide.
		self startThrow2.
	].

! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 16:46'!
moveFinished2
	((self moveCount2 + 1) <= 10) ifTrue:
	[
		self moveCount2:self moveCount2 + 1.
		(self collectionObject2 marbels at:(self moveCount2)) show.

		self collectionNumber2 contents: self moveCount2 asString.
		self totalNumber contents: (self moveCount1 + self moveCount2) asString.
		self sumObject hideAllMarbels.
		self showTotalObject: (self moveCount1 + self moveCount2).

		self motionGuide2 reset.
		self moveableObject2 hide.
		self banner2 reset.
		self startThrow1.
	]
! !

!AnimatedAdditionMorph methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 10:07'!
reset
	self motionGuide1 reset.
	self motionGuide2 reset.

	self motionGuide1 loop:true.
	self motionGuide1 stepInterval:100.
	self motionGuide1 forwardStep:25.

	self motionGuide2 loop:true.
	self motionGuide2 stepInterval:100.
	self motionGuide2 forwardStep:25.

	self collectionObject1 hideAllMarbels.
	self collectionObject2 hideAllMarbels.
	self sumObject hideAllMarbels.

	self moveableObject1 show.
	self moveableObject2 show.

	self totalNumber contents:'0'.
	self collectionNumber1 contents:'0'.
	self collectionNumber2 contents:'0'.

	self moveCount1:0.
	self moveCount2:0.
	
	self banner1 reset.
	self banner2 reset.

	self moveableObject1 hide.
	self moveableObject2 hide.

! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 7/31/2008 16:03'!
showTotalObject:count
	| c |
	c := 1.
	[c <= count]	whileTrue:
	[
		(self sumObject marbels at:c) show.
		c := c + 1.
	].
! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 09:49'!
startAnimation
	self startThrow1.! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 16:42'!
startThrow1
	self moveCount1 < 10 ifTrue:
	[
		self banner1 start:true.
		self banner1 startStepping.
	]
	ifFalse:
	[
		self reset.
		self banner1 start:true.
		self banner1 startStepping.
	]
! !

!AnimatedAdditionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 16:43'!
startThrow2
	self moveCount2 < 10 ifTrue:
	[
		self banner2 start:true.
		self banner2 startStepping.
	]
	ifFalse:
	[
		self reset.
		self banner2 start:true.
		self banner2 startStepping.
	]
! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:10'!
sumObject
	^sumObject! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:10'!
sumObject: aAnimatedMarbel
	sumObject :=aAnimatedMarbel! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:32'!
totalNumber
	^totalNumber! !

!AnimatedAdditionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 14:32'!
totalNumber: aStringMorph
	totalNumber := aStringMorph! !

PasteUpMorph subclass: #AnimatedSubstractionMorph
	instanceVariableNames: 'totalObject substractObject remaningObject motionGuide moveableObject totalNumber substractNumber remaningNumber start secondPassed moveCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubstractActivity'!

!AnimatedSubstractionMorph methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 15:02'!
initCostume
| extName |

	self totalObject initCostume.
	self substractObject initCostume.
	self remaningObject initCostume.

	extName := 'marbel'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self moveableObject wearCostume: t2.
		]
	].
! !

!AnimatedSubstractionMorph methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 14:53'!
initialize
	| extName |
	super initialize.
	self width:200.
	self height:100.
	self start:false.
	self secondPassed:0.
	self moveCount:0.

	self totalObject: AnimatedMarbleBox new.
	self substractObject: AnimatedMarbleBox new.
	self remaningObject: AnimatedMarbleBox new.
	self moveableObject: ImageMorph new.
	self motionGuide: MotionGuide new.
	self motionGuide loop:false.
	self motionGuide stepInterval:100.
	self motionGuide forwardStep:15.

	self totalNumber: StringMorph new.
	self substractNumber: StringMorph new.
	self remaningNumber: StringMorph new.

	self totalNumber contents:'10'.
	self substractNumber contents:'0'.
	self remaningNumber contents:'10'.

	self addMorph: self motionGuide.
	self addMorph: self totalObject.
	self addMorph: self substractObject.
	self addMorph: self remaningObject.
	self addMorph: self moveableObject.
	self addMorph: self remaningNumber.
	self addMorph: self substractNumber.
	self addMorph: self totalNumber.

	self initObjectCount:10.

	extName := 'marbel'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self moveableObject wearCostume: t2.
		]
	].
! !

!AnimatedSubstractionMorph methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 15:26'!
initMotion
	| tmpA |
	tmpA := Array new:5.
	tmpA at:1 put:87@149.
	tmpA at:2 put:125@216.
	tmpA at:3 put:217@246.
	tmpA at:4 put:321@216.
	tmpA at:5 put:359@149.

	self motionGuide initVertices:tmpA TargetObject:self moveableObject.
	self motionGuide intiFinishEventReceiver:(self)  FinishEventSelector:#moveFinished.! !

!AnimatedSubstractionMorph methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 15:06'!
initObjectCount:count

	self totalObject initMarbelsWithCount:count.
	self substractObject initMarbelsWithCount:count.
	self remaningObject initMarbelsWithCount:count.
! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:35'!
motionGuide
	^motionGuide! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:36'!
motionGuide: aMotionGuide
	motionGuide := aMotionGuide! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:36'!
moveableObject
	^moveableObject! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:37'!
moveableObject: anImageMorph
	moveableObject := anImageMorph! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:37'!
moveCount
	^moveCount! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:37'!
moveCount: aNumber
	moveCount := aNumber! !

!AnimatedSubstractionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 15:43'!
moveFinished
	| x tn |
	tn := self totalNumber contents asInteger.

	((self moveCount + 1) <= tn) ifTrue:
	[
		self moveCount:self moveCount + 1.
		(self substractObject marbels at:(self moveCount)) show.
		x := tn - (self moveCount - 1).
		(self remaningObject marbels at:x) hide.

		self substractNumber contents: (self moveCount) asString.
		self remaningNumber contents: (tn - self moveCount) asString.

		self moveableObject hide.
		self motionGuide reset.
	].
	self start:true.
	self startStepping.
	self secondPassed:0.

! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:11'!
remaningNumber
	^remaningNumber! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:12'!
remaningNumber: aStringMorph
	remaningNumber := aStringMorph! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:33'!
remaningObject
	^remaningObject! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:34'!
remaningObject: aAnimatedMarbel
	remaningObject := aAnimatedMarbel! !

!AnimatedSubstractionMorph methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 14:53'!
reset
	self motionGuide reset.

	self start:false.
	self secondPassed:0.
	self moveCount:0.

	self motionGuide loop:false.
	self motionGuide stepInterval:100.
	self motionGuide forwardStep:15.

	self substractObject hideAllMarbels.
	self remaningObject showAllMarbels.
	self moveableObject hide.

	self totalNumber contents:'10'.
	self substractNumber contents:'0'.
	self remaningNumber contents:'10'.
! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:29'!
secondPassed
	^secondPassed! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:29'!
secondPassed: aNumber
	secondPassed := aNumber! !

!AnimatedSubstractionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 13:04'!
startAnimation
	self moveableObject show.
	self motionGuide startMotion.! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:26'!
start
	^start! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 12:27'!
start: aBoolean
	start := aBoolean! !

!AnimatedSubstractionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 12:26'!
stepTime
	^1000.! !

!AnimatedSubstractionMorph methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 14:01'!
step
	self start ifTrue:
	[
		self secondPassed:self secondPassed + 1.
		self secondPassed = 4 ifTrue:
		[
			self totalNumber contents asInteger  = self moveCount ifTrue:
			[
				self reset.
			].

			self moveableObject show.
			self motionGuide startMotion.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:11'!
substractNumber
	^substractNumber! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:12'!
substractNumber: aStringMorph
	substractNumber := aStringMorph! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:33'!
substractObject
	^substractObject! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:34'!
substractObject: aAnimatedMarbel
	substractObject := aAnimatedMarbel! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:10'!
totalNumber
	^totalNumber! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 13:12'!
totalNumber: aStringMorph
	totalNumber := aStringMorph! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:32'!
totalObject
	^totalObject! !

!AnimatedSubstractionMorph methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 10:34'!
totalObject: aAnimatedMarbel
	totalObject := aAnimatedMarbel! !

PasteUpMorph subclass: #FractionAndEquivalentDecimalActivity
	instanceVariableNames: 'page2 page3 page4 page5 cylinder btnSelectWaterLevel btnNext btnPrevious currentPage textDecimal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 16:02'!
btnNextClick:index

	self currentPage = 4 ifTrue:
	[
		self page4 reset.	
		self page4 hide.

		self page5 show.
		
		self btnPrevious show.
		self btnNext hide.

		self currentPage:5.
	].

	self currentPage = 3 ifTrue:
	[
		self page3 reset.	
		self page3 hide.

		self page4 show.
		self page4 reset.

		self btnPrevious show.
		self btnNext show.
		
		self currentPage:4.
	].

	self currentPage = 2 ifTrue:
	[
		self page2 reset.
		self page2 hide.
		
		self page3 show.
		self page3 reset.

		self btnPrevious show.
		self btnNext show.
		
		self currentPage:3.
	].

	self currentPage = 1 ifTrue:
	[
		self hide.
		self page2 show.

		self page2 reset.
		self page2 start:true.
		self page2 startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:2.
	].
! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:22'!
btnNext
	^btnNext! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:23'!
btnNext: aButton
	^btnNext:= aButton! !

!FractionAndEquivalentDecimalActivity methodsFor: 'miscellaneous' stamp: ''!
btnPreviousClick: index 
	self currentPage = 2
		ifTrue: [self page2 hide.
			self page2 reset.
			self show.
			self reset.
			self currentPage: 1.
			self btnPrevious hide.
			self btnNext show].
	self currentPage = 3
		ifTrue: [self page3 hide.
			self page2 reset.
			self page2 start: true.
			self page2 startStepping.
			self page2 show.
			self currentPage: 2.
			self btnPrevious show.
			self btnNext show].
	self currentPage = 4
		ifTrue: [self page4 hide.
			self page3 reset.
			self page3 show.
			self currentPage: 3.
			self btnPrevious show.
			self btnNext show].
	self currentPage = 5
		ifTrue: [self page5 hide.
			self page4 reset.
			self page4 show.
			self currentPage: 4.
			self btnPrevious show.
			self btnNext show]! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:22'!
btnPrevious
	^btnPrevious! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:23'!
btnPrevious: aButton
	^btnPrevious:= aButton! !

!FractionAndEquivalentDecimalActivity methodsFor: 'miscellaneous' stamp: ''!
btnSelectWaterLevelClick: index 
	self cylinder showWaterLevel: index * 10.
	(self textDecimal at: index) show! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:39'!
btnSelectWaterLevel
	^btnSelectWaterLevel! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:39'!
btnSelectWaterLevel: aRadioButton
	btnSelectWaterLevel := aRadioButton! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:32'!
currentPage
	^currentPage! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:33'!
currentPage: aNumber
	currentPage := aNumber! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:21'!
cylinder
	^cylinder! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 14:22'!
cylinder: anObject
	cylinder := anObject! !

!FractionAndEquivalentDecimalActivity methodsFor: 'miscellaneous' stamp: ''!
hideTextDecimal
	1
		to: 9
		do: [:count | 
			(self textDecimal at: count) hide.
			(self textDecimal at: count)
				fontName: 'BitstreamVeraSans'
				size: 26]! !

!FractionAndEquivalentDecimalActivity methodsFor: 'initialization' stamp: 'A 8/18/2008 15:35'!
initCostume
	self btnSelectWaterLevel initName:'Select Water Level' Receiver:self Selector:#btnSelectWaterLevelClick: 
										 sImageName:'radSelect' usImageName:'radUnSelect'.

	self btnNext initImageOver:'nextOver' Down:'nextDown' Up:'nextUp'.
	self btnPrevious initImageOver:'previousOver' Down:'previousDown' Up:'previousUp'.
! !

!FractionAndEquivalentDecimalActivity methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self width: 200.
	self height: 100.
	self btnNext: MyButton new.
	self addMorph: self btnNext.
	self btnNext
		initReceiver: self
		enterSelector: nil
		leaveSelector: nil
		downSelector: nil
		upSelector: #btnNextClick:.
	self btnPrevious: MyButton new.
	self addMorph: self btnPrevious.
	self btnPrevious
		initReceiver: self
		enterSelector: nil
		leaveSelector: nil
		downSelector: nil
		upSelector: #btnPreviousClick:.
	self btnSelectWaterLevel: RadioButton new.
	self addMorph: self btnSelectWaterLevel.
	self cylinder: FractionAndEquivalentDecimalCylinder new.
	self addMorph: self cylinder.
	self initTextDecimal! !

!FractionAndEquivalentDecimalActivity methodsFor: 'initialization' stamp: 'Aayush 8/29/2008 15:57'!
initPage
	self page5:PasteUpMorph new openInWorld.! !

!FractionAndEquivalentDecimalActivity methodsFor: 'initialization' stamp: ''!
initTextDecimal
	self textDecimal: OrderedCollection new.
	1
		to: 9
		do: [:count | self textDecimal add: UserText new openInWorld]! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 16:21'!
page2
	^page2! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 16:21'!
page2: aPasteUpMorph
	page2 := aPasteUpMorph! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 13:42'!
page3
	^page3
! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 13:43'!
page3: aPasteUpMorph
	page3 := aPasteUpMorph
! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 10:31'!
page4
	^page4! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 10:32'!
page4: aPasteUpMorph
	  page4 := aPasteUpMorph! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 15:57'!
page5
	^page5! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 15:57'!
page5: aPasteUpMorph
	  page5 := aPasteUpMorph! !

!FractionAndEquivalentDecimalActivity methodsFor: 'initialization' stamp: 'Aayush 9/10/2008 15:21'!
reset
	self currentPage: 1.
	self show.
	self page2 hide.
	self page3 hide.
	self page4 hide.
	self page5 hide.
	self hideTextDecimal.
	self btnPrevious hide.
	self btnNext show.
! !

!FractionAndEquivalentDecimalActivity methodsFor: 'miscellaneous' stamp: ''!
test
	| x |
	x := 1.
	[x < 10]
		whileTrue: [x := x + 1]! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: ''!
textDecimal
	^ textDecimal! !

!FractionAndEquivalentDecimalActivity methodsFor: 'accessing - properties' stamp: ''!
textDecimal: anOrderedCollection 
	textDecimal := anOrderedCollection! !

PasteUpMorph subclass: #FractionAndEquivalentDecimalCylinder
	instanceVariableNames: 'water maxY minY pixelPerValue start tPos cPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:23'!
cPos
	^cPos! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:23'!
cPos: aPoint
	cPos := aPoint! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'initialization' stamp: ''!
initCostume
	| extName |
	extName := 'water'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [self water wearCostume: t2]]! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self start: false.
	self water: SketchMorph new.
	self addMorph: self water! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'initialization' stamp: ''!
initWaterLevelMax: y1 min: y2 
	maxY := y1.
	minY := y2.
	self water height: y1 - y2.
	self water player setY: y1.
	self water player setForwardDirection: 180.
	pixelPerValue := y1 - y2 / 100! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 11:43'!
maxY
	^maxY! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 11:43'!
minY
	^minY! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 12:22'!
motionGuide
	^motionGuide! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 12:22'!
motionGuide: aMotionGuide
	motionGuide := aMotionGuide! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 11:56'!
pixelPerValue
	^pixelPerValue! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 13:32'!
reached
	self water player getForwardDirection = 0 ifTrue:
	[
		(self tPos y - self water player getY) > 0 ifTrue:
		[
			^false.
		]
		ifFalse:
		[
			^true.
		]
	]	
	ifFalse:
	[
		(self water player getY - self tPos y) > 0 ifTrue:
		[
			^false.
		]
		ifFalse:
		[
			^true.
		]
	].! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'initialization' stamp: 'A 8/18/2008 12:15'!
reset
! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 13:47'!
showWaterLevel:aLevel

	self tPos: ((self water player getX)@((aLevel * self pixelPerValue) + self minY)).
	self cPos: self water player getLocationRounded.

	(cPos y - tPos y) > 0 ifTrue:
	[
		self water player setForwardDirection:180.
	]
	ifFalse:
	[
		(cPos y - tPos y) < 0 ifTrue:
		[
			self water player setForwardDirection:0.
		]
	].

	(cPos y - tPos y) ~= 0 ifTrue:
	[
		self start:true.
		self startStepping.
	].
! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:12'!
start
	^start! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:12'!
start: aBoolean
	start := aBoolean! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 13:14'!
stepTime
	^30.! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 16:00'!
step

	self start ifTrue:
	[
		self reached ifFalse:
		[
			self updateWaterPosition.
		]
		ifTrue:
		[
			self water player setLocationRounded: (self tPos).
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: ''!
test
	self water: SketchMorph new openInWorld! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:23'!
tPos
	^tPos! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 13:23'!
tPos: aPoint
	tPos := aPoint! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'miscellaneous' stamp: 'A 8/18/2008 13:39'!
updateWaterPosition
	self water player getForwardDirection = 0 ifTrue:
	[
		self water player setY: (self water player getY + 5).
	]
	ifFalse:
	[
		self water player setY: (self water player getY - 5).
	].! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 11:15'!
water
	^water! !

!FractionAndEquivalentDecimalCylinder methodsFor: 'accessing - properties' stamp: ''!
water: aSketchMorph 
	water := aSketchMorph! !

PasteUpMorph subclass: #FractionAndEquivalentDecimalPage2
	instanceVariableNames: 'btnNextEg btnPreviousEg divideHowTo1 divideHowTo2 divideHowTo3 start secondPassed currentEg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/1/2008 10:37'!
btnNextEgClick:index

	self currentEg: self currentEg + 1.

	self currentEg > 3 ifTrue:
	[
		self currentEg:1.
	].

	self showStep:self currentEg.
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:01'!
btnNextEg
	^btnNextEg! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:01'!
btnNextEg: aButton
	btnNextEg := aButton! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 16:17'!
btnPreviousEgClick:index
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:02'!
btnPreviousEg
	^btnPreviousEg! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:01'!
btnPreviousEg: aButton
	btnPreviousEg := aButton! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 10:33'!
currentEg
	^currentEg! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 10:33'!
currentEg: aNumber
	currentEg := aNumber! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:02'!
divideHowTo1
	^divideHowTo1! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:04'!
divideHowTo1: aDivideHowtoMorph
	divideHowTo1 := aDivideHowtoMorph! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:02'!
divideHowTo2
	^divideHowTo2! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:04'!
divideHowTo2: aDivideHowtoMorph
	divideHowTo2 := aDivideHowtoMorph! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:02'!
divideHowTo3
	^divideHowTo3! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 15:04'!
divideHowTo3: aDivideHowtoMorph
	divideHowTo3 := aDivideHowtoMorph! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'initialization' stamp: 'Aayush 9/1/2008 10:32'!
initCostume
	self btnNextEg initImageOver:'nextEgOver' Down:'nextEgDown' Up:'nextEgUp'.

"	self btnPreviousEg initImageOver:'nextEgOver' Down:'nextEgDown' Up:'nextEgUp'.
"! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'initialization' stamp: 'Aayush 9/1/2008 10:43'!
initialize
	super initialize.
	self start:false.
	self secondPassed:0.
	self currentEg:0.

	self btnNextEg: MyButton new.
	self btnNextEg initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextEgClick:.
	self addMorph: self btnNextEg.

	self btnPreviousEg: MyButton new.
	self btnPreviousEg initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnPreviousEgClick:.
	self addMorph: self btnPreviousEg.

	self divideHowTo1: FractionAndEquivalentDecimalDivideHowTo1 new.
	self addMorph: self divideHowTo1.

	self divideHowTo2: FractionAndEquivalentDecimalDivideHowTo2 new.
	self addMorph: self divideHowTo2.

	self divideHowTo3: FractionAndEquivalentDecimalDivideHowTo3 new.
	self addMorph: self divideHowTo3.
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'initialization' stamp: 'Aayush 9/1/2008 10:43'!
reset
	self start:false.
	self secondPassed:0.
	self currentEg:0.

	self divideHowTo3 reset.
	self divideHowTo3 show.

	self divideHowTo2 reset.
	self divideHowTo2 hide.

	self divideHowTo1 reset.
	self divideHowTo1 hide.
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 09:54'!
secondPassed
	^secondPassed! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 09:54'!
secondPassed: aNumber
	secondPassed:= aNumber! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/1/2008 10:53'!
showStep:index

	index = 1 ifTrue:
	[
		self divideHowTo3 show.

		self divideHowTo3 reset.
		self divideHowTo3 start:true.
		self divideHowTo3 startStepping.

		self divideHowTo1 hide.
		self divideHowTo2 hide.
	].

	index = 2 ifTrue:
	[
		self divideHowTo1 show.

		self divideHowTo1 reset.
		self divideHowTo1 start:true.
		self divideHowTo1 startStepping.

		self divideHowTo2 hide.
		self divideHowTo3 hide.
	].

	index = 3 ifTrue:
	[
		self divideHowTo2 show.

		self divideHowTo2 reset.
		self divideHowTo2 start:true.
		self divideHowTo2 startStepping.

		self divideHowTo1 hide.
		self divideHowTo3 hide.
	].
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 09:53'!
start
	^start! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 09:54'!
start: aBoolean
	start := aBoolean
! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 10:00'!
stepTime
	^1000.! !

!FractionAndEquivalentDecimalPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/1/2008 10:49'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 2 ifTrue:
		[
			self currentEg:self currentEg + 1.
			self showStep:self currentEg.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

PasteUpMorph subclass: #FractionAndEquivalentDecimalPage3
	instanceVariableNames: 'btnCheckAnswer question answer fractionDisplay1 fractionDisplay2 answerDisplay displayBoardR score fractionSelected answerSelected fractionShowIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: ''!
adMouseEnter: index V2: x V3: y 
	(self answerDisplay at: index)
		color: (Color
				r: 0.935
				g: 0.774
				b: 1.0)! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'aaysuh 9/3/2008 09:35'!
adMouseLeave:index V2:x V3:y
	(self answerDisplay at:index) color: (Color r: 0.613 g: 0.903 b: 1.0).
	! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'A 8/21/2008 13:31'!
adMouseUp:index V2:x V3:y
	| count |
	count := 1.
	[count <= 10] whileTrue:
	[
		index = count ifTrue:
		[
			(self answerDisplay at:count) borderColor: (Color r: 0.972 g: 0.345 b: 0.285).
			 (self answerDisplay at:count) borderWidth:4
		]
		ifFalse:
		[
			(self answerDisplay at:count) borderColor:(Color r: 0.0 g: 0.0 b: 0.0).
			 (self answerDisplay at:count) borderWidth:2
		].

		count := count + 1.
	].

	self answerSelected:index.! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'A 8/21/2008 11:33'!
alignFractionDisplay
	! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:46'!
answerDisplay
	^answerDisplay! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:46'!
answerDisplay: anOrderedCollection
	answerDisplay := anOrderedCollection! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:23'!
answerSelected
	^answerSelected! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:23'!
answerSelected:aNumber
	answerSelected := aNumber! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:19'!
answer
	^answer! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:19'!
answer: anOrderedCollection
	answer := anOrderedCollection! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 11:19'!
btnCheckAnswerClick:index
	| as fs frId aId i n d a |
	as := self answerSelected.
	fs := self fractionSelected.

	(as ~= 0 and: [ fs ~= 0 ]) ifTrue:
	[

		frId := (self fractionDisplay2 at:fs) fractionDisplay qusNo.
		aId := (self answerDisplay at:as) fractionDisplay qusNo.

		frId = aId ifTrue:
		[
			SoundService default playSoundNamedOrBeep: 'right1'.

			i := self fractionShowIndex.

			n := (self question at:frId) at:2.
			d := (self question at:frId) at:3.
			a := (self answer at:frId).

			(self fractionDisplay1 at:i) showWholeNumber:nil Numerator:n Denomenator:d.
			(self fractionDisplay1 at:i) show.
			(self displayBoardR at:i) strMessage contents:a.
			(self displayBoardR at:i) strMessage center:(self displayBoardR at:i) center.
			(self displayBoardR at:i) show.

			self alignFractionDisplay.
			self fractionShowIndex:( i + 1).

			(self fractionDisplay2 at:fs) hide.
			(self answerDisplay at:as) hide.

			self suffelQuestionAnswer.
		]
		ifFalse:
		[
			SoundService default playSoundNamedOrBeep: 'wrong3'.
		]
	]
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:16'!
btnCheckAnswer
	^btnCheckAnswer! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:17'!
btnCheckAnswer: aMyButton
	btnCheckAnswer := aMyButton! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:10'!
displayBoardR
	^displayBoardR! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:11'!
displayBoardR: aDisplayBoardR
	displayBoardR := aDisplayBoardR! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'aaysuh 9/3/2008 09:34'!
fd2MouseEnter:index V2:x V3:y
	(self fractionDisplay2 at:index) color: (Color r: 0.627 g: 0.972 b: 0.662).! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'aaysuh 9/3/2008 09:32'!
fd2MouseLeave:index V2:x V3:y
	(self fractionDisplay2 at:index) color:  (Color r: 0.613 g: 0.903 b: 1.0).! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'A 8/21/2008 13:31'!
fd2MouseUp:index V2:x V3:y
	| count |
	count := 1.
	[count <= 10] whileTrue:
	[
		index = count ifTrue:
		[
			(self fractionDisplay2 at:count) borderColor: (Color r: 0.972 g: 0.345 b: 0.285).
			 (self fractionDisplay2 at:count) borderWidth:4
		]
		ifFalse:
		[
			(self fractionDisplay2 at:count) borderColor:(Color r: 0.0 g: 0.0 b: 0.0).
			 (self fractionDisplay2 at:count) borderWidth:2
		].

		count := count + 1.
	].

	self fractionSelected:index.
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:33'!
fractionDisplay1
	^fractionDisplay1! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:38'!
fractionDisplay1: anOrderedCollection
	fractionDisplay1 := anOrderedCollection! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:35'!
fractionDisplay2
	^fractionDisplay2! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/20/2008 15:38'!
fractionDisplay2: anOrderedCollection
	fractionDisplay2 := anOrderedCollection! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:25'!
fractionSelected
	^fractionSelected! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 13:24'!
fractionSelected:aNumber
	fractionSelected := aNumber! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 14:04'!
fractionShowIndex
	^fractionShowIndex! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 14:05'!
fractionShowIndex: aNumber
	fractionShowIndex := aNumber! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 14:47'!
initAnswerDisplay
	| count |
	self answerDisplay: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self answerDisplay add: FractionAndEquivalentDecimalFractionDisplay new.
		self addMorph: (self answerDisplay at:count).

		(self answerDisplay at:count) on:#mouseEnter send:#adMouseEnter:V2:V3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseLeave send:#adMouseLeave:V2:V3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseUp send:#adMouseUp:V2:V3: to:self withValue:count.

		count := count + 1.
	].
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 11:37'!
initAnswer
	self answer: OrderedCollection new.

	self answer add:('0.3').
	self answer add:('0.4').
	self answer add:('0.14').
	self answer add:('0.22').
	self answer add:('1.23').
	self answer add:('0.133').
	self answer add:('0.9').
	self answer add:('0.475').
	self answer add:('8.3').
	self answer add:('0.728').

	self answer add:('0.142').
	self answer add:('0.666').
	self answer add:('0.4').
	self answer add:('0.75').
	self answer add:('0.333').
	self answer add:('0.25').
	self answer add:('0.125').
	self answer add:('0.357').
	self answer add:('0.684').
	self answer add:('0.882').
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'Aayush 8/29/2008 14:10'!
initCostume
	self btnCheckAnswer initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsDown'.
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 10:11'!
initDisplayBoardR
	| count |
	self displayBoardR: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self displayBoardR add: DisplayBoardR new.
		self addMorph: (self displayBoardR at:count).

		count := count + 1.
	].

! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 12:38'!
initEventHandlers
	| count |
	count := 1.
	[count <= 10] whileTrue:
	[
		(self fractionDisplay2 at:count) on:#mouseEnter send:#fd2MouseEnter:V2:V3: to:self withValue:count.
		(self fractionDisplay2 at:count) on:#mouseLeave send:#fd2MouseLeave:V2:V3: to:self withValue:count.
		(self fractionDisplay2 at:count) on:#mouseUp send:#fd2MouseUp:V2:V3: to:self withValue:count.

		(self answerDisplay at:count) on:#mouseEnter send:#adMouseEnter:V2:V3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseLeave send:#adMouseLeave:V2:V3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseUp send:#adMouseUp:V2:V3: to:self withValue:count.

		count := count + 1.
	].

! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/20/2008 15:56'!
initFractionDisplay1
	| count |
	self fractionDisplay1: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self fractionDisplay1 add: FractionDisplay new.
		self addMorph: (self fractionDisplay1 at:count).

		count := count + 1.
	].

! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 12:03'!
initFractionDisplay2
	| count |
	self fractionDisplay2: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self fractionDisplay2 add: FractionAndEquivalentDecimalFractionDisplay new.
		self addMorph: (self fractionDisplay2 at:count).

		(self fractionDisplay2 at:count) on:#mouseEnter send:#fd2MouseEnter:V2:V3: to:self withValue:count.
		(self fractionDisplay2 at:count) on:#mouseLeave send:#fd2MouseLeave:V2:V3: to:self withValue:count.
		(self fractionDisplay2 at:count) on:#mouseUp send:#fd2MouseUp:V2:V3: to:self withValue:count.

		count := count + 1.
	].

! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 13:21'!
initialize
	super initialize.

	self btnCheckAnswer: MyButton new.
	self addMorph:self btnCheckAnswer.
	self btnCheckAnswer initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCheckAnswerClick:.

	self score: StringMorph new.
	self addMorph:self score.
 	
	self initQuestion.
	self initAnswer.
	self initAnswerDisplay.
	self initDisplayBoardR.
	self initFractionDisplay1.
	self initFractionDisplay2.
	self reset.

! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: 'A 8/21/2008 10:39'!
initQuestion

	self question: OrderedCollection new.

	self question add:(Array withAll:#(nil '3' '10')).
	self question add:(Array withAll:#(nil '4' '10')).
	self question add:(Array withAll:#(nil '14' '100')).
	self question add:(Array withAll:#(nil '22' '100')).
	self question add:(Array withAll:#(nil '123' '100')).
	self question add:(Array withAll:#(nil '133' '1000')).
	self question add:(Array withAll:#(nil '90' '100')).
	self question add:(Array withAll:#(nil '475' '1000')).
	self question add:(Array withAll:#(nil '83' '10')).
	self question add:(Array withAll:#(nil '728' '1000')).

	self question add:(Array withAll:#(nil '1' '7')).
	self question add:(Array withAll:#(nil '2' '3')).
	self question add:(Array withAll:#(nil '6' '15')).
	self question add:(Array withAll:#(nil '6' '8')).
	self question add:(Array withAll:#(nil '5' '15')).
	self question add:(Array withAll:#(nil '3' '12')).
	self question add:(Array withAll:#(nil '1' '8')).
	self question add:(Array withAll:#(nil '5' '14')).
	self question add:(Array withAll:#(nil '13' '14')).
	self question add:(Array withAll:#(nil '15' '17')).
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:18'!
question
	^question! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:18'!
question: anOrderedCollection
	question := anOrderedCollection! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'initialization' stamp: ''!
reset
	self showQuestionSet: 1.
	self fractionShowIndex: 1.
	self answerSelected: 0.
	self fractionSelected: 0.
	1
		to: 10
		do: [:count | 
			(self fractionDisplay1 at: count) hide.
			(self fractionDisplay1 at: count)
				fontName: 'BitstreamVeraSans'
				size: 26.
			(self answerDisplay at: count) show.
			(self fractionDisplay2 at: count) show.
			(self displayBoardR at: count) hide.
			(self displayBoardR at: count) strMessage fontName: 'BitstreamVeraSans' size: 26.
			(self answerDisplay at: count)
				color: (Color
						r: 0.613
						g: 0.903
						b: 1.0).
			(self answerDisplay at: count)
				borderColor: (Color
						r: 0.0
						g: 0.0
						b: 0.0).
			(self answerDisplay at: count)
				borderWidth: 2.
			(self fractionDisplay2 at: count)
				color: (Color
						r: 0.613
						g: 0.903
						b: 1.0).
			(self fractionDisplay2 at: count)
				borderColor: (Color
						r: 0.0
						g: 0.0
						b: 0.0).
			(self fractionDisplay2 at: count)
				borderWidth: 2]! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:14'!
score
	^score
	! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'accessing - properties' stamp: 'A 8/21/2008 10:14'!
score: aStringMorph
	^score := aStringMorph
	! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 9/1/2008 10:04'!
showQuestionSet:aSetNumber
	
	| count qn wn n d x |
	count := 1.
	x := 10 random.

	[count <=10] whileTrue:
	[
		qn := (aSetNumber-1*10)+x.

		wn := (self question at:qn) at:1.
		n := (self question at:qn) at:2.
		d := (self question at:qn) at:3.

		(self fractionDisplay2 at:count) fractionDisplay showWholeNumber:wn Numerator:n Denomenator:d.
		(self fractionDisplay2 at:count) fractionDisplay qusNo:qn.
		(self fractionDisplay2 at:count) fractionDisplay center:(self fractionDisplay2 at:count) center.

		wn := nil.
		n := (self answer at:qn).
		d := nil.

		(self answerDisplay at:count) fractionDisplay showWholeNumber:wn Numerator:n Denomenator:d.
		(self answerDisplay at:count) fractionDisplay qusNo:qn.
		(self answerDisplay at:count) fractionDisplay center:(self answerDisplay at:count) center.

		x := x + 1.

		x > 10 ifTrue:
		[
			x := 1.
		].

		count := count +1.
	]
! !

!FractionAndEquivalentDecimalPage3 methodsFor: 'miscellaneous' stamp: 'aaysuh 9/2/2008 17:24'!
suffelQuestionAnswer

	| vFractionDisplay vAnswerDispaly count size qn1 w1 n1 d1 to qn2 w2 n2 d2 |

	vFractionDisplay := OrderedCollection new.
	vAnswerDispaly := OrderedCollection new.

	count := 1.
	size := self fractionDisplay2 size.
	[count <= size] whileTrue:
	[
		(self answerDisplay at:count) visible ifTrue:
		[
			vAnswerDispaly add:(self answerDisplay at:count).
		].

		(self fractionDisplay2 at:count) visible ifTrue:
		[
			vFractionDisplay add:(self fractionDisplay2 at:count).			
		].

"		self fractionDisplay2 fractionDisplay wholeNumber: StringMorph new.
"		
		count := count + 1.
	].


	count := 1.
	size := vAnswerDispaly size.
	[count <= size] whileTrue:
	[
		qn1 := (vFractionDisplay at:count) fractionDisplay qusNo.
		w1 := nil.
		n1 := (vFractionDisplay at:count) fractionDisplay numerator contents.
		d1 := (vFractionDisplay at:count) fractionDisplay denomenator contents.

		to := size random.

		qn2 := (vFractionDisplay at:to) fractionDisplay qusNo.
		w2 := nil.
		n2 := (vFractionDisplay at:to) fractionDisplay numerator contents.
		d2 := (vFractionDisplay at:to) fractionDisplay denomenator contents.


		(vFractionDisplay at:to) fractionDisplay showWholeNumber:w1 Numerator:n1 Denomenator:d1.
		(vFractionDisplay at:to) fractionDisplay center: (vFractionDisplay at:to) center.
		(vFractionDisplay at:to) fractionDisplay qusNo:qn1.

		(vFractionDisplay at:count) fractionDisplay showWholeNumber:w2 Numerator:n2 Denomenator:d2.
		(vFractionDisplay at:count) fractionDisplay center: (vFractionDisplay at:count) center.
		(vFractionDisplay at:count) fractionDisplay qusNo:qn2.


		qn1 := (vAnswerDispaly at:count) fractionDisplay qusNo.
		w1 := nil.
		n1 := (vAnswerDispaly at:count) fractionDisplay numerator contents.
		d1 := nil.

		to := size random.

		qn2 := (vAnswerDispaly at:to) fractionDisplay qusNo.
		w2 := nil.
		n2 := (vAnswerDispaly at:to) fractionDisplay numerator contents.
		d2 := nil.

		(vAnswerDispaly at:to) fractionDisplay showWholeNumber:w1 Numerator:n1 Denomenator:d1.
		(vAnswerDispaly at:to) fractionDisplay center: (vAnswerDispaly at:to) center.
		(vAnswerDispaly at:to) fractionDisplay qusNo:qn1.

		(vAnswerDispaly at:count) fractionDisplay showWholeNumber:w2 Numerator:n2 Denomenator:d2.
		(vAnswerDispaly at:count) fractionDisplay center: (vAnswerDispaly at:count) center.
		(vAnswerDispaly at:count) fractionDisplay qusNo:qn2.

		count := count + 1.
	].
! !

PasteUpMorph subclass: #FractionAndEquivalentDecimalPage4
	instanceVariableNames: 'score question answer imgCheck txtBox fractionDisplay btnCheckAnswer btnShowCorrect ansCheckedOnce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 8/29/2008 13:16'!
alignFractionDisplay
	| count x w t |

	count := 1.
	[count <= 10] whileTrue:
	[
		x := (self txtBox at:count) left.
		t := (self txtBox at:count) top.
		w := (self fractionDisplay at:count) width.

		(self fractionDisplay at:count) left: (x-w-40).
		(self fractionDisplay at:count) top:t.

		(self txtBox at:count) width:100.

		count := count + 1.
	]! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 13:19'!
ansCheckedOnce
	^ansCheckedOnce! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 8/29/2008 13:19'!
ansCheckedOnce: aBoolean
	ansCheckedOnce := aBoolean! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:06'!
answer
	^answer! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:07'!
answer: anOrderedCollection
	answer := anOrderedCollection! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:41'!
btnCheckAnswerClick:idx
	| count ca ta extName iCheck iCross index check |

	check := 0.
	count := 1.
	[count <= 10] whileTrue:
	[
		(self txtBox at:count) getCharacters size >= 1 ifTrue:
		[
			check := check + 1.
		].

		count := count + 1.
	].

	check = 10 ifTrue:
	[
		extName := 'Check'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
			ifTrue:
 			[
				iCheck := t2.
			]
		].

		extName := 'Cross'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
			ifTrue:
 			[
				iCross := t2.
			]
		].

		check := 0.
		count := 1.
		[count <= 10] whileTrue:
		[
			index := (self fractionDisplay at:count) qusNo.

			ca := self answer at:index.
			ta := (self txtBox at:count)	 getCharacters.

			(ca = ta) ifTrue:
			[
				(self imgCheck at:count) wearCostume:iCheck.

"				self ansCheckedOnce ifFalse:
				[	
"
					self score contents:((self score contents asInteger) +1) asString.

"				].
"
				check := check + 1.
			]
			ifFalse:
			[
				(self imgCheck at:count) wearCostume:iCross.
			].

			(imgCheck at:count) show.
	
			count := count + 1.
		].

		check ~= 10 ifTrue:
		[
			self btnShowCorrect show.
		]
		ifFalse:
		[
			self btnShowCorrect false.
		].

		self btnCheckAnswer hide.

"		self ansCheckedOnce:true.
"	]! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:05'!
btnCheckAnswer
	^btnCheckAnswer! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:05'!
btnCheckAnswer: aButton
	btnCheckAnswer := aButton! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'miscellaneous' stamp: ''!
btnShowCorrectClick: index 
	| extName iCheck |
	extName := 'Check'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [iCheck := t2]].
	1
		to: 10
		do: [:count | 
			(self txtBox at: count)
				setCharacters: (self answer at: (self fractionDisplay at: count) qusNo).
			(self imgCheck at: count)
				wearCostume: iCheck]! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:06'!
btnShowCorrect
	^btnShowCorrect! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:06'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 11:40'!
fractionDisplay
	^fractionDisplay! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 11:51'!
fractionDisplay: anOrderedCollection
	fractionDisplay := anOrderedCollection! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:07'!
imgCheck
	^imgCheck! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:07'!
imgCheck: anOrderedCollection
	imgCheck := anOrderedCollection! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: ''!
initAnswer
	[self answer size >= 1]
		whileTrue: [self answer removeFirst].
	self answer add: '4.333'.
	self answer add: '0.107'.
	self answer add: '0.137'.
	self answer add: '0.072'.
	self answer add: '0.68'.
	self answer add: '0.538'.
	self answer add: '3.2'.
	self answer add: '1.235'.
	self answer add: '1.035'.
	self answer add: '4.294'! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 13:51'!
initCostume
	| count extName iCheck |

	extName := 'Check'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			iCheck := t2.
		]
	].

	count := 1.
	[count <= 10] whileTrue:
	[
		(self imgCheck at:count) wearCostume: iCheck.		

		count := count + 1.
	].

	self btnCheckAnswer initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnShowCorrect initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 11:50'!
initFractionDisplay
	| count |
	self fractionDisplay: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self fractionDisplay add:FractionDisplay new.
		self addMorph: (self fractionDisplay at:count).
		
		count := count + 1.
	].! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 10:14'!
initImgCheck
	| count |
	self imgCheck: OrderedCollection new.

	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.
	self imgCheck add: SketchMorph new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self addMorph: (self imgCheck at:count).		

		count := count + 1.
	].! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 14:01'!
initialize
	super initialize.

	self btnCheckAnswer: MyButton new.
	self addMorph:self btnCheckAnswer.
	self btnCheckAnswer initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCheckAnswerClick:.

	self btnShowCorrect: MyButton new.
	self addMorph:self btnShowCorrect.
	self btnShowCorrect initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnShowCorrectClick:.

	self score: StringMorph new.
	self score contents:'0'.
	self addMorph:self score.
	
	self initAnswer.
	self initQuestion.
	self initTextBox.
	self initImgCheck.
	self initFractionDisplay.
! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 10:10'!
initQuestion
	self question: OrderedCollection new.
	
	self question add:(Array withAll:#('26' '6')).
	self question add:(Array withAll:#('9' '84')).
	self question add:(Array withAll:#('4' '29')).
	self question add:(Array withAll:#('6' '83')).
	self question add:(Array withAll:#('34' '50')).
	self question add:(Array withAll:#('14' '26')).
	self question add:(Array withAll:#('48' '15')).
	self question add:(Array withAll:#('21' '17')).
	self question add:(Array withAll:#('29' '28')).
	self question add:(Array withAll:#('73' '17')).
! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'A 8/19/2008 10:24'!
initTextBox
	| count |
	self txtBox: OrderedCollection new.
	
	count := 1.
	[count <= 10] whileTrue:
	[
		self txtBox add:MyTextMorph new.
		(self txtBox at:count)	maxLength:5.
		(self txtBox at:count) setCharacters: (count asString).
		self addMorph: (self txtBox at:count).
		
		count := count + 1.
	].! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:06'!
question
	^question! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/18/2008 17:07'!
question: anOrderedCollection
	question := anOrderedCollection! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'initialization' stamp: 'Aayush 9/10/2008 15:52'!
reset
	| count |
	self showQuestion.
	self score contents:'0'.
	self ansCheckedOnce:false.

	count := 1.
	[count <= 10] whileTrue:
	[
		(self txtBox at:count) setCharacters:''.

		(imgCheck at:count) hide.

		count := count + 1.
	].

	self btnShowCorrect hide.
	self btnCheckAnswer show.! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 14:00'!
score
	^score! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 14:00'!
score: aStringMorph
	score := aStringMorph! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'miscellaneous' stamp: 'A 8/19/2008 13:19'!
showQuestion
	| startPos count n d |
	startPos := 10 random.

	count := 1.
	[count <= 10] whileTrue:
	[

		n := (question at:startPos) at:1.
		d := (question at:startPos) at:2.

		(self fractionDisplay at:count) showWholeNumber:nil Numerator:n Denomenator:d.
		(self fractionDisplay at:count) qusNo:startPos.

		startPos := startPos + 1.
		startPos > 10 ifTrue:
		[
			startPos := 1.
		].

		count := count + 1.
	]. 

	self alignFractionDisplay.
! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:17'!
txtBox
	^txtBox! !

!FractionAndEquivalentDecimalPage4 methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 10:18'!
txtBox: anOrderedCollection
	txtBox := anOrderedCollection! !

PasteUpMorph subclass: #FractionMultiplicationActivity
	instanceVariableNames: 'btnNextText start currentPage motionGuide pie1 pie2 pie3 pie4 page5 currentMotionObject btnNext btnPrevious secondPassed page2 page3 page4 page6 dispObject seqId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 10:32'!
btnNextClick:index.

	self currentPage = 5 ifTrue:
	[
		self page4 reset.
		self page4 hide.

		self page5 show.
		self page5 reset.

		self btnNext hide.
		self btnPrevious show.

		self currentPage:6.
	].

	self currentPage = 4 ifTrue:
	[
		self page6 reset.
		self page6 hide.

		self page4 show.
		self page4 reset.

		self btnNext show.
		self btnPrevious show.

		self currentPage:5.
	].

	self currentPage = 3 ifTrue:
	[
		self page3 reset.
		self page3 hide.

		self page6 show.
		self page6 reset.
		self page6 start:true.
		self page6	startStepping.

		self btnNext show.
		self btnPrevious show.

		self currentPage:4.
	].

	self currentPage = 2 ifTrue:
	[
		self page2 reset.
		self page2 hide.

		self page3 show.
		self page3 reset.
		self page3 start:true.
		self page3	startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:3.
	].

	self currentPage = 1 ifTrue:
	[
		self reset.
		self hide.

		self page2 show.
		self page2 reset.
		self page2 start:true.
		self page2	startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:2.
	].


! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 14:23'!
btnNextTextClick:index
	self seqId = 5 ifTrue:
	[
		(self dispObject at:16) show.

		self btnNext show.
		self btnNextText hide.
		self seqId:6.
	].

	self seqId = 4 ifTrue:
	[
		self pie2 show.

		self currentMotionObject:2.
		self initMotionPath2.
		self motionGuide startMotion.

		self btnNextText hide.

		self seqId:5.
	].

	self seqId = 3 ifTrue:
	[
		(self dispObject at:8) show.
		(self dispObject at:9) show.
		(self dispObject at:10) show.
		(self dispObject at:11) show.
		(self dispObject at:12) show.

		self seqId:4.
	].

	self seqId = 2 ifTrue:
	[
		(self dispObject at:4) show.
		(self dispObject at:5) show.
		(self dispObject at:6) show.
		(self dispObject at:7) show.

		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		(self dispObject at:2) show.
		(self dispObject at:3) show.

		self seqId:2.
	].
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 09:55'!
btnNextText
	^btnNextText! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 09:55'!
btnNextText: aButton
	btnNextText := aButton! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:46'!
btnNext
	^btnNext! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:47'!
btnNext: aMyButton
	btnNext := aMyButton! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 15:45'!
btnPreviousClick:index.

	self currentPage = 2 ifTrue:
	[
		self page2 hide.

		self show.
		self start:true.
		self startStepping.

		self btnPrevious hide.
		self btnNext show.

		self currentPage:1.
	].

	self currentPage = 3 ifTrue:
	[
		self page3 hide.

		self page2 show.
		self page2 start:true.
		self page2	startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:2.
	].

	self currentPage = 4 ifTrue:
	[
		self page6 hide.

		self page3 show.
		self page3 start:true.
		self page3	startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:3.
	].

	self currentPage = 5 ifTrue:
	[
		self page4 hide.

		self page6 show.
		self page6 start:true.
		self page6 startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage:4.
	].

	self currentPage = 6 ifTrue:
	[
		self page5 hide.

		self page4 show.

		self btnPrevious show.
		self btnNext show.

		self currentPage:5.
	].

! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 15:56'!
btnPrevious
	^btnPrevious! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 15:57'!
btnPrevious: aSketchMorph
	btnPrevious := aSketchMorph! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:56'!
currentMotionObject
	^currentMotionObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:57'!
currentMotionObject: aNumber
	currentMotionObject := aNumber! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 12:02'!
currentPage
	^currentPage! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 12:03'!
currentPage: aNumber
	currentPage := aNumber! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:44'!
dispObj1
	^dispObj1! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:44'!
dispObj1: anImageMorph
	dispObj1 := anImageMorph! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:44'!
dispObj2
	^dispObj2! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:44'!
dispObj2: anImageMorph
	dispObj2 := anImageMorph! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 09:59'!
dispObject
	^dispObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 09:59'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection
! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 10:57'!
initCostume

	| extName |
	
	self btnNext initImageOver:'nextOver' Down:'nextDown' Up:'nextUp'.
	self btnPrevious initImageOver:'previousOver' Down:'previousDown' Up:'previousUp'.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	extName := 'page1-pie1234'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie1  wearCostume: t2.
			self pie2  wearCostume: t2.
			self pie3  wearCostume: t2.
			self pie4  wearCostume: t2.
		]
	].
! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 10:57'!
initialize
	super initialize.
	self start:false.

	self currentMotionObject:1.
	self currentPage:1.

	self width:200.
	self width:100.

	self dispObject: OrderedCollection new.

	self motionGuide: MotionGuide new.
	self addMorph: self motionGuide.
	self motionGuide intiFinishEventReceiver:self FinishEventSelector:#motionComplete.
	self motionGuide loop:false.

	self btnNext: MyButton new openInWorld.
	self btnNext initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextClick:.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self btnPrevious: MyButton new openInWorld.
	self btnPrevious initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnPreviousClick:.

	self pie1: SketchMorph new.
	self pie2: SketchMorph new.
	self pie3: SketchMorph new.
	self pie4: SketchMorph new.
	
	self addMorph: self pie1.
	self addMorph: self pie2.
	self addMorph: self pie3.
	self addMorph: self pie4.

	self page2:FractionMultiplicationPage2 new openInWorld.
	self page3:FractionMultiplicationPage3 new openInWorld.
	self page4:FractionMultiplicationPage4 new openInWorld.
	self page5: PasteUpMorph new openInWorld.
	self page6:FractionMultiplicationPage6 new openInWorld! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 14:06'!
initMotionPath1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (209@611).
	vArray at:2 put: (250@611).
	
	self pie1 comeToFront.
	self motionGuide initVertices:vArray TargetObject:(self pie1).! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 14:12'!
initMotionPath2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: 179@239.
	vArray at:2 put: 1130@239.

	self pie2 comeToFront.
	self motionGuide initVertices:vArray TargetObject:(self pie2).! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 14:17'!
initMotionPath3
	| vArray |
	vArray := Array new:3.
	vArray at:1 put: 466@239.
	vArray at:2 put: 1130@239.
	vArray at:3 put: 1029@239.

	self pie3 comeToFront.
	self motionGuide initVertices:vArray TargetObject:(self pie3).! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 14:19'!
initMotionPath4
	| vArray |
	vArray := Array new:3.
	vArray at:1 put: 790@239.
	vArray at:2 put: 1081@239.
	vArray at:3 put: 1081@289.

	self pie4 comeToFront.
	self motionGuide initVertices: vArray TargetObject:(self pie4).
! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/26/2008 10:33'!
initPage5
	self page5: PasteUpMorph new openInWorld.
! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 14:22'!
motionComplete
	self currentMotionObject = 4 ifTrue:
	[
		btnNextText show.
		(self dispObject at:14) show.
		(self dispObject at:15) show.

		(self dispObject at:13) show.

		self pie4 player setLocationRounded:(1081@289).
		self pie4 player setHeadingTheta:90.
	].

	self currentMotionObject = 3 ifTrue:
	[
		self currentMotionObject:4.
		self pie4 show.

		self initMotionPath4.
		self motionGuide startMotion.
		self pie3 player setLocationRounded:(1032@247).
		self pie3 player setHeadingTheta:180.
	].

	self currentMotionObject = 2 ifTrue:
	[
		self currentMotionObject:3.

		self pie3 show.

		self initMotionPath3.
		self motionGuide startMotion.
		self pie2 player setLocationRounded:(1130@239).
		self pie2 player setHeadingTheta:0.
	].

	self currentMotionObject = 1 ifTrue:
	[
		(self dispObject at:1) show. 
		self btnNextText show.

		self currentMotionObject:2.
	].
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:40'!
motionGuide
	^motionGuide.
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:45'!
motionGuide: aMotionGuide
	motionGuide := aMotionGuide
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:48'!
page2 
	^page2! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:49'!
page2: anObject
	page2 := anObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:49'!
page3
	^page3! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:49'!
page3: anObject
	page3 := anObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 11:34'!
page4
	^page4! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 11:34'!
page4: anObject
	page4 := anObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 10:32'!
page5
	^page5! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 10:32'!
page5: anObject
	page5 := anObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 14:38'!
page6
	^page6! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 14:39'!
page6: anObject
	page6 := anObject! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:43'!
pie1
	^pie1
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:46'!
pie1: anImageMorph
	pie1 := anImageMorph
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:43'!
pie2
	^pie2
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:46'!
pie2: anImageMorph
	pie2 := anImageMorph
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:43'!
pie3
	^pie3
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:46'!
pie3: anImageMorph
	pie3 := anImageMorph
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:43'!
pie4
	^pie4
! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:46'!
pie4: anImageMorph
	pie4 := anImageMorph
! !

!FractionMultiplicationActivity methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 11:27'!
reset
	| cnt siz |
	self currentMotionObject:1.
	self start:false.
	self currentPage:1.
	self secondPassed:0.
	self seqId:1.

	self initMotionPath4.
	self initMotionPath3.
	self initMotionPath2.
	self initMotionPath1.

	self motionGuide reset.

	self btnNext hide.
	self btnPrevious hide.
	self btnNextText hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self pie2 hide.
	self pie3 hide.
	self pie4 hide.


	self show.
	self page2 hide.
	self page3 hide.
	self page4 hide.
	self page5 hide.
	self page6 hide.! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 15:13'!
secondPassed
	^secondPassed! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 15:13'!
secondPassed: aNumber
	secondPassed := aNumber! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 10:42'!
seqId
	^seqId! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 10:43'!
seqId: aNumber
	seqId := aNumber! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/8/2008 15:27'!
startAnimation
	self start:true.
	self startStepping.! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 11:59'!
start
	^start! !

!FractionMultiplicationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 12:00'!
start: aBoolean
	start := aBoolean! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/8/2008 11:59'!
stepTime
	^1000! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 8/8/2008 15:16'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self start:false.
			self motionGuide startMotion.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!FractionMultiplicationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 11:23'!
test
	| extName |
	extName := 'p1-d-16'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].! !

PasteUpMorph subclass: #FractionMultiplicationPage2
	instanceVariableNames: 'start currentPage motionGuide1 motionGuide2 pie1 pie2 pie3 pie4 pie5 pie6 dispObj1 dispObj2 dispObject seqId btnNextText currentMotionObject secondPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 13:58'!
btnNextTextClick:index
	self seqId = 6 ifTrue:
	[
		(self dispObject at:17) show.
		self btnNextText hide.
		self seqId: 7.
	].

	self seqId = 5 ifTrue:
	[
		(self dispObject at:16) show.
		self seqId: 6.
	].

	self seqId = 4 ifTrue:
	[
		self initMotionPath2.
		self pie2 show.
		self motionGuide1 startMotion.
		self currentMotionObject:2.

		self btnNextText hide.
		self seqId: 5.
	].

	self seqId = 3 ifTrue:
	[
		(self dispObject at:5) show.
		(self dispObject at:6) show.
		(self dispObject at:7) show.
		(self dispObject at:8) show.
		(self dispObject at:9) show.
		(self dispObject at:10) show.
		(self dispObject at:11) show.
		(self dispObject at:12) show.
	
		self seqId: 4.
	].

	self seqId = 2 ifTrue:
	[
		(self dispObject at:4) show.

		self seqId: 3.
	].

	self seqId = 1 ifTrue:
	[
		(self dispObject at:3) show.

		self seqId: 2.
	].
! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:27'!
btnNextText
	^btnNextText! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:28'!
btnNextText: aButton
	btnNextText := aButton! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:15'!
currentMotionObject
	^currentMotionObject! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:15'!
currentMotionObject: aNumber
	currentMotionObject := aNumber! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:33'!
dispObj1
	^dispObj1! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:33'!
dispObj1: aSketchMorph
	dispObj1 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:33'!
dispObj2
	^dispObj2! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:33'!
dispObj2: aSketchMorph
	dispObj2 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:03'!
dispObject
	^dispObject! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:04'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 13:09'!
initCostume
	| extName |

	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	extName := 'page2-dispObj1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self dispObj1  wearCostume: t2.
		]
	].

	extName := 'page2-dispObj2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self dispObj2  wearCostume: t2.
		]
	].

	extName := 'page2-pie123'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie1  wearCostume: t2.
			self pie2  wearCostume: t2.
			self pie3  wearCostume: t2.
		]
	].

	extName := 'page2-pie4'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie4  wearCostume: t2.
		]
	].

	extName := 'page2-pie5'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie5  wearCostume: t2.
		]
	].

	extName := 'page2-pie6'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie6  wearCostume: t2.
		]
	].

! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 13:07'!
initialize
	super initialize.
	self start:false.
	
	self width:200.
	self width:100.
	self dispObject: OrderedCollection new.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self motionGuide1: MotionGuide new.
	self addMorph: self motionGuide1.
	self motionGuide1 intiFinishEventReceiver:self FinishEventSelector:#motionCompleteGuide1.
	self motionGuide1 stepInterval:500.
	self motionGuide1 forwardStep:10.
	self motionGuide1 loop:false.

	self motionGuide2: MotionGuide new.
	self addMorph: self motionGuide2.
	self motionGuide2 intiFinishEventReceiver:self FinishEventSelector:#motionCompleteGuide2.
	self motionGuide2 stepInterval:500.
	self motionGuide2 forwardStep:10.
	self motionGuide2 loop:false.

	self pie1: SketchMorph new.
	self pie2: SketchMorph new.
	self pie3: SketchMorph new.
	self pie4: SketchMorph new.
	self pie5: SketchMorph new.
	self pie6: SketchMorph new.
	
	self addMorph: self pie1.
	self addMorph: self pie2.
	self addMorph: self pie3.
	self addMorph: self pie4.
	self addMorph: self pie5.
	self addMorph: self pie6.

	self dispObj1: SketchMorph new.
	self addMorph: self dispObj1.

	self dispObj2: SketchMorph new.
	self addMorph: self dispObj2.

! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:12'!
initMotionPath1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (131@671).
	vArray at:2 put: (150@671).

	self pie1 comeToFront.
	self motionGuide1 initVertices:vArray TargetObject:(self pie1).! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:06'!
initMotionPath2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (130@332).
	vArray at:2 put: (844@332).

	self pie2 comeToFront.
	self motionGuide1 initVertices:vArray TargetObject:(self pie2).! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:06'!
initMotionPath3
	| vArray |
	vArray := Array new:3.
	vArray at:1 put: (354@332).
	vArray at:2 put: (818@332).
	vArray at:3 put: (818@449).

	self pie3 comeToFront.
	self motionGuide1 initVertices:vArray TargetObject:(self pie3).
! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:07'!
initMotionPath4
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (522@332).
	vArray at:2 put: (789@332).

	self pie4 comeToFront.
	self motionGuide1 initVertices:vArray TargetObject:(self pie4).! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:09'!
initMotionPath5
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (818@471).
	vArray at:2 put: (818@571).

	self pie5 comeToFront.
	self pie5 player setForwardDirection:0.
	self pie5 player setHeadingTheta:90.
	self motionGuide1 initVertices:vArray TargetObject:(self pie5).! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:11'!
initMotionPath6
	| vArray |
	vArray := Array new:3.
	vArray at:1 put: (822@423).
	vArray at:2 put: (988@493).
	vArray at:3 put: (1072@332).

	self pie6 comeToFront.
	self motionGuide2 initVertices:vArray TargetObject:(self pie6).! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:10'!
initMotionPath7

	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (818@571).
	vArray at:2 put: (818@379).

	self pie5 comeToFront.
	self pie5 player setForwardDirection:180.
	self pie5 player setHeadingTheta:270.
	self motionGuide1 initVertices:vArray TargetObject:(self pie5).! !

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 13:53'!
motionCompleteGuide1
	self currentMotionObject = 6 ifTrue:
	[
		self pie5 player setForwardDirection:0.
		self pie5 player setHeadingTheta:90.
		self pie5 player setLocationRounded:(818@379).

		(self dispObject at:13) show.
	].

	self currentMotionObject = 5 ifTrue:
	[
		self initMotionPath7.
		self motionGuide1 startMotion.
		self currentMotionObject:6
	].

	self currentMotionObject = 4 ifTrue:
	[
		self pie3 hide.
		self pie5 show.
		self pie6 show.
		self initMotionPath5.
		self motionGuide1 startMotion.
		self motionGuide2 startMotion.
		self currentMotionObject:5
	].

	self currentMotionObject = 3 ifTrue:
	[
		self initMotionPath3.
		self pie3 show.
		self motionGuide1 startMotion.
		self currentMotionObject:4.
		self pie4 player setLocationRounded:(789@332).
		self pie4 player setHeadingTheta:0.
	].

	self currentMotionObject = 2 ifTrue:
	[
		self initMotionPath4.
		self pie4 show.
		self motionGuide1 startMotion.
		self currentMotionObject:3.
		self pie2 player setLocationRounded:(844@332).
	].

	self currentMotionObject = 1 ifTrue:
	[
		self btnNextText show.
		(self dispObject at:1) show.
		(self dispObject at:2) show.
	].! !

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 13:55'!
motionCompleteGuide2
	self pie6 player setLocationRounded:(1072@332).
	self pie6 player setHeadingTheta:293.

	(self dispObject at:18) show.
	(self dispObject at:14) show.
	(self dispObject at:15) show.

	self btnNextText show.! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:56'!
motionGuide1
	^motionGuide1! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
motionGuide1: aMotionGuide
	motionGuide1 := aMotionGuide! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:56'!
motionGuide2
	^motionGuide2! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
motionGuide2: aMotionGuide
	motionGuide2 := aMotionGuide! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
pie1
	^pie1! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:58'!
pie1: aSketchMorph
	pie1 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
pie2
	^pie2! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:58'!
pie2: aSketchMorph
	pie2 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
pie3
	^pie3! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:58'!
pie3: aSketchMorph
	pie3 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
pie4
	^pie4! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:58'!
pie4: aSketchMorph
	pie4 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:57'!
pie5
	^pie5! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 10:58'!
pie5: aSketchMorph
	pie5 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:33'!
pie6
	^pie6! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:33'!
pie6: aSketchMorph
	pie6 := aSketchMorph! !

!FractionMultiplicationPage2 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 13:54'!
reset
	| cnt siz |
	self start:false.
	self secondPassed:0.
	self currentMotionObject:1.
	self seqId:1.

	self btnNextText hide.

	self initMotionPath6.
	self initMotionPath5.
	self initMotionPath4.
	self initMotionPath3.
	self initMotionPath2.
	self initMotionPath1.

	self motionGuide1 reset.
	self motionGuide2 reset.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self pie2 hide.
	self pie3 hide.
	self pie4 hide.
	self pie5 hide.
	self pie6 hide.
! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:14'!
secondPassed
	^secondPassed
! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:14'!
secondPassed: aNumber
	secondPassed := aNumber
! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:04'!
seqId
	^seqId! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 13:05'!
seqId: aNumber
	seqId := aNumber
! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:16'!
start
	^start! !

!FractionMultiplicationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 8/11/2008 11:16'!
start: aBoolean
	start := aBoolean! !

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 8/11/2008 11:41'!
stepTime
	^1000.! !

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 12:25'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed  + 1.
		self secondPassed = 3 ifTrue:
		[
			self start:false.
			self motionGuide1 startMotion.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

!FractionMultiplicationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 13:54'!
test
	| extName |
	
	extName := 'p2-d-18'.

	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #FractionMultiplicationPage3
	instanceVariableNames: 'start motionGuide pie1 pie2 currentMotionObject secondPassed btnNextText seqId dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 15:21'!
btnNextTextClick:index

	self seqId = 3 ifTrue:
	[

		self seqId:4.
	].

	self seqId = 2 ifTrue:
	[
		self initMotionPath2.
		self pie2 show.

		self motionGuide startMotion.
		self btnNextText hide.

		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		self initMotionPath1.
	
		self motionGuide startMotion.
		self pie1 show.

		self btnNextText hide.

		self seqId:2.
	].! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 14:30'!
btnNextText
	^btnNextText! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 14:30'!
btnNextText: aButton
	btnNextText := aButton! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:14'!
currentMotionObject
	^currentMotionObject! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:14'!
currentMotionObject: aNumber
	currentMotionObject := aNumber! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 15:03'!
dispObject
	^dispObject! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 15:04'!
dispObject: anOrderedColection
	dispObject := anOrderedColection
! !

!FractionMultiplicationPage3 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 15:02'!
initCostume
	| extName |

	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	extName := 'page3-pie1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie1  wearCostume: t2.
			self pie7  wearCostume: t2.
		]
	].

	extName := 'page3-pie4'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie4  wearCostume: t2.
			self pie8  wearCostume: t2.
		]
	].

	extName := 'page3-pie2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie2  wearCostume: t2.
		]
	].

	extName := 'page3-pie3'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie3  wearCostume: t2.
		]
	].

	extName := 'page3-pie5'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie5  wearCostume: t2.
		]
	].

	extName := 'page3-pie6'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self pie6  wearCostume: t2.
		]
	].
! !

!FractionMultiplicationPage3 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 15:12'!
initialize
	super initialize.
	super initialize.
	self start:false.
	
	self width:200.
	self width:100.

	self dispObject: OrderedCollection new.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self motionGuide: MotionGuide new.
	self addMorph: self motionGuide.
	self motionGuide intiFinishEventReceiver:self FinishEventSelector:#motionComplete.
	self motionGuide stepInterval:500.
	self motionGuide forwardStep:10.
	self motionGuide loop:false.

	self pie1: SketchMorph new.
	self pie2: SketchMorph new.
	
	self addMorph: self pie1.
	self addMorph: self pie2.
! !

!FractionMultiplicationPage3 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:58'!
initMotionPath1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (130@191).
	vArray at:2 put: (548@191).

	self motionGuide initVertices:vArray TargetObject:(self pie1).! !

!FractionMultiplicationPage3 methodsFor: 'initialization' stamp: 'Aayush 8/25/2008 15:58'!
initMotionPath2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (500@191).
	vArray at:2 put: (1015@191).

	self motionGuide initVertices:vArray TargetObject:(self pie2).! !

!FractionMultiplicationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 15:22'!
motionComplete
	self currentMotionObject = 2 ifTrue:
	[
		(self dispObject at:2) show.
	].

	self currentMotionObject = 1 ifTrue:
	[
		(self dispObject at:1) show.
		self btnNextText show.

		self currentMotionObject:2.
	].
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:09'!
motionGuide
	^motionGuide! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:10'!
motionGuide: aMotionGuide
	motionGuide := aMotionGuide! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:10'!
pie1
	^pie1! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:11'!
pie1: aSketchMorph
	pie1 := aSketchMorph! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:11'!
pie2
	^pie2! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 10:11'!
pie2: aSketchMorph
	pie2 := aSketchMorph! !

!FractionMultiplicationPage3 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 15:18'!
reset
	| cnt siz |
	self start:false.
	self currentMotionObject:1.
	self secondPassed:0.

	self seqId:1.

	self pie1 hide.
	self pie2 hide.

	self btnNextText hide.

	cnt := 1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self motionGuide reset.
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:55'!
secondPassed
	^secondPassed
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:55'!
secondPassed: aNumber
	secondPassed := aNumber
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 14:30'!
seqId
	^seqId
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 14:30'!
seqId: aNumber
	seqId := aNumber
! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:55'!
start
	^start! !

!FractionMultiplicationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 09:55'!
start: aBoolean
	start := aBoolean! !

!FractionMultiplicationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 8/12/2008 10:21'!
stepTime
	^1000! !

!FractionMultiplicationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 15:15'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self btnNextText show.


			self start:false.
		].
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!FractionMultiplicationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 15:12'!
test

	| extName |
	
	extName := 'p3-d-2'.

	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #FractionMultiplicationPage4
	instanceVariableNames: 'btnCheckAnswer answer question questionDisplay imgCheckArr1 imgCheckArr2 btnShowCorrect txtBoxArr1 txtBoxArr2 score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationPage4 methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 16:05'!
alignQuestionDisplay

	| count x w |
	count := 1.
	[count <= 10] whileTrue:
	[
		x := ((self txtBoxArr1 at:count) at:1) left.
		w := (self questionDisplay at:count) width.

		(self questionDisplay at:count) left: (x-w-20).
		count := count + 1.
	]! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 11:22'!
answer
	^answer! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 11:23'!
answer: anOrderedCollection
	answer := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 17:18'!
btnCheckAnswerClick:i
	| count cn1 cd1 cn2 cd2 tn1 td1 tn2 td2 extName imgCheck imgCross index |

	extName := 'Check'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			imgCheck := t2.
		]
	].

	extName := 'Cross'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			imgCross := t2.
		]
	].

	count := 1.
	[count <= 10] whileTrue:
	[
		index := (self questionDisplay at:count) qusNo.

		cn1 := ((self answer at:index) at:1).
		cd1 := ((self answer at:index) at:2).
		cn2 := ((self answer at:index) at:3).
		cd2 := ((self answer at:index) at:4).

		tn1 := ((self txtBoxArr1 at:count) at:1)	 getCharacters.
		td1 := ((self txtBoxArr1 at:count) at:2)	 getCharacters.
		tn2 := ((self txtBoxArr2 at:count) at:1)	 getCharacters.
		td2 := ((self txtBoxArr2 at:count) at:2)	 getCharacters.

		(tn1=cn1 and:[td1=cd1]) ifTrue:
		[
			(self imgCheckArr1 at:count) wearCostume:imgCheck.
			self score contents:((self score contents asInteger) +1) asString.
		]
		ifFalse:
		[
			(self imgCheckArr1 at:count) wearCostume:imgCross.
		].

		(tn2=cn2 and:[td2=cd2]) ifTrue:
		[
			(self imgCheckArr2 at:count) wearCostume:imgCheck.
			self score contents:((self score contents asInteger) +1) asString.
		]
		ifFalse:
		[
			(self imgCheckArr2 at:count) wearCostume:imgCheck.
		].

		(imgCheckArr1 at:count) show.
		(imgCheckArr2 at:count) show.
	
		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 8/12/2008 11:11'!
btnCheckAnswer
	^btnCheckAnswer! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:04'!
btnCheckAnswer: anOrderedCollection
	btnCheckAnswer := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 09:59'!
btnShowCorrectClick:index
	| count extName imgCheck qn |

	extName := 'Check'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			imgCheck := t2.
		]
	].

	count := 1.
	[count <= 10] whileTrue:
	[
		qn := (self questionDisplay at:count) qusNo.

		((self txtBoxArr1 at:count) at:1) setCharacters:((self answer at:qn) at:1).
		((self txtBoxArr1 at:count) at:2) setCharacters:((self answer at:qn) at:2).
		((self txtBoxArr2 at:count) at:1) setCharacters:((self answer at:qn) at:3).
		((self txtBoxArr2 at:count) at:2) setCharacters:((self answer at:qn) at:4).

		(self imgCheckArr1 at:count) wearCostume:imgCheck.
		(self imgCheckArr2 at:count) wearCostume:imgCheck.

		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:05'!
btnShowCorrect
	^btnShowCorrect! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:05'!
btnShowCorrect: anOrderedCollection
	btnShowCorrect:= anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 15:52'!
dispObject
	^dispObject! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 15:52'!
dispObject: anOrderedCollection
	dispObject:= anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:08'!
imgCheckArr1
	^imgCheckArr1! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:08'!
imgCheckArr1: anOrderedCollection
	imgCheckArr1 := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:08'!
imgCheckArr2
	^imgCheckArr2! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:08'!
imgCheckArr2: anOrderedCollection
	imgCheckArr2 := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 11:45'!
initAnswer
	self answer: OrderedCollection new.
	
	self answer add:(Array withAll:#('77' '4' '77' '4')).
	self answer add:(Array withAll:#('54' '2' '27' '1')).
 	self answer add:(Array withAll:#('13' '8' '13' '8')).
	self answer add:(Array withAll:#('12' '48' '1' '4')).
	self answer add:(Array withAll:#('280' '30' '28' '3')).
	self answer add:(Array withAll:#('300' '10' '30' '1')).
	self answer add:(Array withAll:#('1311' '24' '437' '8')).
	self answer add:(Array withAll:#('663' '42' '221' '14')).
	self answer add:(Array withAll:#('114' '48' '57' '24')).
	self answer add:(Array withAll:#('1519' '132' '1519' '132')).


! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 16:07'!
initCostume
	self btnCheckAnswer initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnShowCorrect initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 14:48'!
initImgCheckArr
	| count |
	self imgCheckArr1: OrderedCollection new.
	self imgCheckArr2: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self imgCheckArr1 add: SketchMorph new.
		self imgCheckArr2 add: SketchMorph new.

		self addMorph:(self imgCheckArr1 at:count). 
		self addMorph:(self imgCheckArr2 at:count). 
		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 14:13'!
initialize
	super initialize.
	self width:200.
	self height:100.

	self btnCheckAnswer: MyButton new.
	self addMorph:self btnCheckAnswer.
	self btnCheckAnswer initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCheckAnswerClick:.

	self btnShowCorrect: MyButton new.
	self addMorph:self btnShowCorrect.
	self btnShowCorrect initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnShowCorrectClick:.

	self score: StringMorph new.
	self addMorph:self score	.
	self score contents:'Score'.

	self initAnswer.
	self initQuestion.
	self initQuestionDisplay.
	self initImgCheckArr.
	self initTextBox.
! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 11:48'!
initQuestionDisplay
	| count |
	self questionDisplay: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self questionDisplay add: FractionMultiplicationQuestionDisplay new.
		self addMorph: (self questionDisplay at:count).
		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 15:55'!
initQuestion
	self question: OrderedCollection new.

	self question add:(Array withAll:#(nil '11' '2' nil '7' '2')).
	self question add:(Array withAll:#(nil '6' nil nil '9' '2')).
	self question add:(Array withAll:#('6' '1' '2' nil '1' '4')).
	self question add:(Array withAll:#(nil '4' '8' nil '3' '6')).
	self question add:(Array withAll:#('2' '4' '5' '3' '2' '6')).
	self question add:(Array withAll:#('12' '1' '2' '2' '2' '5')).
	self question add:(Array withAll:#('7' '1' '8' '7' '2' '3')).
	self question add:(Array withAll:#('6' '3' '6' '2' '3' '7')).
	self question add:(Array withAll:#(nil '6' '8' '3' '1' '6')).
	self question add:(Array withAll:#('4' '1' '12' '2' '9' '11')).
! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/14/2008 15:33'!
initTextBox
	| count |

	self txtBoxArr1: OrderedCollection new.
	self txtBoxArr2: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self txtBoxArr1 add:(Array new:2).
		self txtBoxArr2 add:(Array new:2).

		(self txtBoxArr1 at:count) at:1 put:(MyTextMorph new).
		((self txtBoxArr1 at:count) at:1) setCharacters:(count asString,'-C1-N').
		((self txtBoxArr1 at:count) at:1) maxLength:4.
		self addMorph:((self txtBoxArr1 at:count) at:1).

		(self txtBoxArr1 at:count) at:2 put:(MyTextMorph new).
		((self txtBoxArr1 at:count) at:2) setCharacters:(count asString,'-C1-D').
		((self txtBoxArr1 at:count) at:2) maxLength:4.
		self addMorph:((self txtBoxArr1 at:count) at:2).

		(self txtBoxArr2 at:count) at:1 put:(MyTextMorph new).
		((self txtBoxArr2 at:count) at:1) setCharacters:(count asString,'-C2-N').
		((self txtBoxArr2 at:count) at:1) maxLength:4.
		self addMorph:((self txtBoxArr2 at:count) at:1).

		(self txtBoxArr2 at:count) at:2 put:(MyTextMorph new).
		((self txtBoxArr2 at:count) at:2) setCharacters:(count asString,'-C2-D').
		((self txtBoxArr2 at:count) at:2) maxLength:4.
		self addMorph:((self txtBoxArr2 at:count) at:2).


		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:07'!
questionDisplay
	^questionDisplay! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:07'!
questionDisplay: anOrderedCollection
	questionDisplay := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:03'!
question
	^question! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:03'!
question: anOrderedCollection
	question := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'initialization' stamp: 'A 8/15/2008 16:59'!
reset
	| count |
	self showQuestion.
	self score contents:'0'.

	count := 1.
	[count <= 10] whileTrue:
	[
		((self txtBoxArr1 at:count) at:1) setCharacters:''.
		((self txtBoxArr1 at:count) at:2) setCharacters:''.
		((self txtBoxArr2 at:count) at:1) setCharacters:''.
		((self txtBoxArr2 at:count) at:2) setCharacters:''.

		(imgCheckArr1 at:count) hide.
		(imgCheckArr2 at:count) hide.

		count := count + 1.
	].! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 13:56'!
score
	^score! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 13:57'!
score: aStringMorph
	score := aStringMorph! !

!FractionMultiplicationPage4 methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 16:04'!
showQuestion

	| startPos count |
	startPos := 10 random.

	count := 1.
	[count <= 10] whileTrue:
	[
		(self questionDisplay at:count) showQuestion:(self question at:startPos) Sign:'X'.
		(self questionDisplay at:count) qusNo:startPos.

		startPos := startPos + 1.
		startPos > 10 ifTrue:
		[
			startPos := 1.
		].

		count := count + 1.
	]. 

	self alignQuestionDisplay.! !

!FractionMultiplicationPage4 methodsFor: 'miscellaneous' stamp: 'A 8/15/2008 15:06'!
test
	| count |
	count := 1.
	[count<=10] whileTrue:
	[
		(self imgCheckArr1 at:count) show.	
		(self imgCheckArr2 at:count) show.	

		(self questionDisplay at:count) show.
		(self questionDisplay at:count) fontName:'BitstreamVeraSana' size:36.

		count := count + 1.
	].
! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:17'!
txtBoxArr1
	^txtBoxArr1! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:18'!
txtBoxArr1: anOrderedCollection
	txtBoxArr1 := anOrderedCollection! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:17'!
txtBoxArr2
	^txtBoxArr2! !

!FractionMultiplicationPage4 methodsFor: 'accessing - properties' stamp: 'A 8/14/2008 11:18'!
txtBoxArr2: anOrderedCollection
	txtBoxArr2 := anOrderedCollection! !

PasteUpMorph subclass: #FractionMultiplicationPage5
	instanceVariableNames: 'btnNextText dispObject seqId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:33'!
btnNextTextClick:index
	self seqId = 4 ifTrue:
	[
		(self dispObject at:4) show.
		self btnNextText hide.
		self seqId:5.
	].

	self seqId = 3 ifTrue:
	[
		(self dispObject at:3) show.
		self seqId:4.
	].

	self seqId = 2 ifTrue:
	[
		(self dispObject at:2) show.
		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		(self dispObject at:1) show.
		self seqId:2.
	].
! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:08'!
btnNextText
	^btnNextText! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:09'!
btnNextText: aButton
	btnNextText := aButton! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:14'!
dispObject
	^dispObject! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:15'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:16'!
initialize
	super initialize.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	self dispObject: OrderedCollection new.
! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:33'!
reset
	| cnt siz |
	self seqId:1.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self btnNextText show.! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:28'!
seqId
	^seqId! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:29'!
seqId: aNumber
	seqId:= aNumber! !

!FractionMultiplicationPage5 methodsFor: 'as yet unclassified' stamp: 'Aayush 11/3/2008 10:28'!
test
	| extName |
	extName := 'p5-d-4'.

	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #FractionMultiplicationPage6
	instanceVariableNames: 'wholeNumberSolve1 wholeNumberSolve2 fractionMultiplication start secondPassed fractionDisplay1 fractionDisplay2 motionGuide strMul seqId btnNextText dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/17/2008 10:24'!
btnNextTextClick:index
	self seqId = 9 ifTrue:
	[
		(self dispObject at:9) show.
		self btnNextText hide.
		self seqId:10.
	].

	self seqId = 8 ifTrue:
	[
		self fractionMultiplication show.
		self fractionMultiplication start:true.
		self fractionMultiplication startStepping.

		self fractionDisplay1 hide.
		self fractionDisplay2 hide.
		self strMul hide.
		
		self btnNextText hide.

		self seqId:9.
	].

	self seqId = 7 ifTrue:
	[
		self btnNextText hide.

		self fractionDisplay1 show.
		self initMotionFPath1.
		self motionGuide startMotion.

		self seqId:8.
	].

	self seqId = 6 ifTrue:
	[
		self wholeNumberSolve2 show.
		self wholeNumberSolve2 motionGuide startMotion.		
		self btnNextText hide.

		self seqId:7.
	].


	self seqId = 5 ifTrue:
	[
		(self dispObject at:6) show.
		self wholeNumberSolve1 motionGuide startMotion.
		self btnNextText hide.

		self seqId:6.
	].

	self seqId = 4 ifTrue:
	[
		(self dispObject at:5) show.
		self seqId:5.
	].

	self seqId = 3 ifTrue:
	[
		(self dispObject at:4) show.
		self seqId:4.
	].

	self seqId = 2 ifTrue:
	[
		(self dispObject at:3) show.
		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		(self dispObject at:2) show.
		(self dispObject at:1) show.
		self seqId:2.
	].
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:29'!
btnNextText
	^btnNextText! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:30'!
btnNextText: aButton
	btnNextText := aButton! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:30'!
dispObject
	^dispObject! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:30'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
fractionDisplay1
	^fractionDisplay1! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
fractionDisplay1: aFractionDisplayMorph
	fractionDisplay1 := aFractionDisplayMorph! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
fractionDisplay2
	^fractionDisplay2! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
fractionDisplay2: aFractionDisplayMorph
	fractionDisplay2 := aFractionDisplayMorph! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 09:42'!
fractionMultiplicationComplete
	self btnNextText show.
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 13:52'!
fractionMultiplication
	^fractionMultiplication! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 14:12'!
fractionMultiplication: afractionMultiplication
	fractionMultiplication := afractionMultiplication! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 16:15'!
initEventHandler
	self wholeNumberSolve1 motionGuide intiEventReceiver:self VertexReachedSelector:nil PathCompleteSelector:#motionComplete1.
	self wholeNumberSolve2 motionGuide intiEventReceiver:self VertexReachedSelector:nil PathCompleteSelector:#motionComplete2.! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 9/9/2008 16:21'!
initFractionDisplay
	| extName |
	extName := 'fd1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: FractionDisplay) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self fractionDisplay1: t2.
		]
	].

	extName := 'fd2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: FractionDisplay) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self fractionDisplay2: t2.
		]
	].

	extName := 'strMul'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: StringMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self strMul: t2.
		]
	].

	extName := 'mgExt'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: MotionGuideExtended) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self motionGuide: t2.
		]
	].
	self motionGuide intiEventReceiver:self VertexReachedSelector:nil PathCompleteSelector:#motionCompleteF.
! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 16:37'!
initialize
	super initialize.
	self width:100.
	self height:100.
	self start:false.
	self secondPassed:0.

	self dispObject: OrderedCollection new.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	self fractionMultiplication: FractionMultiplicationMorph new.
	self fractionMultiplication fontName:'BitstreamVeraSans' size:36.
	self addMorph: self fractionMultiplication.

	self wholeNumberSolve1: FractionMultiplicationWholeNumberSolve new.
	self wholeNumberSolve1 fontName:'BitstreamVeraSans' size:36.
	self addMorph:self wholeNumberSolve1.

	self wholeNumberSolve2: FractionMultiplicationWholeNumberSolve new.
	self wholeNumberSolve2 fontName:'BitstreamVeraSans' size:36.
	self addMorph:self wholeNumberSolve2.

	self initEventHandler.! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 09:48'!
initMotionFPath1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (326@398).
	vArray at:2 put: (585@184).
	
	self fractionDisplay1 comeToFront.
	self motionGuide initVertices:vArray TargetObject:(self fractionDisplay1).
! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 11/17/2008 10:18'!
initMotionFPath2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (1135@397).
	vArray at:2 put: (679@166).
	
	self fractionDisplay2 comeToFront.
	self motionGuide initVertices:vArray TargetObject:(self fractionDisplay2).
! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 16:59'!
initMotionW1Path1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (13@43).
	vArray at:2 put: (124@61).
	
	self wholeNumberSolve1 wholeNumber comeToFront.
	self wholeNumberSolve1 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve1 wholeNumber).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 16:59'!
initMotionW1Path2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@20).
	vArray at:2 put: (172@61).
	
	self wholeNumberSolve1 denomenator1 comeToFront.
	self wholeNumberSolve1 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve1 denomenator1).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:00'!
initMotionW1Path3
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@65).
	vArray at:2 put: (239@62).
	
	self wholeNumberSolve1 numerator comeToFront.
	self wholeNumberSolve1 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve1 numerator).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:00'!
initMotionW1Path4
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@20).
	vArray at:2 put: (148@23).
	
	self wholeNumberSolve1 denomenator2 comeToFront.
	self wholeNumberSolve1 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve1 denomenator2).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:01'!
initMotionW2Path1
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (13@43).
	vArray at:2 put: (124@61).
	
	self wholeNumberSolve2 wholeNumber comeToFront.
	self wholeNumberSolve2 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve2 wholeNumber).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:02'!
initMotionW2Path2
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@20).
	vArray at:2 put: (172@61).
	
	self wholeNumberSolve2 denomenator1 comeToFront.
	self wholeNumberSolve2 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve2 denomenator1).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:02'!
initMotionW2Path3
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@65).
	vArray at:2 put: (239@62).
	
	self wholeNumberSolve2 numerator comeToFront.
	self wholeNumberSolve2 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve2 numerator).! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 17:03'!
initMotionW2Path4
	| vArray |
	vArray := Array new:2.
	vArray at:1 put: (42@20).
	vArray at:2 put: (148@23).
	
	self wholeNumberSolve2 denomenator2 comeToFront.
	self wholeNumberSolve2 motionGuide initVertices:vArray TargetObject:(self wholeNumberSolve2 denomenator2).! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/17/2008 10:22'!
motionComplete1

	self wholeNumberSolve1 currentMotionObject = 4 ifTrue:
	[
		self wholeNumberSolve1 line2 show.
		self wholeNumberSolve1 eq2 show.
		self wholeNumberSolve1 resD show.
		self wholeNumberSolve1 resN show.

		self btnNextText show.
	].

	self wholeNumberSolve1 currentMotionObject = 3 ifTrue:
	[
		self wholeNumberSolve1 line1 show.
		self wholeNumberSolve1 currentMotionObject:4.
		self initMotionW1Path4.
		self wholeNumberSolve1 motionGuide startMotion.
	].

	self wholeNumberSolve1 currentMotionObject = 2 ifTrue:
	[
		self wholeNumberSolve1 brPlus show.
		self wholeNumberSolve1 currentMotionObject:3.
		self initMotionW1Path3.
		self wholeNumberSolve1 motionGuide startMotion.
	].

	self wholeNumberSolve1 currentMotionObject = 1 ifTrue:
	[
		self wholeNumberSolve1 mul show.
		self wholeNumberSolve1 currentMotionObject:2.
		self initMotionW1Path2.
		self wholeNumberSolve1 motionGuide startMotion.
	].
! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 17:28'!
motionComplete2
	self wholeNumberSolve2 currentMotionObject = 4 ifTrue:
	[
		self wholeNumberSolve2 line2 show.
		self wholeNumberSolve2 eq2 show.
		self wholeNumberSolve2 resD show.
		self wholeNumberSolve2 resN show.

		(self dispObject at:8) show.
		self btnNextText show.
	].

	self wholeNumberSolve2 currentMotionObject = 3 ifTrue:
	[
		self wholeNumberSolve2 line1 show.
		self wholeNumberSolve2 currentMotionObject:4.
		self initMotionW2Path4.
		self wholeNumberSolve2 motionGuide startMotion.
	].

	self wholeNumberSolve2 currentMotionObject = 2 ifTrue:
	[
		self wholeNumberSolve2 brPlus show.
		self wholeNumberSolve2 currentMotionObject:3.
		self initMotionW2Path3.
		self wholeNumberSolve2 motionGuide startMotion.
	].

	self wholeNumberSolve2 currentMotionObject = 1 ifTrue:
	[
		self wholeNumberSolve2 mul show.
		self wholeNumberSolve2 currentMotionObject:2.
		self initMotionW2Path2.
		self wholeNumberSolve2 motionGuide startMotion.
	].
! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 17:33'!
motionCompleteF

	self motionGuide targetObject = self fractionDisplay1 ifTrue:
	[
		self fractionDisplay2 show.
		self strMul show.
		self initMotionFPath2.
		self motionGuide startMotion.
	]
	ifFalse:
	[
		self btnNextText show.
	]
	! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:54'!
motionGuide
	^motionGuide! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:54'!
motionGuide: aMotionGuide
	motionGuide:= aMotionGuide! !

!FractionMultiplicationPage6 methodsFor: 'initialization' stamp: 'Aayush 10/31/2008 17:04'!
reset
	| cnt siz |
	self fractionMultiplication reset.
	self wholeNumberSolve1 reset.
	self initMotionW1Path4.
	self initMotionW1Path3.
	self initMotionW1Path2.
	self initMotionW1Path1.
	self seqId:1.
	self wholeNumberSolve2 reset.
	self initMotionW2Path4.
	self initMotionW2Path3.
	self initMotionW2Path2.
	self initMotionW2Path1.

	self initMotionFPath2.
	self initMotionFPath1.

	self fractionMultiplication hide.
	self fractionDisplay1 hide.
	self fractionDisplay2 hide.
	self strMul hide.

	self start:false.
	self secondPassed:0.
	self btnNextText show.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	]

! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 10:02'!
secondPassed
	^secondPassed! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 10:10'!
secondPassed:aNumber
	secondPassed:=aNumber! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:29'!
seqId
	^seqId! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 10/31/2008 16:29'!
seqId: aNumber
	seqId := aNumber! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 15:05'!
startAnimation
	self fractionDisplay start:true.
	self fractionDisplay startStepping.

	self wholeNumberSolve1.
	self wholeNumberSolve2.
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 10:01'!
start
	^start! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/28/2008 10:01'!
start: aBoolean
	start := aBoolean! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 8/28/2008 10:02'!
stepTime
	^1000.! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 17:12'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.

		self secondPassed = 2 ifTrue:
		[
			self btnNextText show.

			self secondPassed:0.
			self start:false.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
strMul
	^strMul! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 15:36'!
strMul: aStringMorph
	strMul := aStringMorph! !

!FractionMultiplicationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 10/31/2008 17:23'!
test
	| extName |
	extName := 'p6-d-9'.

	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 13:52'!
wholeNumberSolve1
	^wholeNumberSolve1
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 14:13'!
wholeNumberSolve1: awholeNumberSolve 
	wholeNumberSolve1 := awholeNumberSolve 
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 13:52'!
wholeNumberSolve2
	^wholeNumberSolve2
! !

!FractionMultiplicationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 14:13'!
wholeNumberSolve2: awholeNumberSolve 
	wholeNumberSolve2 := awholeNumberSolve 
! !

PasteUpMorph subclass: #FractionMultiplicationWholeNumberSolve
	instanceVariableNames: 'fractionDisplay wholeNumber numerator denomenator1 denomenator2 line1 line2 mul brPlus eq1 eq2 motionGuide resN resD currentMotionObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionMultiplicationActivity'!

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:05'!
brPlus
	^brPlus! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:05'!
brPlus: aString
	brPlus := aString! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:25'!
currentMotionObject
	^currentMotionObject! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:25'!
currentMotionObject: aNumber
	currentMotionObject := aNumber! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:57'!
denomenator1
	^denomenator1! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:58'!
denomenator1: aStringMorph
	denomenator1 := aStringMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:57'!
denomenator2
	^denomenator2! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:58'!
denomenator2: aStringMorph
	denomenator2 := aStringMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:29'!
eq1
	^eq1! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:30'!
eq1: aString
	eq1 := aString! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:29'!
eq2
	^eq2! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:30'!
eq2: aString
	eq2 := aString! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 13:07'!
fontName:f size:s

	self fractionDisplay fontName:f size:s.

	self wholeNumber fontName:f size:s.
	self numerator fontName:f size:s.
	self denomenator1 fontName:f size:s.
	self denomenator2 fontName:f size:s.
	self mul fontName:f size:s.
	self brPlus fontName:f size:s.
	self eq1 fontName:f size:s.
	self eq2 fontName:f size:s.

	self resN fontName:f size:s.
	self resD fontName:f size:s.! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:54'!
fractionDisplay
	^fractionDisplay! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:54'!
fractionDisplay: aFractionDisplay
	fractionDisplay := aFractionDisplay! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 13:23'!
initialize
	super initialize.
	self width:350.
	self height:80.

	self fractionDisplay: FractionDisplay new.
	self addMorph:self fractionDisplay.

	self motionGuide: MotionGuideExtended new.
	self addMorph:self motionGuide.

	self wholeNumber: StringMorph new.
	self addMorph:self wholeNumber.

	self numerator: StringMorph new.
	self addMorph:self numerator.

	self denomenator1: StringMorph new.
	self addMorph:self denomenator1.

	self denomenator2: StringMorph new.
	self addMorph:self denomenator2.

	self resN: StringMorph new.
	self addMorph:self resN.

	self resD: StringMorph new.
	self addMorph:self resD.

	self mul: StringMorph new.
	self addMorph:self mul.
	self mul contents:'X'.

	self brPlus: StringMorph new.
	self addMorph:self brPlus.
	self brPlus contents:'(          ) +'.

	self eq1: StringMorph new.
	self addMorph:self eq1.
	self eq1 contents:'='.

	self eq2: StringMorph new.
	self addMorph:self eq2.
	self eq2 contents:'='.

	self line1: LineMorph new.
	self line1 verticesAt:1 put:(0@0).
	self line1 verticesAt:2 put:(30@0).
	self addMorph:self line1.

	self line2: LineMorph new.
	self line2 verticesAt:1 put:(0@0).
	self line2 verticesAt:2 put:(30@0).
	self addMorph:self line2.
! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'initialization' stamp: 'Aayush 8/27/2008 12:58'!
initWholeN:wn Numerator:n Denomenator:d ResN:rn ResD:rd
	self wholeNumber contents:wn.
	self numerator contents:n.
	self denomenator1 contents:d.
	self denomenator2 contents:d.
	self resN contents: rn.
	self resD contents: rd.

! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:28'!
line1
	^line1! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:28'!
line1: aLineMorph
	line1 := aLineMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:28'!
line2
	^line2! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:29'!
line2: aLineMorph
	line2 := aLineMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:05'!
motionGuide
	^motionGuide! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:05'!
motionGuide: aMotionGuide
	motionGuide := aMotionGuide! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:04'!
mul
	^mul! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:00'!
mul: aString
	mul := aString! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:56'!
numerator
	^numerator! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:56'!
numerator: aStringMorph
	numerator := aStringMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:54'!
resD
	^resD! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:55'!
resD: aStringMorph
	resD := aStringMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'initialization' stamp: 'Aayush 8/28/2008 09:50'!
reset
	self mul hide.
	self brPlus hide.
	self line1 hide.
	self line2 hide.
	self resD hide.
	self resN hide.
	self eq2 hide.
	self currentMotionObject:1.
! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:54'!
resN
	^resN! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 12:55'!
resN: aStringMorph
	resN := aStringMorph! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'miscellaneous' stamp: 'Aayush 8/27/2008 15:56'!
test
	self initWholeN:'2' Numerator:'2' Denomenator:'3' ResN:'8' ResD:'3'.
	self fractionDisplay showWholeNumber:'2' Numerator:'2' Denomenator:'3'.

	self fontName:'BitstreamVeraSans' size:36.

! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:55'!
wholeNumber
	^wholeNumber! !

!FractionMultiplicationWholeNumberSolve methodsFor: 'accessing - properties' stamp: 'Aayush 8/27/2008 11:55'!
wholeNumber: aStringMorph
	wholeNumber := aStringMorph! !

PasteUpMorph subclass: #ImageBox
	instanceVariableNames: 'questionList qna isClicked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 13:22'!
addQuestion: txtQuestion soundQuestion: sQuestion addAnswer: txtAnswer soundAnswer: sAnswer
	"Add question and it's respective answer"
	qna := QnA new.
	qna question: txtQuestion.
	qna questionSound: sQuestion.
	qna answer: txtAnswer.
	qna answerSound: sAnswer.
	questionList add: qna.
	
! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 13:05'!
addQuestion: aQnA
	questionList add: aQnA.
	
! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:17'!
answerAt: anInteger
	| ans |
	ans:= questionList at: anInteger.
	^ans answer.! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 14:07'!
answerSoundAt: anInteger
	| quest |
	quest:= questionList at: anInteger.
	^quest answerSound.! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 13:22'!
clearQuestionList
	self questionList: OrderedCollection new.! !

!ImageBox methodsFor: 'accessing' stamp: 'ram 8/4/2008 12:35'!
displayQuestion
	| txtQuestList t1 t7 t5 speakerList speaker speakerName spd spdPlayer ansSpeaker |
	self hideAnswerBox.
	txtQuestList := World allMorphs
					select: [:t13 | (t13 isKindOf: UserText)
						and: ['Question*' match: t13 externalName]].
	speakerList := World allMorphs
					select: [:t12 | (t12 isKindOf: SketchMorph)
						and: ['Speaker*' match: t12 externalName]].

	txtQuestList do:[:each| each hide].
	speakerList  do:[:each| each hide].

	ansSpeaker := World allMorphs
					select: [:t12 | (t12 isKindOf: SketchMorph)
						and: ['ansSpeaker' match: t12 externalName]].

	1 to: questionList size
		do:[:each| 
			t1 := 'Question' , each asString.
			speakerName:='Speaker', each asString.
			t7 := txtQuestList
						select: [:t4 | t1 match: t4 externalName].
			t5 := t7 at: 1.
			t5 show.
			speaker:= speakerList select:[:sp| speakerName match: sp externalName].
			spd:= speaker at:1.
			spd show.

			spdPlayer:= spd player.
			spdPlayer setAnswer: (self answerAt: each).
			spdPlayer setAnswerSound: (self answerSoundAt: each).
			spdPlayer setQuestionSound: (self questionSoundAt: each).
			t5 setCharacters: (self questionAt: each).
			spdPlayer beep: spdPlayer getQuestionSound.
			spdPlayer waitForSeconds:3.
			spdPlayer showAnswer.
			ansSpeaker size>0 ifTrue:[
				ansSpeaker:= ansSpeaker at:1.
				ansSpeaker player script1.
			].
			
]! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 16:04'!
handlesMouseDown: anEvent
^true! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 13:39'!
handlesMouseOver: evt
^true! !

!ImageBox methodsFor: 'as yet unclassified' stamp: 'Ram 5/1/2008 15:38'!
hideAnswerBox
	| answerBlock |
	answerBlock := World allMorphs
					select: [:t13 | (t13 isKindOf: PasteUpMorph)
						and: ['AnswerBlock' match: t13 externalName]].
	answerBlock:=answerBlock at:1.
	answerBlock hide
	! !

!ImageBox methodsFor: 'as yet unclassified' stamp: 'Ram 5/5/2008 16:10'!
highlight
	| objectList obj |
	objectList := World allMorphs
					select: [:t13 | (t13 isKindOf: PasteUpMorph)
						and: ['ImageBox*' match: t13 externalName]].

	1 to: objectList size
		do:[:each| 
		obj:= objectList at: each.
		obj borderColor: (Color r: 1.00 g: 1.00 b: 1.00)].
	self borderColor: Color blue.! !

!ImageBox methodsFor: 'as yet unclassified' stamp: 'Ram 5/1/2008 16:05'!
initialize
	super initialize.
	questionList:= OrderedCollection new.
	self isClicked:false.! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 16:04'!
isClicked
	"Answer the value of isClicked"

	^ isClicked! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 16:04'!
isClicked: anObject
	"Set the value of isClicked"

	isClicked _ anObject! !

!ImageBox methodsFor: 'as yet unclassified' stamp: 'ram 8/4/2008 12:39'!
mouseDown: anEvent
	self highlight.
	self displayQuestion.
	self isClicked:true.
	self player acceptMethod.! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/2/2008 11:29'!
mouseEnter: evt
		"self borderColor: Color blue."! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/5/2008 16:08'!
mouseLeave: evt
		"self borderColor:(Color r: 1.00 g: 1.00 b: 1.00)."! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:31'!
prepareQuestion
	questionList := OrderedCollection new.

	qna:= QnA new.
	qna question: 'What''s that?'.
	qna answer: 'Its High Five'.
	questionList add: qna.
	
	qna:= QnA new.
	qna question: 'How many fingers are there?'.
	qna answer: 'Four'.
	questionList add: qna.
	
	qna:= QnA new.
	qna question: 'How big is the hand'.
	qna answer: 'its big'.
	questionList add: qna.
	
	qna:= QnA new.
	qna question: 'Anything unusual?'.
	qna answer: 'It''s frog''s hand'.
	questionList add: qna.
! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:08'!
qna
	"Answer the value of qna"

	^ qna! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:08'!
qna: anObject
	"Set the value of qna"

	qna _ anObject! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 12:16'!
questionAt: anInteger
	| quest |
	quest:= questionList at: anInteger.
	^quest question.! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 11:58'!
questionList
	"Answer the value of questionList"

	^ questionList! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 11:58'!
questionList: anObject
	"Set the value of questionList"

	questionList _ anObject! !

!ImageBox methodsFor: 'accessing' stamp: 'Ram 5/1/2008 14:07'!
questionSoundAt: anInteger
	| quest |
	quest:= questionList at: anInteger.
	^quest questionSound.! !

PasteUpMorph subclass: #ImageContainer
	instanceVariableNames: 'vocabularyList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Vocab'!

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/26/2008 18:43'!
allCubes
| t1 |
	t1 := World allMorphs
				select: [:t2 | (t2 isKindOf: PasteUpMorph)
						and: ['Loc*' match: t2 externalName]].
	^ t1! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/26/2008 18:32'!
fillCenterImage: imageTitle imageID: id
	| cont |
	cont:= (self getContainer:'Loc2').
	World allMorphs do:[ : each |( (each isKindOf:VocabImage) and: [each title =imageTitle] and: [each id= id])
		ifTrue:[
			cont addMorph: each.
			each lock:true.
			]
		]
! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/25/2008 14:03'!
getContainer: strContainerName
	| cont |
	cont:=World allMorphs select:[: each| ((each isKindOf:PasteUpMorph)and:[each externalName 	match:strContainerName])].
	cont size>0 
		ifTrue:[
		^(cont at:1).
		]! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/25/2008 13:50'!
initialize

	super initialize.
	self width:100.
	self height:100.
"
	self autoLineLayout:true.
	self borderWidth:1.
     self borderColor:(Color r: 0.031 g: 0.501 b: 0.004).
	img1:= ImageMorph new.
	self addMorph: img1.

	img1:= ImageMorph new.
	self addMorph: img1.

	self submorphs do:[:each| Transcript show: each externalName;cr].
"! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 12:53'!
lockAllCubes: aBoolean
	| cl t3 |
	aBoolean ifTrue:
			[borderWidth:=0]
			ifFalse:[borderWidth:=1].

	cl:= self allCubes.
	1 	to: cl size
		do: [:each | 
			t3 := (cl at: each) player.
			t3 costume borderWidth: borderWidth.
			aBoolean
				ifTrue: [t3 costume lock: true]
				ifFalse: [t3 costume lock: false]]! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/29/2008 13:57'!
lockImage:aBoolean
	| cubes cube img |
	cubes:= self allCubes.
	1 to: cubes size do:[:each|
		cube:= cubes at:each.

		cube submorphs size>0 ifTrue:[
			img:= (cube submorphs at:1).
			img lock:aBoolean.
		]
		]! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/25/2008 16:09'!
moveBackToPieceHolder: anVocabImage
	! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 9/29/2008 13:56'!
moveImagesToContainer
	| cont pieceHolder |
	self lockImage:false.
	cont:= (self getContainer:'Container').
	pieceHolder:= (self getContainer:'imagePieceHolder').
	World allMorphs do:[ : each |( (each isKindOf:VocabImage) and: [each owner externalName ~='Container'])
		ifTrue:[
	
			cont addMorph: each.
			]
		]! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 11:02'!
moveImagesToPieceHolder: imgList
	| pieceHolder container |
	container:= (self getContainer:'Container').
	pieceHolder:= (self getContainer:'imagePieceHolder').
	World allMorphs do:
		[ : each |( (each isKindOf:VocabImage) and: [each owner externalName ='Container'])
		ifTrue:[
			1 to: imgList size do:[:listcount
				|(each title match: (imgList at:listcount))ifTrue:[pieceHolder addMorph: each.].
				]
			]
		].

	container shuffleSubmorphs.

	! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 11:27'!
moveOtherImagesToPieceHolder
	| container pieceHolder x y |

	container:= (self getContainer:'Container').
	pieceHolder:= (self getContainer:'imagePieceHolder').
	container shuffleSubmorphs.

	x:= (container submorphs) asOrderedCollection.
	y:=x select:[:each | each player costume id~=5 ].
	1 to: 10 do:[:each|
		pieceHolder addMorph:(y at:each).
	]

	! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 14:36'!
moveTextLabelToHolder
	| textLabelHolder |
	textLabelHolder:= (self getContainer:'TextLabelContainer').
	World allMorphs do:
		[ : each |( each isKindOf:TextLabel )
		ifTrue:[textLabelHolder addMorph: each.].
		]! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 11:09'!
resetQuestion: aVocab
	| pieceList |
	pieceList:= OrderedCollection new.
	pieceList add: aVocab.

	"move images to container"
	self moveImagesToContainer.

	"set title value of all the cubes"
	self setCubeTitle: aVocab.

	"set answer of the problem"
	self setAnswer:aVocab.

	"move correct pieces image to ImagePieceHolder"
	self moveImagesToPieceHolder:pieceList.

	self moveOtherImagesToPieceHolder.

	"Fill the center image"
	self fillCenterImage: aVocab imageID: 5! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 16:07'!
setAnswer:aString
	| answerBox |
	answerBox:= ((self getContainer:'AnswerBox') ) player.
	answerBox setAnswer: aString.
! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 15:03'!
setCubeTitle:aString
	| cubes cube |
	cubes:= self allCubes.
	1 to: cubes size do:[:each|
		cube:= (cubes at:each)player.
		cube setTitle:aString.
		]! !

!ImageContainer methodsFor: 'accessing' stamp: 'ram 10/2/2008 11:51'!
vocabularyList
	"Answer the value of vocabularyList"

	^ vocabularyList! !

!ImageContainer methodsFor: 'accessing' stamp: 'ram 10/2/2008 11:51'!
vocabularyList: anObject
	"Set the value of vocabularyList"

	vocabularyList _ anObject! !

!ImageContainer methodsFor: 'as yet unclassified' stamp: 'ram 10/2/2008 11:49'!
wordAt: aNumber
	vocabularyList size>= aNumber ifTrue:[
		^vocabularyList at: aNumber.].
	^''! !

PasteUpMorph subclass: #ImageCube
	instanceVariableNames: 'id title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Vocab'!

!ImageCube methodsFor: 'accessing' stamp: 'ram 9/26/2008 10:59'!
id
	"Answer the value of id"

	^ id! !

!ImageCube methodsFor: 'accessing' stamp: 'ram 9/26/2008 10:59'!
id: anObject
	"Set the value of id"

	id _ anObject! !

!ImageCube methodsFor: 'as yet unclassified' stamp: 'ram 9/26/2008 11:02'!
initialize
	super initialize.

	self width:100.
	self height:100.

	self autoLineLayout:true.! !

!ImageCube methodsFor: 'accessing' stamp: 'ram 9/26/2008 10:59'!
title
	"Answer the value of title"

	^ title! !

!ImageCube methodsFor: 'accessing' stamp: 'ram 9/26/2008 10:59'!
title: anObject
	"Set the value of title"

	title _ anObject! !

PasteUpMorph subclass: #LcmActivity
	instanceVariableNames: 'btnNextText timer1 timer2 object1 object2 moveableObject1 moveableObject2 motionGuide1 motionGuide2 marker1 marker2 marker3 text start secondPassed mIndex1 mIndex2 page2 page3 page4 page5 page6 btnNext btnPrevious btnLevel1 btnLevel2 btnLevel3 currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel1
	^btnLevel1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel1: aButton
	btnLevel1 := aButton
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel2
	^btnLevel2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel2: aButton
	btnLevel2 := aButton
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel3
	^btnLevel3! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 14:08'!
btnLevel3: aButton
	btnLevel3 := aButton
! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 13:35'!
btnLevelClick:index
	| c1 c2 |
	c1 := self page3 txtCommonFactorCorrect .
	c2 := self page3 txtRemaningFactorCorrect .

	(c1 and:[c2]) ifTrue:
	[
		index = 1 ifTrue:
		[
			self page3 hide.
			self page4 show.
			self page4 reset.
			self page4 start:true.
			self page4 startStepping.

			self currentPage:4.
		].

		index = 2 ifTrue:
		[
			self page3 hide.
			self page5 show.
			self page5 useQus:1.
			self page5 reset.
			self page5 timer start.

			self currentPage:5.
		].

		index = 3 ifTrue:
		[
			self page3 hide.
			self page5 show.
			self page5 useQus:2.
			self page5 reset.
			self page5 timer start.

			self currentPage:5.
		].
	]
! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 13:04'!
btnNextClick:index
	self currentPage = 2 ifTrue:
	[
		self page2 reset.
		self page2 hide.

		self page3 show.
		self page3 reset.

		self currentPage: 3.
		self btnNext hide.
		self btnPrevious show. 
	].

	self currentPage = 1 ifTrue:
	[
		self reset.
		self hide.

		self page2 show.
		self page2 reset.
		self page2 start:true.
		self page2 startStepping.

		self currentPage: 2.
		self btnNext show.
		self btnPrevious show. 
	]! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'a 10/20/2008 16:26'!
btnNextTextClick:index
	self secondPassed = 5 ifTrue:
	[
		(self text at:5) show.
		self secondPassed:6.

		self btnNext show.
		self btnNextText hide.
	].

	self secondPassed = 4 ifTrue:
	[
		(self text at:4) show.
		self secondPassed:5.
	].

	self secondPassed = 3 ifTrue:
	[
		(self text at:3) show.
		self secondPassed:4.
	].

	self secondPassed = 2 ifTrue:
	[
		(self text at:2) show.
		self secondPassed:3.
	].
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 13:56'!
btnNextText
	^btnNextText! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 13:56'!
btnNextText: aButton
	btnNextText := aButton! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:13'!
btnNext
	^btnNext! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:14'!
btnNext: aButton
	btnNext := aButton! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/18/2005 11:29'!
btnPreviousClick:index
	self btnNext show.
	self currentPage = 2 ifTrue:
	[
		self page2 reset.
		self page2 hide.

		self show.
		self reset.
		self startRace.

		self currentPage: 1.
		self btnNext show.
		self btnPrevious hide. 
	].

	self currentPage = 3 ifTrue:
	[
		self page3 reset.
		self page3 hide.

		self page2 show.
		self page2 reset.
		self page2 start:true.
		self page2 startStepping.

		self currentPage: 2.
		self btnNext show.
		self btnPrevious show. 
	].

	self currentPage = 4 ifTrue:
	[
		self page4 reset.
		self page4 hide.

		self page3 show.

		self currentPage: 3.
	].

	self currentPage = 5 ifTrue:
	[
		self page5 reset.
		self page5 hide.

		self page3 show.

		self currentPage: 3.
	].
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:13'!
btnPrevious
	^btnPrevious! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:14'!
btnPrevious: aButton
	btnPrevious := aButton
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:13'!
currentPage
	^currentPage! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:13'!
currentPage: aNumber
	currentPage := aNumber! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/4/2008 16:18'!
hideMarkers
	| count |
	count := 1.
	[ count <= 9] whileTrue:
	[
		count  <= 3 ifTrue:
		[
			(self marker3 at:count) hide.
		].

		count  <= 6 ifTrue:
		[
			(self marker2 at:count) hide.
		].

		(self marker1 at:count) hide.
		
		count := count + 1.
	].
! !

!LcmActivity methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 14:05'!
initCostume

	| extName count m1 m2 |
	extName := 'frog-2'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self moveableObject1 wearCostume: t2]].

	extName := 'frog-1'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self object1 wearCostume: t2]].

	extName := 'rabbit-2'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self moveableObject2 wearCostume: t2]].


	extName := 'rabbit-1'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self object2 wearCostume: t2]].

	extName := 'marker-1'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [m1 := t2]].

	extName := 'marker-2'.
		World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [m2 := t2]].

	count := 1.
	[ count <= 9] whileTrue:
	[
		count  <= 3 ifTrue:
		[
			(self marker3 at:count) wearCostume:m2.
		].

		count  <= 6 ifTrue:
		[
			(self marker2 at:count) wearCostume:m1.
		].

		(self marker1 at:count) wearCostume:m1.
		
		count := count + 1.
	].

	self btnNext initImageOver:'nextOver' Down:'nextDown' Up:'nextUp'.
	self btnPrevious initImageOver:'previousOver' Down:'previousDown' Up:'previousUp'.

	self btnLevel1 initImageOver:'level1Over' Down:'level1Down' Up:'level1Up'.
	self btnLevel2 initImageOver:'level2Over' Down:'level2Down' Up:'level2Up'.
	self btnLevel3 initImageOver:'level3Over' Down:'level3Down' Up:'level3Up'.
! !

!LcmActivity methodsFor: 'initialization' stamp: 'a 10/20/2008 14:08'!
initialize
	super initialize.

	self object1: SketchMorph new.
	self object2: SketchMorph new.
	self addMorph: self object1.
	self addMorph: self object2.

	self mIndex1:1.
	self mIndex2:1.

	self timer1: LcmPageTimer1 new.
	self timer2: LcmPageTimer2 new.
	self addMorph:self timer1.
	self addMorph:self timer2.

	self moveableObject1: SketchMorph new.
	self moveableObject2: SketchMorph new.
	self addMorph: self moveableObject1.
	self addMorph: self moveableObject2.
	self motionGuide1: MotionGuideExtended new.
	self motionGuide1 loop: false.
	self motionGuide1 stepInterval: 50.
	self motionGuide1 forwardStep: 5.
	self motionGuide1 changeOrientation: true.
	self motionGuide1
		intiEventReceiver: self
		VertexReachedSelector: #vertexReached1:
		PathCompleteSelector: #pathComplete1.
	self addMorph: self motionGuide1.
	self motionGuide2: MotionGuideExtended new.
	self motionGuide2 loop: false.
	self motionGuide2 stepInterval: 50.
	self motionGuide2 forwardStep: 5.
	self motionGuide2 changeOrientation: true.
	self motionGuide2
		intiEventReceiver: self
		VertexReachedSelector: #vertexReached2:
		PathCompleteSelector: #pathComplete2.
	self addMorph: self motionGuide2.

	self initMarker.

	self  currentPage:1.
	self start:false.

	self btnNext: MyButton new openInWorld.
	self btnNext initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextClick:.

	self btnPrevious: MyButton new openInWorld.
	self btnPrevious initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnPreviousClick:.

	self btnNextText: MyButton new.
	self addMorph: self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self btnLevel1: MyButton new openInWorld.
	self btnLevel1 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnLevelClick:.
	self btnLevel1 index:1.

	self btnLevel2: MyButton new openInWorld.
	self btnLevel2 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnLevelClick:.
	self btnLevel2 index:2.

	self btnLevel3: MyButton new openInWorld.
	self btnLevel3 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnLevelClick:.
	self btnLevel3 index:3.
! !

!LcmActivity methodsFor: 'initialization' stamp: 'Aayush 9/4/2008 16:34'!
initMarker
	| count |

	self marker1: OrderedCollection new.
	self marker2: OrderedCollection new.
	self marker3: OrderedCollection new.

	count := 1.
	[ count <= 9] whileTrue:
	[
		self marker1 add:SketchMorph new.
		self addMorph: (self marker1 at:count).

		count := count + 1.
	].

	count := 1.
	[ count <= 6] whileTrue:
	[
		self marker2 add:SketchMorph new.
		self addMorph: (self marker2 at:count).

		count := count + 1.
	].

	count := 1.
	[ count <= 3] whileTrue:
	[
		self marker3 add:SketchMorph new.
		self addMorph: (self marker3 at:count).

		count := count + 1.
	].


! !

!LcmActivity methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 15:19'!
initMotionPath1
	| vertices count x y1 y2 |
	vertices := Array new: 19.
	count := 1.
	x := 38.
	y1 := 695.
	y2 := 720.
	[count <= 19]
		whileTrue: [count\\2 = 0
				ifTrue: [vertices at: count put: x @ y2]
				ifFalse: [vertices at: count put: x @ y1].
			x := x + 60.
			count := count + 1].
	self motionGuide1 initVertices: vertices TargetObject: self moveableObject1! !

!LcmActivity methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 14:50'!
initMotionPath2
	| vertices count x y1 y2 |
	vertices := Array new: 13.
	count := 1.
	x := 38.
	y1 := 575.
	y2 := 600.
	[count <= 13]
		whileTrue: [count\\2 = 0
				ifTrue: [vertices at: count put: x @ y2]
				ifFalse: [vertices at: count put: x @ y1].
			x := x + 90.
			count := count + 1].
	self motionGuide2 initVertices: vertices TargetObject: self moveableObject2! !

!LcmActivity methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 15:11'!
initText
	| extName |
	extName := 'text-1'.
	World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self text1: t2]].

	extName := 'text-2'.
	World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self text2: t2]].

	extName := 'text-3'.
	World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
					ifTrue: [self text3: t2]].
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
marker1
	^marker1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:10'!
marker1: anOrderedCollection
	marker1 := anOrderedCollection! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
marker2
	^marker2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:10'!
marker2: anOrderedCollection
	marker2 := anOrderedCollection! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
marker3
	^marker3! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
marker3: anOrderedCollection
	marker3 := anOrderedCollection! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 16:22'!
mIndex1
	^mIndex1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 16:22'!
mIndex1: aNumber
	mIndex1 := aNumber! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 16:22'!
mIndex2
	^mIndex2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 16:22'!
mIndex2: aNumber
	mIndex2 := aNumber! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:07'!
motionGuide1
	^motionGuide1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
motionGuide1: aMotionGuide
	motionGuide1 := aMotionGuide! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:07'!
motionGuide2
	^motionGuide2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/1/2008 12:08'!
motionGuide2: aMotionGuide
	motionGuide2 := aMotionGuide! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
moveableObject1
	^ moveableObject1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
moveableObject1: anObject 
	moveableObject1 := anObject! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
moveableObject2
	^ moveableObject2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
moveableObject2: anObject 
	moveableObject2 := anObject! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 12:24'!
object1
	^object1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 12:24'!
object1: aSketchMorph
	object1 := aSketchMorph! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 12:24'!
object2
	^object2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 12:24'!
object2: aSketchMorph
	object2 := aSketchMorph! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:09'!
page2
	^page2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:10'!
page2: aPasteUpMorph
	page2 := aPasteUpMorph! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:09'!
page3
	^page3! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:10'!
page3: aPasteUpMorph
	page3 := aPasteUpMorph! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:09'!
page4
	^page4! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:10'!
page4: aPasteUpMorph
	page4 := aPasteUpMorph! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:09'!
page5
	^page5! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 11:10'!
page5: aPasteUpMorph
	page5 := aPasteUpMorph! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/5/2008 09:55'!
pathComplete1
	self object1 show.
	self moveableObject1 hide.
	self object1 player setLocationRounded:(self moveableObject1 player getLocationRounded).
	(self marker1 at:(self mIndex1)) show.
"	(self marker1 at:(self mIndex1)) player setLocationRounded:(self motionGuide1 pathVertices at:(self motionGuide1 pathVertices size)).
"
	self start:true.
	self startStepping.! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/4/2008 17:38'!
pathComplete2
	self object2 show.
	self moveableObject2 hide.
	self object2 player setLocationRounded:(self moveableObject2 player getLocationRounded).

	(self marker2 at:(self mIndex2)) show.
"	(self marker2 at:(self mIndex2)) player setLocationRounded:(self motionGuide2 pathVertices at:(self motionGuide2 pathVertices size)).
"! !

!LcmActivity methodsFor: 'initialization' stamp: 'a 10/22/2008 15:03'!
reset
	| cnt |
	self initCostume.
	self show.

	self initMotionPath1.
	self initMotionPath2.

	self moveableObject1 hide.
	self moveableObject2 hide.

	self object1 show.
	self object1 player setLocationRounded:(self moveableObject1 player getLocationRounded).

	self object2 show.
	self object2 player setLocationRounded:(self moveableObject2 player getLocationRounded).

	self hideMarkers.
	self mIndex1:1.
	self mIndex2:1.
	self start:false.
	self secondPassed:0.

	self currentPage:1.
	self btnPrevious hide.
	self btnNext hide.

	self timer1 reset.
	self timer2 reset.

	cnt := 1.
	[cnt <= self text size] whileTrue:
	[
		(self text at:cnt) hide.		
		cnt := cnt + 1.
	].

	self page2 hide.
	self page3 hide.
	self page4 hide.
	self page5 hide.

	self btnNextText hide.! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
secondPassed
	^ secondPassed! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
secondPassed: aNumber 
	secondPassed := aNumber! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/4/2008 15:50'!
startRace
	self timer2 start:true.
	self timer2 startStepping.

	self timer1 start:true.
	self timer1 startStepping.

! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
start
	^ start! !

!LcmActivity methodsFor: 'accessing - properties' stamp: ''!
start: aBoolean 
	start := aBoolean! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/4/2008 11:11'!
stepTime
	^1000! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 15:08'!
step
	| |
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 1 ifTrue:
		[
			(self marker3 at:3) show.
		].

		self secondPassed = 2 ifTrue:
		[
			(self text at:1) show.
			self btnNextText show.
			self start:false.
		].
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/4/2008 15:51'!
stopRace
	self timer1 start:false.
	self motionGuide1 stopMotion.	

	self timer2 start:false.
	self motionGuide2 stopMotion	

! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/7/2008 12:34'!
test
	| extName |

"	self btnNextText: MyButton new openInWorld.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.


	[self text size >=1] whileTrue:
	[
		self text removeFirst.
	].
	self text addAll:#(1 2 3 4 5).
"
	extName := 'p1:line-1'.
	World allMorphsDo: 
	[	
		:t2 | ( t2 externalName asString sameAs: extName)				
		ifTrue:
		[
			self text at:1 put:t2.
		]
	].
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 16:17'!
text
	^text
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 16:17'!
text: anOrderedCollection
	text := anOrderedCollection
! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 15:14'!
timer1
	^timer1! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 15:15'!
timer1: aLcmPageTimer
	timer1 := aLcmPageTimer! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 15:14'!
timer2
	^timer2! !

!LcmActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/4/2008 15:15'!
timer2: aLcmPageTimer
	timer2 := aLcmPageTimer! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 15:01'!
vertexReached1:index
	
	| n |
	((index\\2) = 1) ifTrue:
	[
		self motionGuide1 stopMotion.

		((index\\6) = 1) ifTrue:
		[
			n := (((self mIndex1 - 3)/3)+1)*2.
			(self marker3 at:(self mIndex1 - n) ) show.
			self timer2 start:true.
			self timer2 startStepping.
		].

		self timer1 start:true.
		self timer1 startStepping.

		self object1 show.
		self moveableObject1 hide.
		self object1 player setLocationRounded:(self moveableObject1 player getLocationRounded).
		
		(self marker1 at:(self mIndex1)) show.
"		(self marker1 at:(self mIndex1)) player setLocationRounded:(self motionGuide1 pathVertices at:index).
"
		self mIndex1: self mIndex1 + 1.
	].

	

! !

!LcmActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 14:40'!
vertexReached2:index

	((index\\2) = 1) ifTrue:
	[
		self motionGuide2 stopMotion.

		(index > 4  and:[ (index\\4) = 1]) ifFalse:
		[
			Transcript show:' < index:', index asString,'> '. 
			self timer2 start:true.
			self timer2 startStepping.
		].

		self object2 show.
		self moveableObject2 hide.
		self object2 player setLocationRounded:(self moveableObject2 player getLocationRounded).


		(self marker2 at:(self mIndex2)) show.
"		(self marker2 at:(self mIndex2)) player setLocationRounded:(self motionGuide2 pathVertices at:index).
"
		self mIndex2: self mIndex2 + 1.
	].

	

! !

PasteUpMorph subclass: #LcmPage2
	instanceVariableNames: 'lcmHowTo1 secondPassed start text btnNextText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPage2 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 14:53'!
btnNextTextClick:index
	self secondPassed = 9 ifTrue:
	[
		(self text at:10) show.
		self btnNextText hide.
		self secondPassed:10
	].

	self secondPassed = 8 ifTrue:
	[
		(self text at:9) show.
		self secondPassed:9
	].

	self secondPassed = 7 ifTrue:
	[
		(self text at:8) show.
		self secondPassed:8
	].

	self secondPassed = 6 ifTrue:
	[
		self lcmHowTo1 show.
		self lcmHowTo1 start:true.
		self lcmHowTo1 startStepping.
		self btnNextText hide.

		self secondPassed:7
	].

	self secondPassed = 5 ifTrue:
	[
		(self text at:7) show.
		self secondPassed:6
	].

	self secondPassed = 4 ifTrue:
	[

		(self text at:6) show.
		self secondPassed:5
	].


	self secondPassed = 3 ifTrue:
	[

		(self text at:5) show.
		self secondPassed:4
	].

	self secondPassed = 2 ifTrue:
	[
		(self text at:4) show.
		self secondPassed:3.
		self btnNextText player setLocationRounded:(906@240).
	].

	self secondPassed = 1 ifTrue:
	[
		(self text at:3) show.
		self secondPassed:2
	].

	self secondPassed = 0 ifTrue:
	[
		(self text at:2) show.
		self secondPassed:1
	].
! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 14:01'!
btnNextText
	^btnNextText! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 14:01'!
btnNextText: aButton
	btnNextText := aButton! !

!LcmPage2 methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 10:50'!
initialize
	super initialize.
	self secondPassed:0.
	self start:false.

	self lcmHowTo1: LcmHowTo new.
	self addMorph: self lcmHowTo1.
! !

!LcmPage2 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 14:51'!
lcmHowTo1Complete
	self btnNextText show.! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:48'!
lcmHowTo1
	^lcmHowTo1! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:49'!
lcmHowTo1: lcmHowToMorph
	lcmHowTo1 := lcmHowToMorph! !

!LcmPage2 methodsFor: 'initialization' stamp: 'a 10/22/2008 14:39'!
reset
	| cnt |
	self lcmHowTo1 reset.
	self start:false.
	self secondPassed:0.

	cnt := 2.
	[cnt <= self text size] whileTrue:
	[
		(self text at:cnt) hide.		
		cnt := cnt + 1.
	].

	self lcmHowTo1 hide.

	self btnNextText show.
	self btnNextText player setLocationRounded:(911@536).
! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:43'!
secondPassed
	^secondPassed! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:43'!
secondPassed: aNumber
	secondPassed := aNumber! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:42'!
start
	^start! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 10:44'!
start: aBoolean
	start:= aBoolean! !

!LcmPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/5/2008 10:44'!
stepTime
	^1000.
! !

!LcmPage2 methodsFor: 'miscellaneous' stamp: 'a 10/20/2008 15:24'!
step
	self start ifTrue:
	[
		self start:false.
	]
	ifFalse:
	[
		self stopStepping
	]! !

!LcmPage2 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 14:19'!
test
"	self btnNextText: MyButton new openInWorld.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.
"
	| extName ar |

	[self text size >=1] whileTrue:
	[
		self text removeFirst.
	].
	self text addAll:#(1 2 3 4 5 6 7 8 9 10).

	extName := 'p2-txt:'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString beginsWith: extName])				
		ifTrue:
		[
			ar := t2 externalName subStrings:':'.
			self text at:((ar at:2) asInteger) put:t2.
		]
	].
! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 14:34'!
text
	^text! !

!LcmPage2 methodsFor: 'accessing - properties' stamp: 'a 10/20/2008 14:35'!
text: anOrderedCollection
	text := anOrderedCollection! !

PasteUpMorph subclass: #LcmPage3
	instanceVariableNames: 'txtCommonFactor txtRemaningFactor btnConfirm1 btnConfirm2 btnTellMe1 btnTellMe2 strOutput1 strOutput2 txtCommonFactorCorrect txtRemaningFactorCorrect imgCheck1 imgCheck2 btnNextText text seqId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:52'!
btnConfirm1
	^btnConfirm1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:52'!
btnConfirm1: anImageMorph
	btnConfirm1 := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:53'!
btnConfirm2
	^btnConfirm2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:52'!
btnConfirm2: anImageMorph
	btnConfirm2 := anImageMorph! !

!LcmPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 17:02'!
btnConfirmClick:index

	| extName txt |
	index = 1 ifTrue:
	[
		(txtCommonFactor getCharacters) withBlanksCondensed  = '7' ifTrue:
		[
			SoundService default playSoundNamedOrBeep: 'right1'.
			self txtCommonFactorCorrect:true.

			extName := 'Check'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
				ifTrue:
 				[
					self imgCheck1  wearCostume: t2.
				]
			].
			self btnNextText show.
		]
		ifFalse:
		[
			SoundService default playSoundNamedOrBeep: 'wrong3'.
			self txtCommonFactorCorrect:false.

			extName := 'Cross'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
				ifTrue:
 				[
					self imgCheck1  wearCostume: t2.
				]
			].
		].
		self imgCheck1 show.
	]
	ifFalse:
	[
		txt := (txtRemaningFactor getCharacters) withBlanksCondensed.

		( txt = '1,3,7' or:[txt = '1,7,3' or: [ txt = '3,1,7' or: [ txt = '3,7,1' or: [ txt = '7,1,3' or: [ txt = '7,3,1']]]]]) ifTrue:
		[
			SoundService default playSoundNamedOrBeep: 'right1'.
			self txtRemaningFactorCorrect:true.

			extName := 'Check'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
				ifTrue:
 				[
					self imgCheck2  wearCostume: t2.
				]
			].
		]
		ifFalse:
		[
			SoundService default playSoundNamedOrBeep: 'wrong3'.
			self txtRemaningFactorCorrect:false.

			extName := 'Cross'.
			World allMorphsDo: 
			[	
				:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
				ifTrue:
 				[
					self imgCheck2  wearCostume: t2.
				]
			].
		].
		self imgCheck2 show.
	].

	(self txtRemaningFactorCorrect and: [ self txtCommonFactorCorrect ]) ifTrue:
	[
		self imgCheck2 show.
		self btnNextText show.

"		self strOutput1 contents:'= 7 X 3 X 7 = 147'.
		self strOutput2 show.
"	].
! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:07'!
btnLevel1
	^btnLevel1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:12'!
btnLevel1: anImageMorph
	btnLevel1 := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:10'!
btnLevel2
	^btnLevel2
	! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:12'!
btnLevel2: anImageMorph
	btnLevel2 := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:10'!
btnLevel3
	^btnLevel3
	! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:12'!
btnLevel3: anImageMorph
	btnLevel3 := anImageMorph! !

!LcmPage3 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 16:47'!
btnNextTextClick:index

	self seqId = 3 ifTrue:
	[
		(self text at:2) show.
		self btnNextText hide.
		self seqId:4.
	].

	self seqId = 2 ifTrue:
	[
		(self text at:1) show.
		self strOutput1 show.
		self strOutput1 contents:'= 7 X 3 X 7 = 147'.
"		self strOutput2 show.
"
		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		self txtRemaningFactor show.
		(self text at:5) show.
		self btnTellMe2 show.
		self btnConfirm2 show.

		self btnNextText hide.

		self seqId:2.
	].

	self seqId = 0 ifTrue:
	[
		self txtCommonFactor show.
		(self text at:4) show.
		self btnTellMe1 show.
		self btnConfirm1 show.

		self btnNextText hide.

		self seqId:1.
	].
! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:18'!
btnNextText
	^btnNextText! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:18'!
btnNextText: aButton
	btnNextText:= aButton! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:59'!
btnNext
	^btnNext! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:59'!
btnNext: anImageMorph
	btnNext := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 10:10'!
btnPrevious
	^btnPrevious! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 10:12'!
btnPrevious: anImageMorph
	btnPrevious := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:53'!
btnTellMe1
	^btnTellMe1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:54'!
btnTellMe1: anImageMorph
	btnTellMe1 := anImageMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:53'!
btnTellMe2
	^btnTellMe2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:54'!
btnTellMe2: anImageMorph
	btnTellMe2 := anImageMorph! !

!LcmPage3 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 16:43'!
btnTellMeClick:index
	| extName |
	index = 1 ifTrue:
	[
		txtCommonFactor setCharacters: '7'.
		self txtCommonFactorCorrect:true.

		extName := 'Check'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
			ifTrue:
 			[
				self imgCheck1  wearCostume: t2.
			]
		].
		self imgCheck1 show.
		self btnNextText show.
	]
	ifFalse:
	[
		txtRemaningFactor setCharacters: '1,3,7'.
		self txtRemaningFactorCorrect:true.

		extName := 'Check'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
			ifTrue:
 			[
				self imgCheck2  wearCostume: t2.
			]
		].
		self imgCheck2 show.
	].

	(self txtRemaningFactorCorrect and: [ self txtCommonFactorCorrect ]) ifTrue:
	[
		self btnNextText show.
	].! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 10:00'!
complete1
	^complete1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 10:01'!
complete1: aBoolean
	complete1 := aBoolean! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 10:00'!
complete2
	^complete2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/8/2008 10:01'!
complete2: aBoolean
	complete2 := aBoolean! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 14:53'!
currentPage
	^currentPage! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 14:53'!
currentPage: aName
	currentPage := aName! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:35'!
imgCheck1
	^imgCheck1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:35'!
imgCheck1: aSketchMorph
	imgCheck1 := aSketchMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:34'!
imgCheck2
	^imgCheck2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:35'!
imgCheck2: aSketchMorph
	imgCheck2 := aSketchMorph! !

!LcmPage3 methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 13:52'!
initButtonEventHandler

	self btnConfirm1 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnConfirmClick:.
	self btnConfirm2 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnConfirmClick:.

	self btnTellMe1 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnTellMeClick:.
	self btnTellMe2 initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnTellMeClick:.
! !

!LcmPage3 methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 14:05'!
initCostume

	self btnTellMe1 initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
	self btnTellMe2 initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
	self btnConfirm1 initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnConfirm2 initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
! !

!LcmPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 8/26/2008 11:38'!
initImgCheck
	self imgCheck1: SketchMorph new openInWorld.
	self imgCheck2: SketchMorph new openInWorld.
! !

!LcmPage3 methodsFor: 'initialization' stamp: 'a 10/22/2008 15:44'!
initialize
	super initialize.
	self width:200.
	self height:100.
	self seqId:0.

	self imgCheck1: SketchMorph new.
	self addMorph:self imgCheck1.

	self imgCheck2: SketchMorph new.
	self addMorph:self imgCheck2.

	self txtCommonFactor: MyTextMorph new.
	self addMorph: (self txtCommonFactor).

	self txtRemaningFactor: MyTextMorph new.
	self addMorph: (self txtRemaningFactor).

	self strOutput1: StringMorph new.
	self addMorph:self strOutput1.

	self strOutput2: SketchMorph new.
	self addMorph:self strOutput2.

	self btnConfirm1: MyButton new.
	self btnConfirm1 index:1.
	self btnConfirm1 strLabel hide.
	self addMorph: (self btnConfirm1).

	self btnConfirm2: MyButton new.
	self btnConfirm2 index:2.
	self btnConfirm2 strLabel hide.
	self addMorph: (self btnConfirm2).

	self btnTellMe1: MyButton new.
	self btnTellMe1 index:1.
	self btnTellMe1 strLabel hide.
	self addMorph: (self btnTellMe1).

	self btnTellMe2: MyButton new.
	self btnTellMe2 index:2.
	self btnTellMe2 strLabel hide.
	self addMorph: (self btnTellMe2).

	self initButtonEventHandler.

	self reset.! !

!LcmPage3 methodsFor: 'initialization' stamp: 'Aayush 9/5/2008 16:29'!
initStrOutput2
	| extName |
	extName := 'text-4'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self strOutput2: t2.
		]
	].
! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 16:59'!
page1
	^page1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 17:00'!
page1: aPasteUpMorph
	page1 := aPasteUpMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 16:59'!
page2
	^page2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/30/2008 17:00'!
page2: aPasteUpMorph
	page2 := aPasteUpMorph! !

!LcmPage3 methodsFor: 'initialization' stamp: 'Aayush 11/11/2008 16:56'!
reset
	self txtCommonFactor setCharacters: ' '.
	self txtRemaningFactor setCharacters: ' '.

	self txtRemaningFactorCorrect:false.
	self txtCommonFactorCorrect:false.

	self seqId:0.

	self imgCheck1 hide.
	self imgCheck2 hide.

	self strOutput1 contents: '= ?'.
	self strOutput2 hide.

	self btnNextText show.

	self txtCommonFactor hide.
	(self text at:4) hide.
	self btnTellMe1 hide.
	self btnConfirm1 hide.

	self txtRemaningFactor hide.
	(self text at:5) hide.
	self btnTellMe2 hide.
	self btnConfirm2 hide.

	(self text at:1) hide.
	(self text at:2) hide.
	self strOutput1 hide.
	self strOutput2 hide.
! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:42'!
seqId
	^seqId! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:42'!
seqId: aNumber
	seqId := aNumber! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 15:08'!
strOutput1
	^strOutput1! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 15:09'!
strOutput1: aStringMorph
	strOutput1 := aStringMorph! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 15:09'!
strOutput2
	^strOutput2! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/4/2008 15:09'!
strOutput2: aStringMorph
	strOutput2 := aStringMorph! !

!LcmPage3 methodsFor: 'miscellaneous' stamp: 'a 10/22/2008 15:40'!
test
	| extName ar |

	self text: OrderedCollection new.
	
	[self text size >=1] whileTrue:
	[
		self text removeFirst.
	].

	self text addAll:#(1 2 3 4 5).

	extName := 'p3-txt:'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString beginsWith: extName])				
		ifTrue:
		[
			ar := t2 externalName subStrings:':'.
			self text at:((ar at:2) asInteger) put:t2.
		]
	].

"
	self btnNextText: MyButton new openInWorld.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.
"
! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:27'!
text
	^text! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'a 10/22/2008 15:27'!
text: anOrderedCollection
	text := anOrderedCollection! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:30'!
txtCommonFactorCorrect
	^txtCommonFactorCorrect! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:30'!
txtCommonFactorCorrect: aBoolean
	txtCommonFactorCorrect := aBoolean! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:50'!
txtCommonFactor
	^txtCommonFactor! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:50'!
txtCommonFactor: aUserText
	txtCommonFactor := aUserText! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:32'!
txtRemaningFactorCorrect
	^txtRemaningFactorCorrect! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 8/26/2008 11:30'!
txtRemaningFactorCorrect: aBoolean
	txtRemaningFactorCorrect := aBoolean! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:51'!
txtRemaningFactor
	^txtRemaningFactor! !

!LcmPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 09:51'!
txtRemaningFactor: aUserText
	txtRemaningFactor := aUserText! !

PasteUpMorph subclass: #LcmPage4
	instanceVariableNames: 'inputSensor answerDisplay questionDisplay textBox imgCross questionAnswer quSet btnCheckAnswer btnShowCorrect score btnNextQuSet start moveableText moveableTextIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:01'!
addEventHandler
	| count |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		(self answerDisplay at:count) on:#mouseUp send:#answerDisplayClick:v2:v3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseEnter send:#answerDisplayMouseEnter:v2:v3: to:self withValue:count.
		(self answerDisplay at:count) on:#mouseLeave send:#answerDisplayMouseLeave:v2:v3: to:self withValue:count.

		(self textBox at:count) on:#mouseUp send:#textBoxClick:v2:v3: to:self withValue:count.
		(self textBox at:count) on:#mouseEnter send:#textBoxMouseEnter:v2:v3: to:self withValue:count.
		(self textBox at:count) on:#mouseLeave send:#textBoxMouseLeave:v2:v3: to:self withValue:count.

		count := count + 1.
	].
! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 14:10'!
alignDisplays
	| count lQd tQd lAd tAd |
	count := 1.

	lQd := 100.
	tQd := 100.

	lAd := 100.
	tAd := 600.

	[ count <= 5 ] whileTrue:
	[
		(self questionDisplay at:count) left:lQd.
		(self questionDisplay at:count) top:tQd.
		(self questionDisplay at:count) width:150.
		(self textBox at:count) left: (lQd + (self questionDisplay at:count) width + 30).
		(self textBox at:count) top:tQd.
		(self textBox at:count) width:150.

		(self imgCross at:count) left: (lQd + (self questionDisplay at:count) width + 30 + (self textBox at:count) width + 30).
		(self imgCross at:count) top:tQd.

		tQd := tQd + (self questionDisplay at:count) height + 20.

 
		(self answerDisplay at:count) left: lAd.
		(self answerDisplay at:count) top: tAd.
		(self answerDisplay at:count)  width: 150.

		lAd := lAd + (self answerDisplay at:count) width + 30.
	
		count := count + 1.
	].
! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 13:57'!
answerDisplayClick:index v2:x v3:y

	| tmp |
	self moveableText visible ifTrue:
	[
		(self answerDisplay at:index) strMessage visible ifTrue:
		[
			tmp := (self moveableText contents).
			self moveableText contents: (self answerDisplay at:index) strMessage contents.
			(self answerDisplay at:index) strMessage contents:tmp.
			(self answerDisplay at:index) strMessage center: (self answerDisplay at:index) center.

			tmp := self moveableTextIndex.
			self moveableTextIndex: (self answerDisplay at:index) index.
			(self answerDisplay at:index) index:tmp.
		]
		ifFalse:
		[
			(self answerDisplay at:index) strMessage contents: (self moveableText contents).
			(self answerDisplay at:index) strMessage center: (self answerDisplay at:index) center.
			self moveableText hide.
			(self answerDisplay at:index) strMessage show.
			(self answerDisplay at:index) index: self moveableTextIndex.
		].
	]
	ifFalse:
	[
		(self answerDisplay at:index) strMessage visible ifTrue:
		[
			self moveableText contents: (self answerDisplay at:index) strMessage contents.
			self moveableTextIndex:(self answerDisplay at:index) index.
			self moveableText show.
			(self answerDisplay at:index) strMessage hide.
		]
	].

! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:05'!
answerDisplayMouseEnter:index v2:x v3:y
	(self answerDisplay at:index) color:  (Color r: 0.71 g: 0.71 b: 1.0)! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:06'!
answerDisplayMouseLeave:index v2:x v3:y
 (self answerDisplay at:index) color: (Color r: 0.613 g: 0.903 b: 1.0)! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:51'!
answerDisplay
	^answerDisplay! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:51'!
answerDisplay: anOrderedCollection
	answerDisplay := anOrderedCollection! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/7/2008 16:49'!
btnCheckAnswerClick:index
	| check count extName |
	check := 0.
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		((self textBox at:count) index = (self questionDisplay at:count) index) ifTrue:
		[
			extName := 'Check'.
			World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
					ifTrue: [
								(self imgCross at:count) wearCostume: t2.
							]].

			check := check + 1.
		
			self score contents: (self score contents asInteger + 1) asString.
		]
		ifFalse:
		[
			extName := 'Cross'.
			World
				allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
					ifTrue: [
								(self imgCross at:count) wearCostume: t2.
							]].
		].

		(self imgCross at:count) show.

		count := count + 1.
	].

	check = 5 ifFalse:
	[
		self btnShowCorrect show.
	].

	self quSet = 3 ifTrue:
	[
		self btnNextQuSet hide.
	]
	ifFalse:
	[
		self btnNextQuSet show.
	].

	self btnCheckAnswer hide.

	self removeEventHandler.! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:25'!
btnCheckAnswer
	^btnCheckAnswer! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:26'!
btnCheckAnswer: aButton
	btnCheckAnswer:= aButton! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/7/2008 16:48'!
btnNextQuSetClick:index
	self quSet: self quSet + 1.

	self score contents: '0'.
	self moveableTextIndex:0.
	self showQuestion.
	self hideObjects.

! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:27'!
btnNextQuSet
	^btnNextQuSet! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:27'!
btnNextQuSet: aButton
	btnNextQuSet:= aButton! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 14:53'!
btnShowCorrectClick:index
	| count i c extName |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		i := (self questionDisplay at:count) index.
		c := ((self questionAnswer at:i) at:2).
		(self textBox at:count) strMessage contents: c.

 		extName := 'Check'.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
				ifTrue: [
							(self imgCross at:count) wearCostume: t2.
						]].

		(self imgCross at:count) show.

		count := count + 1.
	].
! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:58'!
btnShowCorrect
	^btnShowCorrect! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:58'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:15'!
dummy
	^self! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 14:32'!
fontName:f size:s
	| count |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		((self questionDisplay at:count) strMessage) fontName:f size:s.
		((self answerDisplay at:count) strMessage) fontName:f size:s.
		((self textBox at:count) strMessage) fontName:f size:s.
		count := count + 1.
	].

	self score fontName:f size:s.
	self moveableText fontName:f size:s.
! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 14:40'!
hideObjects
	| count |
	self moveableText hide.

	count := 1.
	[ count <= 5 ] whileTrue:
	[
		(self textBox at:count) strMessage hide.
		(self answerDisplay at:count) strMessage show.
		(self imgCross at:count) hide.
		count := count + 1.
	].

	self btnCheckAnswer hide.
	self btnShowCorrect hide.
	self btnNextQuSet hide.! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 13:39'!
imgCross
	^imgCross! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 13:40'!
imgCross: anOrderedCollection
	imgCross := anOrderedCollection! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 9/8/2008 14:25'!
initCostume
	self btnCheckAnswer initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnShowCorrect initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
	self btnNextQuSet initImageOver:'nextQusOver' Down:'nextQusDown' Up:'nextQusUp'.
! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 9/8/2008 13:48'!
initCrossImage

	| count |
	self imgCross: OrderedCollection new.

	count := 1.
	[ count <= 5 ] whileTrue:
	[
		self imgCross add: SketchMorph new.
		self addMorph: (self imgCross at:count).				

		count := count + 1.
	].
! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 9/8/2008 10:49'!
initDisplay

	| count |
	
	self questionDisplay: OrderedCollection new.
	self answerDisplay: OrderedCollection new.
	self textBox: OrderedCollection new.

	count := 1.
	[ count <= 5 ] whileTrue:
	[
		self questionDisplay add: DisplayBoardR new.
		self addMorph:(self questionDisplay at:count).	

		self answerDisplay add: DisplayBoardR new.
		self addMorph:(self answerDisplay at:count).	
		(self answerDisplay at:count) on:#mouseUp send:#answerDisplayClick:v2:v3: to:self withValue:count.

		self textBox add: DisplayBoardR new.
		(self textBox at:count) on:#mouseUp send:#textBoxClick:v2:v3: to:self withValue:count.
		self addMorph:(self textBox at:count).	

		count := count + 1.
	].

! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 9/8/2008 11:10'!
initialize
	super initialize.

	self inputSensor: InputSensor new.

	self start:false.

	self initDisplay.
	self initQuestionAnswer.

	self btnCheckAnswer: MyButton new.
	self btnCheckAnswer initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCheckAnswerClick:.
	self addMorph:self btnCheckAnswer.	
	self btnNextQuSet: MyButton new.
	self btnNextQuSet initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextQuSetClick:.
	self addMorph:self btnNextQuSet.
	self btnShowCorrect: MyButton new.
	self btnShowCorrect initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnShowCorrectClick:.
	self addMorph:self btnShowCorrect.

	self score: StringMorph new.
	self addMorph: self score.

	self moveableText: StringMorph new.
	self addMorph:self moveableText.

	 ! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 11/7/2008 17:23'!
initQuestionAnswer
	self questionAnswer: OrderedCollection new.

	self questionAnswer add:(Array withAll:#('3 , 6' '6')).
	self questionAnswer add:(Array withAll:#('7 , 14' '14')).
	self questionAnswer add:(Array withAll:#('24 , 18' '72')).
	self questionAnswer add:(Array withAll:#('15 , 25' '75')).
	self questionAnswer add:(Array withAll:#('45 , 50' '450')).

	self questionAnswer add:(Array withAll:#('12 , 6' '12')).
	self questionAnswer add:(Array withAll:#('24 , 2' '24')).
	self questionAnswer add:(Array withAll:#('20 , 16' '80')).
	self questionAnswer add:(Array withAll:#('8 , 4' '32')).
	self questionAnswer add:(Array withAll:#('11 , 17' '187')).

	self questionAnswer add:(Array withAll:#('2 , 16' '16')).
	self questionAnswer add:(Array withAll:#('5 , 12' '60')).
	self questionAnswer add:(Array withAll:#('9 , 15' '45')).
	self questionAnswer add:(Array withAll:#('7 , 10' '70')).
	self questionAnswer add:(Array withAll:#('18 , 5' '90')).
! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:29'!
inputSensor
	^inputSensor! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:29'!
inputSensor: aInputSensor
	inputSensor := aInputSensor! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 13:53'!
moveableTextIndex
	^moveableTextIndex! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 13:53'!
moveableTextIndex: aNumber
	moveableTextIndex := aNumber! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:44'!
moveableText
	^moveableText! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:44'!
moveableText: aStringMorph
	moveableText := aStringMorph! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 17:09'!
questionAnswer
	^questionAnswer! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 17:09'!
questionAnswer: anOrderedCollection
	questionAnswer := anOrderedCollection! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:53'!
questionDisplay
	^questionDisplay! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:52'!
questionDisplay: anOrderedCollection
	questionDisplay := anOrderedCollection! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:23'!
quSet
	^quSet! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:23'!
quSet: aNumber
	quSet := aNumber! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:14'!
removeEventHandler
	| count |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		(self answerDisplay at:count) on:#mouseUp send:#dummy to:self.
		(self answerDisplay at:count) on:#mouseEnter send:#dummy to:self.
		(self answerDisplay at:count) on:#mouseLeave send:#dummy to:self.

		(self textBox at:count) on:#mouseUp send:#dummy to:self.
		(self textBox at:count) on:#mouseEnter send:#dummy to:self.
		(self textBox at:count) on:#mouseLeave send:#dummy to:self.

		count := count + 1.
	].
! !

!LcmPage4 methodsFor: 'initialization' stamp: 'Aayush 9/9/2008 12:16'!
reset
	self quSet:1.
	self score contents: '0'.
	self start:false.
	self moveableTextIndex:0.

	self showQuestion.
	self hideObjects.
! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:26'!
score
	^score! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:26'!
score: aStringMorph
	score := aStringMorph! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:08'!
showQuestion
	
	| sPosQ count qPos sPosA i |

	sPosQ := 5 random.

	count := 1 .
	[count <= 5] whileTrue:
	[
		qPos := ((self quSet - 1) * 5)	+ sPosQ.

		(self questionDisplay at:count) strMessage contents: ((self questionAnswer at:qPos) at:1).
		(self questionDisplay at:count) index:qPos.
		(self questionDisplay at:count) strMessage center:(self questionDisplay at:count) center.

"		(self answerDisplay at:count) strMessage contents: ((self questionAnswer at:qPos) at:2).
		(self answerDisplay at:count) index:qPos.
		(self answerDisplay at:count) strMessage center:(self answerDisplay at:count) center.
"
		sPosQ := sPosQ + 1.
		sPosQ > 5 ifTrue:
		[
			sPosQ := 1.
		].	

		count := count + 1.
	].


	sPosA := 5 random.

	count := 1 .
	[count <= 5] whileTrue:
	[
		i := (self questionDisplay at:count) index.

		(self answerDisplay at:sPosA) strMessage contents: ((self questionAnswer at:i) at:2).
		(self answerDisplay at:sPosA) index:i.
		(self answerDisplay at:sPosA) strMessage center:(self answerDisplay at:sPosA) center.

		sPosA := sPosA + 1.
		sPosA > 5 ifTrue:
		[
			sPosA := 1.
		].	

		count := count + 1.
	].

	self addEventHandler.! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:35'!
start
	^start! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 10:35'!
start: aBoolean
	start := aBoolean! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 10:34'!
stepTime
	^100.


! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 12:12'!
step
	self start ifTrue:
	[
		self moveableText center: self inputSensor cursorPoint.
	]
	ifFalse:
	[
		self stopStepping.
	].
	! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/8/2008 14:01'!
textBoxClick:index v2:x v3:y
	| tmp count check |
	self moveableText visible ifTrue:
	[
		(self textBox at:index) strMessage visible ifTrue:
		[
			tmp := (self moveableText contents).
			self moveableText contents: (self textBox at:index) strMessage contents.
			(self textBox at:index) strMessage contents:tmp.
			(self textBox at:index) strMessage center:(self textBox at:index) center.
		]
		ifFalse:
		[
			(self textBox at:index) strMessage contents:self moveableText contents.
			(self textBox at:index) strMessage center:(self textBox at:index) center.
			(self textBox at:index) strMessage show.
			self moveableText hide.	

			tmp := self moveableTextIndex.
			self moveableTextIndex: (self textBox at:index) index.
			(self textBox at:index) index:tmp.
		]
	]
	ifFalse:
	[
		(self textBox at:index) strMessage visible ifTrue:
		[
			self moveableText contents: (self textBox at:index) strMessage contents.
			(self textBox at:index) strMessage hide.
			self moveableText show.

			self moveableTextIndex:(self textBox at:index) index.
		]
	].

	count := 1.
	check := 0.
	[ count <= 5 ] whileTrue:
	[
		(self textBox at:count) strMessage visible ifTrue:
		[
			check := check + 1.
		].
		count := count + 1.
	].
	check = 5 ifTrue:
	[
		self btnCheckAnswer show.
	]
	ifFalse:
	[
		self btnCheckAnswer hide.
	].
! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:10'!
textBoxMouseEnter:index v2:x v3:y
	(self textBox at:index) color:  (Color r: 0.387 g: 1.0 b: 0.548).
! !

!LcmPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 15:04'!
textBoxMouseLeave:index v2:x v3:y
 (self textBox at:index) color: (Color r: 0.613 g: 0.903 b: 1.0)! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:52'!
textBox
	^textBox! !

!LcmPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/5/2008 16:52'!
textBox: anOrderedCollection
	textBox := anOrderedCollection! !

PasteUpMorph subclass: #LcmPage5
	instanceVariableNames: 'questionAnswer1 questionAnswer2 useQus score timer quSet questionDisplay textBox imgCheck btnCheckAnswer btnShowCorrect btnNextQuSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-LcmActivity'!

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 12:52'!
alignDisplays2
	| count |
	count := 1.

	[ count <= 5 ] whileTrue:
	[
		(self questionDisplay at:count) left:( (self textBox at:count) left - (self questionDisplay at:count) width - 30).
		(self questionDisplay at:count) top:(self textBox at:count) top.

		count := count + 1.
	].


! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 11:17'!
alignDisplays
	| count lQd tQd |
	count := 1.

	lQd := 100.
	tQd := 100.

	[ count <= 5 ] whileTrue:
	[
		(self questionDisplay at:count) left:lQd.
		(self questionDisplay at:count) top:tQd.
		(self questionDisplay at:count) width:150.
		(self textBox at:count) left: (lQd + (self questionDisplay at:count) width + 30).
		(self textBox at:count) top:tQd.
		(self textBox at:count) width:150.

		(self imgCheck at:count) left: (lQd + (self questionDisplay at:count) width + 30 + (self textBox at:count) width + 30).
		(self imgCheck at:count) top:tQd.

		tQd := tQd + (self questionDisplay at:count) height + 20.
 	
		count := count + 1.
	].
! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 10:09'!
btnCheckAnswerClick:index

	| check count extName i cAns |

	check := 0.
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		(((self textBox at:count) getCharacters) size >= 1) ifTrue:		
		[
			check := check + 1.
		].

		count := count + 1.
	].

	check = 5 ifTrue:
	[

		self timer pause.

		check := 0.
		count := 1.
		[ count <= 5 ] whileTrue:
		[
			i := (self questionDisplay at:count) index.
			self useQus = 1 ifTrue:
			[
				cAns := (self questionAnswer1 at:i) at:2.
			]
			ifFalse:
			[
				cAns := (self questionAnswer2 at:i) at:2.
			].	
	
			cAns = (self textBox at:count) getCharacters withoutTrailingBlanks ifTrue:
			[	
				extName := 'Check'.
				World
					allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
						ifTrue: [
									(self imgCheck at:count) wearCostume: t2.
								]].

				check := check + 1.
			
				self score contents: (self score contents asInteger + 1) asString.
			]
			ifFalse:
			[
				extName := 'Cross'.
				World
					allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
						ifTrue: [
									(self imgCheck at:count) wearCostume: t2.
								]].
			].

			(self imgCheck at:count) show.

			count := count + 1.
		].

		check = 5 ifFalse:
		[
			self btnShowCorrect show.
		].

		self btnNextQuSet show.
		self btnCheckAnswer hide.
	].! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:46'!
btnCheckAnswer
	^btnCheckAnswer! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:47'!
btnCheckAnswer: aButton
	btnCheckAnswer := aButton! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 13:42'!
btnNextQuSetClick:index
	self quSet: self quSet + 1.

	self score contents: '0'.
	self showQuestion.
	self hideObjects.
	self timer reset.
	self timer hide.
	self timer show.
	self timer start.

	self quSet = 3 ifTrue:
	[
		self btnNextQuSet hide.
	].
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 11:13'!
btnNextQuSet
	^ btnNextQuSet! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 11:13'!
btnNextQuSet: aButton
	btnNextQuSet := aButton! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 11:30'!
btnShowCorrectClick:index
	| count i extName cAns |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		i := (self questionDisplay at:count) index.

		self useQus = 1 ifTrue:
		[
			cAns := (self questionAnswer1 at:i) at:2.
		]
		ifFalse:
		[
			cAns := (self questionAnswer2 at:i) at:2.
		].	

		(self textBox at:count) setCharacters: cAns.

 		extName := 'Check'.
		World
			allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)	and: [t2 externalName asString sameAs: extName])
				ifTrue: [
							(self imgCheck at:count) wearCostume: t2.
						]].

		(self imgCheck at:count) show.

		count := count + 1.
	].
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:47'!
btnShowCorrect
	^btnShowCorrect! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:48'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 11:43'!
fontName:f size:s
	| count |
	count := 1.
	[ count <= 5 ] whileTrue:
	[
		((self questionDisplay at:count) strMessage) fontName:f size:s.
		(self textBox at:count) fontName:f size:s.
		count := count + 1.
	].

	self score fontName:f size:s.
! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/10/2008 10:04'!
hideObjects
	| count |

	count := 1.
	[ count <= 5 ] whileTrue:
	[
		(self textBox at:count) setCharacters:''.
		(self imgCheck at:count) hide.
		count := count + 1.
	].

	self btnShowCorrect hide.
	self btnNextQuSet hide.
	self btnCheckAnswer show.! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:45'!
imgCheck
	^imgCheck! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:45'!
imgCheck: anOrderedCollection
	imgCheck := anOrderedCollection! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 9/9/2008 10:49'!
initCostume
	self btnCheckAnswer initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnShowCorrect initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
	self btnNextQuSet initImageOver:'nextQusOver' Down:'nextQusDown' Up:'nextQusUp'.
! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 9/8/2008 17:04'!
initDisplay
	
	| count |
	self questionDisplay: OrderedCollection new.
	self textBox: OrderedCollection new.
	self imgCheck:OrderedCollection new.

	count := 1.
	[count <= 5] whileTrue:
	[
		self questionDisplay add: DisplayBoardR new.
		self addMorph:(self questionDisplay at:count).

		self textBox add: MyTextMorph new.
		(self textBox at:count) maxLength:5.
		self addMorph:(self textBox at:count).

		self imgCheck add: SketchMorph new.
		self addMorph:(self imgCheck at:count).

		count := count + 1.
	].! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 9/9/2008 10:50'!
initialize
	super initialize.

	self initQuestionAnswer1.
	self initQuestionAnswer2.

	self initDisplay.

	self btnCheckAnswer: MyButton new.
	self btnCheckAnswer initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCheckAnswerClick:.
	self addMorph:self btnCheckAnswer.	
	self btnNextQuSet: MyButton new.
	self btnNextQuSet initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextQuSetClick:.
	self addMorph:self btnNextQuSet.
	self btnShowCorrect: MyButton new.
	self btnShowCorrect initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnShowCorrectClick:.
	self addMorph:self btnShowCorrect.

	self score: StringMorph new.
	self addMorph: self score.

	self timer: MyTimer new.
	self addMorph: self timer.

! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 11/7/2008 16:53'!
initQuestionAnswer1
	self questionAnswer1: OrderedCollection new.

	self questionAnswer1 add: (Array withAll:#('37 , 6' '222')).
	self questionAnswer1 add: (Array withAll:#('28 , 84' '84')).
	self questionAnswer1 add: (Array withAll:#('243 , 27' '243')).
	self questionAnswer1 add: (Array withAll:#('13 , 65' '65')).
	self questionAnswer1 add: (Array withAll:#('21 , 49' '147')).

	self questionAnswer1 add: (Array withAll:#('48 , 39' '624')).
	self questionAnswer1 add: (Array withAll:#('95 , 25' '475')).
	self questionAnswer1 add: (Array withAll:#('65 , 13' '65')).
	self questionAnswer1 add: (Array withAll:#('25 , 40' '280')).
	self questionAnswer1 add: (Array withAll:#('105 , 35' '105')).

	self questionAnswer1 add: (Array withAll:#('225 , 50' '450')).
	self questionAnswer1 add: (Array withAll:#('243 , 27' '243')).
	self questionAnswer1 add: (Array withAll:#('900 , 60' '900')).
	self questionAnswer1 add: (Array withAll:#('76 , 30' '1140')).
	self questionAnswer1 add: (Array withAll:#('31 , 310' '310')).
! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 11/7/2008 16:55'!
initQuestionAnswer2
	self questionAnswer2: OrderedCollection new.

	self questionAnswer2 add: (Array withAll:#('17 , 34 , 51' '102')).
	self questionAnswer2 add: (Array withAll:#('27 , 18 , 36' '108')).
	self questionAnswer2 add: (Array withAll:#('6 , 36 , 216' '1')).
	self questionAnswer2 add: (Array withAll:#('9 , 81 , 243' '243')).
	self questionAnswer2 add: (Array withAll:#('2 , 3 , 4' '12')).

	self questionAnswer2 add: (Array withAll:#('6 , 2 , 98' '294')).
	self questionAnswer2 add: (Array withAll:#('5 , 3 , 90' '710')).
	self questionAnswer2 add: (Array withAll:#('64 , 8 , 1' '64')).
	self questionAnswer2 add: (Array withAll:#('2 , 56 , 14' '112')).
	self questionAnswer2 add: (Array withAll:#('12 , 16 , 12' '96')).

	self questionAnswer2 add: (Array withAll:#('78 , 12 , 9' '1044')).
	self questionAnswer2 add: (Array withAll:#('69 , 4 , 30' '780')).
	self questionAnswer2 add: (Array withAll:#('60 , 72 , 40' '720')).
	self questionAnswer2 add: (Array withAll:#('70 , 14 , 49' '980')).
	self questionAnswer2 add: (Array withAll:#('65 , 13 , 26' '130')).
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:00'!
questionAnswer1
	^questionAnswer1! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:00'!
questionAnswer1: anOrderedCollection
	questionAnswer1 := anOrderedCollection! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:00'!
questionAnswer2
	^questionAnswer2! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:00'!
questionAnswer2: anOrderedCollection
	questionAnswer2 := anOrderedCollection! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:42'!
questionDisplay
	^questionDisplay! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:43'!
questionDisplay: anOrderedCollection
	questionDisplay := anOrderedCollection! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:42'!
quSet
	^quSet! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:42'!
quSet: aNumber
	quSet := aNumber! !

!LcmPage5 methodsFor: 'initialization' stamp: 'Aayush 9/9/2008 13:31'!
reset
	self quSet: 1.

	self score contents:'0'.

	self hideObjects.

	self showQuestion.
	self timer reset.
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:00'!
score
	^score! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:01'!
score: aStringMorph
	score := aStringMorph! !

!LcmPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/9/2008 12:50'!
showQuestion
	
	| sPosQ count qPos |

	sPosQ := 5 random.

	count := 1 .
	[count <= 5] whileTrue:
	[
		qPos := ((self quSet - 1) * 5)	+ sPosQ.

		self useQus = 1 ifTrue:
		[
			(self questionDisplay at:count) strMessage contents: ((self questionAnswer1 at:qPos) at:1).
			(self questionDisplay at:count) index:qPos.
			(self questionDisplay at:count) width: (self questionDisplay at:count) strMessage width + 20.
			(self questionDisplay at:count) strMessage center:(self questionDisplay at:count) center.
		]
		ifFalse:
		[
			(self questionDisplay at:count) strMessage contents: ((self questionAnswer2 at:qPos) at:1).
			(self questionDisplay at:count) index:qPos.
			(self questionDisplay at:count) width: (self questionDisplay at:count) strMessage width + 20.
			(self questionDisplay at:count) strMessage center:(self questionDisplay at:count) center.
		].

		sPosQ := sPosQ + 1.
		sPosQ > 5 ifTrue:
		[
			sPosQ := 1.
		].	

		count := count + 1.
	].
	self alignDisplays2.! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:44'!
textBox
	^textBox! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:44'!
textBox: anOrderedCollection
	textBox := anOrderedCollection! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:01'!
timer
	^timer
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/8/2008 16:01'!
timer: aTimerMorph
	timer := aTimerMorph
! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 10:48'!
useQus
	^useQus! !

!LcmPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/9/2008 10:48'!
useQus: aNumber
	useQus:= aNumber! !

PasteUpMorph subclass: #MyButtonTest
	instanceVariableNames: 'button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MyButtonTest methodsFor: 'as yet unclassified' stamp: 'Aayush 7/31/2008 13:20'!
button
	^button! !

!MyButtonTest methodsFor: 'as yet unclassified' stamp: 'Aayush 7/31/2008 13:20'!
button: aMyButton
	button := aMyButton! !

!MyButtonTest methodsFor: 'as yet unclassified' stamp: 'Aayush 7/31/2008 13:24'!
initialize
	super initialize.
	self button:MyButton new.
	self addMorph: self button.
	self button label:'Click Me'.
	self button initImageOver:'over' Down:'down' Up:'up'.
	self button initReceiver:nil enterSelector:nil leaveSelector:nil downSelector:nil upSelector:nil.
! !

PasteUpMorph subclass: #NoticeReadingActivity
	instanceVariableNames: 'page2 btnNext btnPrevious currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-NoticeReadingActivity'!

!NoticeReadingActivity methodsFor: 'miscellaneous' stamp: 'Aayush 10/2/2008 16:06'!
btnNextClick: index 
	
	self currentPage = 1	ifTrue: 
	[
		self hide.

		self page2 show.
		self page2 reset.

		self btnPrevious show.
		self btnNext hide.

		self currentPage: 2
	]
! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:11'!
btnNext
	^btnNext! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:28'!
btnNext: aButton
	btnNext := aButton! !

!NoticeReadingActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/23/2008 10:24'!
btnPreviousClick: index 
	self currentPage = 2	ifTrue: 
	[
		self page2 hide.

		self show.

		self btnPrevious hide.
		self btnNext show.

		self currentPage: 1
	].! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:27'!
btnPrevious
	^btnPrevious! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:28'!
btnPrevious: aButton
	btnPrevious := aButton! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:13'!
currentPage
	^currentPage! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:13'!
currentPage: aNumber
	currentPage := aNumber! !

!NoticeReadingActivity methodsFor: 'initialization' stamp: 'Aayush 9/19/2008 10:58'!
initCostume
	self btnNext initImageOver:'nextOver' Down:'nextDown' Up:'nextUp'.
	self btnPrevious initImageOver:'previousOver' Down:'previousDown' Up:'previousUp'.
! !

!NoticeReadingActivity methodsFor: 'initialization' stamp: 'Aayush 10/2/2008 13:49'!
initialize
	super initialize.
	
	self btnNext: MyButton new openInWorld.
	self btnNext initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnNextClick:.
	self btnPrevious: MyButton new openInWorld.
	self btnPrevious initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnPreviousClick:.
! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:10'!
page2
	^page2! !

!NoticeReadingActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:29'!
page2:aPage
	page2 :=aPage! !

!NoticeReadingActivity methodsFor: 'initialization' stamp: 'Aayush 9/23/2008 10:23'!
reset
	self show.
	self page2 hide.
	
	self currentPage:1.

	self btnNext show.
	self btnPrevious hide.
! !

!NoticeReadingActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/19/2008 13:00'!
test
	self page2: NoticeReadingPage2 new openInWorld.! !

PasteUpMorph subclass: #NoticeReadingPage2
	instanceVariableNames: 'displayBoardQus displayBoardOpt imgCheck btnSelectAns btnConfirm btnNextAns btnShowCorrect question lblQusNo currentQus qusPool stReasult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-NoticeReadingActivity'!

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:10'!
btnAnsSelectClick:index
	self btnConfirm show.
! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/17/2008 10:07'!
btnConfirmClick:index
	| n |
	(self question at:(self currentQus)) xIndex: (self displayBoardOpt at:(self btnSelectAns selectedIndex)) index.

	self currentQus: self getQusNo.

	self currentQus = 0 ifTrue:
	[
		self btnConfirm hide.
		
		n := self getNoOfCorrect.
		(self stReasult at:2) contents: 'Correct answers: ' ,n asString.
		(self stReasult at:1) contents: 'Attempted questions: 10'.

		(self stReasult at:1) show.
		(self stReasult at:2) show.

		n < 10 ifTrue:
		[
			self btnShowCorrect show.
		].

		self removeEventHandlers.
		self btnSelectAns enable:false.
	]
	ifFalse:
	[
		self showQuestion.
		self btnSelectAns select:0.
	].

	self btnConfirm hide.! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 11:03'!
btnConfirm
	^btnConfirm! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 11:03'!
btnConfirm: aButton
	btnConfirm := aButton! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:58'!
btnNextAnsClick:index
	| count extName |
	self currentQus:self getQusNo.

	self currentQus = 0 ifTrue:
	[
		self btnShowCorrectClick:0.
	]
	ifFalse:
	[
		self showQuestion.

		(self question at:(self currentQus)) xIndex = (self question at:(self currentQus)) cIndex ifTrue:
		[
			count := 1.
			[count <= 4] whileTrue:
			[
				(self question at:(self currentQus)) xIndex = (self displayBoardOpt at:count) index ifTrue:
				[
					self btnSelectAns select:count.	

					extName := 'Check'.
					World allMorphsDo: 
					[	
						:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
						ifTrue:
 						[
							(self imgCheck at:count)  wearCostume: t2.
						]
					].
					(self imgCheck at:count) show.
				]
				ifFalse:
				[
					(self imgCheck at:count) hide.			
				].

				count := count + 1.
			]
		]
		ifFalse:
		[
			count := 1.
			[count <= 4] whileTrue:
			[
				(self question at:(self currentQus)) xIndex = (self displayBoardOpt at:count) index ifTrue:
				[
					self btnSelectAns select:count.	

					extName := 'Cross'.
					World allMorphsDo: 
					[	
						:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
						ifTrue:
 						[
							(self imgCheck at:count)  wearCostume: t2.
						]
					].
					(self imgCheck at:count) show.
				]
				ifFalse:
				[
					(self question at:(self currentQus)) cIndex = (self displayBoardOpt at:count) index ifTrue:
					[
						extName := 'Check'.
						World allMorphsDo: 
						[	
							:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
							ifTrue:
 							[
								(self imgCheck at:count)  wearCostume: t2.
							]
						].
						(self imgCheck at:count) show.
					]
					ifFalse:
					[
						(self imgCheck at:count) hide.
					]
				].
			
				count := count + 1.
			]
		]
	].
	self btnConfirm hide.! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:50'!
btnNextAns
	^btnNextAns! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 11:30'!
btnNextAns: aButton
	btnNextAns := aButton! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 12:06'!
btnSelectAns
	^btnSelectAns! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 12:08'!
btnSelectAns: aRadioButton
	btnSelectAns := aRadioButton! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 15:00'!
btnShowCorrectClick:index

	| count |
	self lblQusNo contents:'0'.

	[self qusPool size >= 1] whileTrue:
	[
		self qusPool removeFirst.
	].

	count := 1.
	[count <= self question size] whileTrue:
	[
		self qusPool add: count.
		count := count + 1.
	].

	self btnNextAnsClick:0.

	self btnNextAns show.
	self btnShowCorrect hide.
! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:53'!
btnShowCorrect
	^btnShowCorrect! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:53'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 10:04'!
currentQus
	^currentQus! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 10:04'!
currentQus: aNumber
	currentQus := aNumber! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:43'!
displayBoardOptClick:index v2:x v3:y
	self btnSelectAns select:index.! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:44'!
displayBoardOptMouseEnter:index v2:x v3:y
	| count |
	count := 1.
	[count <= 4] whileTrue:
	[
		count = index ifTrue:
		[
			(self displayBoardOpt at:count) color:(Color r: 0.742 g: 0.548 b: 1.0).
		]
		ifFalse:
		[
			(self displayBoardOpt at:count) color: (Color r: 0.613 g: 0.903 b: 1.0).
		].
		count := count + 1.
	]! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:44'!
displayBoardOptMouseLeave:index v2:x v3:y
	(self displayBoardOpt at:index) color: (Color r: 0.613 g: 0.903 b: 1.0).! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:49'!
displayBoardOpt
	^displayBoardOpt! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2008 12:57'!
displayBoardOpt: anOrderedCollection
	displayBoardOpt := anOrderedCollection! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:49'!
displayBoardQus
	^displayBoardQus! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:54'!
displayBoardQus: aDisplayBoard
	displayBoardQus := aDisplayBoard! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:49'!
doNothing
! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 14:24'!
fontName:f size:s
	self displayBoardQus strMessage fontName:f size:s.

	(self displayBoardOpt at:1) strMessage fontName:f size:s.
	(self displayBoardOpt at:2) strMessage fontName:f size:s.
	(self displayBoardOpt at:3) strMessage fontName:f size:s.
	(self displayBoardOpt at:4) strMessage fontName:f size:s.

	self lblQusNo fontName:f size:s.! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 10:55'!
getNoOfCorrect

	| size count correct |
	size := self question size.
	count := 1.
	correct := 0.

	[count <= size] whileTrue:
	[
		(self question at:count) cIndex = (self question at:count) xIndex ifTrue:
		[
			correct := correct + 1.
		].
		
		count := count + 1.
	].

	^correct.! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/19/2005 16:08'!
getQusNo
	| x y |
	x := (self qusPool size) random.
	
	x > 0 ifTrue:
	[
		y := self qusPool at:x.
		self qusPool removeAt:x.
		^y.
	]
	ifFalse:
	[
		^x
	]
! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:50'!
imgCheck
	^imgCheck! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2008 12:57'!
imgCheck: aDisplayBoard
	imgCheck := aDisplayBoard! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/23/2008 10:20'!
initCostume
	self btnConfirm initImageOver:'confirmEOver' Down:'confirmEDown' Up:'confirmEUp'.
	self btnNextAns initImageOver:'nextAnsOver' Down:'nextAnsDown' Up:'nextAnsUp'.
	self btnShowCorrect initImageOver:'tellAnsOver' Down:'tellAnsDown' Up:'tellAnsUp'.
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/19/2008 09:51'!
initDisplayBoards
	self displayBoardOpt: OrderedCollection new.

	self displayBoardOpt add: DisplayBoardR new.
	self addMorph: (self displayBoardOpt at:1).
	self displayBoardOpt add: DisplayBoardR new.
	self addMorph: (self displayBoardOpt at:2).
	self displayBoardOpt add: DisplayBoardR new.
	self addMorph: (self displayBoardOpt at:3).
	self displayBoardOpt add: DisplayBoardR new.
	self addMorph: (self displayBoardOpt at:4).

	self displayBoardQus:  DisplayBoardR new.
	self addMorph:self displayBoardQus.
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/22/2008 14:45'!
initEventHandlers
	(self displayBoardOpt at:1) on:#mouseUp send:#displayBoardOptClick:v2:v3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseUp send:#displayBoardOptClick:v2:v3: to:self withValue:2.	
	(self displayBoardOpt at:3) on:#mouseUp send:#displayBoardOptClick:v2:v3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseUp send:#displayBoardOptClick:v2:v3: to:self withValue:4.

	(self displayBoardOpt at:1) on:#mouseEnter send:#displayBoardOptMouseEnter:v2:v3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseEnter send:#displayBoardOptMouseEnter:v2:v3: to:self withValue:2.
	(self displayBoardOpt at:3) on:#mouseEnter send:#displayBoardOptMouseEnter:v2:v3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseEnter send:#displayBoardOptMouseEnter:v2:v3: to:self withValue:4.

	(self displayBoardOpt at:1) on:#mouseLeave send:#displayBoardOptMouseLeave:v2:v3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseLeave send:#displayBoardOptMouseLeave:v2:v3: to:self withValue:2.
	(self displayBoardOpt at:3) on:#mouseLeave send:#displayBoardOptMouseLeave:v2:v3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseLeave send:#displayBoardOptMouseLeave:v2:v3: to:self withValue:4.
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/18/2008 17:11'!
initImgCheck
	self imgCheck: OrderedCollection new.
	
	self imgCheck add: SketchMorph new.
	self addMorph: (self imgCheck at:1).
	self imgCheck add: SketchMorph new.
	self addMorph: (self imgCheck at:2).
	self imgCheck add: SketchMorph new.
	self addMorph: (self imgCheck at:3).
	self imgCheck add: SketchMorph new.
	self addMorph: (self imgCheck at:4).
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/25/2008 15:15'!
initialize
	super initialize.

	self btnSelectAns: RadioButton new.
	self addMorph:self btnSelectAns.
	self btnSelectAns initName:'Ans' Receiver:self Selector:#btnAnsSelectClick: sImageName:'imgS' usImageName:'imgUS'.
	self btnSelectAns addItem: '1'.
	self btnSelectAns addItem: '2'.
	self btnSelectAns addItem: '3'.
	self btnSelectAns addItem: '4'.

	self stReasult: OrderedCollection new.
	self stReasult add: StringMorph new.
	self addMorph: (self stReasult at:1).
	self stReasult add: StringMorph new.
	self addMorph: (self stReasult at:2).

	self qusPool: OrderedCollection new.

	self lblQusNo: StringMorph new.
	self addMorph:self lblQusNo.

	self btnConfirm: MyButton new.
	self addMorph:self btnConfirm.
	self btnConfirm initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnConfirmClick:.

	self btnNextAns: MyButton new.
	self addMorph:self btnNextAns.
	self btnNextAns initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnNextAnsClick:.

	self btnShowCorrect: MyButton new.
	self addMorph:self btnShowCorrect.
	self btnShowCorrect initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnShowCorrectClick:.

	self initQuestion.
	self initImgCheck.
	self initDisplayBoards.
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 12:06'!
initQuestion
	self question: OrderedCollection new.

	self question add: (NoticeReadingQuestion new).
	(self question at:1) question: 'Who are invited for the meeting ?'.

	(self question at:1) option add: 'Forest'.
	(self question at:1) option add: 'Members'.
	(self question at:1) option add: 'Group'.
	(self question at:1) option add: 'Patle'.

	(self question at:1) cIndex:2.
	(self question at:1) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:2) question: 'What is the name of the community forest mentioned in the notice ?'.
	(self question at:2) option add: 'Logging'.
	(self question at:2) option add: 'User group'.
	(self question at:2) option add: 'Patle'.
	(self question at:2) option add: 'Shree chandi'.

	(self question at:2) cIndex:3.
	(self question at:2) xIndex:0.

	self question add: (NoticeReadingQuestion new).

	(self question at:3) question: 'What is the subject of the discussion ?'.
	(self question at:3) option add: 'Illegal logging'.
	(self question at:3) option add: 'Landslide'.
	(self question at:3) option add: 'Conflict'.
	(self question at:3) option add: 'Hunger'.

	(self question at:3) cIndex:1.
	(self question at:3) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:4) question: 'What time is the meeting going to start ?'.
	(self question at:4) option add: '7:15 AM'.
	(self question at:4) option add: '6:00 PM'.
	(self question at:4) option add: '7:15 AM'.
	(self question at:4) option add: '6:00 AM'.

	(self question at:4) cIndex:4.
	(self question at:4) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:5) question: 'What time is the meeting ending ?'.
	(self question at:5) option add: '21 Mangsir'.
	(self question at:5) option add: '2065'.
	(self question at:5) option add: '6:00 AM'.
	(self question at:5) option add: '7:15 AM'.

	(self question at:5) cIndex:4.
	(self question at:5) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:6) question: 'What is the name of the school where the meeting is going to take place ?'.
	(self question at:6) option add: 'Patle'.
	(self question at:6) option add: 'Kavre'.
	(self question at:6) option add: 'Shree chandi'.
	(self question at:6) option add: 'Community'.

	(self question at:6) cIndex:3.
	(self question at:6) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:7) question: 'Where is th illegal logging taking place ?'.
	(self question at:7) option add: 'In patle community forest'.
	(self question at:7) option add: 'In village near Patle communuty forest'.
	(self question at:7) option add: 'In Shree chandi primary school'.
	(self question at:7) option add: 'In city Patle communuty forest'.

	(self question at:7) cIndex:1.
	(self question at:7) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:8) question: 'On what date is the meeting called ?'.
	(self question at:8) option add: '21 Mangsir, 2006'.
	(self question at:8) option add: '21 Magh, 2065'.
	(self question at:8) option add: '21 Mangsir, 2064'.
	(self question at:8) option add: '21 Mangsir, 2065'.

	(self question at:8) cIndex:4.
	(self question at:8) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:9) question: 'Where is the venue for the meeting ?'.
	(self question at:9) option add: 'Patle community forest'.
	(self question at:9) option add: 'Kavre'.
	(self question at:9) option add: 'Shree chandi primery school'.
	(self question at:9) option add: 'User groups village'.

	(self question at:9) cIndex:3.
	(self question at:9) xIndex:0.

	self question add: (NoticeReadingQuestion new).
	(self question at:10) question: 'What does "the area" in the last sentence of the notice imply ?'.
	(self question at:10) option add: 'Shree chandi primary school'.
	(self question at:10) option add: 'Patle community forrest'.
	(self question at:10) option add: 'Kavre'.
	(self question at:10) option add: 'The house around patle community forrest'.

	(self question at:10) cIndex:2.
	(self question at:10) xIndex:0.
! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:35'!
lblQusNo
	^lblQusNo! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 13:41'!
lblQusNo: aStringMoprh
	lblQusNo := aStringMoprh! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2005 12:52'!
question
	^question! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/18/2008 14:10'!
question: anOrderedCollection
	question := anOrderedCollection! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 14:34'!
qusPool
	^qusPool! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2008 14:35'!
qusPool: anOrderedCollection
	qusPool := anOrderedCollection
! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/22/2008 15:05'!
removeEventHandlers
	(self displayBoardOpt at:1) on:#mouseUp send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseUp send:#doNothing to:self.	
	(self displayBoardOpt at:3) on:#mouseUp send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseUp send:#doNothing to:self.

	(self displayBoardOpt at:1) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:3) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseEnter send:#doNothing to:self.

	(self displayBoardOpt at:1) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:3) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseLeave send:#doNothing to:self.
! !

!NoticeReadingPage2 methodsFor: 'initialization' stamp: 'Aayush 9/22/2008 14:56'!
reset
	| count |
	self btnConfirm hide.
	self btnShowCorrect hide.
	self btnNextAns hide.

	self lblQusNo contents:'0'.

	count := 1.
	[count <= self question size] whileTrue:
	[
		(self question at:count) xIndex:0.
		count := count + 1.
	].
	
	[self qusPool size >= 1] whileTrue:
	[
		self qusPool removeFirst.
	].

	count := 1.
	[count <= self question size] whileTrue:
	[
		self qusPool add: count.
		count := count + 1.
	].

	count := 1.
	[count <= self imgCheck size] whileTrue:
	[
		(self imgCheck at:count) hide.
		count := count + 1.
	].

	self currentQus:self getQusNo.
	self btnSelectAns enable:true.

	self showQuestion.
	self btnSelectAns select:0.

	(self stReasult at:1) hide.
	(self stReasult at:2) hide.

	self initEventHandlers.! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/19/2005 15:46'!
showQuestion
	| st count |

	self lblQusNo contents: (self lblQusNo contents asInteger + 1) asString.
	self displayBoardQus strMessage contents: (self question at:(self currentQus)) question.

	st := 4 random.
	count := 1.
	[count <= 4] whileTrue:
	[
		(self displayBoardOpt at:st) strMessage contents: ((self question at:(self currentQus)) option at:count).
		(self displayBoardOpt at:st) index: count.
		st := st + 1.

		st > 4 ifTrue:
		[
			st := 1.
		].

		count := count + 1.
	].
! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2005 16:40'!
stReasult
	^stReasult! !

!NoticeReadingPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/19/2005 16:41'!
stReasult: anOrderedCollection
	stReasult := anOrderedCollection! !

!NoticeReadingPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/17/2008 09:58'!
test
	(self question at:1) question: 'Who are invited to the meeting ?'.
	(self question at:1) option at:1 put: 'Forest'.
	(self question at:1) option at:2 put: 'Members'.
	(self question at:1) option at:3 put: 'Group'.
	(self question at:1) option at:4 put: 'Patle'.
	(self question at:1) cIndex:2.
	(self question at:1) xIndex:0.

	(self question at:2) question: 'What is the name of the Community Forest mentioned in the notice ?'.
	(self question at:2) option at:1 put: 'Logging'.
	(self question at:2) option at:2 put: 'User group'.
	(self question at:2) option at:3 put: 'Patle'.
	(self question at:2) option at:4 put: 'Shree Chandi'.
	(self question at:2) cIndex:3.
	(self question at:2) xIndex:0.

	(self question at:3) question: 'What is the subject of the discussion ?'.
	(self question at:3) option at:1 put: 'Illegal logging'.
	(self question at:3) option at:2 put: 'Landslide'.
	(self question at:3) option at:3 put: 'Conflict'.
	(self question at:3) option at:4 put: 'Hunger'.
	(self question at:3) cIndex:1.
	(self question at:3) xIndex:0.

	(self question at:4) question: 'At what time is the meeting going to start ?'.
	(self question at:4) option at:1 put: '7:15 AM'.
	(self question at:4) option at:2 put: '6:00 PM'.
	(self question at:4) option at:3 put: '7:15 AM'.
	(self question at:4) option at:4 put: '6:20 AM'.
	(self question at:4) cIndex:4.
	(self question at:4) xIndex:0.

	(self question at:5) question: 'At what time is the meeting ending ?'.
	(self question at:5) option at:1 put: '21 Mangsir'.
	(self question at:5) option at:2 put: '2065'.
	(self question at:5) option at:3 put: '6:00 AM'.
	(self question at:5) option at:4 put: '7:15 AM'.
	(self question at:5) cIndex:4.
	(self question at:5) xIndex:0.

	(self question at:6) question: 'What is the name of the school where the meeting is going to take place ?'.
	(self question at:6) option at:1 put: 'Patle'.
	(self question at:6) option at:2 put: 'Kavre'.
	(self question at:6) option at:3 put: 'Shree Chandi'.
	(self question at:6) option at:4 put: 'Community'.
	(self question at:6) cIndex:3.
	(self question at:6) xIndex:0.

	(self question at:7) question: 'Where is the illegal logging taking place ?'.
	(self question at:7) option at:1 put: 'In Patle Community Forest'.
	(self question at:7) option at:2 put: 'In the village near Patle Communuty Forest'.
	(self question at:7) option at:3 put: 'In Shree Chandi Primary School'.
	(self question at:7) option at:4 put: 'In the city near Patle Community Forest'.
	(self question at:7) cIndex:1.
	(self question at:7) xIndex:0.

	(self question at:8) question: 'On which date is the meeting being held ?'.
	(self question at:8) option at:1 put: '21 Mangsir, 2006'.
	(self question at:8) option at:2 put: '21 Magh, 2065'.
	(self question at:8) option at:3 put: '21 Mangsir, 2064'.
	(self question at:8) option at:4 put: '21 Mangsir, 2065'.
	(self question at:8) cIndex:4.
	(self question at:8) xIndex:0.

	(self question at:9) question: 'Where is the venue for the meeting ?'.
	(self question at:9) option at:1 put: 'Patle Community Forest'.
	(self question at:9) option at:2 put: 'Kavre'.
	(self question at:9) option at:3 put: 'Shree Chandi Primary School'.
	(self question at:9) option at:4 put: 'User groups village'.
	(self question at:9) cIndex:3.
	(self question at:9) xIndex:0.

	(self question at:10) question: 'What does "the area" in the last sentence of the notice refer to ?'.
	(self question at:10) option at:1 put: 'Shree Chandi Primary School'.
	(self question at:10) option at:2 put: 'Patle Community Forest'.
	(self question at:10) option at:3 put: 'Kavre'.
	(self question at:10) option at:4 put: 'The house around Patle Community Forest'.
	(self question at:10) cIndex:2.
	(self question at:10) xIndex:0.
! !

PasteUpMorph subclass: #ObjectSetMorph
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:33'!
initialize
	super initialize.
	self resetObjectSequence.! !

!ObjectSetMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 15:32'!
installNewTallyMorph
	| object |
	objects atEnd ifTrue: [^self].
	object := objects next.
	World allMorphsDo: [ :m | (m isKindOf: TallyMorph) ifTrue: [m setTallyObject: object] ].! !

!ObjectSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 15:31'!
resetObjectSequence
	objects := self submorphs readStream.! !

!PasteUpMorph class methodsFor: '*ole-scripting' stamp: 'lg 10/31/2007 16:07'!
additionsToViewerCategoryGameInstrument
	^ #().
! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 13:52'!
animalNames
	^self  submorphs collect:
	[:morph| morph externalName]! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:55'!
gameValue
	^self submorphs size! !

!PasteUpMorph methodsFor: '*ole-flaps' stamp: 'lg 12/4/2007 11:11'!
hideFlaps
	self submorphs do: [ :m | m class = FlapTab ifTrue: [m hide]].! !

!PasteUpMorph methodsFor: '*ole-override' stamp: 'lg 12/23/2007 21:37'!
installFlaps
	"Get flaps installed within the bounds of the receiver"

	| localFlapTabs |
	Project current assureFlapIntegrity.
	self addGlobalFlaps.
	localFlapTabs := self localFlapTabs.
	localFlapTabs do: [:each | each visible: false].

	Preferences eToyFriendly ifTrue: [
		ProgressInitiationException display: 'Building Viewers...' translated
			during: [:bar |
				localFlapTabs keysAndValuesDo: [:i :each |
					each adaptToWorld.
					each setVisibilityByMode.
					self displayWorld.
					bar value: i / self localFlapTabs size]].
	] ifFalse: [
		localFlapTabs keysAndValuesDo: [:i :each |
			each adaptToWorld.
			each setVisibilityByMode.
			self displayWorld]].

	OLE updateSugarToolbar.
	self assureFlapTabsFitOnScreen.
	self bringTopmostsToFront! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 16:28'!
makeAnimalButton:label
	^AnimalButton new label:label.
! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 12/24/2007 09:58'!
setGameValue: n tallyObject: object
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object costume duplicate beSticky ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*ole-game' stamp: 'lg 11/1/2007 08:36'!
setGameValue: n
	| object |
	object := self submorphs first.
	self removeAllMorphs.
	n timesRepeat: [ self addMorph: object duplicate ].
	self spreadMorphs.! !

!PasteUpMorph methodsFor: '*OLE' stamp: 'ss 10/5/2007 15:32'!
showAnimalNames
	|row|
	row:= AlignmentMorph inARow:
			(self animalNames collect:[:label| self makeAnimalButton:label]).
	row openInWorld; position: 200@600
       ! !

!PasteUpMorph methodsFor: '*ole-project loading' stamp: 'lg 12/18/2007 07:48'!
showLinksToProjectsInDirectory: dirName 
	self removeAllMorphs.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.
	self addLinksToProjectsInDirectory: dirName.
! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject
	^self valueOfProperty: #tallyObject! !

!PasteUpMorph methodsFor: '*ole-game-element' stamp: 'lg 10/29/2007 15:59'!
tallyObject: object
	^self setProperty: #tallyObject toValue: object! !

PasteUpMorph subclass: #PicturePuzzleBlockMorph
	instanceVariableNames: 'interiorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:43'!
hasRightPiece
	^self submorphs anySatisfy: [ :morph | (self valueOfProperty: #puzzlePosition) = (morph valueOfProperty: #puzzlePosition)].
 ! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/11/2007 17:39'!
initialize
	super initialize.
	self color: World color.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:24'!
isInteriorBlock
	^interiorBlock.! !

!PicturePuzzleBlockMorph methodsFor: 'puzzle' stamp: 'lg 10/9/2007 21:23'!
isInteriorBlock: flag 
	interiorBlock := flag.! !

PasteUpMorph subclass: #ProjectDirectoryMorph
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 12:44'!
expungeChildProjects
	self shouldBeImplemented! !

!ProjectDirectoryMorph class methodsFor: 'class initialization' stamp: 'lg 1/29/2008 13:06'!
startUp
	Smalltalk isMorphic ifTrue:
		[World allMorphsDo:
			[:m | (m isKindOf: ProjectDirectoryMorph) ifTrue: [m updateDirectoryListing]]].! !

!ProjectDirectoryMorph class methodsFor: 'updating' stamp: 'lg 12/18/2007 16:49'!
updateAllDirectoryListings
	WorldState addDeferredUIMessage: [Project removeAllButCurrent.].
	World allMorphsDo:
		[ :m | (m isKindOf: self) ifTrue: [m updateDirectoryListing] ].! !

!ProjectDirectoryMorph class methodsFor: 'projects' stamp: 'lg 12/20/2007 17:55'!
updateDirectoryListings
	World allMorphsDo: [ :m |
		(m isKindOf: self) ifTrue: [m updateDirectoryListing] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'ss 4/11/2008 15:07'!
addLinksToProjectsInDirectory: dirName 
	| dir subdirNames |
	dir := FileDirectory on: (Smalltalk imagePath, FileDirectory slash, dirName).
	subdirNames := dir directoryNames sort collect: [ :sub | dirName, FileDirectory slash, sub ].
	subdirNames do: [ :subdir |
		(Project linksForDirectory: subdir) ifNotNilDo:
			[ :linksMorph | self addMorphBack: linksMorph ] ]! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/18/2007 08:09'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new; listDirection: #topToBottom; cellInset: 10; cellPositioning: #topLeft.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 12/20/2007 20:42'!
showDirectory: dirName
	directory := dirName.
	self removeAllMorphs.
	self addLinksToProjectsInDirectory: dirName.! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 1/29/2008 12:36'!
startUp
	self updateDirectoryListing! !

!ProjectDirectoryMorph methodsFor: 'initialization' stamp: 'lg 1/29/2008 12:36'!
updateDirectoryListing
	directory ifNotNil: [self showDirectory: directory].! !

!ProjectDirectoryMorph class methodsFor: 'class initialization' stamp: 'lg 1/29/2008 12:35'!
initialize
	super initialize.
	Smalltalk addToStartUpList: ProjectDirectoryMorph.
! !

PasteUpMorph subclass: #QuestionListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

PasteUpMorph subclass: #QuestionSetMorph
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!QuestionSetMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 08:20'!
questions
	^(self submorphs collect: #duplicate) readStream.! !

PasteUpMorph subclass: #TallyMorph
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

TallyMorph subclass: #TallyAnswerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
handlesMouseDown: event
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:38'!
isGameChoice
	^true! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:37'!
isGameInput
	^false! !

!TallyAnswerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 11:41'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:55'!
getGameValue
	^ (self submorphs select: [ :m | (m isKindOf: SimpleHighlightMorph) not]) size.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
increment
	self setGameValue: self getGameValue + 1! !

!TallyMorph methodsFor: 'initialization' stamp: 'lg 10/11/2007 12:22'!
initialize
	super initialize.
! !

!TallyMorph methodsFor: 'game' stamp: ''!
isGameInput
	^ true! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 11:58'!
removeAllObjects
	self submorphs do: [ :m | (m isKindOf: SimpleHighlightMorph) ifFalse: [self removeMorph: m]].! !

!TallyMorph methodsFor: 'game' stamp: 'lg 10/14/2007 12:02'!
setGameValue: n
	self removeAllObjects.
	n timesRepeat: [ self addMorph: tallyObject duplicate beSticky].
	self spreadMorphs.! !

!TallyMorph methodsFor: 'objects' stamp: 'lg 10/11/2007 11:29'!
setTallyObject: object
	tallyObject := object.! !

PasteUpMorph subclass: #TriangleClassificationActivity
	instanceVariableNames: 'page currentPage btnNext btnPrevious ruler protractor line strValue mark1 mark2 start secondPassed btnNextText dispObject seqId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 15:38'!
btnNextClick: index 
	self currentPage = 7	ifTrue: 
	[
"		(self page at:7) reset.
"		(self page at:7) hide.

		(self page at:8) show.
		(self page at:8) reset.

		self btnPrevious show.
		self btnNext hide.

		self currentPage: 8
	].

	self currentPage = 6	ifTrue: 
	[
		(self page at:6) reset.
		(self page at:6) hide.

		(self page at:7) show.
		(self page at:7) reset.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 7
	].

	self currentPage = 5	ifTrue: 
	[
		(self page at:5) reset.
		(self page at:5) hide.

		(self page at:6) show.
		(self page at:6) reset.
		(self page at:6) start:true.
		(self page at:6) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 6
	].
	
	self currentPage = 4	ifTrue: 
	[
		(self page at:4) reset.
		(self page at:4) hide.

		(self page at:5) show.
		(self page at:5) reset.
		(self page at:5) start:true.
		(self page at:5) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 5
	].
	
	self currentPage = 3	ifTrue: 
	[
		(self page at:3) reset.
		(self page at:3) hide.

		(self page at:4) show.
		(self page at:4) reset.
		(self page at:4) start:true.
		(self page at:4) startStepping.

		self btnPrevious show.
		self btnNext show.
	
		self currentPage: 4
	].
	
	self currentPage = 2	ifTrue: 
	[
		(self page at:2) reset.
		(self page at:2) hide.

		(self page at:3) show.

		(self page at:3) reset.
		(self page at:3) start:true.
		(self page at:3) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 3
	].
	
	self currentPage = 1	ifTrue: 
	[
		self reset.
		self hide.

		(self page at:2) show.
		(self page at:2) reset.
		(self page at:2) start:true.
		(self page at:2) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 2
	]! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:15'!
btnNextTextClick: index 
	self seqId = 2 ifTrue:
	[
		self btnNextText hide.
		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		self protractor show.
		self protractor reset.
		self protractor player setLocationRounded:(734@276).
		self protractor player setHeadingTheta:90.

		self protractor index:1.
		self protractor left2Right:false.
		self protractor targetAngle:60.
		self protractor start:true.
		self protractor startStepping.

		self btnNextText hide.
		self start:true.
		self startStepping.

		self seqId:2.
	].
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:19'!
btnNextText
	^btnNextText! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:19'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:13'!
btnNext
	^btnNext! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:13'!
btnNext: aButton
	btnNext := aButton! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 15:37'!
btnPreviousClick: index 
	self currentPage = 2	ifTrue: 
	[
		(self page at:2) reset.
		(self page at:2) hide.

		self show.
		self start: true.
		self startStepping.
		self btnPrevious hide.
		self btnNext show.
		self currentPage: 1
	].

	self currentPage = 3	ifTrue: 
	[
		(self page at:3) reset.
		(self page at:3) hide.

		(self page at:2) show.
		(self page at:2) start: true.
		(self page at:2) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 2
	].

	self currentPage = 4	ifTrue: 
	[
		(self page at:4) reset.
		(self page at:4) hide.

		(self page at:3) show.
		(self page at:3) start: true.
		(self page at:3) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 3
	].

	self currentPage = 5	ifTrue: 
	[
		(self page at:5) reset.
		(self page at:5) hide.

		(self page at:4) show.
		(self page at:4) start: true.
		(self page at:4) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 4
	].

	self currentPage = 6	ifTrue: 
	[
		(self page at:6) reset.
		(self page at:6) hide.

		(self page at:5) show.
		(self page at:5) start: true.
		(self page at:5) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 5
	].

	self currentPage = 7	ifTrue: 
	[
"		(self page at:7) reset.
"		(self page at:7) hide.

		(self page at:6) show.
		(self page at:6) start: true.
		(self page at:6) startStepping.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 6
	].

	self currentPage = 8	ifTrue: 
	[
		(self page at:8) reset.
		(self page at:8) hide.

		(self page at:7) show.
		(self page at:7) reset.

		self btnPrevious show.
		self btnNext show.

		self currentPage: 7
	].
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:16'!
btnPrevious
	^btnPrevious! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:15'!
btnPrevious: aButton
	btnPrevious := aButton! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:12'!
currentPage
	^currentPage! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/10/2008 16:13'!
currentPage: aNumber
	currentPage := aNumber! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:22'!
dispObject
	^dispObject! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:23'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationActivity methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 12:21'!
initCostume
	| extName |

	self btnNext initImageOver:'nextOver' Down:'nextDown' Up:'nextUp'.
	self btnPrevious initImageOver:'previousOver' Down:'previousDown' Up:'previousUp'.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	self protractor initCostume.

	extName := 'ruler'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			self ruler wearCostume: t2.
		]
	].

	extName := 'mark1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark1 at:1)  wearCostume: t2.
			(self mark1 at:2)  wearCostume: t2.
			(self mark1 at:3)  wearCostume: t2.
		]
	].

	extName := 'p1-m2-1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark2 at:1)  wearCostume: t2.
		]
	].

	extName := 'p1-m2-2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark2 at:2)  wearCostume: t2.
		]
	].
			
	extName := 'p1-m2-3'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark2 at:3)  wearCostume: t2.
		]
	].

	extName := 'p1-t1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self imgText at:1)  wearCostume: t2.
		]
	].

	extName := 'p1-t2'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self imgText at:2)  wearCostume: t2.
		]
	].
! !

!TriangleClassificationActivity methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 12:51'!
initialize
	super initialize.
	self start:false.
	self secondPassed:0.

	self ruler: SketchMorph new.
	self addMorph: self ruler.

	self protractor: Protractor new.
	self protractor initEventReceiver: self Selector: #protractorComplete:.
	self addMorph: self protractor.

	self btnNext: MyButton new openInWorld.
	self btnNext initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnNextClick:.
	self btnPrevious: MyButton new openInWorld.
	self btnPrevious initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnPreviousClick:.

	self btnNextText: MyButton new.
	self addMorph:btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at: 1) verticesAt: 1 put: 0 @ 0.
	(self line at: 1) verticesAt: 2 put: 300 @ 0.
	self addMorph: (self line at: 1).
	self line add: LineMorph new.
	(self line at: 2) verticesAt: 1 put: 0 @ 0.
	(self line at: 2) verticesAt: 2 put: 300 @ 0.
	self addMorph: (self line at: 2).
	self line add: LineMorph new.
	(self line at: 3) verticesAt: 1 put: 0 @ 0.
	(self line at: 3) verticesAt: 2 put: 300 @ 0.
	self addMorph: (self line at: 3).

	self strValue: OrderedCollection new.
	self strValue add: StringMorph new.
	(self strValue at: 1) contents: '10 cm'.
	self addMorph: (self strValue at: 1).
	self strValue add: StringMorph new.
	(self strValue at: 2) contents: '10 cm'.
	self addMorph: (self strValue at: 2).
	self strValue add: StringMorph new.
	(self strValue at: 3) contents: '10 cm'.
	self addMorph: (self strValue at: 3).

	self mark1: OrderedCollection new.
	self mark1 add: SketchMorph new.
	self addMorph: (self mark1 at: 1).
	self mark1 add: SketchMorph new.
	self addMorph: (self mark1 at: 2).
	self mark1 add: SketchMorph new.
	self addMorph: (self mark1 at: 3).
	self mark2: OrderedCollection new.
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 1).
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 2).
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 3).
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:07'!
line
	^line
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:08'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:15'!
mark1
	^mark1! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:13'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:15'!
mark2
	^mark2! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:13'!
mark2: anOrderedCollection
	mark2 := anOrderedCollection! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/2/2008 10:50'!
page
	^page! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 10/2/2008 10:50'!
page: anOrderedCollection
	page := anOrderedCollection! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 16:13'!
protractorComplete:index
	(self mark2 at:index) show.

	index = 1 ifTrue:
	[
		self protractor player setLocationRounded:(432@276).
		self protractor player setHeadingTheta:90.
		self protractor index:2.
		self protractor left2Right:true.
		self protractor targetAngle:60.
		self protractor start:true.
		self protractor startStepping.
	]
	ifFalse:
	[
		(self dispObject at:3) show.
		self start:true.
		self startStepping.
		(self mark2 at:3) show.
		self btnNext show.
	]
	
"	self start:true.
	self startStepping.
"! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 17:14'!
protractor
	^protractor! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 17:14'!
protractor: aProtractor
	protractor := aProtractor! !

!TriangleClassificationActivity methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 12:51'!
reset
	| cnt siz |
	self currentPage:1.
	self start:false.
	self secondPassed:0.
	self seqId:1.

	(self mark1 at:1) hide.
	(self mark1 at:2) hide.
	(self mark1 at:3) hide.

	(self mark2 at:1) hide.
	(self mark2 at:2) hide.
	(self mark2 at:3) hide.

	(self strValue at:1) hide.
	(self strValue at:2) hide.
	(self strValue at:3) hide.

	self ruler hide.
	self protractor hide.

	cnt := 1.
	[cnt <= self page size] whileTrue:
	[
		cnt = 1 ifTrue:
		[
			(self page at:cnt) show.
		]
		ifFalse:
		[
			(self page at:cnt) hide.
		].

		cnt := cnt + 1.
	].

	self btnNext hide.
	self btnPrevious hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self btnNextText hide.
! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:06'!
ruler
	^ruler! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:06'!
ruler: aSketchMorph
	ruler := aSketchMorph! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 12:41'!
secondPassed
	^secondPassed! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 12:41'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:22'!
seqId
	^seqId! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 12:22'!
seqId: aNumber
	seqId := aNumber! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 16:16'!
start
	^start! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 16:17'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 9/11/2008 16:15'!
stepTime
	^1000.
! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:13'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self ruler show.
			self ruler player setHeadingTheta:300.
			self ruler player setLocationRounded:(772@356).
		].

		self secondPassed = 4 ifTrue:
		[
			(self strValue at:1) show.
		].

		self secondPassed = 7 ifTrue:
		[
			self ruler player setHeadingTheta:240.
			self ruler player setLocationRounded:(396@354).
		].

		self secondPassed = 8 ifTrue:
		[
			(self strValue at:2) show.
		].

		self secondPassed = 11 ifTrue:
		[
			self ruler show.
			self ruler player setHeadingTheta:0.
			self ruler player setLocationRounded:(680@209).
		].

		self secondPassed = 12 ifTrue:
		[
			(self strValue at:3) show.
		].

		self secondPassed = 13 ifTrue:
		[
			(self mark1 at:1) show.
		].

		self secondPassed = 14 ifTrue:
		[
			(self mark1 at:2) show.
		].

		self secondPassed = 15 ifTrue:
		[
			(self mark1 at:3) show.
			self start:false.
			self btnNextText show.

			(self dispObject at:1) show.
			(self dispObject at:2) show.
		].

		self secondPassed = 18 ifTrue:
		[
			self ruler hide.
			self start:false.
		].

		self secondPassed = 21 ifTrue:
		[
			self protractor hide.
			self start:false.
		].
	]
	ifFalse:
	[
		self stopStepping.
	].! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:08'!
strValue
	^strValue! !

!TriangleClassificationActivity methodsFor: 'accessing - properties' stamp: 'Aayush 9/11/2008 12:08'!
strValue: anOrderedCollection
	strValue := anOrderedCollection! !

!TriangleClassificationActivity methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 15:27'!
test
	| extName |
	extName := 'p1-d-3'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].! !

PasteUpMorph subclass: #TriangleClassificationPage2
	instanceVariableNames: 'ruler protractor line strValue mark1 mark2 start secondPassed dispObject seqId btnNextText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:31'!
btnNextTextClick:index

	self seqId = 1 ifTrue:
	[
		self seqId:2.

		self protractor show.
		self protractor reset.
		self protractor player setLocationRounded:(673@343).
		self protractor player setHeadingTheta:90.
		self protractor index:1.
		self protractor left2Right:false.
		self protractor targetAngle:30.
		self protractor start:true.
		self protractor startStepping.
		self start:true.
		self startStepping.
		self btnNextText hide.
	].
! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:03'!
btnNextText
	^btnNextText! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:03'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:05'!
dispObject
	^dispObject! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:05'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection
! !

!TriangleClassificationPage2 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 14:21'!
initCostume
	| extName |
	self protractor initCostume.
	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

"	extName := 'ruler'.
	World
		allMorphsDo: [:t2 | (t2 externalName asString sameAs: extName)
				ifTrue: [self ruler wearCostume: t2]].
	extName := 'mark1'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self mark1 at: 1)
						wearCostume: t2.
					(self mark1 at: 2)
						wearCostume: t2]].
"
	extName := 'p2-m2-1'.
	World	allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs:extName]) ifTrue:
	[
		(self mark2 at: 1) wearCostume: t2.
		]].

	extName := 'p2-m2-2'.
	World	allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs:extName]) ifTrue:
	[
		(self mark2 at: 2) wearCostume: t2.
		]].


	extName := 'p2-m2-3'.
	World	allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs:extName]) ifTrue:
	[
		(self mark2 at: 3) wearCostume: t2.
		]].

	extName := 'text1'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self imgText at: 1)
						wearCostume: t2]].
	extName := 'text2'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self imgText at: 2)
						wearCostume: t2]]! !

!TriangleClassificationPage2 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 14:21'!
initialize
	super initialize.
	self start: false.
	self secondPassed:0.
	self ruler: SketchMorph new.
	self addMorph: self ruler.
	self protractor: Protractor new.
	self protractor initEventReceiver: self Selector: #protractorComplete:.

	self addMorph: self protractor.
	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at: 1)
		verticesAt: 1
		put: 0 @ 0.
	(self line at: 1)
		verticesAt: 2
		put: 300 @ 0.
	self
		addMorph: (self line at: 1).
	self line add: LineMorph new.
	(self line at: 2)
		verticesAt: 1
		put: 0 @ 0.
	(self line at: 2)
		verticesAt: 2
		put: 300 @ 0.
	self
		addMorph: (self line at: 2).
	self line add: LineMorph new.
	(self line at: 3)
		verticesAt: 1
		put: 0 @ 0.
	(self line at: 3)
		verticesAt: 2
		put: 300 @ 0.
	self
		addMorph: (self line at: 3).
	self strValue: OrderedCollection new.
	self strValue add: StringMorph new.
	(self strValue at: 1)
		contents: '10 cm'.
	self
		addMorph: (self strValue at: 1).
	self strValue add: StringMorph new.
	(self strValue at: 2)
		contents: '10 cm'.
	self strValue add: StringMorph new.
	(self strValue at: 3) contents: '10 cm'.

	self addMorph: (self strValue at: 2).
	self mark1: OrderedCollection new.
	self mark1 add: SketchMorph new.
	self addMorph: (self mark1 at: 1).
	self mark1 add: SketchMorph new.
	self addMorph: (self mark1 at: 2).
	self mark2: OrderedCollection new.
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 1).
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 2).
	self mark2 add: SketchMorph new.
	self addMorph: (self mark2 at: 3).

	self btnNextText: MyButton new.
	self addMorph:self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self dispObject: OrderedCollection new.
! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
line
	^line
! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
mark1
	^mark1! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
mark2
	^mark2! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
mark2: anOrderedCollection
	mark2 := anOrderedCollection! !

!TriangleClassificationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:32'!
protractorComplete:index
	(self mark2 at:index) show.

	index = 1 ifTrue:
	[
		self protractor player setLocationRounded:(292@344).
		self protractor player setHeadingTheta:90.
		self protractor index:2.
		self protractor left2Right:true.
		self protractor targetAngle:30.
		self protractor start:true.
		self protractor startStepping.
	]
	ifFalse:
	[
		(self dispObject at:3) show.
		(self mark2 at:3) show.
	
		self start:true.
		self startStepping.
	].

! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 16:58'!
protractor
	^protractor! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 16:58'!
protractor: aProtractor
	protractor := aProtractor! !

!TriangleClassificationPage2 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 13:01'!
reset

	| cnt siz |
	self start: false.
	self secondPassed: 0.
	self seqId:1.

	(self mark1 at: 1) hide.
	(self mark1 at: 2) hide.
	(self mark2 at: 1) hide.
	(self mark2 at: 2) hide.
	(self mark2 at: 3) hide.
	(self strValue at: 1) hide.
	(self strValue at: 2) hide.
	(self strValue at: 3) hide.

	self ruler hide.
	self protractor hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self btnNextText hide.
! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
ruler
	^ruler! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
ruler: aSketchMorph
	ruler := aSketchMorph! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
secondPassed
	^secondPassed! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:04'!
seqId
	^seqId! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:04'!
seqId: aNumber
	seqId := aNumber! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
start
	^start! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 9/12/2008 13:12'!
stepTime
	^1000.
! !

!TriangleClassificationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:34'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self ruler show.
			self ruler player setHeadingTheta:330.
			self ruler player setLocationRounded:(740@393).
		].

		self secondPassed = 4 ifTrue:
		[
			(self strValue at:1) show.
		].

		self secondPassed = 7 ifTrue:
		[
			self ruler player setHeadingTheta:211.
			self ruler player setLocationRounded:(228@391).
		].

		self secondPassed = 8 ifTrue:
		[
			(self strValue at:2) show.
		].

"		self secondPassed = 11 ifTrue:
		[
			self ruler player setHeadingTheta:0.
			self ruler player setLocationRounded:(540@277).
		].

		self secondPassed = 12 ifTrue:
		[
			(self strValue at:3) show.
		].
"
		self secondPassed = 9 ifTrue:
		[
			(self mark1 at:1) show.
		].
		self secondPassed = 10 ifTrue:
		[
			(self mark1 at:2) show.

			(self dispObject at:1) show.
			(self dispObject at:2) show.
			self start:false.
			self btnNextText show.
		].

		self secondPassed = 12 ifTrue:
		[
			self ruler hide.
			self start:false.
		].

		self secondPassed = 14 ifTrue:
		[
			self protractor hide.
			self start:false.
		].
	]
	ifFalse:
	[
		self stopStepping.
	].! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
strValue
	^strValue! !

!TriangleClassificationPage2 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:12'!
strValue: anOrderedCollection
	strValue := anOrderedCollection! !

!TriangleClassificationPage2 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:44'!
test
	| extName |
	extName := 'p2-d-1'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].

	extName := 'p2-d-2'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].

	extName := 'p2-d-3'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage3
	instanceVariableNames: 'ruler line strValue mark1 start secondPassed dispObject btnNextText seqId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 15:35'!
btnNextTextClick: index 
	self seqId = 2 ifTrue:
	[
		(self dispObject at:3) show.
		self btnNextText hide.
		self seqId:3.
	].

	self seqId = 1 ifTrue:
	[
		(self dispObject at:1) show.
		(self dispObject at:2) show.
		
		self seqId:2.
	].
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 14:12'!
btnNextText
	^btnNextText! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 14:12'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:06'!
dispObject
	^dispObject! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:06'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationPage3 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 14:23'!
initCostume
	| extName |

	self btnNextText initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.

	extName := 'ruler'.
	World
		allMorphsDo: [:t2 | (t2 externalName asString sameAs: extName)
				ifTrue: [self ruler wearCostume: t2]].

	extName := 'text1'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self imgText at: 1)
						wearCostume: t2]].
	extName := 'text2'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self imgText at: 2)
						wearCostume: t2]]! !

!TriangleClassificationPage3 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 14:23'!
initialize
	super initialize.
	self start: false.
	self ruler: SketchMorph new.
	self addMorph: self ruler.

	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at: 1) verticesAt: 1	put: 0 @ 0.
	(self line at: 1) verticesAt: 2	put: 300 @ 0.
	self addMorph: (self line at: 1).
	self line add: LineMorph new.
	(self line at: 2) verticesAt: 1	put: 0 @ 0.
	(self line at: 2) verticesAt: 2	put: 300 @ 0.
	self addMorph: (self line at: 2).
	self line add: LineMorph new.
	(self line at: 3) verticesAt: 1 put: 0 @ 0.
	(self line at: 3) verticesAt: 2	put: 300 @ 0.
	self addMorph: (self line at: 3).

	self strValue: OrderedCollection new.
	self strValue add: StringMorph new.
	(self strValue at: 1) contents: '10 cm'.
	self addMorph: (self strValue at: 1).

	self strValue add: StringMorph new.
	(self strValue at: 2) contents: '10 cm'.
	self addMorph: (self strValue at: 2).

	self strValue add: StringMorph new.
	(self strValue at: 3) contents: '10 cm'.
	self addMorph: (self strValue at: 3).

	self btnNextText: MyButton new.
	self addMorph: self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self seqId:1.

	self dispObject: OrderedCollection new.
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
line
	^line
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
mark1
	^mark1! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationPage3 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 14:20'!
reset

	| cnt siz |
	self start: false.
	self seqId:1.

	self secondPassed: 0.

	(self strValue at: 1) hide.
	(self strValue at: 2) hide.
	(self strValue at: 3) hide.
	self ruler hide.
	self btnNextText hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
ruler
	^ruler! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
ruler: aSketchMorph
	ruler := aSketchMorph! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
secondPassed
	^secondPassed! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:06'!
seqId
	^seqId! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 13:06'!
seqId: aNumber
	seqId := aNumber
! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
start
	^start! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 9/15/2008 15:28'!
stepTime
	^1000.
! !

!TriangleClassificationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 14:24'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self ruler show.
			self ruler player setHeadingTheta:290.
			self ruler player setLocationRounded:(815@287).
		].

		self secondPassed = 4 ifTrue:
		[
			(self strValue at:1) show.
		].

		self secondPassed = 7 ifTrue:
		[
			self ruler player setHeadingTheta:220.
			self ruler player setLocationRounded:(433@392).
		].

		self secondPassed = 8 ifTrue:
		[
			(self strValue at:2) show.
		].

		self secondPassed = 11 ifTrue:
		[
			self ruler player setHeadingTheta:0.
			self ruler player setLocationRounded:(689@239).
		].

		self secondPassed = 12 ifTrue:
		[
			(self strValue at:3) show.
		].

		self secondPassed = 13 ifTrue:
		[
			self ruler hide.
			self start:false.

			self btnNextText show.
		].

	]
	ifFalse:
	[
		self stopStepping.
	].! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
strValue
	^strValue! !

!TriangleClassificationPage3 methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:28'!
strValue: anOrderedCollection
	strValue := anOrderedCollection! !

!TriangleClassificationPage3 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 15:34'!
test

	| extName |
	extName := 'p3-d-3'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage4
	instanceVariableNames: 'protractor line mark1 start secondPassed btnNextText seqId dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:00'!
btnNextTextClick: index 
	self seqId = 1 ifTrue:
	[
		(self dispObject at:1) show.
		(self dispObject at:2) show.
		self btnNextText hide.
		self seqId:2.
	].

! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:45'!
btnNextText
	^btnNextText! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:45'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:46'!
dispObject
	^dispObject! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:46'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationPage4 methodsFor: 'initialization' stamp: 'Aayush 10/21/2008 12:54'!
initCostume
	| extName |
	extName := 'p1-m2-1'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self mark1 at: 1)
						wearCostume: t2]].
	extName := 'p4-m1-2'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self mark1 at: 2)
						wearCostume: t2]].
	extName := 'p4-m1-3'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self mark1 at: 3)
						wearCostume: t2]].
	extName := 'text1'.
	World
		allMorphsDo: [:t2 | ((t2 isKindOf: SketchMorph)
					and: [t2 externalName asString sameAs: extName])
				ifTrue: [(self imgText at: 1)
						wearCostume: t2]].

"	self protractor initCostume.
"! !

!TriangleClassificationPage4 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 15:49'!
initialize
	super initialize.
	self start:false.
	self protractor: Protractor new.
	self protractor initEventReceiver:self Selector:#protractorComplete:.
	self addMorph:self protractor.

	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at:1) verticesAt:1 put:(0@0).
	(self line at:1) verticesAt:2 put:(300@0).
	self addMorph:(self line at:1).

	self line add: LineMorph new.
	(self line at:2) verticesAt:1 put:(0@0).
	(self line at:2) verticesAt:2 put:(300@0).
	self addMorph:(self line at:2).

	self line add: LineMorph new.
	(self line at:3) verticesAt:1 put:(0@0).
	(self line at:3) verticesAt:2 put:(300@0).
	self addMorph:(self line at:3).

	self mark1: OrderedCollection new.
	self mark1 add:SketchMorph new.
	self addMorph: (self mark1 at:1).
	self mark1 add:SketchMorph new.
	self addMorph: (self mark1 at:2).
	self mark1 add:SketchMorph new.
	self addMorph: (self mark1 at:3).


	self btnNextText: MyButton new.
	self addMorph: self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self seqId:1.

	self dispObject: OrderedCollection new.
! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
line
	^line
! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
mark1
	^mark1! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/12/2008 16:17'!
protractorComplete:index
	self start:true.
	self startStepping.
	
	(self mark1 at:index) show.! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 15:48'!
protractor
	^protractor! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 15:49'!
protractor: aProtractor
	protractor:= aProtractor! !

!TriangleClassificationPage4 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 15:58'!
reset
	| cnt siz |
	self start:false.
	self secondPassed:0.

	(self mark1 at:1) hide.
	(self mark1 at:2) hide.
	(self mark1 at:3) hide.

	self protractor hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self seqId:1.

	self btnNextText hide.
! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
secondPassed
	^secondPassed! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:46'!
seqId
	^seqId! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 15:46'!
seqId: aNumber
	seqId := aNumber! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
start
	^start! !

!TriangleClassificationPage4 methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:42'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 9/12/2008 13:42'!
stepTime
	^1000.
! !

!TriangleClassificationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 15:58'!
step
	self start ifTrue: 
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue: 
		[
			self protractor show.
			self protractor reset.
			self protractor index: 1.
			self protractor left2Right: false.
			self protractor targetAngle: 60.
			self protractor player setHeadingTheta: 90.
			self protractor player setLocationRounded: 709@302.
			self protractor start: true.
			self protractor startStepping.
			self start: false
		].

			self secondPassed = 6
				ifTrue: [self protractor reset.
					self protractor index: 2.
					self protractor left2Right: true.
					self protractor targetAngle: 70.
					self protractor player setHeadingTheta: 90.
					self protractor player setLocationRounded: 474 @302.
					self protractor start: true.
					self protractor startStepping.
					self start: false].
			self secondPassed = 8 ifTrue: 
			[
				(self mark1 at: 3) show.

			].
			self secondPassed = 10 ifTrue: 
			[
				self start: false.
				self secondPassed: 0.
				self protractor hide.
				self btnNextText show.
			].

	]
	ifFalse: 
	[
		self stopStepping
	]! !

!TriangleClassificationPage4 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 15:56'!
test
	| extName |
	extName := 'p4-d-2'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage5
	instanceVariableNames: 'protractor line mark1 start secondPassed btnNextText seqId dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:10'!
btnNextTextClick: index 
	self seqId = 1 ifTrue:
	[
		(self dispObject at:2) show.
		(self dispObject at:1) show.
		self btnNextText hide.
		self seqId:2.
	].
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:05'!
btnNextText
	^btnNextText! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:05'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:03'!
dispObject
	^dispObject
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:03'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection
! !

!TriangleClassificationPage5 methodsFor: 'initialization' stamp: 'Aayush 9/18/2005 11:19'!
initCostume
	| extName |

	self protractor initCostume.

	extName := 'p5-m1-1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark1 at:1)  wearCostume: t2.
		]
	].

	extName := 'text1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self imgText at:1)  wearCostume: t2.
		]
	].

! !

!TriangleClassificationPage5 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 15:50'!
initialize
	super initialize.
	self start:false.
	self protractor: Protractor new.
	self protractor initEventReceiver:self Selector:#protractorComplete:.
	self addMorph:self protractor.

	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at:1) verticesAt:1 put:(0@0).
	(self line at:1) verticesAt:2 put:(300@0).
	self addMorph:(self line at:1).

	self line add: LineMorph new.
	(self line at:2) verticesAt:1 put:(0@0).
	(self line at:2) verticesAt:2 put:(300@0).
	self addMorph:(self line at:2).

	self line add: LineMorph new.
	(self line at:3) verticesAt:1 put:(0@0).
	(self line at:3) verticesAt:2 put:(300@0).
	self addMorph:(self line at:3).

	self mark1: OrderedCollection new.
	self mark1 add:SketchMorph new.
	self addMorph: (self mark1 at:1).

	self btnNextText: MyButton new.
	self addMorph: self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self seqId:1.

	self dispObject: OrderedCollection new.
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
line
	^line
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
mark1
	^mark1! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 10:07'!
protractorComplete:index
	self start:true.
	self startStepping.
	
	(self mark1 at:index) show.! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
protractor
	^protractor! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
protractor: aProtractor
	protractor:= aProtractor! !

!TriangleClassificationPage5 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 16:08'!
reset
	| cnt siz |
	self start:false.
	self secondPassed:0.

	(self mark1 at:1) hide.

	self protractor hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self seqId:1.
	self btnNextText hide.
! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
secondPassed
	^secondPassed! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:03'!
seqId
	^seqId! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:03'!
seqId: aNumber
	seqId := aNumber! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
start
	^start! !

!TriangleClassificationPage5 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:07'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 10:07'!
stepTime
	^1000.
! !

!TriangleClassificationPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:11'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self protractor show.
			self protractor reset.
			self protractor index:1.
			self protractor left2Right:true.
			self protractor targetAngle:90.
			self protractor player setHeadingTheta:90.
			self protractor player setLocationRounded:(458@314).
			self protractor start:true.
			self protractor startStepping.
			self start:false.
		].

		self secondPassed = 5 ifTrue:
		[
			self start:false.
			self secondPassed:0.
			self protractor hide.
			
			self btnNextText show.
		].
	]
	ifFalse:
	[
		self stopStepping.
	].! !

!TriangleClassificationPage5 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:09'!
test
	| extName |
	extName := 'p5-d-2'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage6
	instanceVariableNames: 'protractor line mark1 start secondPassed btnNextText seqId dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:33'!
btnNextTextClick: index 
	self seqId = 1 ifTrue:
	[
		(self dispObject at:2) show.
		(self dispObject at:1) show.
		self btnNextText hide.
		self seqId:2.
	].

! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:16'!
btnNextText
	^btnNextText! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:17'!
btnNextText: aButton
	btnNextText := aButton! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:18'!
dispObject
	^dispObject! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:18'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationPage6 methodsFor: 'initialization' stamp: 'Aayush 9/18/2005 11:19'!
initCostume
	| extName |

	self protractor initCostume.

	extName := 'p6-m1-1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self mark1 at:1)  wearCostume: t2.
		]
	].

	extName := 'text1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			(self imgText at:1)  wearCostume: t2.
		]
	].

! !

!TriangleClassificationPage6 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 15:50'!
initialize
	super initialize.
	self start:false.
	self protractor: Protractor new.
	self protractor initEventReceiver:self Selector:#protractorComplete:.
	self addMorph:self protractor.

	self line: OrderedCollection new.
	self line add: LineMorph new.
	(self line at:1) verticesAt:1 put:(0@0).
	(self line at:1) verticesAt:2 put:(300@0).
	self addMorph:(self line at:1).

	self line add: LineMorph new.
	(self line at:2) verticesAt:1 put:(0@0).
	(self line at:2) verticesAt:2 put:(300@0).
	self addMorph:(self line at:2).

	self line add: LineMorph new.
	(self line at:3) verticesAt:1 put:(0@0).
	(self line at:3) verticesAt:2 put:(300@0).
	self addMorph:(self line at:3).

	self mark1: OrderedCollection new.
	self mark1 add:SketchMorph new.
	self addMorph: (self mark1 at:1).

	self btnNextText: MyButton new.
	self addMorph: self btnNextText.
	self btnNextText initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextTextClick:.

	self seqId:1.

	self dispObject: OrderedCollection new.
! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
line
	^line
! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
mark1
	^mark1! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
mark1: anOrderedCollection
	mark1 := anOrderedCollection! !

!TriangleClassificationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 10:26'!
protractorComplete:index
	self start:true.
	self startStepping.
	
	(self mark1 at:index) show.! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
protractor
	^protractor! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
protractor: aProtractor
	protractor:= aProtractor! !

!TriangleClassificationPage6 methodsFor: 'initialization' stamp: 'Aayush 11/3/2008 16:26'!
reset
	| cnt siz |
	self start:false.
	self secondPassed:0.

	(self mark1 at:1) hide.

	self protractor hide.

	cnt :=1.
	siz := self dispObject size.
	[cnt <= siz] whileTrue:
	[
		(self dispObject at:cnt) hide.
		cnt := cnt + 1.
	].

	self seqId:1.

	self btnNextText hide.! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
secondPassed
	^secondPassed! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
secondPassed: aNumber
	secondPassed := aNumber! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:17'!
seqId
	^seqId! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 11/3/2008 16:18'!
seqId: aNumber
	seqId := aNumber! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
start
	^start! !

!TriangleClassificationPage6 methodsFor: 'accessing - properties' stamp: 'Aayush 9/16/2008 10:26'!
start: aBoolean
	start := aBoolean! !

!TriangleClassificationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 9/16/2008 10:26'!
stepTime
	^1000.
! !

!TriangleClassificationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:28'!
step
	self start ifTrue:
	[
		self secondPassed: self secondPassed + 1.
		self secondPassed = 3 ifTrue:
		[
			self protractor show.
			self protractor reset.
			self protractor index:1.
			self protractor left2Right:true.
			self protractor targetAngle:120.
			self protractor player setHeadingTheta:90.
			self protractor player setLocationRounded:(517@301).
			self protractor start:true.
			self protractor startStepping.
			self start:false.
		].

		self secondPassed = 5 ifTrue:
		[
			self protractor hide.
			self start:false.
			self secondPassed:0.
			self btnNextText show.
		].
	]
	ifFalse:
	[
		self stopStepping.
	].! !

!TriangleClassificationPage6 methodsFor: 'miscellaneous' stamp: 'Aayush 11/3/2008 16:27'!
test
	| extName |
	extName := 'p6-d-1'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].

	extName := 'p6-d-2'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage7
	instanceVariableNames: 'book btnSelectAns btnConfirm btnShowCorrect btnNextAns displayBoardOpt question questionPool currentQuestion imgCross dispObject custumHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:53'!
addEventHandlers
	self btnSelectAns enable:true.

	(self displayBoardOpt at:1) on:#mouseUp send:#displayBoardOptMouseClick:V2:V3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseUp send:#displayBoardOptMouseClick:V2:V3: to:self withValue:2.	
	(self displayBoardOpt at:3) on:#mouseUp send:#displayBoardOptMouseClick:V2:V3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseUp send:#displayBoardOptMouseClick:V2:V3: to:self withValue:4.

	(self displayBoardOpt at:1) on:#mouseEnter send:#displayBoardOptMouseEnter:V2:V3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseEnter send:#displayBoardOptMouseEnter:V2:V3: to:self withValue:2.
	(self displayBoardOpt at:3) on:#mouseEnter send:#displayBoardOptMouseEnter:V2:V3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseEnter send:#displayBoardOptMouseEnter:V2:V3: to:self withValue:4.

	(self displayBoardOpt at:1) on:#mouseLeave send:#displayBoardOptMouseLeave:V2:V3: to:self withValue:1.
	(self displayBoardOpt at:2) on:#mouseLeave send:#displayBoardOptMouseLeave:V2:V3: to:self withValue:2.
	(self displayBoardOpt at:3) on:#mouseLeave send:#displayBoardOptMouseLeave:V2:V3: to:self withValue:3.
	(self displayBoardOpt at:4) on:#mouseLeave send:#displayBoardOptMouseLeave:V2:V3: to:self withValue:4.
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:10'!
book
	^book
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:10'!
book: aBookMorph
	book := aBookMorph
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 10/22/2008 11:50'!
btnAnsSelectClick:index
	self btnConfirm show.! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:50'!
btnConfirmClick:index
	| qusNo |
	(self question at:(self currentQuestion)) xIndex:(self displayBoardOpt at:(self btnSelectAns selectedIndex)) index.

	qusNo := self getQusNo.
	qusNo = 0 ifTrue:
	[
		self btnShowCorrect show.
		self btnConfirm hide.
		self removeEventHandler.
	]
	ifFalse:
	[
		self currentQuestion: qusNo.
		self showQuestion:qusNo.
		self btnConfirm hide.
		self btnSelectAns select:0.
	]

! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/21/2008 17:05'!
btnConfirm
	^btnConfirm! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/21/2008 17:05'!
btnConfirm: aButton
	btnConfirm := aButton! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 16:33'!
btnNextAnsClick:index
	| count extName cnt |

	(self imgCross at:1) hide.
	(self imgCross at:2) hide.
	(self imgCross at:3) hide.
	(self imgCross at:4) hide.
	
	self currentQuestion: self getQusNo.

	self currentQuestion = 0 ifTrue:
	[
		self btnShowCorrectClick:1.
	]
	ifFalse:
	[
		self showQuestion: self currentQuestion.

		count := 1.
		[count <= 4] whileTrue:
		[
			((self question at:(self currentQuestion)) xIndex = (self displayBoardOpt at:count) index) ifTrue:
			[
				self btnSelectAns select:count.

				extName := 'Check'.

				((self question at:(self currentQuestion)) xIndex = (self question at:(self currentQuestion)) cIndex) ifFalse:
				[
					cnt := 1.
					[cnt <= 4] whileTrue:
					[
						((self displayBoardOpt at:cnt) index = (self question at:(self currentQuestion)) cIndex) ifTrue:
						[
							self custumHolder allMorphsDo: 
							[	
								:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName]) 								ifTrue:
								[
									(self imgCross at:cnt) wearCostume:t2.
									(self imgCross at:cnt) show.					
								]
							].
							cnt := 5.
						].
	
						cnt := cnt + 1.
					].

					extName := 'Cross'.
				].
				
				self custumHolder allMorphsDo: 
				[	
					:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
					ifTrue:
					[
						(self imgCross at:count) wearCostume:t2.
						(self imgCross at:count) show.					
					]
				].
				count := 5.
			].
			
			count := count + 1.
		].
	].

	self btnConfirm hide.
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:06'!
btnNextAns
	^btnNextAns
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:06'!
btnNextAns: aButton
	btnNextAns := aButton
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 14:56'!
btnSelectAns
	^btnSelectAns! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 14:57'!
btnSelectAns: aRadioButton
	btnSelectAns := aRadioButton! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/5/2008 16:40'!
btnShowCorrectClick:index

	self initQuestionPool.

	self btnNextAnsClick:1.
	self btnShowCorrect hide.
	self btnNextAns show.

	(self dispObject at:2) show.
	self calcScore.! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:03'!
btnShowCorrect
	^btnShowCorrect! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:04'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/5/2008 16:40'!
calcScore
	| scr cnt siz |
	scr := 0.
	siz := self question size.
	cnt := 1.
	[cnt <= siz] whileTrue:
	[
		(self question at:cnt) xIndex = (self question at:cnt) cIndex ifTrue:
		[
			scr := scr + 1.
		].
		cnt := cnt + 1.
	].

	(self dispObject at:1) contents:(scr asString).! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/29/2008 11:24'!
currentQuestion
	^currentQuestion! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/29/2008 11:25'!
currentQuestion: aNumber
	currentQuestion := aNumber
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 11/11/2008 15:58'!
custumHolder
	^custumHolder! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 11/11/2008 15:58'!
custumHolder: aPasteUpMorph
	custumHolder := aPasteUpMorph! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:42'!
displayBoardOptMouseClick:index V2:x V3:y
	self btnSelectAns select:index.
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:36'!
displayBoardOptMouseEnter:index V2:y V3:z

	| cnt |
	cnt := 1.
	[ cnt <= 4] whileTrue:
	[
		cnt = index ifTrue:
		[
			(self displayBoardOpt at:cnt) borderColor:(Color r: 1.0 g: 0.0 b: 0.0).
		]
		ifFalse:
		[
			(self displayBoardOpt at:cnt) borderColor:(Color r: 0.0 g: 0.0 b: 0.0).
		].

		cnt := cnt + 1.
	].
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:37'!
displayBoardOptMouseLeave:index V2:y V3:z
	(self displayBoardOpt at:index) borderColor:(Color r: 0.0 g: 0.0 b: 0.0).
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:19'!
displayBoardOpt
	^displayBoardOpt! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/25/2008 15:19'!
displayBoardOpt: anOrderedCollection
	displayBoardOpt := anOrderedCollection! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 11/5/2008 12:33'!
dispObject
	^dispObject! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 11/5/2008 12:33'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:55'!
doNothing
	^self! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 10/22/2008 11:01'!
getQusNo
	| x y |
	x := (self questionPool size) random.
	
	x > 0 ifTrue:
	[
		y := self questionPool at:x.
		self questionPool removeAt:x.
		^y.
	]
	ifFalse:
	[
		^x
	]
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 12:14'!
imgCross
	^imgCross! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/22/2008 12:14'!
imgCross: anOrderedCollection
	imgCross := anOrderedCollection! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 9/25/2008 15:17'!
initButtons
	self btnSelectAns: RadioButton new.
	self addMorph:self btnSelectAns.
	self btnSelectAns initName:'Ans' Receiver:self Selector:#btnAnsSelectClick: sImageName:'imgS' usImageName:'imgUS'.
	self btnSelectAns addItem: '1'.
	self btnSelectAns addItem: '2'.
	self btnSelectAns addItem: '3'.
	self btnSelectAns addItem: '4'.

	self btnConfirm: MyButton new.
	self addMorph:self btnConfirm.
	self btnConfirm initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnConfirmClick:.

	self btnNextAns: MyButton new.
	self addMorph:self btnNextAns.
	self btnNextAns initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnNextAnsClick:.

	self btnShowCorrect: MyButton new.
	self addMorph:self btnShowCorrect.
	self btnShowCorrect initReceiver: self enterSelector: nil leaveSelector: nil downSelector: nil upSelector: #btnShowCorrectClick:.
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/23/2008 15:59'!
initCostume
	| extName |
	self btnConfirm initImageOver:'confirmOver' Down:'confirmDown' Up:'confirmUp'.
	self btnNextAns initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.
	self btnShowCorrect initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/22/2008 11:13'!
initDisplayBoardOpt
	self displayBoardOpt: OrderedCollection new.

	self displayBoardOpt add: DisplayBoardX new.
	self addMorph: (self displayBoardOpt at:1).

	self displayBoardOpt add: DisplayBoardX new.
	self addMorph: (self displayBoardOpt at:2).

	self displayBoardOpt add: DisplayBoardX new.
	self addMorph: (self displayBoardOpt at:3).

	self displayBoardOpt add: DisplayBoardX new.
	self addMorph: (self displayBoardOpt at:4).
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/22/2008 12:21'!
initImgCross
	self imgCross: OrderedCollection new.

	self imgCross add: SketchMorph new.
	self imgCross add: SketchMorph new.
	self imgCross add: SketchMorph new.
	self imgCross add: SketchMorph new.

	self addMorph: (self imgCross at:1).
	self addMorph: (self imgCross at:2).
	self addMorph: (self imgCross at:3).
	self addMorph: (self imgCross at:4).
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/21/2008 17:12'!
initialize
	super initialize.

	self book: BookMorph new.
	self addMorph: self book.

	self initButtons.
	self initDisplayBoardOpt.
	self initQuestion.! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/22/2008 10:59'!
initQuestionPool
	| count |

	self questionPool = nil ifTrue:
	[
		self questionPool: OrderedCollection new.
	].

	[self questionPool size >= 1] whileTrue:
	[
		self questionPool removeFirst.
	].

	count := 1.
	[count <= 6] whileTrue:
	[
		self questionPool add: count.
		count := count + 1.
	].
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 10/21/2008 17:03'!
initQuestion

	self question: OrderedCollection new.

	self question add: MyQuestion new.
	self question add: MyQuestion new.
	self question add: MyQuestion new.
	self question add: MyQuestion new.
	self question add: MyQuestion new.
	self question add: MyQuestion new.

	(self question at:1) question: 'Equiletral triangle'.
	(self question at:1) option add: 6.
	(self question at:1) option add: 2.
	(self question at:1) option add: 5.
	(self question at:1) option add: 1.
	(self question at:1) cIndex:4.
	(self question at:1) xIndex:0.

	(self question at:2) question: 'Isosceles triangle'.
	(self question at:2) option add: 1.
	(self question at:2) option add: 4.
	(self question at:2) option add: 2.
	(self question at:2) option add: 6.
	(self question at:2) cIndex:3.
	(self question at:2) xIndex:0.

	(self question at:3) question: 'Scalen triangle'.
	(self question at:3) option add: 3.
	(self question at:3) option add: 5.
	(self question at:3) option add: 1.
	(self question at:3) option add: 6.
	(self question at:3) cIndex:1.
	(self question at:3) xIndex:0.

	(self question at:4) question: 'Acute angled Triangle'.
	(self question at:4) option add: 5.
	(self question at:4) option add:  2.
	(self question at:4) option add: 4.
	(self question at:4) option add: 1.
	(self question at:4) cIndex:3.
	(self question at:4) xIndex:0.

	(self question at:5) question: 'Obtuse angled triangle'.
	(self question at:5) option add: 6.
	(self question at:5) option add: 2.
	(self question at:5) option add: 1.
	(self question at:5) option add: 5.
	(self question at:5) cIndex:4.
	(self question at:5) xIndex:0.

	(self question at:6) question: 'Right angled triangle'.
	(self question at:6) option add: 4.
	(self question at:6) option add: 6.
	(self question at:6) option add: 2.
	(self question at:6) option add: 5.
	(self question at:6) cIndex:2.
	(self question at:6) xIndex:0.
! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/26/2008 12:42'!
questionPool
	^questionPool! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 9/26/2008 12:43'!
questionPool: anOderedCollection
	questionPool := anOderedCollection! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/21/2008 17:06'!
question
	^question! !

!TriangleClassificationPage7 methodsFor: 'accessing - properties' stamp: 'Aayush 10/21/2008 17:06'!
question: anOrderedCollection
	question := anOrderedCollection! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 09:50'!
removeEventHandler
	self btnSelectAns enable:false.

	(self displayBoardOpt at:1) on:#mouseUp send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseUp send:#doNothing to:self.	
	(self displayBoardOpt at:3) on:#mouseUp send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseUp send:#doNothing to:self.

	(self displayBoardOpt at:1) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:3) on:#mouseEnter send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseEnter send:#doNothing to:self.

	(self displayBoardOpt at:1) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:2) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:3) on:#mouseLeave send:#doNothing to:self.
	(self displayBoardOpt at:4) on:#mouseLeave send:#doNothing to:self.
! !

!TriangleClassificationPage7 methodsFor: 'initialization' stamp: 'Aayush 11/5/2008 15:04'!
reset

	| cnt |
	self btnShowCorrect hide.
 	self btnNextAns hide.
	self btnConfirm hide.

	self initQuestionPool.
	
	self currentQuestion: self getQusNo.
	self showQuestion:self currentQuestion.
	self btnSelectAns select:0.

	(self imgCross at:1) hide.
	(self imgCross at:2) hide.
	(self imgCross at:3) hide.
	(self imgCross at:4) hide.

	self addEventHandlers.

	cnt := 1.
	[cnt <= self question size] whileTrue:
	[
		(self question at:cnt) xIndex:0.				

		cnt := cnt + 1.
	].

	(self dispObject at:2) hide.
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 14:59'!
showQuestion1:qusNo
	|extName opt ar |

	self book goToPage:qusNo.

	extName := 'p7-o-'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString beginsWith:extName) ifTrue:
 		[
			opt := (self question at:qusNo) option at:1.	
			ar := t2 externalName subStrings:'-'.
			(ar at:3) = opt asInteger ifTrue:
			[
				(self displayBoardOpt at:1) dispImage wearCostume: t2.
				(self displayBoardOpt at:1) dispImage center:(self displayBoardOpt at:1) center.
				(self displayBoardOpt at:1) index:1.
			]
			ifFalse:
			[
				opt := (self question at:qusNo) option at:2.	
				(ar at:3) = opt asInteger ifTrue:
				[
					(self displayBoardOpt at:2) dispImage wearCostume: t2.
					(self displayBoardOpt at:2) dispImage center:(self displayBoardOpt at:2) center.
					(self displayBoardOpt at:2) index:2.
				]
				ifFalse:
				[
					opt := (self question at:qusNo) option at:3.	
					(ar at:3) = opt asInteger ifTrue:
					[
						(self displayBoardOpt at:3) dispImage wearCostume: t2.
						(self displayBoardOpt at:3) dispImage center:(self displayBoardOpt at:3) center.
						(self displayBoardOpt at:3) index:3.
					]
					ifFalse:
					[
						opt := (self question at:qusNo) option at:4.	
						(ar at:3) = opt asInteger ifTrue:
						[
							(self displayBoardOpt at:3) dispImage wearCostume: t2.
							(self displayBoardOpt at:3) dispImage center:(self displayBoardOpt at:3) center.
							(self displayBoardOpt at:3) index:3.
						]
					]
				]
			].
		]
	].
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 15:07'!
showQuestion2:qusNo
	|extName opt |

	self book goToPage:qusNo.

	opt := (self question at:qusNo) option at:1.	
	extName := 'p7-o',opt asString.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			(self displayBoardOpt at:1) dispImage wearCostume: t2.
			(self displayBoardOpt at:1) dispImage center:(self displayBoardOpt at:1) center.
		]
	].

	(self displayBoardOpt at:1) index:1.

	opt := (self question at:qusNo) option at:2.	
	extName := 'p7-o',opt asString.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			(self displayBoardOpt at:2) dispImage wearCostume: t2.
			(self displayBoardOpt at:2) dispImage center:(self displayBoardOpt at:2) center.
		]
	].
	(self displayBoardOpt at:2) index:2.

	opt := (self question at:qusNo) option at:3.	
	extName := 'p7-o',opt asString.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			(self displayBoardOpt at:3) dispImage wearCostume: t2.
			(self displayBoardOpt at:3) dispImage center:(self displayBoardOpt at:3) center.
		]
	].
	(self displayBoardOpt at:3) index:3.

	opt := (self question at:qusNo) option at:4.	
	extName := 'p7-o',opt asString.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			(self displayBoardOpt at:4) dispImage wearCostume: t2.
			(self displayBoardOpt at:4) dispImage center:(self displayBoardOpt at:4) center.
		]
	].
	(self displayBoardOpt at:4) index:4.
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 16:04'!
showQuestion:qusNo
	|extName opt ar |

	extName := 'p7-o-'.
	self custumHolder allMorphsDo: 
	[	
		:t2 | (t2 externalName asString beginsWith:extName) ifTrue:
 		[
"			self break.
"			opt := (self question at:qusNo) option at:1.	
			ar := t2 externalName subStrings:'-'.
			(ar at:3) = opt asString ifTrue:
			[
				(self displayBoardOpt at:1) dispImage wearCostume: t2.
				(self displayBoardOpt at:1) dispImage center:(self displayBoardOpt at:1) center.
				(self displayBoardOpt at:1) index:1.
			]
			ifFalse:
			[
				opt := (self question at:qusNo) option at:2.	
				(ar at:3) = opt asString ifTrue:
				[
					(self displayBoardOpt at:2) dispImage wearCostume: t2.
					(self displayBoardOpt at:2) dispImage center:(self displayBoardOpt at:2) center.
					(self displayBoardOpt at:2) index:2.
				]
				ifFalse:
				[
					opt := (self question at:qusNo) option at:3.	
					(ar at:3) = opt asString ifTrue:
					[
						(self displayBoardOpt at:3) dispImage wearCostume: t2.
						(self displayBoardOpt at:3) dispImage center:(self displayBoardOpt at:3) center.
						(self displayBoardOpt at:3) index:3.
					]
					ifFalse:
					[
						opt := (self question at:qusNo) option at:4.	
						(ar at:3) = opt asString ifTrue:
						[
							(self displayBoardOpt at:4) dispImage wearCostume: t2.
							(self displayBoardOpt at:4) dispImage center:(self displayBoardOpt at:4) center.
							(self displayBoardOpt at:4) index:4.
						]
					]
				]
			].
		]
	].

	self book goToPage:qusNo.
! !

!TriangleClassificationPage7 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 15:59'!
test
	| extName |
	extName := 'p7CHolder'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self custumHolder: t2.
		]
	].
! !

PasteUpMorph subclass: #TriangleClassificationPage8
	instanceVariableNames: 'peg pegAns line lineAns imgCross triangleCod triangleAnsCod displayBoardQus question btnConfirm btnCancle btnNextAns btnShowCorrect currentQuestion questionPool lineToDraw vertexToSet inputSensor start dispObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-TriangleClassificationActivity'!

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 12:14'!
addPegEventHandler:b

	| count cnt |
	count := 1.
	[count <= 10] whileTrue:
	[
		cnt := 1.
		[cnt <= 10] whileTrue:
		[
			b ifTrue:
			[
				((self peg at:count) at:cnt) on:#mouseUp send:#pegClick:V2:V3: to:self withValue: (count asString , '-' ,cnt asString).
			]
			ifFalse:
			[
				((self peg at:count) at:cnt) on:#mouseUp send:#doNothing to:self.
			].
			cnt := cnt + 1.		
		].

		count := count + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 10:46'!
arrangePeg:startPoint1 pegAns:startPoint2
	| left top width height count cnt |

	left:=startPoint1 x.
	top:=startPoint1 y.	
	width := ((self peg at:1) at:1) width.
	height := ((self peg at:1) at:1) height.

	count:=1.
	[count <=10] whileTrue:
	[
		cnt := 1.
		[cnt <=10] whileTrue:
		[
			((self peg at:count) at:cnt) center:(left@top).
			left := left + width + 20.	
			cnt := cnt + 1.
		].

		top := top + height + 20.	
		left:=startPoint1 x.

		count := count + 1.
	].

	left:=startPoint2 x.
	top:=startPoint2 y.	
	width := ((self pegAns at:1) at:1) width.
	height := ((self pegAns at:1) at:1) height.

	count:=1.
	[count <=10] whileTrue:
	[
		cnt := 1.
		[cnt <=10] whileTrue:
		[
			((self pegAns at:count) at:cnt) center:(left@top).
			left := left + width + 10.	
			cnt := cnt + 1.
		].

		top := top + height + 10.	
		left:=startPoint2 x.

		count := count + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/23/2008 16:34'!
arrangePeg: startPoint
	| left top width height count cnt |

	left:=startPoint x.
	top:=startPoint y.	
	width := ((self peg at:1) at:1) width.
	height := ((self peg at:1) at:1) height.

	count:=1.
	[count <=10] whileTrue:
	[
		cnt := 1.
		[cnt <=10] whileTrue:
		[
			((self peg at:count) at:cnt) center:(left@top).
			left := left + width + 10.	
			cnt := cnt + 1.
		].

		top := top + height + 10.	
		left:=startPoint x.

		count := count + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 19:00'!
btnCancleClick:index
	(self line at:1) hide.
	(self line at:2) hide.
	(self line at:3) hide.

	self lineToDraw:1.
	self vertexToSet:1.

	self btnCancle hide.
	self btnConfirm hide.
	
	self start:false.! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/20/2008 09:51'!
btnCancle
	^btnCancle! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/20/2008 09:52'!
btnCancle: aButton
	btnCancle  := aButton! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 13:41'!
btnConfirmClick:index
	(self triangleCod at:(self currentQuestion)) at:1 put:( (self line at:1) vertexAt:1).
	(self triangleCod at:(self currentQuestion)) at:2 put:( (self line at:1) vertexAt:2).
	(self triangleCod at:(self currentQuestion)) at:3 put:( (self line at:2) vertexAt:2).

	self currentQuestion: self getQusNo.
	self currentQuestion = 0 ifTrue:
	[
		self btnShowCorrect show.

		self btnConfirm hide.
		self btnCancle hide.

		self addPegEventHandler:false.
	]
	ifFalse:
	[
		self showQuestion:self currentQuestion.

		self btnCancleClick:1.

		self btnConfirm hide.
		self btnCancle hide.
	].
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:34'!
btnConfirm
	^btnConfirm! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:34'!
btnConfirm: aButton
	btnConfirm := aButton
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 14:55'!
btnNextAnsClick:index

	self currentQuestion: self getQusNo.
	self currentQuestion = 0 ifTrue:
	[
		self btnShowCorrectClick:1.
	]
	ifFalse:
	[
		self showQuestion: self currentQuestion.

		(self line at:1) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:1).
		(self line at:1) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:2).

		(self line at:2) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:2).
		(self line at:2) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:3).

		(self line at:3) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:3).
		(self line at:3) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:1).

		self doAccordingToAns.
	].! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/27/2008 12:19'!
btnNextAns
	^btnNextAns! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/27/2008 12:19'!
btnNextAns: aButton
	btnNextAns := aButton! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/6/2008 10:58'!
btnShowCorrectClick:index
	| |
	self initQuestionPool.
	self currentQuestion: self getQusNo.
	self showQuestion:self currentQuestion.

	(self line at:1) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:1).
	(self line at:1) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:2).

	(self line at:2) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:2).
	(self line at:2) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:3).

	(self line at:3) verticesAt:1 put: ((self triangleCod at:(self currentQuestion)) at:3).
	(self line at:3) verticesAt:2 put: ((self triangleCod at:(self currentQuestion)) at:1).

	(self dispObject at:2) show.
	self calcScore.

	self doAccordingToAns.

	self btnNextAns show.
	self btnShowCorrect hide.

! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/27/2008 12:19'!
btnShowCorrect
	^btnShowCorrect! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/27/2008 12:19'!
btnShowCorrect: aButton
	btnShowCorrect := aButton! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/6/2008 11:05'!
calcScore
	| scr cnt siz |

	scr := 0.
	cnt := 1.
	siz := self question size.
	
	[cnt <= siz] whileTrue:
	[
		(self checkAns:cnt) ifTrue:
		[
			scr := scr + 1.
			self question at:cnt put: true.
		]
		ifFalse:
		[
			self question at:cnt put: false.
		].
	
		cnt := cnt + 1.
	].

	(self dispObject at:1) setCharacters: (scr asString).
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 13:44'!
checkAns:qNo
	| d1 d2 d3 d1s d2s d3s p1 p2 d23s lo |

	p1 := ((self triangleCod at:qNo) at:1).
	p2 := ((self triangleCod at:qNo) at:2).

	d1 := (((p1 x -p2 x) squared) + ((p1 y -p2 y) squared)) sqrt.

	p1 := ((self triangleCod at:qNo) at:2).
	p2 := ((self triangleCod at:qNo) at:3).

	d2 := (((p1 x -p2 x) squared) + ((p1 y -p2 y) squared)) sqrt.

	p1 := ((self triangleCod at:qNo) at:3).
	p2 := ((self triangleCod at:qNo) at:1).

	d3 := (((p1 x -p2 x) squared) + ((p1 y -p2 y) squared)) sqrt.

	d2 >= d1 ifTrue:
	[
		d2 >=d3 ifTrue:
		[
			lo:= d2.
			d2 := d1.
			d1 := lo.
		]
		ifFalse:
		[
			lo:=d3.
			d3 := d1.
			d1 := lo.	
		]	
	]
	ifFalse:
	[
		d1 >=d3 ifTrue:
		[
			lo:= d1.
		]
		ifFalse:
		[
			lo:=d3.
			d3 := d1.
			d1 := lo.	
		]	
	].	

	d1s:= d1 squared.
	d2s:= d2 squared.
	d3s:= d3 squared.

	qNo = 1 ifTrue:
	[
		(d1 = d2 or:[ d2 = d3 or:[ d3 =d1]]) ifTrue:
		[
			^true
		].		
	].

	qNo = 2 ifTrue:
	[
		(d1 ~= d2 and:[ d2~=d3 and:[ d3 ~= d1]]) ifTrue:
		[
			^true
		].
	].

	qNo = 3 ifTrue:
	[
		((d2s+d3s)>d1s) ifTrue:
		[
			^true
		]
	].

	qNo = 4 ifTrue:
	[
		((d2s+d3s)<d1s) ifTrue:
		[
			^true
		]
	].

	qNo = 5 ifTrue:
	[
		d23s:= (d2s+d3s).

		d1s = d23s ifTrue:
		[
			^true
		].
	].

	^false.! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:55'!
currentQuestion
	^currentQuestion! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:56'!
currentQuestion: aNumber
	currentQuestion := aNumber! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:33'!
displayBoardQus
	^displayBoardQus! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:33'!
displayBoardQus: aDisplayBoard
	displayBoardQus := aDisplayBoard! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/6/2008 09:53'!
dispObject
	^dispObject! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/6/2008 09:54'!
dispObject: anOrderedCollection
	dispObject := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/6/2008 11:10'!
doAccordingToAns
	| extName |
	(self question at:(self currentQuestion)) ifFalse:
	[
		self showPegAns:true.
		self showAns:self currentQuestion.
		(self imgCross at:2) show.
		(self imgCross at:1) show.

		extName := 'Cross1'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName]) ifTrue:
 			[
				(self imgCross at:1) wearCostume: t2.
			].
		].
	]
	ifTrue:
	[
		self showPegAns:false.
		(self imgCross at:2) hide.
		(self imgCross at:1) show.

		extName := 'Check1'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName]) ifTrue:
 			[
				(self imgCross at:1) wearCostume: t2.
			].
		].
	].
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 12:15'!
doNothing
	^self! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 11:03'!
getQusNo
	| x y |
	x := (self questionPool size) random.
	
	x > 0 ifTrue:
	[
		y := self questionPool at:x.
		self questionPool removeAt:x.
		^y.
	]
	ifFalse:
	[
		^x
	]
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:14'!
imgCross
	^imgCross! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:15'!
imgCross: anOrderedCollection
	imgCross := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 11/6/2008 10:54'!
initCostume
	| ro co extName |
	self btnConfirm initImageOver:'confirmOver' Down:'confirmDown' Up:'confirmUp'.
	self btnCancle initImageOver:'cancleOver' Down:'cancleDown' Up:'cancleUp'.
	self btnShowCorrect initImageOver:'checkAnsOver' Down:'checkAnsDown' Up:'checkAnsUp'.
	self btnNextAns initImageOver:'next2Over' Down:'next2Down' Up:'next2Up'.


	extName := 'peg'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName]) ifTrue:
 		[
			ro := 1.
			[ro <= 10] whileTrue:
			[
				co := 1.
				[co <= 10] whileTrue:
				[
					((self peg at:ro) at:co) wearCostume: t2.
					((self pegAns at:ro) at:co) wearCostume: t2.
					co := co + 1.
				].
				ro := ro + 1.
			]
		]
	].

	extName := 'Check1'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName]) ifTrue:
 		[
			(self imgCross at:1) wearCostume:t2.
			(self imgCross at:2) wearCostume:t2
		]
	].
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 12:18'!
initialize
	super initialize.

	self btnConfirm: MyButton new.
	self btnConfirm initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnConfirmClick:.
	self addMorph: self btnConfirm.

	self btnCancle: MyButton new.
	self btnCancle initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnCancleClick:.
	self addMorph: btnCancle.

	self btnShowCorrect: MyButton new.
	self btnShowCorrect initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnShowCorrectClick:.
	self addMorph: btnShowCorrect.

	self btnNextAns: MyButton new.
	self btnNextAns initReceiver:self enterSelector:nil leaveSelector:nil downSelector:nil upSelector:#btnNextAnsClick:.
	self addMorph: btnNextAns.

	self displayBoardQus: DisplayBoardX new.
	self addMorph: self displayBoardQus.

	self imgCross: OrderedCollection new.
	self imgCross add: SketchMorph new.
	self imgCross add: SketchMorph new.
	self addMorph:(self imgCross at:1).
	self addMorph:(self imgCross at:2).

	self initTriangleCod.

	self questionPool: OrderedCollection new.

	self initPeg.
	self initLine.
	self initQuestion.! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 10:10'!
initLine
	self line: OrderedCollection new.
	self line add: LineMorph new.
	self line add: LineMorph new.
	self line add: LineMorph new.

	self addMorph: (self line at:1).
	self addMorph: (self line at:2).
	self addMorph: (self line at:3).

	self lineAns: OrderedCollection new.
	self lineAns add: LineMorph new.
	self lineAns add: LineMorph new.
	self lineAns add: LineMorph new.

	self addMorph: (self lineAns at:1).
	self addMorph: (self lineAns at:1).
	self addMorph: (self lineAns at:1).

"
	self triangleAnsCod add: OrderedCollection new.
	(self triangleAnsCod at:1) add: (Array new:2).
	(self triangleAnsCod at:1) add: (Array new:2).
	(self triangleAnsCod at:1) add: (Array new:2).

	(((self triangleAnsCod at:1) at:1) at:1 put:( ((self pegAns at:1) at:5) center ).
	(((self triangleAnsCod at:1) at:1) at:2 put:( ((self pegAns at:10) at:1) center ).


	(self triangleAnsCod at:2) at:1 put:( ((self pegAns at:1) at:5) center ).
	(self triangleAnsCod at:1) at:2 put:( ((self pegAns at:10) at:1) center ).
"! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/24/2008 15:38'!
initPeg
	| count cnt |

	self peg: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self peg add:OrderedCollection new.

		cnt := 1.
		[cnt <= 10] whileTrue:
		[
			(self peg at:count) add: SketchMorph new.
			((self peg at:count) at:cnt) on:#mouseUp send:#pegClick:V2:V3: to:self withValue: (count asString , '-' ,cnt asString).
			self addMorph: ((self peg at:count) at:cnt).
			cnt := cnt + 1.		
		].

		count := count + 1.
	].

	self pegAns: OrderedCollection new.

	count := 1.
	[count <= 10] whileTrue:
	[
		self pegAns add:OrderedCollection new.

		cnt := 1.
		[cnt <= 10] whileTrue:
		[
			(self pegAns at:count) add: SketchMorph new.
			self addMorph: ((self pegAns at:count) at:cnt).
			cnt := cnt + 1.		
		].

		count := count + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 11:02'!
initQuestionPool
	| count |

	self questionPool = nil ifTrue:
	[
		self questionPool: OrderedCollection new.
	].

	[self questionPool size >= 1] whileTrue:
	[
		self questionPool removeFirst.
	].

	count := 1.
	[count <= 5] whileTrue:
	[
		self questionPool add: count.
		count := count + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/23/2008 16:08'!
initQuestion
	self question: OrderedCollection new.

	self question add: 1.
	self question add: 2.
	self question add: 3.
	self question add: 4.
	self question add: 5.
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 10:39'!
initTriangleAnsCod

	(self triangleAnsCod at:1) at:1 put:( ((self pegAns at:1) at:5) center).
	(self triangleAnsCod at:1) at:2 put:( ((self pegAns at:10) at:1) center).
	(self triangleAnsCod at:1) at:3 put:( ((self pegAns at:10) at:9) center).

	(self triangleAnsCod at:2) at:1 put:( ((self pegAns at:4) at:3) center).
	(self triangleAnsCod at:2) at:2 put:( ((self pegAns at:8) at:1) center).
	(self triangleAnsCod at:2) at:3 put:( ((self pegAns at:5) at:10) center).

	(self triangleAnsCod at:3) at:1 put:( ((self pegAns at:1) at:5) center).
	(self triangleAnsCod at:3) at:2 put:( ((self pegAns at:6) at:2) center).
	(self triangleAnsCod at:3) at:3 put:( ((self pegAns at:7) at:7) center).

	(self triangleAnsCod at:4) at:1 put:( ((self pegAns at:1) at:1) center).
	(self triangleAnsCod at:4) at:2 put:( ((self pegAns at:8) at:5) center).
	(self triangleAnsCod at:4) at:3 put:( ((self pegAns at:8) at:10) center).

	(self triangleAnsCod at:5) at:1 put:( ((self pegAns at:2) at:2) center).
	(self triangleAnsCod at:5) at:2 put:( ((self pegAns at:9) at:2) center).
	(self triangleAnsCod at:5) at:3 put:( ((self pegAns at:9) at:10) center).
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 10:44'!
initTriangleCod
	| c |

	self triangleCod:OrderedCollection new.
	self triangleAnsCod:OrderedCollection new.

	c := 1.
	[c <= 5] whileTrue:
	[
		self triangleCod add: OrderedCollection new.
		self triangleAnsCod add: OrderedCollection new.

		(self triangleCod at:c) add: 1.
		(self triangleCod at:c) add: 2.
		(self triangleCod at:c) add: 3.

		(self triangleAnsCod at:c) add: 1.
		(self triangleAnsCod at:c) add: 2.
		(self triangleAnsCod at:c) add: 3.

		c := c + 1.
	].
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/4/2008 11:43'!
inputSensor
	^inputSensor! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/4/2008 11:43'!
inputSensor: aInputSensor
	inputSensor := aInputSensor! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:11'!
lineAns
	^lineAns! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:14'!
lineAns: aLine
	lineAns :=aLine
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:58'!
lineToDraw
	^lineToDraw! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:58'!
lineToDraw: aNumber
	lineToDraw := aNumber! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:32'!
line
	^line
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:32'!
line: anOrderedCollection
	line := anOrderedCollection
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:24'!
pegAns
	^pegAns! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:23'!
pegAns: anOrderedCollection
	pegAns := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 18:48'!
pegClick:index V2:x V3:y
	| row col arr |

	arr := index subStrings: '-'.

	row:= (arr at:1) asInteger.
	col := (arr at:2) asInteger.

	self lineToDraw = 2 ifTrue:
	[
		self lineToDraw:3.	
		(self line at:2) verticesAt:1 put: ( (self line at:1) vertexAt:2).
		(self line at:2) verticesAt:2 put:( (self peg at:row) at:col) center.

		(self line at:3) verticesAt:1 put: ( (self line at:2) vertexAt:2).
		(self line at:3) verticesAt:2 put:( (self line at:1) vertexAt:1).

		(self line at:2) show.
		(self line at:3) show.

		self btnConfirm show.
		self btnCancle show.
	].

	self lineToDraw = 1 ifTrue:
	[
		self vertexToSet = 2 ifTrue:
		[
			self vertexToSet:2.
			self lineToDraw:2.	
			(self line at:1) verticesAt:2 put:( (self peg at:row) at:col) center.
			(self line at:1) show.
		].

		self vertexToSet = 1 ifTrue:
		[
			self vertexToSet:2.
			(self line at:1) verticesAt:1 put:( (self peg at:row) at:col) center.
			(self line at:1) verticesAt:2 put:( (self peg at:row) at:col) center.

			self start:true.
			self startStepping.
		].
	].
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:31'!
peg
	^peg! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:32'!
peg: anOrderedCollection
	peg := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:56'!
questionPool
	^questionPool
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:56'!
questionPool: anOrderedCollection
	questionPool := anOrderedCollection
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:33'!
question
	^question
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 10:34'!
question: anOrderedCollection
	question := anOrderedCollection
! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 10/27/2008 12:57'!
resetTriangleCod

	| cnt |
	cnt := 1.
	[cnt <= 5] whileTrue:
	[
		(self triangleCod at:cnt) at:1 put:0.
		(self triangleCod at:cnt) at:2 put:0.
		(self triangleCod at:cnt) at:3 put:0.

		cnt := cnt + 1.
	]! !

!TriangleClassificationPage8 methodsFor: 'initialization' stamp: 'Aayush 11/6/2008 09:56'!
reset
	self currentQuestion:1.
	self start:false.

	(self imgCross at:1) hide	.
	(self imgCross at:2) hide	.

	self showPegAns:false.

	self btnCancleClick:1.

	self initQuestionPool.
	self currentQuestion: self getQusNo.
	self showQuestion:self currentQuestion.
	self addPegEventHandler:true.

	self btnShowCorrect hide.
	self btnNextAns hide.
	self btnCancle hide.
	self btnConfirm hide.
	self resetTriangleCod.

	(self dispObject at:2) hide.! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 10:54'!
showAns:q

	(self lineAns at:1) verticesAt:1 put: ((self triangleAnsCod at:q) at:1).
	(self lineAns at:1) verticesAt:2 put: ((self triangleAnsCod at:q) at:2).

	(self lineAns at:2) verticesAt:1 put: ((self triangleAnsCod at:q) at:2).
	(self lineAns at:2) verticesAt:2 put: ((self triangleAnsCod at:q) at:3).

	(self lineAns at:3) verticesAt:1 put: ((self triangleAnsCod at:q) at:3).
	(self lineAns at:3) verticesAt:2 put: ((self triangleAnsCod at:q) at:1).
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 10/27/2008 09:43'!
showPegAns:v
	| count cnt |
	count:=1.
	[count <=10] whileTrue:
	[
		cnt := 1.
		[cnt <=10] whileTrue:
		[
			v ifTrue:
			[
				((self pegAns at:count) at:cnt) show.
			]
			ifFalse:
			[
				((self pegAns at:count) at:cnt) hide.
			].

			cnt := cnt + 1.
		].

		count := count + 1.
	].

	v ifTrue:
	[
		(self lineAns at:1) show.
		(self lineAns at:2) show.
		(self lineAns at:3) show.
	]
	ifFalse:
	[
		(self lineAns at:1) hide.
		(self lineAns at:2) hide.
		(self lineAns at:3) hide.
	].
! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 15:13'!
showQuestion:qNo

	| extName |
	extName := 'p7-o-',(qNo+1) asString.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs:extName) ifTrue:
 		[
			(self displayBoardQus ) dispImage wearCostume: t2.
		]
	].

	(self displayBoardQus ) index:qNo.! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/4/2008 11:45'!
start
	^start! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 11/4/2008 11:45'!
start: aBoolean
	start:= aBoolean! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 11:45'!
stepTime
	^500! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/4/2008 12:54'!
step
	self start ifTrue:
	[
		self lineToDraw = 2 ifTrue:
		[
			(self line at:2) verticesAt:1 put: ( (self line at:1) vertexAt:2).
			(self line at:2) verticesAt:2 put:(self inputSensor cursorPoint).

			(self line at:3) verticesAt:1 put: (self inputSensor cursorPoint).
			(self line at:3) verticesAt:2 put:((self line at:1) vertexAt:1).

			(self line at:2) show.
			(self line at:3) show.
		].

		self lineToDraw = 1 ifTrue:
		[
			self vertexToSet = 2 ifTrue:
			[
				(self line at:1) verticesAt:2 put:( self inputSensor cursorPoint).
				(self line at:1) show.
			].
		].
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!TriangleClassificationPage8 methodsFor: 'miscellaneous' stamp: 'Aayush 11/6/2008 09:56'!
test
	| extName |
	extName := 'p8-d-2'.
	World allMorphsDo: 
	[	
		:t2 | (t2 externalName asString sameAs: extName)				
		ifTrue:
 		[
			self dispObject add: t2.
		]
	].
! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:16'!
triangleAnsCod
	^triangleAnsCod! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:17'!
triangleAnsCod: anOrderedCollection
	triangleAnsCod := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:16'!
triangleCod
	^triangleCod! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/24/2008 15:16'!
triangleCod: anOrderedCollection
	triangleCod := anOrderedCollection! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:58'!
vertexToSet
	^vertexToSet! !

!TriangleClassificationPage8 methodsFor: 'accessing - properties' stamp: 'Aayush 10/3/2008 11:58'!
vertexToSet: aNumber
	vertexToSet := aNumber! !

!True methodsFor: '*ole' stamp: 'lg 10/29/2007 12:36'!
yesNoString
	^'<yes>'! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:59'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self fillIn: menu from: {
		{'OLE...' translated. { self . #oleDo }. 'open the Open Learning Exchange extensions menu' }.
		nil.
		{'previous project' translated. { #myWorld . #goBack }. 'return to the most-recently-visited project' translated}.
		{'jump to project...' translated. { #myWorld . #jumpToProject }. 'put up a list of all projects, letting me choose one to go to' translated}.
		{'save project on file...' translated. { #myWorld  . #saveOnFile }. 'save this project on a file' translated}.
		{'load project from file...' translated. { self  . #loadProject }. 'load a project from a file' translated}.
		nil}.
	myWorld addUndoItemsTo: menu.

		self fillIn: menu from: {
		{'restore display (r)' . { World . #restoreMorphicDisplay }. 'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.' translated}.
		nil}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'open...' translated. { self  . #openWindow } }.
			{'windows...' translated. { self  . #windowsDo } }.
			{'changes...' translated. { self  . #changesDo } }}].
	self fillIn: menu from: { 
		{'help...' translated. { self  . #helpDo }.  'puts up a menu of useful items for updating the system, determining what version you are running, and much else' translated}.
		{'appearance...' translated. { self  . #appearanceDo }. 'put up a menu offering many controls over appearance.' translated}}.

	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: {
			{'do...' translated. { Utilities . #offerCommonRequests} . 'put up an editible list of convenient expressions, and evaluate the one selected.' translated}}].

	self fillIn: menu from: { 
		nil.
		{'objects (o)' translated. { #myWorld . #activateObjectsTool } . 'A tool for finding and obtaining many kinds of objects' translated}.
		{'new morph...' translated. { self  . #newMorph }. 'Offers a variety of ways to create new objects' translated}.
		nil.
		{'authoring tools...' translated. { self  . #scriptingDo } . 'A menu of choices useful for authoring' translated}.
		{'playfield options...' translated. { self  . #playfieldDo } . 'A menu of options pertaining to this object as viewed as a playfield' translated}.
		{'flaps...' translated. { self . #flapsDo } . 'A menu relating to use of flaps.  For best results, use "keep this menu up"' translated}.
		{'projects...' translated. { self  . #projectDo }. 'A menu of commands relating to use of projects' translated}}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'print PS to file...' translated. { self  . #printWorldOnFile } . 'write the world into a postscript file' translated}.
			{'debug...' translated. { self  . #debugDo } . 'a menu of debugging items' translated}}].
	self fillIn: menu from: { 
		nil.
		{'save' translated. { SmalltalkImage current  . #saveSession } . 'save the current version of the image on disk' translated}.
		{'save as...' translated. { SmalltalkImage current . #saveAs }. 'save the current version of the image on disk under a new name.' translated}.
		{'save as new version' translated. { SmalltalkImage current . #saveAsNewVersion }. 'give the current image a new version-stamped name and save it under that name on disk.' translated}.
		{'save and quit' translated. { self  . #saveAndQuit } . 'save the current image on disk, and quit out of Squeak.' translated}.
		{'quit' translated. { self  . #quitSession } . 'quit out of Squeak.' translated}}.

	^ menu! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 12:22'!
oleDo
	self doPopUp: self oleMenu.! !

!TheWorldMenu methodsFor: '*ole' stamp: 'cjs 8/12/2008 12:05'!
oleMenu
	| menu |
	menu := self menu: 'Open Learning Exchange'.
	^ self fillIn: menu from: {
		{ 'author mode' translated. { OLE. #authorMode } }.
		{ 'user mode' translated. { OLE. #userMode } }.
		nil.
		{ 'toggle flaps' translated. { self. #toggleFlaps } }.
		nil.
		{ 'deploy' translated. { OLE. #deploy } }.
		nil.
		{ 'make EpaathText' translated. { EpaathText. #createFromWorldMenu } } 
	}
! !

!TheWorldMenu methodsFor: '*ole' stamp: 'lg 11/24/2007 13:13'!
toggleFlaps
	| wasHidden |
	wasHidden := World submorphs noneSatisfy: [ :m | m class = FlapTab and: [ m visible ] ].
	World submorphs do: [  :m | m class = FlapTab ifTrue: [ m visible: wasHidden]].! !

!False methodsFor: '*ole' stamp: 'lg 10/29/2007 12:35'!
yesNoString
	^'<no>'.! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

!Number methodsFor: '*ole' stamp: 'lg 10/11/2007 12:02'!
roundedUp
	^self = self asInteger ifTrue: [self asInteger] ifFalse: [self asInteger + 1].! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 11/25/2007 11:10'!
findProjectFileNamed: projectName recursivelyInDirectory: directoryName
	| directory entries subdirs filename |
	directory := FileDirectory on: directoryName.
	entries := FileList2 projectOnlySelectionMethod: directory entries.
	entries := entries detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [nil].
	entries isNil ifFalse: [^entries first].
	"Recurse"
	subdirs := directory directoryNames collect: [ :subdir | directory fullPathFor: subdir].
	subdirs do: [:dir | filename := self findProjectFileNamed: projectName recursivelyInDirectory: dir.
						 filename isNil ifFalse: [^(FileDirectory on: dir) fullPathFor: filename]].
	^nil.
! !

!ProjectLoading class methodsFor: '*ole-public' stamp: 'lg 12/21/2007 13:32'!
openFromDirectory: dir andProjectName: projectName
        | directory aStream entries fileName |
        (Project named: projectName)
                ifNotNilDo: [:project | ^ project enter].
        directory := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dir.
        entries := FileList2 projectOnlySelectionMethod: directory entries.
        entries := entries
                                detect: [:each | (Project parseProjectFileName: each first) first = projectName] ifNone: [^ false].
        fileName := entries first.
        self
                showProgressBarDuring: [ProgressNotification signal: '0'.
                        directory := FileDirectory on: Smalltalk imagePath, FileDirectory slash, dir.
                        aStream := directory readOnlyFileNamed: fileName.
                        self
                                openName: fileName
                                stream: aStream
                                fromDirectory: directory
                                withProjectView: #none]
! !

!ProjectLoading class methodsFor: '*ole-loading' stamp: 'lg 12/7/2007 10:44'!
openRecursivelyFromDirectory: dirName andProjectName: projectName 
	| dir |
	dir := FileDirectory on: dirName.
	(self openFromDirectory: dirName andProjectName: projectName)
		ifTrue: [^true]
		ifFalse: [dir directoryNames do:
			[:subdir | (self openRecursivelyFromDirectory: (dir fullPathFor: subdir) andProjectName: projectName) ifTrue: [^true]]].
	^false.! !

!FlapTab methodsFor: '*ole' stamp: 'lg 12/4/2007 11:36'!
setVisibilityByMode
	self visible: OLE isAuthorMode.! !

EllipseMorph subclass: #DisplayBoardE
	instanceVariableNames: 'strMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

EllipseMorph subclass: #EllipticGameInputMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:38'!
getGameValue
	^label contents asInteger.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:27'!
handlesMouseDown: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
handlesMouseOver: event
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:30'!
initialize
	super initialize.
	label := StringMorph new.
	label  contents: '0'; center: self center.
	self addMorph: label.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:34'!
isGameChoice
	^true! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:33'!
layoutChanged
	label center: self center.
	^super layoutChanged.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 06:39'!
mouseDown: event
	NumberGame answer: self getGameValue.! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseEnter: event
	self color: (Color yellow alpha: 0.25).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/14/2007 12:06'!
mouseLeave: event
	self color: (Color transparent).! !

!EllipticGameInputMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/12/2007 05:35'!
setGameValue: n
	label contents: n asString.! !

EllipseMorph subclass: #FractionAndEquivalentDecimalFractionDisplay
	instanceVariableNames: 'fractionDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-FractionAndEquivalentDecimalActivity'!

!FractionAndEquivalentDecimalFractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 14:55'!
fractionDisplay
	^fractionDisplay! !

!FractionAndEquivalentDecimalFractionDisplay methodsFor: 'accessing - properties' stamp: 'A 8/19/2008 14:55'!
fractionDisplay: aFractionDisplay
	fractionDisplay := aFractionDisplay! !

!FractionAndEquivalentDecimalFractionDisplay methodsFor: 'initialization' stamp: 'A 8/20/2008 15:00'!
initialize
	super initialize.

	self width:100.
	self height:100.
	self borderWidth:6.

	self fractionDisplay: FractionDisplay new.
	self addMorph:self fractionDisplay.

	self fractionDisplay fontName:'BitstreamVeraSans' size:26.
	self fractionDisplay showWholeNumber:nil Numerator:'25' Denomenator:'5'.
	self fractionDisplay center:self center.

! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !

UserText subclass: #InputFieldMorph
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!InputFieldMorph commentStamp: 'sw 2/8/2008 01:28' prior: 0!
A type-in field accepting only a given number of digits.!

InputFieldMorph subclass: #FLText
	instanceVariableNames: 'tallyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FLText methodsFor: 'as yet unclassified' stamp: 'a 3/7/2008 17:24'!
initialize

super initialize.
self maxLength:1.
self setCharacters: ''.
self borderWidth:2.
! !

InputFieldMorph subclass: #InputFieldMorphWithBGColor
	instanceVariableNames: 'myCharacter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 5/7/2008 10:44'!
acceptText
	super rejectKeystroke.
! !

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 4/3/2008 17:20'!
checkAnswer
	self getCharacters size>0 
	ifTrue:[
		self getCharacters= self myCharacter 
			ifTrue:[^true]
			ifFalse:[^false].
			]
	ifFalse:[^false]
! !

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 6/16/2008 15:40'!
initialize
	super initialize.
	self crAction: (MessageSend receiver: self selector: #acceptText).
	self myCharacter:'0'.! !

!InputFieldMorphWithBGColor methodsFor: 'as yet unclassified' stamp: 'Ram 5/7/2008 10:45'!
keyStroke: evt 
	| key |
	key:= evt keyCharacter.
	key charCode = 13
		ifTrue:[^super rejectKeystroke	 ].
	super keyStroke:evt.
	self getCharacters size>0 
	ifTrue:[
		self getCharacters= self myCharacter 
			ifTrue:[ self backgroundColor:(Color r: 1.0 g: 1.0 b: 1.0)]
			ifFalse:[self backgroundColor:(Color r: 1.0 g: 1.0 b: 0.0)].
			]
	ifFalse:[self backgroundColor:(Color r: 1.0 g: 1.0 b: 1.0)]
! !

!InputFieldMorphWithBGColor methodsFor: 'accessing' stamp: 'Ram 4/2/2008 16:59'!
myCharacter
	"Answer the value of myCharacter"

	^ myCharacter! !

!InputFieldMorphWithBGColor methodsFor: 'accessing' stamp: 'Ram 4/2/2008 16:59'!
myCharacter: anObject
	"Set the value of myCharacter"

	myCharacter _ anObject! !

!InputFieldMorph class methodsFor: 'parts bin' stamp: 'sw 2/8/2008 01:36'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!"

	^ self partName:	'Digits Field' translatedNoop
		categories:		{'OLE' translatedNoop}
		documentation:	'A type-in field whose contents are limited to a given number of digits' translatedNoop! !

!InputFieldMorph methodsFor: 'menu' stamp: 'sw 2/8/2008 00:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add object-specific menu items to a menu."

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'set number of digits...' translated target: self action: #setNumberOfDigits! !

!InputFieldMorph methodsFor: 'initialization' stamp: 'ss 2/14/2008 14:15'!
initialize
	"Initialize the receiver."

	self setProperty: #defaultContents toValue: '42' asText.
	super initialize.
	maxLength := 2.
	self width: 60.
	self beAllFont: (StrikeFont familyName: 'BitStreamVeraSans' size: 40)

"
DigitsField initializedInstance openInHand
"! !

!InputFieldMorph methodsFor: 'event handling' stamp: 'a 3/9/2008 12:17'!
keyStroke: evt 
	"Handle a keystroke event."

	| newSel key |
	key := evt keyCharacter.

	evt commandKeyPressed ifTrue: [^ self rejectKeystroke].

	(#(8 13 28 29) includes: key charCode) ifTrue: [^ super keyStroke: evt].

	"key isDigit ifFalse: [^ self rejectKeystroke]."
	(self editor selection size = 0 and: [text string size >= maxLength]) ifTrue: [^ self rejectKeystroke].

	super keyStroke: evt.
	ActiveHand keyboardFocus == self ifFalse: [self releaseEditor. ^ self].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last! !

!InputFieldMorph methodsFor: 'accessing' stamp: 'sw 2/8/2008 01:29'!
maxLength: aLength
	"Set the maximum number of digits accepted."

	maxLength := aLength! !

!InputFieldMorph methodsFor: 'as yet unclassified' stamp: 'a 3/5/2008 13:24'!
obtainKeyboardFocus
	ActiveHand keyboardFocus: self renderedMorph.
	self renderedMorph editor selectAll! !

!InputFieldMorph methodsFor: 'event handling' stamp: 'ss 2/14/2008 13:02'!
rejectKeystroke
	"Reject keystroke input"

	"Beeper beep.
	self flashBounds"	
	^self ! !

!InputFieldMorph methodsFor: 'menu actdions' stamp: 'sw 2/8/2008 01:42'!
setNumberOfDigits
	"Put up a dialog telling the user the current number of digits specified and allowing him to change that setting."

	| result |
	result := FillInTheBlank request: 'Type number of digits desired' translated initialAnswer: maxLength printString.
	result ifEmpty: [^ self].
	result isAllDigits ifFalse: [^ self inform: 'type digits only please' translated].
	maxLength := result.
	text string size > maxLength ifTrue:
		[text replaceFrom: maxLength + 1 to: text string size with: ''.
		self releaseParagraph; paragraph]! !

InputFieldMorph subclass: #InputTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!InputTextMorph methodsFor: 'as yet unclassified' stamp: 'ram 7/14/2008 10:30'!
acceptText
	super rejectKeystroke.! !

!InputTextMorph methodsFor: 'as yet unclassified' stamp: 'ram 7/14/2008 10:29'!
initialize
	super initialize.
	self crAction: (MessageSend receiver: self selector: #acceptText).
! !

!InputTextMorph methodsFor: 'as yet unclassified' stamp: 'ram 7/14/2008 10:53'!
keyStroke: evt 
	| key |
	key:= evt keyCharacter.
	key charCode = 13
		ifTrue:[
			self player acceptMethod.
			^super rejectKeystroke	
	].
	super keyStroke:evt.
	! !

InputFieldMorph subclass: #MyTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MyTextMorph methodsFor: 'initialization' stamp: 'Aayush 6/19/2008 15:58'!
acceptOnCR
	^true.! !

!MyTextMorph methodsFor: 'initialization' stamp: 'Aayush 7/1/2008 12:25'!
initialize
	super initialize.
	self borderWidth:2.
	self maxLength:3.
	
! !

!MyTextMorph methodsFor: 'as yet unclassified' stamp: 'Aayush 7/14/2008 16:05'!
keyStroke: evt 
	"Handle a keystroke event."

	| newSel key evtModified |
	key := evt keyCharacter.

	evt commandKeyPressed ifTrue: [^ self rejectKeystroke].

	(#(8 13 28 29) includes: key charCode) ifTrue: [^ super keyStroke: evt].

	"key isDigit ifFalse: [^ self rejectKeystroke]."
	(self editor selection size = 0 and: [text string size >= maxLength]) ifTrue: [^ self rejectKeystroke].

	evtModified := evt.
	evtModified keyValue: (key asString) asUppercase.

	super keyStroke: evtModified.
	ActiveHand keyboardFocus == self ifFalse: [self releaseEditor. ^ self].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last! !

UserText subclass: #NepaliTextMorph
	instanceVariableNames: 'maxLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NepaliTextMorph class methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:23'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!!!"

	^ self partName:	'InputField' translatedNoop
		categories:		{'OLE' translatedNoop}
		documentation:	'A type-in field whose contents are limited to a given number of letters' translatedNoop
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add object-specific menu items to a menu."

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'set number of digits...' translated target: self action: #setNumberOfDigits
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:29'!
initialize
	"Initialize the receiver."

	self setProperty: #defaultContents toValue: '00' asText.
	super initialize.
	maxLength := 5.
	self beAllFont: (StrikeFont familyName: 'DevanagariNew' size: 60).
	self width: 50.
	self borderWidth:1.! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:18'!
keyStroke: evt 
	"Handle a keystroke event."

	| newSel key |
	key := evt keyCharacter.

	evt commandKeyPressed ifTrue: [^ super keyStroke: evt].

	(#(8 13 28 29) includes: key charCode) ifTrue: [^ super keyStroke: evt].

	"key isDigit ifFalse: [^ self rejectKeystroke]."
	(self editor selection size = 0 and: [text string size >= maxLength]) ifTrue: [^ self rejectKeystroke].

	super keyStroke: evt.
	ActiveHand keyboardFocus == self ifFalse: [self releaseEditor. ^ self].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:19'!
maxLength: aLength
	"Set the maximum number of digits accepted."

	maxLength := aLength
! !

!NepaliTextMorph methodsFor: 'as yet unclassified' stamp: 'Ram 3/18/2008 13:18'!
rejectKeystroke
	"Reject keystroke input"
	^self ! !

ProtoObject subclass: #CostumizedBookMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!CostumizedBookMorph methodsFor: 'as yet unclassified' stamp: 'a 3/6/2008 16:36'!
playPageFlipSound: soundName
	^self
! !

SketchMorph subclass: #FootBall
	instanceVariableNames: 'leftBlocked rightBlocked upBlocked downBlocked lastClicked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:31'!
displayQuestion
	World allMorphsDo:[:each| ((each isKindOf: SketchMorph) 
									and:['Envelop*' match: each externalName] 
									and:[self player overlapsAny: each player]
									)ifTrue:[Transcript show: each; cr.]
		
	]
! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
downBlocked
	"Answer the value of downBlocked"

	^ downBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
downBlocked: anObject
	"Set the value of downBlocked"

	downBlocked _ anObject! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 4/15/2008 12:16'!
handleKeystroke: anEvent
	| keyValue |

	keyValue:= anEvent keyValue.
	keyValue= 30 "up arrow"
		ifTrue: [ (self  color: (Color r: 0.0 g: 0.0 b: 0.0) sees: (Color r: 1.0 g: 0.596 b: 0.0)) 
					ifFalse:[self position:  self position-(0@4).]
					ifTrue:[(self lastClicked='up') 
								ifTrue:[self position:  self position+(0@12).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'up'.
				].
	keyValue= 31 "down arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.0) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position+(0@4).]
					ifTrue:[(self lastClicked='down')
								ifTrue:[ self position: self position-(0@12).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'down'.
				].
	keyValue= 29 "right arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.00) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position+(4@0).]
					ifTrue:[(self lastClicked='right')
								ifTrue:[self position: self position-(12@0).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'right'.
				].
	keyValue= 28 "left arrow"
		ifTrue: [(self color: (Color r: 0.0 g: 0.0 b: 0.00) sees: (Color r: 1.0 g: 0.596 b: 0.0))
					ifFalse:[self position: self position-(4@0).]
					ifTrue:[(self lastClicked='left')
								ifTrue:[self position: self position+(12@0).]
								ifFalse:[self moveAwayFromWall].
							].
					self lastClicked: 'left'.
				].

! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:31'!
handlesMouseDown:anEvent
^true! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
handlesMouseOver:anEvent
^true
! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
lastClicked
	"Answer the value of lastClicked"

	^ lastClicked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
lastClicked: anObject
	"Set the value of lastClicked"

	lastClicked _ anObject! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
leftBlocked
	"Answer the value of leftBlocked"

	^ leftBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
leftBlocked: anObject
	"Set the value of leftBlocked"

	leftBlocked _ anObject! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
mouseDown:anEvent
	anEvent redButtonPressed! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
mouseEnter:anEvent
anEvent hand newKeyboardFocus: self! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:32'!
moveAwayFromWall
	 | lastMove |
	lastMove:= self lastClicked.
	lastMove ='up'ifTrue:[self position:  self position+(0@6)].
	lastMove ='down'ifTrue:[self position: self position-(0@6)].
	lastMove ='right'ifTrue:[self position: self position-(6@0)].
	lastMove ='left'ifTrue:[self position:  self position+(6@0)].
	! !

!FootBall methodsFor: 'as yet unclassified' stamp: 'Ram 3/11/2008 16:33'!
resetBlock
	self upBlocked:false.
	self downBlocked:false.
	self leftBlocked:false.
	self rightBlocked:false.

! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
rightBlocked
	"Answer the value of rightBlocked"

	^ rightBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
rightBlocked: anObject
	"Set the value of rightBlocked"

	rightBlocked _ anObject! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
upBlocked
	"Answer the value of upBlocked"

	^ upBlocked! !

!FootBall methodsFor: 'accessing' stamp: 'Ram 3/11/2008 16:29'!
upBlocked: anObject
	"Set the value of upBlocked"

	upBlocked _ anObject! !

SketchMorph subclass: #PicturePuzzlePieceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/10/2007 15:34'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	(morph isKindOf: PicturePuzzleBlockMorph) ifTrue:
		[ morph submorphs do: [ :m | morph owner placeInEmptyBox: m ] without: self ].
	self beep: 'click'.
	(morph owner isKindOf: PicturePuzzleMorph) ifTrue:
		[ morph owner checkCompletion ].! !

!PicturePuzzlePieceMorph methodsFor: 'puzzle' stamp: 'lg 10/14/2007 12:34'!
label: string 
	| morph font |
	font := string asInteger isNil ifTrue: [((TextStyle named: #BitstreamVeraSansMono) fontOfPointSize: 32)]
							  ifFalse: [((TextStyle named: #DevanagariNew) fontOfPointSize: 36)].
	morph := StringMorph contents: string font: font.
	morph shadowOffset: 2@2.
	morph center: self center.
	morph color: (Color white darker); hasDropShadow: true; shadowColor: (Color black alpha: 0.75).
	self addMorph: morph.! !

SketchMorph subclass: #Protractor
	instanceVariableNames: 'angPointer left2Right targetAngle start eventReceiver eventSelector index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 14:15'!
angPointer
	^angPointer! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 14:15'!
angPointer: aLineMorph
	angPointer := aLineMorph! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:21'!
eventReceiver
	^eventReceiver! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/15/2008 15:21'!
eventSelector
	^eventSelector! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 16:13'!
index
	^index! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 16:13'!
index: aNumber
	index := aNumber! !

!Protractor methodsFor: 'initialization' stamp: 'Aayush 9/12/2008 13:58'!
initCostume
	| extName |
	extName := 'protractor'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self wearCostume: t2.
		]
	].
! !

!Protractor methodsFor: 'initialization' stamp: 'Aayush 9/12/2008 16:02'!
initEventReceiver:r Selector:s
	eventReceiver:= r.
	eventSelector:=s.
! !

!Protractor methodsFor: 'initialization' stamp: 'Aayush 9/12/2008 08:49'!
initialize
	super initialize.
	self start:false.
	self angPointer: LineMorph new.
	self angPointer verticesAt:1 put:(0@0).
	self angPointer verticesAt:2 put:(300@0).
	self addMorph:self angPointer.
! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:54'!
left2Right
	^left2Right! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 08:57'!
left2Right: aBoolean
	left2Right := aBoolean.

	self left2Right ifTrue:
	[
		self angPointer player setHeadingTheta:0.
	]
	ifFalse:
	[
		self angPointer player setHeadingTheta:180.
	].
	! !

!Protractor methodsFor: 'initialization' stamp: 'Aayush 9/12/2008 09:09'!
reset
	self start:false.
	self left2Right:true.
	self angPointer player setHeadingTheta:0.
! !

!Protractor methodsFor: 'miscellaneous' stamp: ''!
showAngle: angle 
	self left2Right
		ifTrue: [self angPointer player setHeadingTheta: angle]
		ifFalse: [self angPointer player setHeadingTheta: 180 - angle]! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 14:00'!
start
	^start! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 14:00'!
start: aBoolean
	start := aBoolean! !

!Protractor methodsFor: 'miscellaneous' stamp: 'Aayush 11/11/2008 16:27'!
stepTime
	^3! !

!Protractor methodsFor: 'miscellaneous' stamp: 'Aayush 9/15/2008 15:21'!
step
	| tmp |
	self start ifTrue:
	[

		self angPointer player getHeadingTheta = self targetAngle ifTrue:
		[
			self start: false.
			(self eventReceiver) ~= nil ifTrue:
			[
				tmp := Array new:1.
				tmp at:1 put: self index.

				(self eventReceiver) perform:(self eventSelector) withArguments:tmp .
			].
		]
		ifFalse:
		[
			self left2Right ifTrue:
			[
				self angPointer player setHeadingTheta: self angPointer player getHeadingTheta + 1.
			]
			ifFalse:
			[
				self angPointer player setHeadingTheta: self angPointer player getHeadingTheta - 1.
			]		
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 13:55'!
targetAngle
	^targetAngle! !

!Protractor methodsFor: 'accessing - properties' stamp: 'Aayush 9/12/2008 09:28'!
targetAngle: aNumber
		
	self left2Right ifTrue:
	[
		targetAngle := aNumber.
	]
	ifFalse:
	[
		targetAngle := 180 - aNumber.
	].
	! !

SketchMorph subclass: #RestartButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add custom menu items"

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'restore base graphic' translated target: self action: #restoreBaseGraphicFromMenu.
	aCustomMenu add: 'call this my base graphic' translated target: self action: #callThisBaseGraphic.
	aCustomMenu add: 'choose new graphic...' translated target: self action: #chooseNewGraphic.
	aCustomMenu addLine.
	aCustomMenu add: 'set as background' translated target: rotatedForm action: #setAsBackground.
	self addPaintingItemsTo: aCustomMenu hand: aHandMorph.
	self addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:30'!
addPicturePuzzleItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu addLine.
	aCustomMenu add: 'create picture puzzle morph' translated
					target: self action: #grabPicturePuzzleMorph.
	aCustomMenu add: 'create picture puzzle thumbnail' translated
					target: self action: #grabPicturePuzzleThumbnailMorph.
! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 09:31'!
grabPicturePuzzleMorph
	| morph |
	morph := self picturePuzzleMorph openInWorld.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:34'!
grabPicturePuzzleThumbnailMorph
	self picturePuzzleThumbnailMorph openInWorld grab.! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/9/2007 20:20'!
picturePuzzleMorph
	^PicturePuzzleMorph new scrambleForm: self form! !

!SketchMorph methodsFor: '*ole-picturepuzzle' stamp: 'lg 10/10/2007 10:31'!
picturePuzzleThumbnailMorph
	^PicturePuzzleThumbnailMorph new makeThumbnailFromForm: self form.! !

ImageMorph subclass: #AnimatedMarbleBox
	instanceVariableNames: 'marbels start marbelPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-RomanNumberActivity'!

!AnimatedMarbleBox methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 13:24'!
hideAllMarbels
	| count |
	count :=1.
	[ count <= self marbels size] whileTrue:
	[
		(self marbels at:count) hide.
		count := count + 1.
	].
! !

!AnimatedMarbleBox methodsFor: 'initialization' stamp: 'Aayush 7/30/2008 10:57'!
initCostume
	| t1 count size |
	t1 := 'box'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self  wearCostume: t2.
		]
	].

	count := 1.
	size := self marbels size.
	[ count <= size ] whileTrue:
	[
		t1 := 'marbel'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				(self  marbels at:count) wearCostume: t2.
			]
		].
		
		count := count + 1.
	].
! !

!AnimatedMarbleBox methodsFor: 'initialization' stamp: 'aayush 7/9/2008 12:28'!
initialize
	super initialize.
	self marbels: OrderedCollection new.
	self start:false.
	self marbelPos:0.
	self initCostume.! !

!AnimatedMarbleBox methodsFor: 'initialization' stamp: 'aayush 7/8/2008 17:10'!
initMarbelsWithCount:count
	| x t1 |
	x := 1.
	[ x <= count ] whileTrue:
	[
		self marbels add: (ImageMorph new).
		self addMorph: (self marbels at:x).
		
		t1 := 'marbel'.
		World allMorphsDo: 
		[	
			:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
			ifTrue:
	 		[
				(self  marbels at:x) wearCostume: t2.
			]
		].
		
		(self marbels at:x) center: self center.
		x := x + 1.
	].! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 10:10'!
marbelPos
	^marbelPos! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/9/2008 10:10'!
marbelPos: aNumber
	marbelPos := aNumber! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 16:19'!
marbels
	^marbels
! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 16:19'!
marbels: anOrderedCollection
	marbels :=anOrderedCollection
! !

!AnimatedMarbleBox methodsFor: 'initialization' stamp: 'Aayush 8/4/2008 11:03'!
reset
	self hideAllMarbels.
	self marbelPos:0.
	self start:false.
! !

!AnimatedMarbleBox methodsFor: 'miscellaneous' stamp: 'Aayush 7/30/2008 13:24'!
showAllMarbels
	| count |
	count :=1.
	[ count <= self marbels size] whileTrue:
	[
		(self marbels at:count) show.
		count := count + 1.
	].
! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 16:33'!
start
	^start! !

!AnimatedMarbleBox methodsFor: 'accessing - properties' stamp: 'aayush 7/8/2008 16:33'!
start: aBoolean
	start := aBoolean! !

!AnimatedMarbleBox methodsFor: 'miscellaneous' stamp: 'aayush 7/8/2008 16:24'!
stepTime
	^500.! !

!AnimatedMarbleBox methodsFor: 'miscellaneous' stamp: 'Aayush 8/4/2008 11:02'!
step
	self start ifTrue:
	[
		self marbelPos: self marbelPos + 1.
		(self marbelPos <= self marbels size) ifTrue:
		[
			(self marbels at:self marbelPos) show.
		]
		ifFalse:
		[
			self start:false.
"			self marbelPos:0.
			self hideAllMarbels.
"		]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

ImageMorph subclass: #Banner
	instanceVariableNames: 'banner start stepInterval currentIndex eventReceiver changedSelector roundCompleteSelector loop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!Banner methodsFor: 'miscellaneous' stamp: 'Aayush 7/31/2008 16:32'!
addNew: extName 
	
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
	 	[
			self banner add:t2.
		]
	].
	! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:23'!
banner
	^banner! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:24'!
banner: anOrderedCollection
	banner := anOrderedCollection! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:38'!
changedSelector
	^changedSelector! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:34'!
currentIndex
	^currentIndex! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:34'!
currentIndex: aNumber
	currentIndex := aNumber! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:36'!
eventReceiver
	^eventReceiver! !

!Banner methodsFor: 'initialization' stamp: 'Aayush 8/1/2008 12:06'!
initialize
	super initialize.
	self banner: OrderedCollection new.
	self start:false.
	self stepInterval:1000.
	self currentIndex:0.
	self loop:true.! !

!Banner methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 16:44'!
initReceiver:r changedSelector:cs roundCompleteSelector:rc
	eventReceiver := r.
	changedSelector := cs.
	roundCompleteSelector := rc! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:59'!
loop
	^loop! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 17:00'!
loop: aBoolean
	loop := aBoolean! !

!Banner methodsFor: 'miscellaneous' stamp: 'Aayush 7/31/2008 16:29'!
removeAllBanners
	[self banner size >= 1]  whileTrue:
	[
		self banner removeFirst.
	].
! !

!Banner methodsFor: 'initialization' stamp: 'Aayush 8/1/2008 15:13'!
reset
	self start:false.
	self currentIndex:1.
	self  wearCostume: (self banner at:currentIndex).

! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:41'!
roundCompleteSelector
	^roundCompleteSelector! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:25'!
start
	^start! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:25'!
start: aBoolean
	start := aBoolean! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:26'!
stepInterval
	^stepInterval
! !

!Banner methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 16:26'!
stepInterval: aNumber
	stepInterval := aNumber
! !

!Banner methodsFor: 'miscellaneous' stamp: 'Aayush 7/31/2008 16:33'!
stepTime
	^self stepInterval.! !

!Banner methodsFor: 'miscellaneous' stamp: 'Aayush 8/1/2008 12:10'!
step
	| tmp |
	self start ifTrue:
	[
		self currentIndex: self currentIndex + 1.
		tmp := Array new:1.

		(self currentIndex > self banner size) ifTrue:
		[
			self loop ifFalse:
			[
				self stopStepping.
			]
			ifTrue:
			[
				self currentIndex:1.
				self  wearCostume: (self banner at:(self currentIndex)).
			].

			self roundCompleteSelector ~= nil ifTrue:
			[
				tmp at:1 put:0.
				(self eventReceiver) perform:(self roundCompleteSelector) withArguments:tmp.
			].
		]
		ifFalse:
		[
			self  wearCostume: (self banner at:(self currentIndex)).

			self changedSelector ~= nil ifTrue:
			[
				tmp at:1 put:(self currentIndex).
				(self eventReceiver) perform:(self changedSelector) withArguments:tmp.
			].
		].
	]
	ifFalse:
	[
		self stopStepping.
	].
! !

ImageMorph subclass: #DisplayAnswer
	instanceVariableNames: 'txtBox imgCheck strValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:07'!
imgCheck
	^imgCheck! !

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:07'!
imgCheck: anImageMorph
	imgCheck := anImageMorph! !

!DisplayAnswer methodsFor: 'initialization' stamp: 'Aayush 7/4/2008 12:46'!
initialize
	super initialize.

	self txtBox: MyTextMorph new.
	self addMorph: self txtBox.

	self strValue: StringMorph new.
	self addMorph: self strValue.

	self imgCheck: ImageMorph new.
	self addMorph: self imgCheck.
	! !

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:11'!
strValue
	^strValue! !

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 12:11'!
strValue: aStringMorph
	strValue := aStringMorph! !

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 11:57'!
txtBox
	^txtBox! !

!DisplayAnswer methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 11:57'!
txtBox: myTextMorph
	txtBox := myTextMorph! !

ImageMorph subclass: #DisplayBoard
	instanceVariableNames: 'dispImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

DisplayBoard subclass: #DisplayBoardExtended
	instanceVariableNames: 'strMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

DisplayBoardExtended subclass: #AnimatedCloud
	instanceVariableNames: 'strMessage2 start startPosition endPosition aimedAt explodeShowSecondPassed explodeShow stepInterval id parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubstractActivity'!

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 11:10'!
aimedAt
	^aimedAt! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 11:10'!
aimedAt: aBoolean
	aimedAt := aBoolean! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:49'!
endPosition
	^endPosition! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:48'!
endPosition: aPoint
	endPosition:= aPoint! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 17:28'!
explodeShowSecondPassed
	^explodeShowSecondPassed
	! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 17:29'!
explodeShowSecondPassed: aNumber
	explodeShowSecondPassed := aNumber
	! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 17:27'!
explodeShow
	^explodeShow! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 17:27'!
explodeShow: aBoolean
	explodeShow := aBoolean! !

!AnimatedCloud methodsFor: 'miscellaneous' stamp: 'Aayush 7/18/2008 12:38'!
explode
	| t1 |
	self explodeShow:true.
	t1 := 'questionDisplayExplode'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: t1])				
		ifTrue:
 		[
			self wearCostume: t2.
		]
	].
	self strMessage hide.
	self strMessage2 hide.
	self aimedAt:false.
	self selectionImage hide.
	
! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 09:47'!
id
	^id! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 09:48'!
id: aNumber
	id := aNumber! !

!AnimatedCloud methodsFor: 'initialization' stamp: 'Aayush 7/17/2008 11:09'!
initCostume
	| extName |
	extName := 'questionDisplayBg'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self wearCostume: t2.
		]
	].

	extName := 'selectionImage'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
 		[
			self selectionImage wearCostume: t2.
		]
	].

	self selectionImage center: self center.
! !

!AnimatedCloud methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 10:38'!
initialize
	super initialize.
	self id:0.
	self stepInterval: 1000.
	self start:false.
	self explodeShow:false.
	self explodeShowSecondPassed:0.
	self aimedAt:false.
	self strMessage2: (StringMorph new).
	self strMessage2 fontName: 'BitstreamVeraSans' size:26.
	self addMorph: self strMessage2.

	self addMorph: self selectionImage.
	self selectionImage hide.
	self initCostume.
! !

!AnimatedCloud methodsFor: 'initialization' stamp: 'Aayush 7/21/2008 14:45'!
initPosition: distance
	self startPosition: self center.
	self endPosition: ((self center) x@distance).
! !

!AnimatedCloud methodsFor: 'miscellaneous' stamp: 'Aayush 7/21/2008 09:54'!
insertMessage: message Message2:message2 Operator:operator.
	self strMessage contents: message.
	self strMessage2 contents: operator, ' ' , message2.

	self strMessage center: self center - (0@10).
	self strMessage2 center: self center + (0@10)..
	self strMessage2 right: 	(self strMessage right).

! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 10:45'!
parent
	^parent! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 10:45'!
parent: anObject
	parent :=  anObject! !

!AnimatedCloud methodsFor: 'initialization' stamp: 'Aayush 7/21/2008 16:10'!
reset
	self start:false.
	self aimedAt:false.
	self stepInterval:2000.
	self selectionImage hide.
	self center: self startPosition.
	self explodeShow:false.
	self explodeShowSecondPassed:0.

	! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/22/2008 11:54'!
selectionImage
	^ self dispImage! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:48'!
startPosition
	^startPosition! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:48'!
startPosition: aPoint
	startPosition:= aPoint! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:47'!
start
	^start! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:48'!
start: aBoolean
	start:= aBoolean! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 15:22'!
stepInterval
	^stepInterval! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 15:22'!
stepInterval: aNumber
	stepInterval := aNumber! !

!AnimatedCloud methodsFor: 'miscellaneous' stamp: 'Aayush 7/18/2008 15:22'!
stepTime
	^ self stepInterval.
! !

!AnimatedCloud methodsFor: 'miscellaneous' stamp: 'Aayush 7/24/2008 10:11'!
step
	| extName |
	self start ifTrue:
	[
		self aimedAt ifTrue:
		[
			self selectionImage visible ifTrue:
			[
				self selectionImage hide.
			]
			ifFalse:
			[
				self selectionImage show.
			]
		].

		self explodeShow ifTrue:
		[
			self explodeShowSecondPassed: self explodeShowSecondPassed + 0.5.
			self explodeShowSecondPassed =0.5 ifTrue:
			[
				self explodeShow:false.
				self explodeShowSecondPassed:0.
				self center: self startPosition.

				" ****** get new message, new costume *********"

				extName := 'questionDisplayBg'.
				World allMorphsDo: 
				[	
					:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
					ifTrue:
 					[
						self wearCostume: t2.
					]
				].
				self parent makeQuestionFor: (self id).
				self parent changeAnswer:self id.
			]
		].

		self center y < self endPosition y ifTrue:
		[		
			self center: self center + (0@20).
		]
		ifFalse:
		[
			self center: self startPosition.
			self parent makeQuestionFor: (self id).
			self parent changeAnswer:self id.
			self parent decreaseLife.
		]
	]
	ifFalse:
	[
		self stopStepping.
	]! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:52'!
strMessage2
	^strMessage2
! !

!AnimatedCloud methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 09:53'!
strMessage2: aStringMorph
	strMessage2 := aStringMorph

! !

!DisplayBoardExtended methodsFor: 'initialization' stamp: 'Aayush 7/17/2008 10:00'!
initialize
	super initialize.
	self strMessage: StringMorph new.
	self strMessage fontName: 'BitstreamVeraSans' size:26.
	self addMorph: self strMessage! !

!DisplayBoardExtended methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 08:32'!
strMessage
	^strMessage! !

!DisplayBoardExtended methodsFor: 'accessing - properties' stamp: 'Aayush 7/4/2008 08:32'!
strMessage: aStringMorph
	strMessage := aStringMorph! !

!DisplayBoard methodsFor: 'accessing - properties' stamp: 'Aayush 5/22/2008 16:52'!
dispImage
	^dispImage! !

!DisplayBoard methodsFor: 'accessing - properties' stamp: 'Aayush 5/22/2008 16:53'!
dispImage: anImageMorph
	dispImage:= anImageMorph! !

!DisplayBoard methodsFor: 'initialization' stamp: 'Aayush 5/22/2008 16:54'!
initialize
	super initialize.
	self dispImage: ImageMorph new.
	self addMorph: self dispImage.
	self dispImage center: self center.! !

ImageMorph subclass: #DisplayBoardText
	instanceVariableNames: 'strMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!DisplayBoardText methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 10:12'!
initialize
	super initialize.
	self strMessage: StringMorph new.
	self addMorph: self strMessage.! !

!DisplayBoardText methodsFor: 'accessing - properties' stamp: 'Aayush 7/23/2008 10:18'!
strMessage
	^strMessage! !

!DisplayBoardText methodsFor: 'accessing - properties' stamp: 'Aayush 7/23/2008 10:18'!
strMessage: aStringMorph
	strMessage := aStringMorph! !

ImageMorph subclass: #Gun
	instanceVariableNames: 'start targetObject fireBullet bulletFwStep bullet parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-AddSubstractActivity'!

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 16:09'!
bulletFwStep
	^bulletFwStep! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 16:09'!
bulletFwStep: aNumber
	bulletFwStep := aNumber! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 16:13'!
bullet
	^bullet! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 16:13'!
bullet: anImageMorph
	bullet := anImageMorph! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/18/2008 10:06'!
distanceBetweenPoint:p Point1: p1
	^(((p x - p1 x) squared) + ((p y - p1 y) squared)) safeSquareRoot! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/17/2008 16:05'!
fireABullet! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:30'!
fireBullet
	^fireBullet! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:31'!
fireBullet: aBoolean
	fireBullet := aBoolean! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/18/2008 13:33'!
fire
	self fireBullet:true.! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/17/2008 15:12'!
getTargetHeading
	| p b thetaR thetaD |
	p := (((self center) y - (self targetObject center) y) ).
	b := ((self targetObject center) x) - ((self center) x).
	thetaR := ((p/b) arcTan).
	thetaD := thetaR * (180/3.142).
	
	b < 0 ifTrue:
	[
		^ thetaD + 180 
	]
	ifFalse:
	[
		^thetaD
	].

	! !

!Gun methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 12:50'!
initCostume
	| extName |
	extName := 'gun'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self wearCostume: t2.
		]
	].

	extName := 'bullet'.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self bullet wearCostume: t2.
		]
	].
! !

!Gun methodsFor: 'initialization' stamp: 'Aayush 7/23/2008 10:35'!
initialize
	super initialize.
	self start:false.
	self fireBullet:false.
	self bulletFwStep:10.
	self bullet: ImageMorph new openInWorld.
	self initCostume.! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/17/2008 15:39'!
lockAt: anObject
	targetObject := anObject.
	self start:true.
	self startStepping.! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:09'!
parent
	^parent! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/21/2008 11:09'!
parent: anObject
	parent := anObject! !

!Gun methodsFor: 'initialization' stamp: 'Aayush 7/18/2008 14:00'!
reset
	self start:false.
	self fireBullet:false.
	self bullet player setX: self player getX.
	self bullet player setY: self player getY.
	self bulletFwStep:10.
	self player setHeadingTheta:90.! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/17/2008 15:04'!
setHeadingToward: aPoint
	| p b thetaR thetaD |

	p :=  ((self center) y - (aPoint y) ).
	b := (aPoint x) - ((self center) x).
	thetaR := (p/b) arcTan.
	thetaD := thetaR * (180/3.142).
	self player setHeadingTheta:thetaD.	! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 12:30'!
start
	^start! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 12:31'!
start: aBoolean
	start := aBoolean! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/17/2008 12:28'!
stepTime
	^500.! !

!Gun methodsFor: 'miscellaneous' stamp: 'Aayush 7/23/2008 15:18'!
step
	| |
	self start ifTrue:
	[
			self player setHeading:0.
			self player setHeadingTheta: (self getTargetHeading).

			self fireBullet ifTrue:
			[
				self player getX > self targetObject player getX ifTrue:
				[
					self bullet player getX > self targetObject player getX ifTrue:
					[
						self bullet player setHeadingTheta: self player getHeadingTheta.
						self bullet player forward: self bulletFwStep.
						self bulletFwStep: self bulletFwStep + 10.
					]
					ifFalse:
					[
						self parent checkAnswer ifTrue:
						[
							self parent increaseScore.
							self fireBullet:false.
							self start:false.
							self targetObject explode.
							SoundService default playSoundNamedOrBeep: 'explode3'.
						]
						ifFalse:
						[
							SoundService default playSoundNamedOrBeep: '1CAN3'.
							self parent decreaseScore.
						].

						self bullet player setX: self player getX.
						self bullet player setY: self player getY.
						self bulletFwStep:10.
						self fireBullet:false.
					]
				]
				ifFalse:
				[
					self bullet player getX < self targetObject player getX ifTrue:
					[
						self bullet player setHeadingTheta: self player getHeadingTheta.
						self bullet player forward: self bulletFwStep.
						self bulletFwStep: self bulletFwStep + 10.
					]
					ifFalse:
					[
						self parent checkAnswer ifTrue:
						[

							self parent increaseScore.
							self fireBullet:false.
							self start:false.
							self targetObject explode.
							SoundService default playSoundNamedOrBeep: 'explode3'.
						]
						ifFalse:
						[
							SoundService default playSoundNamedOrBeep: '1CAN3'.
							self parent decreaseScore.
						].
						self bullet player setX: self player getX.
						self bullet player setY: self player getY.
						self bulletFwStep:10.
						self fireBullet:false.
					]
				].
			]
	]
	ifFalse:
	[
		self stopStepping.
	]
! !

!Gun methodsFor: 'accessing - properties' stamp: 'Aayush 7/17/2008 12:56'!
targetObject
	^targetObject! !

ImageMorph subclass: #MyButton
	instanceVariableNames: 'strLabel mouseDownImage mouseUpImage mouseOverImage eventReceiver receiverDownSelector receiverEnterSelector receiverLeaveSelector receiverUpSelector index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Common-ByAayush'!

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:52'!
eventReceiver
	^eventReceiver! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 10:55'!
index
	^index! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 10:56'!
index: aNumber
	index:= aNumber! !

!MyButton methodsFor: 'initialization' stamp: 'Aayush 8/5/2008 13:43'!
initCostume

	self strLabel center: self center.! !

!MyButton methodsFor: 'initialization' stamp: 'Aayush 8/5/2008 13:43'!
initImageOver:o Down:d Up:u
	| extName |

	extName := d.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self mouseDownImage:t2.
		]
	].

	extName := o.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self mouseOverImage:t2
		]
	].

	extName := u.
	World allMorphsDo: 
	[	
		:t2 | ((t2 isKindOf: SketchMorph) and: [t2 externalName asString sameAs: extName])				
		ifTrue:
		[
			self mouseUpImage:t2
		]
	].

	self wearCostume: self mouseUpImage.! !

!MyButton methodsFor: 'initialization' stamp: 'Aayush 8/5/2008 10:56'!
initialize
	super initialize.
	self strLabel: StringMorph new.
	self addMorph: self strLabel.
	self index:0.

	self on:#mouseEnter send:#mouseEnter to:self.
	self on:#mouseLeave send:#mouseLeave to:self.
	self on:#mouseDown send:#mouseDown to:self.
	self on:#mouseUp send:#mouseUp to:self.
! !

!MyButton methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 13:15'!
initReceiver:r enterSelector:e leaveSelector:l downSelector:d upSelector:u
	receiverUpSelector := u.
	receiverDownSelector := d.
	receiverEnterSelector := e.
	receiverLeaveSelector := l.

	eventReceiver := r.
! !

!MyButton methodsFor: 'initialization' stamp: 'Aayush 7/31/2008 13:01'!
label:aString
	self strLabel contents: aString.
	self strLabel center: self center.! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:37'!
mouseDownImage
	^mouseDownImage! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 13:40'!
mouseDownImage: anObject
	mouseDownImage := anObject! !

!MyButton methodsFor: 'miscellaneous' stamp: 'Aayush 8/5/2008 13:44'!
mouseDown
	| tmp |
	self mouseDownImage ~= nil ifTrue:
	[
		self wearCostume: self mouseDownImage.
	].

	self receiverDownSelector ~= nil ifTrue:
	[
		tmp := Array new:1.
		tmp at:1 put:(self index).
		(self eventReceiver) perform:(self receiverDownSelector) withArguments:tmp .
	].
! !

!MyButton methodsFor: 'miscellaneous' stamp: 'Aayush 8/5/2008 13:44'!
mouseEnter
	| tmp |
	self mouseOverImage ~= nil ifTrue:
	[
		self wearCostume: self mouseOverImage.
	].

	self receiverEnterSelector ~= nil ifTrue:
	[
		tmp := Array new:1.
		tmp at:1 put:(self index).
		(self eventReceiver) perform:(self receiverEnterSelector) withArguments:tmp .
	].
! !

!MyButton methodsFor: 'miscellaneous' stamp: 'Aayush 8/5/2008 13:45'!
mouseLeave
	| tmp |
	self mouseUpImage ~= nil ifTrue:
	[
		self wearCostume: self mouseUpImage.
	].

	self receiverLeaveSelector ~= nil ifTrue:
	[
		tmp := Array new:1.
		tmp at:1 put:(self index).
		(self eventReceiver) perform:(self receiverLeaveSelector) withArguments:tmp .
	].
! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:37'!
mouseOverImage
	^mouseOverImage! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 13:40'!
mouseOverImage: anObject
	mouseOverImage := anObject! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 11:37'!
mouseUpImage
	^mouseUpImage! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 8/5/2008 13:40'!
mouseUpImage: anObject
	mouseUpImage := anObject! !

!MyButton methodsFor: 'miscellaneous' stamp: 'Aayush 8/5/2008 13:46'!
mouseUp
	| tmp |
	self mouseUpImage ~= nil ifTrue:
	[
		self wearCostume: self mouseUpImage.
	].

	self receiverUpSelector ~= nil ifTrue:
	[
		tmp := Array new:1.
		tmp at:1 put:(self index).
		(self eventReceiver) perform:(self receiverUpSelector) withArguments:tmp .
	].

! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 12:05'!
receiverDownSelector
	^receiverDownSelector! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 13:12'!
receiverEnterSelector
	^receiverEnterSelector! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 13:13'!
receiverLeaveSelector
	^receiverLeaveSelector! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 12:05'!
receiverUpSelector
	^receiverUpSelector! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 12:59'!
strLabel
	^strLabel
	! !

!MyButton methodsFor: 'accessing - properties' stamp: 'Aayush 7/31/2008 12:59'!
strLabel: aStringMorph
	strLabel:= aStringMorph
	! !

ImageMorph subclass: #PicturePuzzleThumbnailMorph2
	instanceVariableNames: 'filename gridSize cache labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!PicturePuzzleThumbnailMorph2 class methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:28'!
file: filename cache: flag
	^PicturePuzzleThumbnailMorph2 new setImageFile: filename cache: flag.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
handlesMouseDown: event
	^true! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:05'!
initialize
	super initialize.
	gridSize := 4.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:08'!
loadFileIntoCache
	cache := (FileStream readOnlyFileNamed: filename) binary contents.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:10'!
loadForm
	^cache = nil ifTrue: [ImageReadWriter formFromFileNamed: filename] ifFalse: [ImageReadWriter formFromStream: cache readStream].! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:21'!
mouseDown: event
	self openPuzzle.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:31'!
openPuzzle
	| morph |
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue: [m delete] ].
	morph := PicturePuzzleMorph new rows: gridSize; columns: gridSize.
	morph labels: (labels caseOf: { [nil] -> [ #() ].
							      [#letters] -> ['ABCDEFGHIJKLMNOPQRSTUVWXYZ' asArray collect: #asString].
							      [#numbers] -> [(1 to: 100) collect: #asString]}).
	morph scrambleForm: self loadForm.
	morph center: World center.
	morph top: 90.
	morph openInWorld! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename cache: flag
	cache := nil.
	filename := aFilename.
	flag ifTrue: [self loadFileIntoCache].
	self showThumbnail.
! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 17:14'!
setImageFile: aFilename
	self setImageFile: aFilename cache: false.! !

!PicturePuzzleThumbnailMorph2 methodsFor: 'as yet unclassified' stamp: 'lg 10/16/2007 11:00'!
showThumbnail
	self image: (self loadForm scaledToSize: 200@150).
! !

ImageMorph subclass: #VocabImage
	instanceVariableNames: 'title id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE-Vocab'!

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 9/25/2008 16:51'!
getContainer: strContainerName
	| cont |
	cont:=World allMorphs select:[: each| ((each isKindOf:PasteUpMorph)and:[each externalName 	match:strContainerName])].
	cont size>0 
		ifTrue:[
		^(cont at:1).
		]! !

!VocabImage methodsFor: 'accessing' stamp: 'ram 9/25/2008 11:28'!
id
	"Answer the value of id"

	^ id! !

!VocabImage methodsFor: 'accessing' stamp: 'ram 9/25/2008 11:28'!
id: anObject
	"Set the value of id"

	id _ anObject! !

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 10/13/2008 15:06'!
imageSelfPositionCenter
 	| cont own ownerList |
	
	own:= self owner externalName.
	ownerList:=#('Exerciepage' 'Loc1' 'Loc3' 'Loc4' 'Loc5' 'Loc6' 'Loc7' 'Loc8' 'Loc9').
	cont:=self getContainer:'Loc2'.
	
	1 to: ownerList size do:[:each| (own match: (ownerList at:each))
		ifTrue:[
			cont addMorph: self.
			^self.
				]
		].


! !

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 10/1/2008 12:12'!
imageSelfPosition
 	| own ownerList cont |
	own:= self owner externalName.
	ownerList:=#( 'Exerciepage' 'Loc2' 'TextLabelContainer').
	cont:=self getContainer:'imagePieceHolder'.
	
	1 to: ownerList size do:[:each| (own match: (ownerList at:each))
		ifTrue:[
			cont addMorph: self.
			^self.
				]
		].

! !

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 9/25/2008 17:17'!
initialize
 	| img |
	super initialize.
	img:= (ImageMorph new).
	self addMorph: img.
	self on:#mouseLeave send:#onMouseLeaveCall to: self.
! !

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 9/29/2008 13:54'!
onMouseLeaveCall
	self id~= 5 ifTrue:[
	self imageSelfPosition.]
	ifFalse:[self imageSelfPositionCenter].
	self removeMultiple! !

!VocabImage methodsFor: 'as yet unclassified' stamp: 'ram 9/29/2008 13:51'!
removeMultiple
 	| own cont |

	own:= self owner.
	('Loc*' match: own externalName )
	ifTrue:[
		own submorphs size>1 
			ifTrue:[
					cont:=self getContainer:'imagePieceHolder'.
					cont addMorph: self.
					].
			].

! !

!VocabImage methodsFor: 'accessing' stamp: 'ram 9/25/2008 11:28'!
title
	"Answer the value of title"

	^ title! !

!VocabImage methodsFor: 'accessing' stamp: 'ram 9/25/2008 11:28'!
title: anObject
	"Set the value of title"

	title _ anObject! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/20/2007 21:50'!
makeTheButtons

	^ Preferences useArtificialSweetenerBar
		ifTrue: [self makeTheSimpleButtonsSqueakland]
		ifFalse: [OLE isAuthorMode ifTrue: [self makeTheSimpleButtons] ifFalse: [self makeTheMinimalButtons]]
! !

!SugarNavigatorBar methodsFor: '*ole-override' stamp: 'lg 12/23/2007 20:45'!
makeTheMinimalButtons
	"Add the buttons for use in normal kids' mode."

	^((Project current parent isTopProject) ifTrue: [{}] ifFalse: [{self buttonPrev}]),
	(((DisplayScreen actualScreenSize = OLPCVirtualScreen virtualScreenExtent)
		ifFalse: [{#spacer. self buttonZoom}]
		ifTrue: [#()])),
	{	#spacer.
		self buttonStop.
		}
! !

BookMorph subclass: #CosutmizedBookMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

SimpleButtonMorph subclass: #ScramblerMorph
	instanceVariableNames: 'gridSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:49'!
doButtonAction
	World allMorphsDo: [ :m | (m isKindOf: PicturePuzzleMorph) ifTrue:
								[ m rows: gridSize; columns: gridSize; rescramble ] ].! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
drawOn: canvas
	| c p r blockWidth blockHeight |
	blockWidth := self width // gridSize.
	blockHeight := self height // gridSize.
	(0 to: gridSize-1) do: [ :row | (0 to: gridSize-1) do: [ :col |
		c := row+col \\ 2 = 0 ifTrue: [color] ifFalse: [Color white].
		p := self position + ((blockWidth*col) @ (blockHeight*row)).
		r := p corner: p + (blockWidth@blockHeight).
		canvas fillRectangle: r color: c
	]]! !

!ScramblerMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/11/2007 17:45'!
initialize
	super initialize.
	self color: Color black.
	gridSize := 3.! !

!Integer methodsFor: '*ole-sound' stamp: 'lg 10/4/2007 12:24'!
sayInNepali
	self beep: 'ne-' , self asWords.! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 10/13/2007 12:49'!
balloonText
	^nil.
! !

!ProjectViewMorph methodsFor: '*ole' stamp: 'lg 12/7/2007 11:18'!
setupDiskProxyUnderImage
	(project isKindOf: Project) ifTrue: [project := project setupDiskProxyUnderImage]! !
EpaathText initialize!
OLE initialize!
ProjectDirectoryMorph initialize!
